﻿-- $Revision: 75525 $
--[[
TODO: (Updated 10/25/2007

*Add Drum recipes to vendors
*Fix remaining Enchanting Oils to actually work
:ODOT

Specialcases = When there are several combines that yield the same itemid
[index or itemid]itemid|name

Combines
[index]skill|components|recipe|yield|itemid
index = itemid or -enchantid or specialcase
skill =
	A = Alchemy
	B = Blacksmithing
	Ba = Armorsmith
	Bw = Weaponsmith
	Bws = Master Swordsmith
	Bwh = Master Hammersmith
	Bwx = Master Axesmith
	N = Enchanting
	E = Engineering
	Eg = Gnomish Engineer
	Eb = Goblin Engineer
	J = Jewelcrafting
	L = Leatherworking
	Ld = Dragonscale Leatherworking
	Le = Elemental Leatherworking
	Lt = Tribal Leatherworking
	T = Tailoting
	C = Cooking
	X = First Aid
	P = Poisons
	M = Mining
	# = level
components =
  itemid[:num] ...
recipe = recipeid (Optional)
yield = how many the combine makes (Optional)
itemid = itemid crafted if it differs from index (Optional)

Components
[itemid] = "cost/source"
Name
Cost (sell value for all except vendor, where it is buy value) per item
Source
	V = Vendor (Only items with unlimited supply)
	D = Dropped
	C = Crafted
	M = Mined
	H = Herbalism
	S = Skinned
	F = Fished
	E = Disenchanted
	G = Gathered (No skill required)
	P = Pickpocketed

Enchants
[-enchantid]name/description

Zones
[index]name

Vendors
[index]name|zone|faction|location|comment

Recipes
[recipeid]#|source|price|level
# = combine id
source
	D = Drop
	V = Vendor
	Q = Quest
	# index to table vendors
Price = Vendor sell price (Optional)
Level = faction rank needed (Optional)

]]

if not TradeskillInfo or not TradeskillInfo.vars then return end

TradeskillInfo.vars.difficultyLevel = {
	['trivial'] = 1,
	['easy'] = 2,
	['medium'] = 3,
	['optimal'] = 4,
}


TradeskillInfo.vars.diffcolors = {
	[1] = '|cff777777',
	[2] = '|cff33bb33',
	[3] = '|cffffff00',
	[4] = '|cffff7733',
	[5] = '|cffffffff',
}


TradeskillInfo.vars.specialcases = {
	[3577] = "1,2",
	[1] = "3577",
  	[2] = "3577",
	[6037] = "3,4",
	[3] = "6037",
	[4] = "6037",
	[7080] = "5,6",
	[5] = "7080",
	[6] = "7080",
	[7076] = "7,8",
	[7] = "7076",
	[8] = "7076",
	[21884] = "9,10",
	[9] = "21884",
	[10] = "21884",
	[21885] = "11,12",
	[11] = "21885",
	[12] = "21885",
	[22452] = "13,14",
	[13] = "22452",
	[14] = "22452",
	[10577] = "15,16",
	[15] = "10577",
	[16] = "10577",
	[18258] = "17,18",
	[17] = "18258",
	[18] = "18258",
	[22448] = "19,20",
	[19] = "22448",
	[20] = "22448",
	[22449] = "21,22",
	[21] = "22449",
	[22] = "22449",
	[35624] = "23,24",
	[23] = "35624",
	[24] = "35624",
	[35622] = "25,26",
	[25] = "35622",
	[26] = "35622",
	[35623] = "27,28",
	[27] = "35623",
	[28] = "35623",
	[35627] = "29,30",
	[29] = "35627",
	[30] = "35627",
	[35625] = "31,32",
	[31] = "35625",
	[32] = "35625",
	[36860] = "33,34",
	[33] = "36860",
	[34] = "36860",
	[41163] = "35,36",
	[35] = "41163",
	[36] = "41163",
	[44680] = "37,38",
	[37] = "44680",
	[38] = "44680"
}

TradeskillInfo.vars.combines = {
--[[ Alchemy --]]
	[2454] = "2329|A1/55/75/95|2449 765 3371",	-- Elixir of Lion's Strength
	[5997] = "7183|A1/55/75/95|765:2 3371",	-- Elixir of Minor Defense
	[118] = "2330|A1/55/75/95|2447 765 3371",	-- Minor Healing Potion
	[3382] = "3170|A15/60/80/100|2447 2449:2 3371",	-- Weak Troll's Blood Potion
	[2455] = "2331|A25/65/85/105|785 765 3371",	-- Minor Mana Potion
	[2456] = "2332|A40/70/90/110|785:2 2447 3371",	-- Minor Rejuvenation Potion
	[4596] = "4508|A50/80/100/120|3164 2447 3371|4597",	-- Discolored Healing Potion
	[2457] = "3230|A50/80/100/120|2452 765 3371|2553",	-- Elixir of Minor Agility
	[2458] = "2334|A50/80/100/120|2449:2 2447 3371",	-- Elixir of Minor Fortitude
	[858] = "2337|A55/85/105/125|118 2450",	-- Lesser Healing Potion
	[5631] = "6617|A60/90/110/130|5635:2 3371|5640",	-- Rage Potion
	[2459] = "2335|A60/90/110/130|2452 2450 3371|2555",	-- Swiftness Potion
	[6370] = "7836|A80/80/90/100|6358:2 3371",	-- Blackmouth Oil
	[6662] = "8240|A90/120/140/160|6522 2449 3371|6663",	-- Elixir of Giant Growth
	[5996] = "7179|A90/120/140/160|3820 6370:2 3371",	-- Elixir of Water Breathing
	[3383] = "3171|A90/120/140/160|785 2450:2 3371",	-- Elixir of Wisdom
	[6051] = "7255|A100/130/150/170|2453 2452 3371|6053",	-- Holy Protection Potion
	[6372] = "7841|A100/130/150/170|2452 6370 3371",	-- Swim Speed Potion
	[929] = "3447|A110/135/155/175|2453 2450 3372",	-- Healing Potion
	[3384] = "3172|A110/135/155/175|785:3 3355 3371|3393",	-- Minor Magic Resistance Potion
	[3385] = "3173|A120/145/165/185|785 3820 3371",	-- Lesser Mana Potion
	[3386] = "3174|A120/145/165/185|1288 2453 3372|3394||3386",	-- Potion of Curing
	[3388] = "3176|A125/150/170/190|2453:2 2450:2 3372",	-- Strong Troll's Blood Potion
	[3389] = "3177|A130/155/175/195|3355 3820 3372",	-- Elixir of Defense
	[6371] = "7837|A130/150/160/170|6359:2 3371",	-- Fire Oil
	[6048] = "7256|A135/160/180/200|3369 3356 3372|6054",	-- Shadow Protection Potion
	[6373] = "7845|A140/165/185/205|6371:2 3356 3372",	-- Elixir of Firepower
	[3390] = "2333|A140/165/185/205|3355 2452 3372|3396",	-- Elixir of Lesser Agility
	[3391] = "3188|A150/175/195/215|2449 3356 3372|6211",	-- Elixir of Ogre's Strength
	[5634] = "6624|A150/175/195/215|6370:2 3820 3372|5642",	-- Free Action Potion
	[1710] = "7181|A155/175/195/215|3357 3356 3372",	-- Greater Healing Potion
	[3827] = "3452|A160/180/200/220|3820 3356 3372",	-- Mana Potion
	[3824] = "3449|A165/190/210/230|3818:4 3369:4 3372|6068",	-- Shadow Oil
	[6049] = "7257|A165/210/230/250|4402 6371 3372|6055",	-- Fire Protection Potion
	[3823] = "3448|A165/185/205/225|3818 3355 3372",	-- Lesser Invisibility Potion
	[3826] = "3451|A180/200/220/240|3357 2453 3372|3831",	-- Mighty Troll's Blood Potion
	[3825] = "3450|A175/195/215/235|3355 3821 3372|3830",	-- Elixir of Fortitude
	[5633] = "6618|A175/195/215/235|5637 3356 3372|5643",	-- Great Rage Potion
	[8949] = "11449|A185/205/225/245|3820 3821 3372",	-- Elixir of Agility
	[17708] = "21923|A190/210/230/250|3819:2 3358 3372|17709",	-- Elixir of Frost Power
	[3829] = "3454|A200/220/240/260|3358:4 3819:2 3372|14634",	-- Frost Oil
	[6050] = "7258|A190/205/225/245|3819 3821 3372|6056",	-- Frost Protection Potion
	[6052] = "7259|A190/210/230/250|3357 3820 3372|6057",	-- Nature Protection Potion
	[3828] = "3453|A195/215/235/255|3358 3818 3372|3832",	-- Elixir of Detect Lesser Invisibility
	[8951] = "11450|A195/215/235/255|3355 3821 3372",	-- Elixir of Greater Defense
	[9061] = "11456|A210/225/245/265|4625 9260 3372|10644",	-- Goblin Rocket Fuel
	[10592] = "12609|A200/220/240/260|3821 3818 3372",	-- Catseye Elixir
	[6149] = "11448|A205/220/240/260|3358 3821 3372",	-- Greater Mana Potion
	[8956] = "11451|A205/220/240/260|4625 3821 8925",	-- Oil of Immolation
	[1] = "11479|A225/240/260/280|3575|9304||3577",	-- Transmute: Iron to Gold
	[3] = "11480|A225/240/260/280|3860|9305||6037",	-- Transmute: Mithril to Truesilver
	[9036] = "11453|A210/225/245/265|3358 8831 8925|9293",	-- Magic Resistance Potion
	[9149] = "11459|A225/240/260/280|3575:4 9262 8831:4 4625:4|9303",	-- Philosopher's Stone
	[18294] = "22808|A215/230/250/270|7972 8831:2 8925",	-- Elixir of Greater Water Breathing
	[4623] = "4942|A215/230/250/270|3858 3821 3372|4624",	-- Lesser Stoneshield Potion
	[3928] = "11457|A215/230/250/270|8838 3358 8925",	-- Superior Healing Potion
	[9144] = "11458|A225/240/260/280|8153 8831 8925|9294",	-- Wildvine Potion
	[12190] = "15833|A230/245/265/285|8831:3 8925",	-- Dreamless Sleep Potion
	[9154] = "11460|A230/245/265/285|8836 8925",	-- Elixir of Detect Undead
	[9210] = "11473|A245/260/280/300|8845:2 4342 8925|9302",	-- Ghost Dye
	[9155] = "11461|A235/250/270/290|8839 3821 8925",	-- Arcane Elixir
	[9179] = "11465|A235/250/270/290|8839 3358 8925",	-- Elixir of Greater Intellect
	[9264] = "11476|A250/265/285/305|8845:3 8925|9301",	-- Elixir of Shadow Power
	[9172] = "11464|A235/250/270/290|8845 8838 8925|9295",	-- Invisibility Potion
	[9197] = "11468|A240/255/275/295|8831:3 8925|9297",	-- Elixir of Dream Vision
	[9187] = "11467|A240/255/275/295|8838 3821 8925",	-- Elixir of Greater Agility
	[9088] = "11466|A240/255/275/295|8836 8839 8925|9296",	-- Gift of Arthas
	[9206] = "11472|A245/260/280/300|8838 8846 8925|9298",	-- Elixir of Giants
	[9224] = "11477|A250/265/285/305|8846 8845 8925|9300",	-- Elixir of Demonslaying
	[9233] = "11478|A250/265/285/305|8846:2 8925",	-- Elixir of Detect Demon
	[21546] = "26277|A250/265/285/305|6371:3 4625:3 8925|21547",	-- Elixir of Greater Firepower
	[3387] = "3175|A250/275/295/315|8839:2 8845 8925|3395",	-- Limited Invulnerability Potion
	[13423] = "17551|A250/250/255/260|13422 3372",	-- Stonescale Oil
	[13442] = "17552|A255/270/290/310|8846:3 8925|13476",	-- Mighty Rage Potion
	[13443] = "17553|A260/275/295/315|8838:2 8839:2 8925|13477",	-- Superior Mana Potion
	[13445] = "17554|A265/280/300/320|13423:2 8838 8925|13478",	-- Elixir of Superior Defense
	[13447] = "17555|A270/285/305/325|13463 13466:2 8925|13479",	-- Elixir of the Sages
	[7078] = "17559|A275/275/282/290|7082|13482||7078",	-- Transmute: Air to Fire
	[12360] = "17187|A275/275/282/290|12359 12363|12958||12360",	-- Transmute: Arcanite
	[12803] = "17566|A275/275/282/290|7076|13489||12803",	-- Transmute: Earth to Life
	[5] = "17561|A275/275/282/290|7076|13484||7080",	-- Transmute: Earth to Water
	[6] = "17563|A275/275/282/290|12808|13486||7080",	-- Transmute: Undeath to Water
	[7] = "17560|A275/275/282/290|7078|13483||7076",	-- Transmute: Fire to Earth
	[8] = "17565|A275/275/282/290|12803|13488||7076",	-- Transmute: Life to Earth
	[7082] = "17562|A275/275/282/290|7080|13485||7082",	-- Transmute: Water to Air
	[12808] = "17564|A275/275/282/290|7080|13487||12808",	-- Transmute: Water to Undeath
	[13453] = "17557|A275/290/310/330|8846:2 13466:2 8925|13481",	-- Elixir of Brute Force
	[20002] = "24366|A275/290/310/330|13463:2 13464 8925|20012",	-- Greater Dreamless Sleep Potion
	[20007] = "24365|A275/290/310/330|13463 13466:2 8925|20011",	-- Mageblood Potion
	[13446] = "17556|A275/290/310/330|13464:2 13465 8925|13480",	-- Major Healing Potion
	[13452] = "17571|A280/295/315/335|13465:2 13466:2 8925|13491",	-- Elixir of the Mongoose
	[13455] = "17570|A280/295/315/335|13423:2 10620 8925|13490",	-- Greater Stoneshield Potion
	[13454] = "17573|A285/300/320/340|13463:3 13465 8925|13493",	-- Greater Arcane Elixir
	[20008] = "24367|A285/300/320/340|13467:2 13465:2 10286:2 8925|20013",	-- Living Action Potion
	[13462] = "17572|A285/300/320/340|13467:2 13466:2 8925|13492",	-- Purification Potion
	[9030] = "11452|A285/225/245/265|7067 3821 8925",	-- Restorative Potion
	[13461] = "17577|A290/305/325/345|11176 13463 8925|13497",	-- Greater Arcane Protection Potion
	[13457] = "17574|A290/305/325/345|7068 13463 8925|13494",	-- Greater Fire Protection Potion
	[13456] = "17575|A290/305/325/345|7070 13463 8925|13495",	-- Greater Frost Protection Potion
	[13458] = "17576|A290/305/325/345|7067 13463 8925|13496",	-- Greater Nature Protection Potion
	[13459] = "17578|A290/305/325/345|3824 13463 8925|13499",	-- Greater Shadow Protection Potion
	[20004] = "24368|A290/305/325/345|8846 13466:2 8925|20014",	-- Major Troll's Blood Potion
	[13444] = "17580|A295/310/330/350|13463:3 13467:2 8925|13501",	-- Major Mana Potion
	[19931] = "24266|A300/315/322/330|12938 19943 12804:6 13468||3",	-- Gurubashi Mojo Madness
	[28103] = "33740|A300/315/322/330|13463 22785 18256",	-- Adept's Elixir
	[13513] = "17638|A300/315/322/330|13467:7 13465:3 13468 8925|13522",	-- Flask of Chromatic Resistance
	[13511] = "17636|A300/315/322/330|13463:7 13467:3 13468 8925|13520",	-- Flask of Distilled Wisdom
	[13506] = "17634|A300/315/322/330|13423:7 13465:3 13468 8925|13518",	-- Flask of Petrification
	[13512] = "17637|A300/315/322/330|13463:7 13465:3 13468 8925|13521",	-- Flask of Supreme Power
	[13510] = "17635|A300/315/322/330|8846:7 13423:3 13468 8925|13519",	-- Flask of the Titans
	[18253] = "22732|A300/310/320/330|10286 13464:4 13463:4 18256|18257",	-- Major Rejuvenation Potion
	[28102] = "33738|A300/315/322/330|13465 22785 18256",	-- Onslaught Elixir
	[7068] = "25146|A300/301/305/310|7077|20761|3|7068",	-- Transmute: Elemental Fire
	[28100] = "33732|A300/315/322/330|13464 22785 18256",	-- Volatile Healing Potion
	[22823] = "28543|A305/320/327/335|22787 22785 18256|22900",	-- Elixir of Camouflage
	[22824] = "28544|A305/320/327/335|13465 22785 18256",	-- Elixir of Major Strength
	[22825] = "28545|A310/325/332/340|13464 22786 18256",	-- Elixir of Healing Power
	[32062] = "39636|A310/325/332/340|22787:2 22785 18256",	-- Elixir of Major Fortitude
	[28101] = "33733|A310/325/332/340|22787:2 22785 18256",	-- Unstable Mana Potion
	[28104] = "33741|A315/330/337/345|22789:3 22785 18256",	-- Elixir of Mastery
	[22826] = "28546|A315/330/337/345|22787:2 22785 18256|22901",	-- Sneaking Potion
	[34440] = "45061|A325/335/342/350|22787:2 8925", -- Mad Alchemist's Potion
	[32063] = "39637|A320/335/342/350|22786 22787:2 18256|32070",	-- Earthen Elixir
	[32067] = "39638|A320/335/342/350|22785 22789 18256",	-- Elixir of Draenic Wisdom
	[22827] = "28549|A320/335/342/350|22578:2 22790 18256|22902",	-- Elixir of Major Frost Power
	[22828] = "28550|A320/335/342/350|22789:3 18256|22903",	-- Insane Strength Potion
	[31080] = "38070|A325/340/347/355|22452 21886 22457",	-- Mercurial Stone
	[22830] = "28552|A325/340/347/355|22787:2 22789 18256|22904",	-- Elixir of the Searching Eye
	[22829] = "28551|A325/340/347/355|22791:2 22785 18256",	-- Super Healing Potion
	[32068] = "39639|A330/345/352/360|22790 22787 18256|32071",	-- Elixir of Ironskin
	[22831] = "28553|A330/345/352/360|22789 22785:2 18256|22905",	-- Elixir of Major Agility
	[31679] = "38960|A335/350/357/365|22789 22792:2 18256|31680",	-- Fel Strength Elixir
	[22871] = "28554|A335/350/357/365|22787:3 22791 18256|22906",	-- Shrouding Potion
	[22832] = "28555|A340/355/362/370|22786:2 22785 18256|22907",	-- Super Mana Potion
	[22834] = "28557|A345/360/367/375|22790:3 22789 18256|22909",	-- Elixir of Major Defense
	[22833] = "28556|A345/360/367/375|22574:2 22790 18256|22908",	-- Elixir of Major Firepower
	[31676] = "38962|A345/360/367/375|22785:2 22792:3 18256|31681",	-- Fel Regeneration Potion
	[13503] = "17632|A350/365/372/380|9149 25867 25868 22794:2 23571:5|13517",	-- Alchemist's Stone
	[25867] = "32765|A350|23079:3 23107:3 23112:3 22452:2 21885:2|25869||25867",	-- Transmute: Earthstorm Diamond
	[23571] = "29688|A350/365/372/380|22452 21885 22451 21884 22457|23574||23571",	-- Transmute: Primal Might
	[25868] = "32766|A350|23077:3 21929:3 23117:3 21884:2 22451:2|29232||25868",	-- Transmute: Skyfire Diamond
	[9] = "28566|A350/365/372/380|22451|22915||21884",	-- Transmute: Primal Air to Fire
	[10] = "28582|A375/375/377/380|22457|||21884",	-- Transmute: Primal Mana to Fire
	[11] = "28567|A350/365/372/380|22452|22916||21885",	-- Transmute: Primal Earth to Water
	[13] = "28568|A350/365/372/380|21884|30443||22452",	-- Transmute: Primal Fire to Earth
	[22451] = "28569|A350/365/372/380|21885|22918||22451",	-- Transmute: Primal Water to Air
	[22839] = "28565|A350/365/372/380|22792:2 22791 18256|22914",	-- Destruction Potion
	[22835] = "28558|A350/365/372/380|22790 22792 18256|22910",	-- Elixir of Major Shadow Power
	[22838] = "28564|A350/365/372/380|22789:2 22791 18256|22913",	-- Haste Potion -- also 35295
	[22837] = "28563|A350/365/372/380|22789:2 22790 18256|22912",	-- Heroic Potion
	[22836] = "28562|A350/365/372/380|22786 22792 18256|22911",	-- Major Dreamless Sleep Potion
	[22840] = "28570|A355/370/375/380|22790 22791 18256|22919",	-- Elixir of Major Mageblood
	[31677] = "38961|A360/375/377/380|22793 22792:2 18256|31682",	-- Fel Mana Potion
	[22861] = "28590|A360/375/377/380|22794 22793:3 22791:7 18256|||22861",	-- Flask of Blinding Light
	[22851] = "28587|A360/375/377/380|22794 22793:3 22790:7 18256",	-- Flask of Fortification
	[22853] = "28588|A360/375/377/380|22794 22793:3 22786:7 18256",	-- Flask of Mighty Restoration
	[22866] = "28591|A360/375/377/380|22794 22793:3 22792:7 18256|||22866",	-- Flask of Pure Death
	[22854] = "28589|A360/375/377/380|22794 22793:3 22789:7 18256",	-- Flask of Relentless Assault
	[22845] = "28575|A360/375/377/380|22457 22793:3 18256:5|22923|5",	-- Major Arcane Protection Potion
	[22841] = "28571|A360/375/377/380|21884 22793:3 18256:5|22920|5",	-- Major Fire Protection Potion
	[22842] = "28572|A360/375/377/380|21885 22793:3 18256:5|22921|5",	-- Major Frost Protection Potion
	[22847] = "28577|A360/375/377/380|21886 22793:3 18256:5|22925|5",	-- Major Holy Protection Potion
	[22844] = "28573|A360/375/377/380|21886 22793:3 18256:5|22922|5",	-- Major Nature Protection Potion
	[22846] = "28576|A360/375/377/380|22456 22793:3 18256:5|22924|5",	-- Major Shadow Protection Potion
	[22850] = "28586|A360/375/377/380|22793:2 22786 22791 18256",	-- Super Rejuvenation Potion
	[22848] = "28578|A365/375/377/380|22791 22793 18256|22926",	-- Elixir of Empowerment -- also 35294
	[22849] = "28579|A365/375/377/380|22790:2 22573:3 18256|22927",	-- Ironshield Potion
	[21886] = "28585|A375/375/377/380|22452",	-- Transmute: Primal Earth to Life
	[22457] = "28583|A375/375/377/380|21884",	-- Transmute: Primal Fire to Mana
	[14] = "28584|A375/375/377/380|21886|||22452",	-- Transmute: Primal Life to Earth
	[12] = "28580|A375/375/377/380|22456|||21885",	-- Transmute: Primal Shadow to Water
	[22456] = "28581|A375/375/377/380|21885",	-- Transmute: Primal Water to Shadow
	[32839] = "41458|A375/360/370/380|22457:2 22793:7 23782",	-- Cauldron of Major Arcane Protection
	[32849] = "41500|A375/360/370/380|21884:2 22793:7 23782",	-- Cauldron of Major Fire Protection
	[32850] = "41501|A375/360/370/380|21885:2 22793:7 23782",	-- Cauldron of Major Frost Protection
	[32851] = "41502|A375/360/370/380|21886:2 22793:7 23782",	-- Cauldron of Major Nature Protection
	[32852] = "41503|A375/360/370/380|22456:2 22793:7 23782",	-- Cauldron of Major Shadow Protection
	[33208] = "42736|A375/390/397/405|22786:7 22791:3 22794 18256|33209", --Flask of Chromatic Wonder
--[[ Blacksmithing --]]
	[2853] = "2663|B1/20/40/60|2840:2",	-- Copper Bracers
	[2852] = "2662|B1/50/70/90|2840:4",	-- Copper Chain Pants
	[10421] = "12260|B1/15/35/55|2840:4",	-- Rough Copper Vest
	[2862] = "2660|B1/15/35/55|2835",	-- Rough Sharpening Stone
	[3239] = "3115|B1/15/35/55|2835 2589",	-- Rough Weightstone
	[2844] = "2737|B15/55/75/95|2840:6 2880 2589:2",	-- Copper Mace
	[2845] = "2738|B20/60/80/100|2840:6 2880 2589:2",	-- Copper Axe
	[3469] = "3319|B20/60/80/100|2840:8",	-- Copper Chain Boots
	[2847] = "2739|B25/65/85/105|2840:6 2880 2589:2",	-- Copper Shortsword
	[3470] = "3320|B25/45/65/85|2835:2",	-- Rough Grinding Stone
	[7955] = "9983|B30/70/90/110|2840:10 2880:2 3470 2318",	-- Copper Claymore
	[7166] = "8880|B30/70/90/110|2840:6 2880 3470 2318",	-- Copper Dagger
	[33791] = "43549|B35/75/95/115|2840:10 818 3470:2|33792", -- Heavy Copper Longsword
	[3488] = "3293|B35/75/95/115|2840:12 2880:2 774:2 3470:2 2318:2",	-- Copper Battle Axe
	[3471] = "3321|B35/75/95/115|2840:8 3470:2|3609",	-- Copper Chain Vest
	[2851] = "2661|B35/75/95/115|2840:6",	-- Copper Chain Belt
	[3472] = "3323|B40/80/100/120|2840:8 3470:2",	-- Runed Copper Gauntlets
	[3473] = "3324|B45/85/105/125|2840:8 2321:2 3470:3",	-- Runed Copper Pants
	[3474] = "3325|B60/100/120/140|2840:8 818 774|3610",	-- Gemmed Copper Gauntlets
	[2863] = "2665|B65/65/72/80|2836",	-- Coarse Sharpening Stone
	[3240] = "3116|B65/65/72/80|2836 2592",	-- Coarse Weightstone
	[6214] = "7408|B65/105/125/145|2840:12 2880:2 2318:2",	-- Heavy Copper Maul
	[3489] = "3294|B70/110/130/150|2840:10 2880:2 2842:2 3470:2 2318:2",	-- Thick War Axe
	[2857] = "2666|B70/110/130/150|2840:10",	-- Runed Copper Belt
	[3478] = "3326|B75/75/87/100|2836:2",	-- Coarse Grinding Stone
	[2864] = "2667|B80/120/140/160|2840:12 1210 3470:2|2881",	-- Runed Copper Breastplate
	[2854] = "2664|B90/115/127/140|2840:10 3470:3",	-- Runed Copper Bracers
	[3487] = "3292|B95/135/155/175|2840:14 2880:2 818:2 2319:2",	-- Heavy Copper Broadsword
	[6350] = "7817|B95/125/140/155|2841:6 3470:6",	-- Rough Bronze Boots
	[6731] = "8367|B100/140/160/180|2840:16 818:2 3470:3|6735",	-- Ironforge Breastplate
	[15869] = "19666|B100/100/110/120|2842 3470||2",	-- Silver Skeleton Key
	[29201] = "34979|B100/130/145/160|2841:6 3470:2 2319",	-- Thick Bronze Darts
	[6338] = "7818|B100/105/107/110|2842 3470:2",	-- Silver Rod
	[3848] = "3491|B105/135/150/165|2841:6 2880:4 3470:2 818 2319",	-- Big Bronze Knife
	[2865] = "2668|B105/145/160/175|2841:6",	-- Rough Bronze Leggings
	[2866] = "2670|B105/145/160/175|2841:7",	-- Rough Bronze Cuirass
	[2848] = "2740|B110/140/155/170|2841:6 2880:4 2319",	-- Bronze Mace
	[3480] = "3328|B110/140/155/170|2841:5 3478",	-- Rough Bronze Shoulders
	[5540] = "6517|B110/140/155/170|2841:6 3466 5498:2 3478:2",	-- Pearl-handled Dagger
	[2849] = "2741|B115/145/160/175|2841:7 2880:4 2319",	-- Bronze Axe
	[2868] = "2672|B120/150/165/180|2841:5 3478:2",	-- Patterned Bronze Bracers
	[2850] = "2742|B120/150/165/180|2841:5 2880:4 2319:2",	-- Bronze Shortsword
	[3490] = "3295|B125/155/170/185|2841:4 3466 2459 1210:2 3478:2 2319:2|2883",	-- Deadly Bronze Poniard
	[3481] = "3330|B125/155/170/185|2841:8 2842:2 3478:2|2882",	-- Silvered Bronze Shoulders
	[7956] = "9985|B125/155/170/185|2841:8 3466 2319",	-- Bronze Warhammer
	[3486] = "3337|B125/125/137/150|2838:3",	-- Heavy Grinding Stone
	[2871] = "2674|B125/125/132/140|2838",	-- Heavy Sharpening Stone
	[3241] = "3117|B125/125/132/140|2838 2592",	-- Heavy Weightstone
	[3491] = "3296|B130/160/175/190|2841:8 3466 1206 1210 3478:2 2319:2",	-- Heavy Bronze Mace
	[3482] = "3331|B130/160/175/190|2841:6 2842 3478:2",	-- Silvered Bronze Boots
	[2869] = "2673|B130/160/175/190|2841:10 2842:2 3478:2|5578",	-- Silvered Bronze Breastplate
	[7957] = "9986|B130/160/175/190|2841:12 3466:2 2319:2",	-- Bronze Greatsword
	[3483] = "3333|B135/165/180/195|2841:8 2842 3478:2",	-- Silvered Bronze Gauntlets
	[7958] = "9987|B135/165/180/195|2841:14 3466 2319:2",	-- Bronze Battle Axe
	[5541] = "6518|B140/170/185/200|2841:10 3466 5500 3478:2 2319:2|5543",	-- Iridescent Hammer
	[2870] = "2675|B145/175/190/205|2841:20 1206:2 1705:2 5500:2 2842:4",	-- Shining Silver Breastplate
	[3484] = "3334|B145/175/190/205|3575:6 3478:2 2605|3611",	-- Green Iron Boots
	[3492] = "3297|B145/175/190/205|3575:6 3466:2 3391 1705:2 3478:2 2319:2|3608",	-- Mighty Iron Hammer
	[15870] = "19667|B150/150/160/170|3577 3486||2",	-- Golden Skeleton Key
	[3485] = "3336|B150/180/195/210|3575:4 5498:2 3478:2 2605|3612",	-- Green Iron Gauntlets
	[3851] = "3494|B155/180/192/205|3575:8 3466:2 3486 2842:4 4234:2|10858",	-- Solid Iron Maul
	[11128] = "14379|B150/155/157/160|3577 3478:2",	-- Golden Rod
	[7071] = "8768|B150/150/152/155|3575||2",	-- Iron Buckle
	[6042] = "7221|B150/180/195/210|3575:6 3478:4|6044",	-- Iron Shield Spike
	[7914] = "9813|B160/185/197/210|3575:20 3486:4|7979",	-- Barbaric Iron Breastplate
	[3842] = "3506|B155/180/192/205|3575:8 3486 2605",	-- Green Iron Leggings
	[3849] = "3492|B160/185/197/210|3575:6 3466:2 3486 1705:2 4234:3|12162",	-- Hardened Iron Shortsword
	[10423] = "12259|B155/180/192/205|2841:12 2842:4 3478:2|10424",	-- Silvered Bronze Leggings
	[7913] = "9811|B160/185/197/210|3575:8 5635:4 3486:2|7978",	-- Barbaric Iron Shoulders
	[3840] = "3504|B160/185/197/210|3575:7 3486 2605|3870",	-- Green Iron Shoulders
	[3835] = "3501|B165/190/202/215|3575:6 2605",	-- Green Iron Bracers
	[6043] = "7222|B165/190/202/215|3575:4 3478:2 1705|6045",	-- Iron Counterweight
	[3852] = "3495|B170/195/207/220|3575:10 3577:4 1705:2 3466:2 4234:2 3486:2|3867",	-- Golden Iron Destroyer
	[3843] = "3507|B170/195/207/220|3575:10 3577:2 3486|3872",	-- Golden Scale Leggings
	[3836] = "3502|B170/195/207/220|3575:12 3864 2605",	-- Green Iron Helm
	[7915] = "9814|B175/200/212/225|3575:10 5637:2 5635:2|7980",	-- Barbaric Iron Helm
	[3841] = "3505|B175/200/212/225|3859:6 3577:2 3486|3871",	-- Golden Scale Shoulders
	[3850] = "3493|B175/200/212/225|3575:8 3466:2 3486:2 1529:2 4234:3|3866",	-- Jade Serpentblade
	[3853] = "3496|B180/205/217/230|3859:8 3466:2 3486:2 1705:3 4234:3|12163",	-- Moonsteel Broadsword
	[3844] = "3508|B180/205/217/230|3575:20 3486:4 1529:2 1206:2 4255",	-- Green Iron Hauberk
	[7916] = "9818|B180/205/217/230|3575:12 5637:4 3486:2|7981",	-- Barbaric Iron Boots
	[12259] = "15972|B180/205/217/230|3859:10 3466:2 1206 7067 4234",	-- Glinting Steel Dagger
	[3855] = "3498|B185/210/222/235|3575:14 3466:2 3486:2 3577:4 4234:2|12164",	-- Massive Iron Axe
	[7917] = "9820|B185/210/222/235|3575:14 3486:3 5637:2|7982",	-- Barbaric Iron Gloves
	[3846] = "3513|B185/210/222/235|3859:8 3864 1705 3486:2|3874",	-- Polished Steel Boots
	[6040] = "7223|B185/210/222/235|3859:5 3486:2",	-- Golden Scale Bracers
	[17704] = "21913|B190/215/227/240|3859:10 3829 7070:2 7069:2 4234:2|17706",	-- Edge of Winter
	[3837] = "3503|B190/215/227/240|3859:8 3577:2 3486:2|6047",	-- Golden Scale Coif
	[12260] = "15973|B190/215/227/240|3859:10 3577:4 7068:2 4234:2|12261",	-- Searing Golden Blade
	[6041] = "7224|B190/215/227/240|3859:8 3486:2 4234:4|6046",	-- Steel Weapon Chain
	[3845] = "3511|B195/220/232/245|3859:12 3577:2 3486:4|3873",	-- Golden Scale Cuirass
	[3854] = "3497|B200/225/237/250|3859:8 3466:2 3486:2 1529:2 3829 4234:4|3868",	-- Frost Tiger Blade
	[3847] = "3515|B200/225/237/250|3859:10 3577:4 3486:4|3875",	-- Golden Scale Boots
	[3856] = "3500|B200/225/237/250|3859:10 3466:2 3486:3 3864:2 3824 4234:3|3869",	-- Shadow Crescent Axe
	[7963] = "9916|B200/225/237/250|3859:16 3486:3",	-- Steel Breastplate
	[15871] = "19668|B200/200/210/220|6037 7966||2",	-- Truesilver Skeleton Key
	[29202] = "34981|B200/220/230/240|3859:5 7069:2 3486:2 4234",	-- Whirling Steel Axes
	[9060] = "11454|B200/225/237/250|3860:5 3577 6037|10713",	-- Inlaid Mithril Cylinder
	[7966] = "9920|B200/200/205/210|7912:4",	-- Solid Grinding Stone
	[7964] = "9918|B200/200/205/210|7912",	-- Solid Sharpening Stone
	[7965] = "9921|B200/200/205/210|7912 4306",	-- Solid Weightstone
	[11144] = "14380|B200/205/207/210|6037 3486",	-- Truesilver Rod
	[9366] = "11643|B205/225/235/245|3859:10 3577:4 3486:4|9367",	-- Golden Scale Gauntlets
	[7919] = "9928|B205/225/235/245|3860:6 4338:4",	-- Heavy Mithril Gauntlet
	[7918] = "9926|B205/225/235/245|3860:8 4234:6",	-- Heavy Mithril Shoulder
	[7941] = "9993|B210/235/247/260|3860:12 3864:2 7966 4234:4",	-- Heavy Mithril Axe
	[7921] = "9933|B210/230/240/250|3860:10|7975",	-- Heavy Mithril Pants
	[7920] = "9931|B210/230/240/250|3860:12",	-- Mithril Scale Pants
	[7924] = "9937|B215/235/245/255|3860:8|7995",	-- Mithril Scale Bracers
	[7967] = "9939|B215/235/245/255|3860:4 6037:2 7966:4|7976",	-- Mithril Shield Spike
	[7922] = "9935|B215/235/245/255|3859:14 7966",	-- Steel Plate Helm
	[7942] = "9995|B220/245/257/270|3860:16 7909:2 7966 4304:4|7992",	-- Blue Glittering Axe
	[7927] = "9950|B220/240/250/260|3860:10 4338:6 6037 7966|7984",	-- Ornate Mithril Gloves
	[7926] = "9945|B220/240/250/260|3860:12 6037 7966|7983",	-- Ornate Mithril Pants
	[7936] = "9979|B220/265/275/285|3860:14 6037:2 4304:4 7966 7909",	-- Ornate Mithril Boots
	[7935] = "9972|B220/260/270/280|3860:16 6037:6 7077 7966",	-- Ornate Mithril Breastplate
	[7937] = "9980|B220/265/275/285|3860:16 6037:2 7966",	-- Ornate Mithril Helm
	[7938] = "9954|B225/245/255/265|3860:10 6037:8 7909:3 3864:3 5966 7966:2",	-- Truesilver Gauntlets, removed armorsmith requirement
	[7928] = "9952|B225/245/255/265|3860:12 6037 4304:6|7985",	-- Ornate Mithril Shoulder
	[7943] = "9997|B225/250/262/275|3860:14 6037:4 7966 4304:2|8029",	-- Wicked Mithril Blade
	[7945] = "10001|B230/255/267/280|3860:16 7971 1210:4 7966 4304:2",	-- Big Black Mace
	[7930] = "9959|B230/250/260/270|3860:16",	-- Heavy Mithril Breastplate
	[7931] = "9961|B230/250/260/270|3860:10 4338:6",	-- Mithril Coif
	[7933] = "9968|B235/255/265/275|3860:14 4304:4",	-- Heavy Mithril Boots
	[7932] = "9966|B235/255/265/275|3860:14 4304:4|7991",	-- Mithril Scale Shoulders
	[7954] = "10003|B235/260/272/285|3860:24 7075:4 6037:6 3864:5 1529:5 7966:4 4304:4",	-- The Shatterer, removed weaponsmith requirement
	[7969] = "9964|B235/255/265/275|3860:4 7966:3|7989",	-- Mithril Spurs
	[7944] = "10005|B240/265/277/290|3860:14 7909 1705:2 1206:2 7966 4338:2|7993",	-- Dazzling Mithril Rapier
	[7934] = "9970|B245/255/265/275|3860:14 7909|7990",	-- Heavy Mithril Helm
	[7946] = "10009|B245/270/282/295|3860:18 7075:2 7966 4304:4|8028",	-- Runed Mithril Hammer
	[7939] = "9974|B245/265/275/285|3860:12 6037:12 7910:2 7971:2 7966:2",	-- Truesilver Breastplate, removed armorsmith requirement
	[7961] = "10007|B245/270/282/295|3860:28 7081:6 6037:8 3823:2 7909:6 7966:4 4304:2",	-- Phantom Blade, removed weaponsmith requirement
	[7959] = "10011|B250/275/287/300|3860:28 7972:10 6037:10 7966:6 4304:6",	-- Blight, removed weaponsmith requirement
	[12405] = "16642|B250/270/280/290|12359:16 12361|12682",	-- Thorium Armor
	[12406] = "16643|B250/270/280/290|12359:8|12683",	-- Thorium Belt
	[12644] = "16639|B250/255/257/260|12365:4",	-- Dense Grinding Stone
	[12404] = "16641|B250/255/257/260|12365",	-- Dense Sharpening Stone
	[12643] = "16640|B250/255/257/260|12365 14047",	-- Dense Weightstone
	[7947] = "10013|B255/280/292/305|3860:12 6037:6 7910:2 7966 4304:2|8030",	-- Ebon Shiv
	[12408] = "16644|B255/275/285/295|12359:8|12684",	-- Thorium Bracers
	[11606] = "15293|B270/290/300/310|11371:10 7077:2|11614",	-- Dark Iron Mail
	[7960] = "10015|B260/285/297/310|3860:30 6037:16 7910:6 7081:4 7966:8 4304:6",	-- Truesilver Champion, removed armorsmith requirement
	[12416] = "16645|B260/280/290/300|12359:10 7077:2|12685",	-- Radiant Belt
	[11608] = "15292|B265/285/295/305|11371:18 7077:4|11610",	-- Dark Iron Pulverizer
	[12424] = "16647|B265/285/295/305|12359:10 8170:6|12688",	-- Imperial Plate Belt
	[12428] = "16646|B265/285/295/305|12359:12 8170:6|12687",	-- Imperial Plate Shoulders
	[12624] = "16650|B270/290/300/310|12359:40 12655:2 12803:4 8153:4 12364|12691",	-- Wildthorn Mail
	[11605] = "15295|B280/300/310/320|11371:6 7077|11615",	-- Dark Iron Shoulders
	[12425] = "16649|B270/290/300/310|12359:12|12690",	-- Imperial Plate Bracers
	[12415] = "16648|B270/290/300/310|12359:18 7077:2 7910|12689",	-- Radiant Breastplate
	[11607] = "15294|B275/295/305/315|11371:26 7077:4|11611",	-- Dark Iron Sunderer
	[12774] = "16970|B275/300/312/325|12359:30 12655:4 7910:4 12361:4 12644:2 8170:4|12821",	-- Dawn's Edge
	[15872] = "19669|B275/275/280/285|12360 12644||2",	-- Arcanite Skeleton Key
	[12773] = "16969|B275/300/312/325|12359:10 12799:2 12644:2 8170:4|12819",	-- Ornate Thorium Handaxe
	[12645] = "16651|B275/295/305/315|12359:4 12644:4 7076:2|12692",	-- Thorium Shield Spike
	[16206] = "20201|B275/275/280/285|12360:3 12644",	-- Arcanite Rod
	[12777] = "16978|B280/305/317/330|12655:10 7078:4 7077:4 12800:2 12644:2|12825",	-- Blazing Rapier
	[12776] = "16973|B280/305/317/330|12359:20 12655:6 12364:2 12804:4 8170:4|12824",	-- Enchanted Battlehammer
	[12775] = "16971|B280/305/317/330|12359:12 12644:6 8170:6|12823",	-- Huge Thorium Battleaxe
	[12409] = "16652|B280/300/310/320|12359:12 8170:8|12693",	-- Thorium Boots
	[12410] = "16653|B280/300/310/320|12359:12 7910|12694",	-- Thorium Helm
	[11604] = "15296|B285/305/315/325|11371:20 7077:8|11612",	-- Dark Iron Plate
	[12628] = "16667|B285/305/315/325|12359:40 12662:10 12361:4 7910:4|12696",	-- Demon Forged Breastplate
	[12781] = "16983|B285/310/322/335|12655:6 12360:2 12804:4 12799:2 12361:2 12364|12827",	-- Serenity
	[12418] = "16654|B285/305/315/325|12359:18 7077:4|12695",	-- Radiant Gloves
	[12782] = "16985|B290/315/327/340|12359:40 12360:2 12662:16 12808:8 12361:2 12644:2 8170:4|12830",	-- Corruption
	[12631] = "16655|B290/310/320/330|12359:20 12655:6 7078:2 7910:4|12699",	-- Fiery Plate Gauntlets
	[19051] = "23632|B290/310/320/330|12359:8 6037:6 12811|19203",	-- Girdle of the Dawn
	[19043] = "23628|B290/310/320/330|12359:12 7076:3 12803:3|19202",	-- Heavy Timbermaw Belt
	[12419] = "16656|B290/310/320/330|12359:14 7077:4|12697",	-- Radiant Boots
	[12792] = "16984|B290/315/327/340|12359:30 7077:4 7910:4 8170:4|12828",	-- Volcanic Hammer
	[17014] = "20874|B295/315/325/335|11371:4 17010:2 17011:2|17051",	-- Dark Iron Bracers
	[16989] = "20872|B295/315/325/335|11371:6 17010:3 17011:3|17049",	-- Fiery Chain Girdle
	[17193] = "21161|B300/325/337/350|17203:8 11371:20 12360:50 7078:25 11382:10 17011:10 17010:10|18592",	-- Sulfuron Hammer
	[12632] = "16661|B295/315/325/335|12359:20 12655:4 7080:4 12361:4|12703",	-- Storm Gauntlets
	[12426] = "16657|B295/315/325/335|12359:18|12700",	-- Imperial Plate Boots
	[12427] = "16658|B295/315/325/335|12359:18 7910|12701",	-- Imperial Plate Helm
	[12417] = "16659|B295/315/325/335|12359:18 7077:4|12702",	-- Radiant Circlet
	[19166] = "23638|B300/320/330/340|17011:3 17010:6 12360:12 11382 11371:4|19208",	-- Black Amnesty
	[22194] = "27589|B300/320/330/340|22203:8 22202:24 12810:8 13512|22220",	-- Black Grasp of the Destroyer
	[19167] = "23639|B300/320/330/340|17011:5 17010:2 12360:16 11371:6|19209",	-- Blackfury
	[19168] = "23652|B300/320/330/340|17011:6 17010:6 12360:10 11371:6 12809:12|19211",	-- Blackguard
	[20039] = "24399|B300/320/330/340|17011:3 17010:3 17012:4 11371:6|20040",	-- Dark Iron Boots
	[19164] = "23637|B300/320/330/340|17011:3 17010:5 17012:4 11371:4 11382:2|19207",	-- Dark Iron Gauntlets
	[19148] = "23636|B300/320/330/340|17011:4 17010:2 11371:4|19206",	-- Dark Iron Helm
	[17013] = "20876|B300/320/330/340|11371:16 17010:4 17011:6|17052",	-- Dark Iron Leggings
	[19170] = "23650|B300/320/330/340|17011:4 17010:7 12360:12 11371:8 12800:4|19210",	-- Ebon Hand
	[16988] = "20873|B300/320/330/340|11371:16 17010:4 17011:5|17053",	-- Fiery Chain Shoulders
	[22671] = "28244|B300/320/330/340|22682:4 12359:12 12360:2 7080:2",	-- Icebane Bracers
	[22669] = "28242|B300/320/330/340|22682:7 12359:16 12360:2 7080:4",	-- Icebane Breastplate
	[22670] = "28243|B300/320/330/340|22682:5 12359:12 12360:2 7080:2",	-- Icebane Gauntlets
	[12641] = "16746|B300/320/330/340|12360:30 12655:30 12364:6 12800:6|12728",	-- Invulnerable Mail
	[22198] = "27586|B300/320/330/340|22203:8 22202:24 12655:8 7076:4|22219",	-- Jagged Obsidian Shield
	[12640] = "16729|B300/320/330/340|12359:80 12360:12 8146:40 12361:10 12800:4|12717",	-- Lionheart Helm
	[19169] = "23653|B300/320/330/340|17011:8 17010:5 12360:10 11371:12 12364:4|19212",	-- Nightfall
	[22191] = "27590|B300/320/330/340|22203:15 22202:36 12810:12 12809:10 12800:4|22221",	-- Obsidian Mail Tunic
	[22384] = "27830|B300/320/330/340|12360:15 11371:10 12808:20 20520:20 15417:10 12753:2|22390",	-- Persuader
	[22383] = "27832|B300/320/330/340|12360:12 20725:2 13512:2 12810:4|22389",	-- Sageblade
	[12639] = "16741|B300/320/330/340|12360:15 12655:20 7076:10 12361:4 12799:4|12720",	-- Stronghold Gauntlets
	[22196] = "27587|B300/320/330/340|22203:18 22202:40 12655:12 7076:10 12364:4|22222",	-- Thick Obsidian Breastplate
	[22385] = "27829|B300/320/330/340|12360:12 12655:20 7076:10 13510:2|22388",	-- Titanic Leggings
	[12798] = "16991|B300/320/330/340|12359:40 12360:12 12808:10 12364:8 12644:2 12810:4|12835",	-- Annihilator
	[12790] = "16990|B300/320/330/340|12360:15 12800:8 12811 12799:4 12810:8 12644:2|12834",	-- Arcanite Champion
	[12784] = "16994|B300/320/330/340|12360:20 12810:6 12644:2|12838",	-- Arcanite Reaper
	[19690] = "24136|B300/320/330/340|12359:20 19774:10 19726:2 7910:2|19776",	-- Bloodsoul Breastplate
	[19692] = "24138|B300/320/330/340|12359:12 19774:6 19726:2 12810:4|19778",	-- Bloodsoul Gauntlets
	[19691] = "24137|B300/320/330/340|12359:16 19774:8 19726:2 7910|19777",	-- Bloodsoul Shoulders
	[17016] = "20897|B300/320/330/340|11371:18 17011:12 11382:2 12810:2|17060",	-- Dark Iron Destroyer
	[17015] = "20890|B300/320/330/340|11371:16 17010:12 11382:2 12810:2|17059",	-- Dark Iron Reaver
	[20550] = "24914|B300/320/330/340|12359:20 20520:10 6037:10|20554",	-- Darkrune Breastplate
	[20549] = "24912|B300/320/330/340|12359:12 20520:6 6037:6 12810:2|20553",	-- Darkrune Gauntlets
	[20551] = "24913|B300/320/330/340|12359:16 20520:8 6037:8 11754|20555",	-- Darkrune Helm
	[19693] = "24139|B300/320/330/340|12359:20 19774:14 12799:2|19779",	-- Darksoul Breastplate
	[19694] = "24140|B300/320/330/340|12359:18 19774:12 12799:2|19780",	-- Darksoul Leggings
	[19695] = "24141|B300/320/330/340|12359:16 19774:10 12799|19781",	-- Darksoul Shoulders
	[12618] = "16745|B300/320/330/340|12360:8 12655:24 7076:4 7080:4 12364:2 12800:2|12727",	-- Enchanted Thorium Breastplate
	[12620] = "16742|B300/320/330/340|12360:6 12655:16 7076:6 12799:2 12800|12725",	-- Enchanted Thorium Helm
	[12619] = "16744|B300/320/330/340|12360:10 12655:20 7080:6 12361:2 12364|12726",	-- Enchanted Thorium Leggings
	[12797] = "16992|B300/320/330/340|12360:18 12361:8 12800:8 7080:4 12644:2 12810:4|12836",	-- Frostguard
	[19057] = "23633|B300/320/330/340|12360:2 6037:10 12811|19205",	-- Gloves of the Dawn
	[12796] = "16988|B300/320/330/340|12359:50 12360:15 12809:4 12810:6 7076:10|12833",	-- Hammer of the Titans
	[12783] = "16995|B300/320/330/340|12360:10 12655:10 12810:2 7910:6 12800:6 12799:6 12644:4|12839",	-- Heartseeker
	[22197] = "27585|B300/320/330/340|22202:14 12655:4 7076:2|22209",	-- Heavy Obsidian Belt
	[19048] = "23629|B300/320/330/340|12360:4 7076:6 12803:6|19204",	-- Heavy Timbermaw Boots
	[12636] = "16728|B300/320/330/340|12359:40 12655:4 8168:60 12799:6 12364:2|12716",	-- Helm of the Great Chief
	[22764] = "28463|B300/320/330/340|12655:6 12803:2|22768",	-- Ironvine Belt
	[22762] = "28461|B300/320/330/340|12655:12 19726:2 12360:2 12803:2|22766",	-- Ironvine Breastplate
	[22763] = "28462|B300/320/330/340|12655:8 19726 12803:2|22767",	-- Ironvine Gloves
	[22195] = "27588|B300/320/330/340|22202:14 12810:4|22214",	-- Light Obsidian Belt
	[12794] = "16993|B300/320/330/340|12655:20 12364:8 12799:8 7076:6 12810:4|12837",	-- Masterwork Stormhammer
	[12633] = "16724|B300/320/330/340|12359:20 12655:4 6037:6 3577:6 12800:2|12711",	-- Whitesoul Helm
	[18262] = "22757|B300/300/310/320|7067:2 12365:3|18264",	-- Elemental Sharpening Stone
	[29203] = "34982|B300/320/330/340|12655:2 12359:6 8170",	-- Enchanted Thorium Blades
	[23493] = "29551|B300/310/320/330|23445:4",	-- Fel Iron Chain Coif
	[23482] = "29545|B300/310/320/330|23445:4",	-- Fel Iron Plate Gloves
	[12422] = "16663|B300/320/330/340|12359:20|12705",	-- Imperial Plate Chest
	[12429] = "16730|B300/320/330/340|12359:24|12715",	-- Imperial Plate Leggings
	[12420] = "16725|B300/320/330/340|12359:20 7077:4|12713",	-- Radiant Leggings
	[12613] = "16731|B300/320/330/340|12359:40 12360:2 7910|12718",	-- Runic Breastplate
	[12611] = "16665|B300/320/330/340|12359:20 12360:2 2842:10|12707",	-- Runic Plate Boots
	[12612] = "16726|B300/320/330/340|12359:30 12360:2 6037:2 12364|12714",	-- Runic Plate Helm
	[12614] = "16732|B300/320/330/340|12359:40 12360:2 7910|12719",	-- Runic Plate Leggings
	[12610] = "16664|B300/320/330/340|12359:20 12360:2 3577:6|12706",	-- Runic Plate Shoulders
	[12414] = "16662|B300/320/330/340|12359:12|12704",	-- Thorium Leggings
	[25843] = "32655|B300/300/305/310|23445:6",	-- Fel Iron Rod
	[23528] = "29654|B300/300/305/310|23445 22573",	-- Fel Sharpening Stone
	[28420] = "34607|B300/300/305/310|23445 21877",	-- Fel Weightstone
	[23484] = "29547|B305/315/325/335|23445:4",	-- Fel Iron Plate Belt
	[23491] = "29552|B310/320/330/340|23445:5",	-- Fel Iron Chain Gloves
	[23497] = "29557|B310/320/330/340|23445:9",	-- Fel Iron Hatchet
	[23494] = "29553|B315/325/335/345|23445:6",	-- Fel Iron Chain Bracers
	[23498] = "29558|B315/325/335/345|23445:10",	-- Fel Iron Hammer
	[23487] = "29548|B315/325/335/345|23445:6",	-- Fel Iron Plate Boots
	[23488] = "29549|B315/325/335/345|23445:8",	-- Fel Iron Plate Pants
	[23490] = "29556|B320/330/340/350|23445:9",	-- Fel Iron Chain Tunic
	[23499] = "29565|B320/330/340/350|23445:12",	-- Fel Iron Greatsword
	[23502] = "29566|B325/335/345/355|23446:8|23590",	-- Adamantite Maul
	[23489] = "29550|B325/335/345/355|23445:10",	-- Fel Iron Breastplate
	[23559] = "32284|B325/325/330/335|23446",	-- Lesser Rune of Warding
	[23503] = "29568|B330/340/350/360|23446:8|23591",	-- Adamantite Cleaver
	[23504] = "29569|B330/340/350/360|23446:7 21887:2|23592",	-- Adamantite Dagger
	[33185] = "42688|B335/345/350/355|23573:2 23449|33186", -- Adamantite Weapon Chain -- also 35296
	[23506] = "29603|B335/345/355/365|23446:6 22452:2 21884:2|23594",	-- Adamantite Plate Bracers
	[23508] = "29605|B335/345/355/365|23446:8 21887:2 22452:3 21884:2|23595",	-- Adamantite Plate Gloves
	[23505] = "29571|B335/345/355/365|23446:12|23593",	-- Adamantite Rapier
	[23507] = "29606|B340/350/360/370|23446:12 22452:4 21884:2|23596",	-- Adamantite Breastplate
	[23575] = "29728|B340/340/345/350|23446|23638||23575",	-- Lesser Ward of Shielding
	[29204] = "34983|B350/360/370/380|23448:6 22451:2 21884:2 23793",	-- Felsteel Whisper Knives
	[23515] = "29614|B350/360/370/380|23445:6 21885:3 21884:2|23601",	-- Flamebane Bracers
	[23529] = "29656|B350/350/355/360|23446 22573:2|23618",	-- Adamantite Sharpening Stone
	[28421] = "34608|B350/350/355/360|23446 21877:2|28632",	-- Adamantite Weightstone
	[25844] = "32656|B350/350/355/360|23446:10|25846",	-- Adamantite Rod
	[25521] = "32285|B350/350/355/360|23449|25526",	-- Greater Rune of Warding
	[23510] = "29608|B355/365/375/385|23573:2 22445:8 22449:2|23597",	-- Enchanted Adamantite Belt
	[23511] = "29611|B355/365/375/385|23573:3 22445:12 22449:2|23598",	-- Enchanted Adamantite Boots
	[23516] = "29615|B355/365/375/385|23445:12 21885:5 21884:3|23602",	-- Flamebane Helm
	[23509] = "29610|B360/370/380/390|23573:4 22445:20 22449:4|23599",	-- Enchanted Adamantite Breastplate
	[23517] = "29619|B360/370/380/390|23448:6|23605",	-- Felsteel Gloves
	[23518] = "29620|B360/370/380/390|23448:8|23606",	-- Felsteel Leggings
	[23514] = "29616|B360/370/380/390|23445:8 21885:4 21884:4|23603",	-- Flamebane Gloves
	[23524] = "29628|B360/370/380/390|23449:3 21885:2 22457:2|23608",	-- Khorium Belt
	[23523] = "29629|B360/370/380/390|23449:6 21885:4 22457:4|23609",	-- Khorium Pants
	[23530] = "29657|B360/370/380/390|23448:4 21884:4 22452:4|24002",	-- Felsteel Shield Spike
	[23537] = "29669|B365/375/385/395|23448:6 22456:15 23572|23626",	-- Black Felsteel Bracers
	[23539] = "29672|B365/375/385/395|23573:6 23571:2 21885:15 23572|23628",	-- Blessed Bracers
	[23538] = "29671|B365/375/385/395|23573:6 21886:20 23572|23627",	-- Bracers of the Green Fortress
	[23555] = "29699|B365/375/385/395|23449:10 23448:10 23571:8 23572:2|23636",	-- Dirge
	[23554] = "29698|B365/375/385/395|23449:10 23573:4 23447:10 23571:8 23572:2|23635",	-- Eternium Runed Blade
	[23542] = "29694|B365/375/385/395|23449:10 23448:10 23571:8 23572:2|23631",	-- Fel Edged Battleaxe
	[23546] = "29697|B365/375/385/395|23449:10 23448:10 23571:8 23572:2|23634",	-- Fel Hardened Maul
	[23531] = "29658|B365/375/385/395|23448:10 23571:3 23572|23620",	-- Felfury Gauntlets
	[23540] = "29692|B365/375/385/395|23449:10 23448:10 23571:6 23572:2|23629",	-- Felsteel Longblade
	[23543] = "29695|B365/375/385/395|23449:10 23448:10 23571:8 23572:2|23632",	-- Felsteel Reaper
	[23532] = "29622|B365/375/385/395|23573:10 23571:2 22452:15 23572|23621",	-- Gauntlets of the Iron Tower
	[23556] = "29700|B365/375/385/395|23449:10 23573:4 23447:10 23571:8 23572:4|23637",	-- Hand of Eternity
	[23535] = "29664|B365/375/385/395|23573:8 22452:22 22457:12 23572|23624",	-- Helm of the Stalwart Defender
	[23541] = "29693|B365/375/385/395|23449:20 23573:2 23571:6 23572:2|23630",	-- Khorium Champion
	[23536] = "29668|B365/375/385/395|23573:8 23571:3 21886:18 23572|23625",	-- Oathkeeper's Helm
	[23544] = "29696|B365/375/385/395|23449:10 23448:10 23571:8 23572:2|23633",	-- Runic Hammer
	[23533] = "29662|B365/375/385/395|23448:10 23571:5 23572|23622",	-- Steelgrip Gauntlets
	[23534] = "29663|B365/375/385/395|23573:8 22451:16 21885:16 23572|23623",	-- Storm Helm
	[23512] = "29613|B365/375/385/395|23573:4 22445:24 22449:4|23600",	-- Enchanted Adamantite Leggings
	[23519] = "29621|B365/375/385/395|23448:8|23607",	-- Felsteel Helm
	[23513] = "29617|B365/375/385/395|23445:16 21885:6 21884:4|23604",	-- Flamebane Breastplate
	[23525] = "29630|B365/375/385/395|23449:4 21885:3 22457:3|23610",	-- Khorium Boots
	[23520] = "29642|B365/375/385/395|23445:8 21884:6 23449:3 22824:2|23611",	-- Ragesteel Gloves
	[23521] = "29643|B365/375/385/395|23445:10 21884:10 23449:4 22824:4|23612",	-- Ragesteel Helm
	[33173] = "42662|B365/375/385/395|23445:12 21884:2 23449:8 27503:2|33174||33173", --Ragesteel Shoulders
	[32854] = "43846|B365/375/385/395|23449:16 23448:12 23571:6 23572:2|33954", -- Hammer of Righteous Might
	[23527] = "29649|B370/380/390/400|23573:4 21886:6 22452:4|23617",	-- Earthpeace Breastplate
	[23522] = "29645|B370/380/390/400|23445:12 21884:10 23449:6 22824:4|23613",	-- Ragesteel Breastplate
	[31369] = "38477|B375/385/395/405|23449:8 21885:12 21884:12 23572|31393",	-- Iceguard Breastplate
	[31371] = "38479|B375/385/395/405|23449:8 21885:12 21884:12 23572|31395",	-- Iceguard Helm
	[31370] = "38478|B375/385/395/405|23449:8 21885:12 21884:12 23572|31394",	-- Iceguard Leggings
	[31364] = "38473|B375/385/395/405|23448:8 21886:12 22456:12 23572|31390",	-- Wildguard Breastplate
	[31368] = "38476|B375/385/395/405|23448:8 21886:12 22456:12 23572|31392",	-- Wildguard Helm
	[31367] = "38475|B375/385/395/405|23448:8 21886:12 22456:12 23572|31391",	-- Wildguard Leggings
	[25845] = "32657|B360/365/370/375|23447:4|25847",	-- Eternium Rod
	[23576] = "29729|B375/0/0/375|23447|23639||23576",	-- Greater Ward of Shielding
	[30034] = "36389|B375/385/395/405|30183:2 23573:5 21885:10 22452:5|30321", --Belt of the Guardian
	[30033] = "36391|B375/385/395/405|23572:2 23573:4 21885:12|30323", -- Boots of the Protector
	[30032] = "36390|B375/385/395/405|30183:2 23573:5 21884:10|30322", -- Red Belt of Battle
	[30031] = "36392|B375/385/395/405|23572:2 23573:4 21884:12|30324", -- Red Havok Boots
	[32573] = "41135|B375/385/395/405|23449:18 23573:2 21884:8 32428:2|32739", --Dawnsteel Shoulders -- also 35530
	[32568] = "41132|B375/385/395/405|23448:14 23573:2 22451:6 32428:4|32736", --Swiftsteel Bracers -- also 35531
	[32571] = "41134|B375/385/395/405|23449:14 23573:2 21884:6 32428:4|32738", --Dawnsteel Bracers -- also 35529
	[32570] = "41133|B375/385/395/405|23448:18 23573:2 22451:8 32428:2|32737", --Swiftsteel Shoulders -- also 35532
	[32403] = "40034|B375/385/395/405|32428 22450 21886:2 22456:2 23446:4|32442", --Shadesteel Bracers
	[32401] = "40036|B375/385/395/405|32428:2 22450 21886:3 22456:4 23446:8|32444", --Shadesteel Girdle
	[32404] = "40035|B375/385/395/405|32428:3 22450 21886:4 22456:6 23446:12|32443", --Shadesteel Greaves
	[32402] = "40033|B375/385/395/405|32428:2 22450 21886:2 22456:4 23446:4|32442", --Shadesteel Sabots
--[[ blacksmithing specialty --]]
	[30069] = "36122|Ba260/280/290/300|3860:16 7075:2",	-- Earthforged Leggings
	[30070] = "36124|Ba260/280/290/300|3860:16 7081:2",	-- Windforged Leggings
	[30074] = "36129|Ba330/340/350/360|23446:8 22452:4",	-- Heavy Earthforged Breastplate
	[30076] = "36130|Ba330/340/350/360|23446:8 21885:2 22451:2",	-- Stormforged Hauberk
	[28483] = "34533|Ba350/360/370/380|23571:8 23573:6 23447:6 23449:8",	-- Breastplate of Kings
	[23563] = "34529|Ba350/360/370/380|22456:20 22451:20 23573:6 23448:4 23449:8",	-- Nether Chain Shirt
	[28484] = "34534|Ba375/385/395/405|28483 23572:10 22457:10",	-- Bulwark of Kings
	[28485] = "36257|Ba375/385/395/405|28484 30183:2",	-- Bulwark of the Ancient Kings
	[23565] = "36256|Ba375/385/395/405|23564 30183:2",	-- Embrace of the Twisting Nether
	[23564] = "34530|Ba375/385/395/405|23563 23572:10 22457:10",	-- Twisting Nether Chain Shirt
	[30071] = "36125|Bw260/280/290/300|3860:12 7075:4",	-- Light Earthforged Blade
	[30073] = "36128|Bw260/280/290/300|3860:12 7077:4",	-- Light Emberforged Hammer
	[30072] = "36126|Bw260/280/290/300|3860:12 7081:4",	-- Light Skyforged Axe
	[30088] = "36135|Bwx330/340/350/360|23446:10 22451:6",	-- Skyforged Great Axe
	[30087] = "36134|Bwx330/340/350/360|23446:8 21885:3 22451:3",	-- Stormforged Axe
	[28434] = "34543|Bwx350/360/370/380|22451:12 22452:12 23571:4 23447:22",	-- Lunar Crescent
	[28431] = "34541|Bwx350/360/370/380|23571:5 22456:20 23573:2 23448:12",	-- The Planar Edge
	[28432] = "34542|Bwx375/385/395/405|28431 23572:8 23448:6",	-- Black Planar Edge
	[28436] = "36261|Bwx375/385/395/405|28435 30183:5",	-- Bloodmoon
	[28435] = "34544|Bwx375/385/395/405|28434 23572:8 22457:10",	-- Mooncleaver
	[28433] = "36260|Bwx375/385/395/405|28432 30183:5",	-- Wicked Edge of the Planes
	[30093] = "36137|Bwh330/340/350/360|23446:12 22452:6",	-- Great Earthforged Hammer
	[30089] = "36136|Bwh330/340/350/360|23446:8 21884:6",	-- Lavaforged Warhammer
	[28437] = "34545|Bwh350/360/370/380|21884:20 22452:20 23447:12 23449:8",	-- Drakefist Hammer
	[28440] = "34547|Bwh350/360/370/380|22451:20 21885:20 23573:6 23449:12",	-- Thunder
	[28441] = "34548|Bwh375/385/395/405|28440 23572:8 22457:10",	-- Deep Thunder
	[28438] = "34546|Bwh375/385/395/405|28437 23572:8 23571:2",	-- Dragonmaw
	[28439] = "36262|Bwh375/385/395/405|28438 30183:5",	-- Dragonstrike
	[28442] = "36263|Bwh375/385/395/405|28441 30183:5",	-- Stormherald
	[30086] = "36133|Bws330/340/350/360|23446:10 22452:6",	-- Stoneforged Claymore
	[30077] = "36131|Bws330/340/350/360|23446:6 22451:6",	-- Windforged Rapier
	[28425] = "34535|Bws350/360/370/380|22456:20 22457:20 23448:14",	-- Fireguard
	[28428] = "34538|Bws350/360/370/380|23571:10 23449:14 23573:6",	-- Lionheart Blade
	[28427] = "36258|Bws375/385/395/405|28426 30183:5",	-- Blazefury
	[28426] = "34537|Bws375/385/395/405|28425 23572:8 22451:10",	-- Blazeguard
	[28429] = "34540|Bws375/385/395/405|28428 23572:8 23571:2",	-- Lionheart Champion
	[28430] = "36259|Bws375/385/395/405|28429 30183:5",	-- Lionheart Executioner
--[[ Horde only blacksmithing, needs fixed --]]
	[7929] = "9957|B220/250/260/270|3860:12 7067|99999",	-- Orcish War Leggings
--[[ Cooking --]]
	[33924] = "43779|W1/50/62/75|30817:8 1179:4 2678:4 6889:8 2593 785:3|33925", -- Delicious Chocolate Cake
	[6290] = "7751|W1/45/65/85|6291|6325",	-- Brilliant Smallfish
	[2679] = "2538|W1/45/65/85|2672",	-- Charred Wolf Meat
	[12224] = "15935|W1/45/65/85|12223 2678|12226",	-- Crispy Bat Wing
	[17197] = "21143|W1/45/65/85|6889 17194|17200",	-- Gingerbread Cookie
	[6888] = "8604|W1/45/65/85|6889 2678",	-- Herb Baked Egg
	[27635] = "33276|W1/45/65/85|27668|27685",	-- Lynx Steak
	[2681] = "2540|W1/45/65/85|769",	-- Roasted Boar Meat
	[24105] = "33277|W1/45/65/85|23676|27686",	-- Roasted Moongraze Tenderloin
	[787] = "7752|W1/45/65/85|6303|6326",	-- Slitherskin Mackerel
	[30816] = "37836|W1/30/35/40|30817 2678",	-- Spice Bread
	[2888] = "2795|W10/60/80/100|2886 2894|2889",	-- Beer Basted Boar Ribs
	[5472] = "6412|W10/50/70/90|5465|5482",	-- Kaldorei Spider Kabob
	[2680] = "2539|W10/50/70/90|2672 2678",	-- Spiced Wolf Meat
	[5473] = "6413|W20/60/80/100|5466|5483",	-- Scorpid Surprise
	[17198] = "21144|W35/75/95/115|6889 1179 17196 17194|17201",	-- Egg Nog
	[5474] = "6414|W35/75/95/115|5467 2678|5484|2",	-- Roasted Kodo Meat
	[6890] = "8607|W40/80/100/120|3173|6892",	-- Smoked Bear Meat
	[27636] = "33278|W50/90/110/130|27669|27687",	-- Bat Bites
	[5525] = "6499|W50/90/110/130|5503 159",	-- Boiled Clams
	[2684] = "2541|W50/90/110/130|2673",	-- Coyote Steak
	[5476] = "6415|W50/90/110/130|5468 2678|5485|2",	-- Fillet of Frenzy
	[724] = "2542|W50/90/110/130|723 2678|2697",	-- Goretusk Liver Pie
	[6316] = "7754|W50/90/110/130|6317 2678|6329",	-- Loch Frenzy Delight
	[4592] = "7753|W50/90/110/130|6289|6328",	-- Longjaw Mud Snapper
	[5095] = "7827|W50/90/110/130|6361|6368",	-- Rainbow Fin Albacore
	[5477] = "6416|W50/90/110/130|5469 4536|5486|2",	-- Strider Stew
	[3220] = "3371|W60/100/120/140|3173 3172 3174|3679|2",	-- Blood Sausage
	[22645] = "28267|W60/100/120/140|22644|22647",	-- Crunchy Spider Surprise
	[7676] = "9513|W60/100/120/140|2452 159|18160",	-- Thistle Tea
	[2683] = "2544|W75/115/135/155|2674 2678",	-- Crab Cake
	[733] = "2543|W75/115/135/155|729 730 731|728",	-- Westfall Stew
	[3662] = "3370|W80/120/140/160|2924 2678|3678",	-- Crocolisk Steak
	[2687] = "2546|W80/120/140/160|2677 2678",	-- Dry Pork Ribs
	[21072] = "25704|W80/120/140/160|21071 2678|21099",	-- Smoked Sagefish
	[2682] = "2545|W85/125/145/165|2675 2678|2698",	-- Cooked Crab Claw
	[6657] = "8238|W85/125/145/165|6522 2678|6661",	-- Savory Deviate Delight
	[5526] = "6501|W90/130/150/170|5503 1179 2678|5528",	-- Clam Chowder
	[5478] = "6417|W90/130/150/170|5051|5487|2",	-- Dig Rat Stew
	[3663] = "3372|W90/130/150/170|1468:2 2692|3680",	-- Murloc Fin Soup
	[4593] = "7755|W100/140/160/180|6308|6330",	-- Bristle Whisker Catfish
	[5479] = "6418|W100/140/160/180|5470 2692|5488|2",	-- Crispy Lizard Tail
	[1082] = "2547|W100/135/155/175|1081 1080|2699",	-- Redridge Goulash
	[1017] = "2549|W100/140/160/180|1015:2 2665|2701|3",	-- Seasoned Wolf Kabob
	[3726] = "3397|W110/150/170/190|3730 2692|3734",	-- Big Bear Steak
	[3666] = "3377|W110/150/170/190|2251:2 2692|3683",	-- Gooey Spider Cake
	[5480] = "6419|W110/150/170/190|5471 2678:4|5489|2",	-- Lean Venison
	[2685] = "2548|W110/130/150/170|2677:2 2692|2700",	-- Succulent Pork Ribs
	[3664] = "3373|W120/160/180/200|3667 2692|3681",	-- Crocolisk Gumbo
	[5527] = "6500|W125/165/185/205|5504 2692",	-- Goblin Deviled Clams
	[3727] = "3398|W125/175/195/215|3731 2692|3735",	-- Hot Lion Chops
	[12209] = "15853|W125/165/185/205|1015 2678|12227",	-- Lean Wolf Steak
	[3665] = "3376|W130/170/190/210|3685 2692|3682",	-- Curiously Tasty Omelet
	[20074] = "24418|W150/160/180/200|3667:2 3713|20075",	-- Heavy Crocolisk Stew
	[3728] = "3399|W150/190/210/230|3731:2 3713|3736",	-- Tasty Lion Steak
	[4457] = "4094|W175/215/235/255|3404 2692|4609",	-- Barbecued Buzzard Wing
	[12213] = "15863|W175/215/235/255|12037 2692|12232",	-- Carrion Surprise
	[6038] = "7213|W175/215/235/255|4655 2692|6039",	-- Giant Clam Scorcho
	[10841] = "13028|W175/175/190/205|3821 159||4",	-- Goldthorn Tea
	[13851] = "15856|W175/215/235/255|12203 2692|12229",	-- Hot Wolf Ribs
	[12212] = "15861|W175/215/235/255|12202 159 4536:2|12231|2",	-- Jungle Stew
	[8364] = "20916|W175/215/235/255|8365|17062",	-- Mithril Headed Trout
	[12214] = "15865|W175/215/235/255|12037 2596|12233",	-- Mystery Stew
	[12210] = "15855|W175/215/235/255|12184 2692|12228",	-- Roast Raptor
	[4594] = "7828|W175/190/210/230|6362|6369",	-- Rockscale Cod
	[21217] = "25954|W175/215/235/255|21153 2692|21219",	-- Sagefish Delight
	[3729] = "3400|W175/215/235/255|3712 3713|3737",	-- Soothing Turtle Bisque
	[12217] = "15906|W200/225/237/250|12037 4402 2692|12239",	-- Dragonbreath Chili
	[12215] = "15910|W200/225/237/250|12204:2 3713 159|12240|2",	-- Heavy Kodo Stew
	[17222] = "21175|W200/225/237/250|12205:2",	-- Spider Sausage
	[13927] = "18239|W225/250/262/275|13754 3713|13940",	-- Cooked Glossy Mightfish
	[13930] = "18241|W225/250/262/275|13758|13941",	-- Filet of Redgill
	[12218] = "15933|W225/250/262/275|12207 3713:2|16110",	-- Monster Omelet
	[12216] = "15915|W225/250/262/275|12206 2692:2|16111",	-- Spiced Chili Crab
	[6887] = "18238|W225/250/262/275|4603|13939",	-- Spotted Yellowtail
	[18045] = "22480|W225/250/262/275|12208 3713|18046",	-- Tender Wolf Steak
	[16766] = "20626|W225/250/262/275|7974:2 2692 1179|16767|2",	-- Undermine Clam Chowder
	[13928] = "18240|W240/265/277/290|13755 3713|13942",	-- Grilled Squid
	[13929] = "18242|W240/265/277/290|13756 2692:2|13943",	-- Hot Smoked Bass
	[13931] = "18243|W250/275/285/295|13759 159|13945",	-- Nightfin Soup
	[13932] = "18244|W250/275/285/295|13760|13946",	-- Poached Sunscale Salmon
	[13935] = "18247|W275/300/312/325|13889 3713|13949",	-- Baked Salmon
	[13933] = "18245|W275/300/312/325|13888 159|13947",	-- Lobster Stew
	[13934] = "18246|W275/300/312/325|13893 2692 3713|13948",	-- Mightfish Steak
	[18254] = "22761|W275/300/312/325|18255 3713|18267",	-- Runn Tum Tuber Surprise
	[20452] = "24801|W285/310/322/335|20424 3713",	-- Smoked Desert Dumplings
	[27661] = "33290|W300/320/330/340|27422|27694",	-- Blackened Trout
	[27651] = "33279|W300/320/330/340|27671|27684",	-- Buzzard Bites
	[30155] = "36210|W300/320/330/340|24477:2 3713|30156",	-- Clam Bar
	[21023] = "25659|W300/325/337/350|2692 9061 8150 21024|21025|5",	-- Dirge's Kickin' Chimaerok Chops
	[27662] = "33291|W300/320/330/340|27425|27695",	-- Feltail Delight
	[27655] = "33284|W300/320/330/340|27674|27688",	-- Ravager Dog
	[33867] = "43761|W300/320/330/340|33823|33869", -- Broiled Bloodfin
	[33874] = "43772|W300/345/355/365|27671|33875", -- Kibler's Bits
	[33866] = "43758|W300/320/330/340|27678 13757|33871", -- Stormchops
	[27663] = "33292|W310/330/340/350|27429|27696",	-- Blackened Sporefish
	[27656] = "33285|W310/330/340/350|27676|27689",	-- Sporeling Snack
	[27657] = "33286|W315/335/345/355|27677|27690",	-- Blackened Basilisk
	[27664] = "33293|W320/340/350/360|27435|27697",	-- Grilled Mudfish
	[27665] = "33294|W320/340/350/360|27437|27698",	-- Poached Bluefish
	[27666] = "33295|W325/345/355/365|27438|27699",	-- Golden Fish Sticks
	[27658] = "33287|W325/345/355/365|27678|27691",	-- Roasted Clefthoof
	[27660] = "33289|W325/345/355/365|27682|27693",	-- Talbuk Steak
	[27659] = "33288|W325/345/355/365|27681|27692",	-- Warp Burger
	[34411] = "45022|W325/0/0/325|34412 17196 17194|34413|2", --Hot Apple Cider
	[33825] = "43707|W325/335/345/355|33824|33870", -- Skullfish Soup
	[33872] = "43765|W325/335/345/355|27682 2692|33873", -- Spicy Hot Talbuk
	[31673] = "38868|W335/355/365/375|31671|31674",	-- Crunchy Serpent
	[31672] = "38867|W335/355/365/375|31670|31675",	-- Mok'Nathal Shortribs
	[27667] = "33296|W350/370/375/380|27439|27700",	-- Spicy Crawdad
	[33048] = "42296|W320/335/345/355|27422 2593 3713",	-- Stewed Trout
	[33052] = "42302|W350/375/380/385|27515 4539:5 3713:5||6",	-- Fisherman's Feast
	[33053] = "42305|W350/375/380/385|27516 3713:2||2",	-- Hot Buttered Trout
--[[ Enchanting --]]
	[6218] = "7421|D1/5/7/10|6217 10940 10938",	-- Runed Copper Rod
	[-7428] = "D1/80/100/120|10938 10940",	-- Enchant Bracer - Minor Deflection
	[-7418] = "D1/70/90/110|10940",	-- Enchant Bracer - Minor Health
	[11287] = "14293|D10/75/95/115|4470 10938",	-- Lesser Magic Wand
	[-7420] = "D15/70/90/110|10940",	-- Enchant Chest - Minor Health
	[-7443] = "D20/80/100/120|10938|6342",	-- Enchant Chest - Minor Mana
	[-7426] = "D40/90/110/130|10940:2 10938",	-- Enchant Chest - Minor Absorption
	[20744] = "25124|D45/55/65/75|10940:2 17034 3371",	-- Minor Wizard Oil
	[-7454] = "D45/95/115/135|10940 10938:2",	-- Enchant Cloak - Minor Resistance
	[-7457] = "D50/100/120/140|10940:3",	-- Enchant Bracer - Minor Stamina
	[-7766] = "D60/105/125/145|10938:2|6344",	-- Enchant Bracer - Minor Spirit
	[-7748] = "D60/105/125/145|10940:2 10938:2",	-- Enchant Chest - Lesser Health
	[11288] = "14807|D70/110/130/150|4470 10939",	-- Greater Magic Wand
	[-7771] = "D90/110/130/150|10940:3 10939",	-- Enchant Cloak - Minor Protection
	[-7779] = "D80/115/135/155|10940:2 10939",	-- Enchant Bracer - Minor Agility
	[-7782] = "D80/115/135/155|10940:5|6347",	-- Enchant Bracer - Minor Strength
	[-7776] = "D80/115/135/155|10939 10938|6346",	-- Enchant Chest - Lesser Mana
	[-7786] = "D90/120/140/160|10940:4 10939:2|6348",	-- Enchant Weapon - Minor Beastslayer
	[-7788] = "D90/120/140/160|10940:2 10939 10978",	-- Enchant Weapon - Minor Striking
	[6339] = "7795|D100/130/150/170|6338 10940:6 10939:3 6218",	-- Runed Silver Rod
	[-7793] = "D100/130/150/170|10939:3|6349",	-- Enchant 2H Weapon - Lesser Intellect
	[-7745] = "D100/130/150/170|10940:4 10978",	-- Enchant 2H Weapon - Minor Impact
	[-13378] = "D105/130/150/170|10998 10940:2",	-- Enchant Shield - Minor Stamina
	[-13380] = "D110/135/155/175|10998 10940:6|11038",	-- Enchant 2H Weapon - Lesser Spirit
	[-13419] = "D110/135/155/175|10998|11039",	-- Enchant Cloak - Minor Agility
	[-13421] = "D115/140/160/180|10940:6 10978",	-- Enchant Cloak - Lesser Protection
	[-13464] = "D115/140/160/180|10998 10940 10978|11081",	-- Enchant Shield - Lesser Protection
	[-7859] = "D120/145/165/185|10998:2|6375",	-- Enchant Bracer - Lesser Spirit
	[-7857] = "D120/145/165/185|10940:4 10998",	-- Enchant Chest - Health
	[-7867] = "D125/150/170/190|10940:6 10998:2|6377",	-- Enchant Boots - Minor Agility
	[-7863] = "D125/150/170/190|10940:8",	-- Enchant Boots - Minor Stamina
	[-7861] = "D125/150/170/190|6371 10998",	-- Enchant Cloak - Lesser Fire Resistance
	[-13501] = "D130/155/175/195|11083:2",	-- Enchant Bracer - Lesser Stamina
	[-13485] = "D130/155/175/195|10998:2 10940:4",	-- Enchant Shield - Lesser Spirit
	[-13522] = "D135/160/180/200|11082 6048|11098",	-- Enchant Cloak - Lesser Shadow Resistance
	[-13536] = "D140/165/185/205|11083:2|11101",	-- Enchant Bracer - Lesser Strength
	[-13538] = "D140/165/185/205|10940:2 11082 11084",	-- Enchant Chest - Lesser Absorption
	[-13503] = "D140/165/185/205|11083:2 11084",	-- Enchant Weapon - Lesser Striking
	[-13529] = "D145/170/190/210|11083:3 11084",	-- Enchant 2H Weapon - Lesser Impact
	[-13607] = "D145/170/190/210|11082 10998:2",	-- Enchant Chest - Mana
	[-13620] = "D145/170/190/210|11083 6370:3|11152",	-- Enchant Gloves - Fishing
	[-13617] = "D145/170/190/210|11083 3356:3|11151",	-- Enchant Gloves - Herbalism
	[-13612] = "D145/170/190/210|11083 2772:3|11150",	-- Enchant Gloves - Mining
	[20745] = "25125|D150/160/170/180|11083:3 17034:2 3372|20752",	-- Minor Mana Oil
	[11130] = "13628|D150/175/195/215|11128 5500 11082:2 11083:2 6339",	-- Runed Golden Rod
	[-13622] = "D150/175/195/215|11082:2",	-- Enchant Bracer - Lesser Intellect
	[-13626] = "D150/175/195/215|11082 11083 11084",	-- Enchant Chest - Minor Stats
	[11289] = "14809|D155/175/195/215|11291 11134 11083",	-- Lesser Mystic Wand
	[-13635] = "D155/175/195/215|11138 11083:3",	-- Enchant Cloak - Defense
	[-13631] = "D155/175/195/215|11134 11083",	-- Enchant Shield - Lesser Stamina
	[-13637] = "D160/180/200/220|11083 11134",	-- Enchant Boots - Lesser Agility
	[-13640] = "D160/180/200/220|11083:3",	-- Enchant Chest - Greater Health
	[-13642] = "D165/185/205/225|11134",	-- Enchant Bracer - Spirit
	[-13644] = "D170/190/210/230|11083:4",	-- Enchant Boots - Lesser Stamina
	[-13646] = "D170/190/210/230|11134 11083:2|11163",	-- Enchant Bracer - Lesser Deflection
	[-13648] = "D170/190/210/230|11083:6",	-- Enchant Bracer - Stamina
	[11290] = "14810|D175/195/215/235|11291 11135 11137",	-- Greater Mystic Wand
	[-13657] = "D175/195/215/235|11134 7068",	-- Enchant Cloak - Fire Resistance
	[-13653] = "D175/195/215/235|11134 5637:2 11138|11164",	-- Enchant Weapon - Lesser Beastslayer
	[-13655] = "D175/195/215/235|11134 7067 11138|11165",	-- Enchant Weapon - Lesser Elemental Slayer
	[-13661] = "D180/200/220/240|11137",	-- Enchant Bracer - Strength
	[-13659] = "D180/200/220/240|11135 11137",	-- Enchant Shield - Spirit
	[-13663] = "D185/205/225/245|11135",	-- Enchant Chest - Greater Mana
	[-13687] = "D190/210/230/250|11135 11134:2|11167",	-- Enchant Boots - Lesser Spirit
	[-21931] = "D190/210/230/250|11135:3 11137:3 11139 3819:2|17725",	-- Enchant Weapon - Winter's Might
	[-13689] = "D195/215/235/255|11135:2 11137:2 11139|11168",	-- Enchant Shield - Lesser Block
	[-13693] = "D195/215/235/255|11135:2 11139",	-- Enchant Weapon - Striking
	[20746] = "25126|D200/210/220/230|11137:3 17035:2 3372",	-- Lesser Wizard Oil
	[11145] = "13702|D200/220/240/260|11144 7971 11135:2 11137:2 11130",	-- Runed Truesilver Rod
	[-13695] = "D200/220/240/260|11137:4 11139",	-- Enchant 2H Weapon - Impact
	[-13700] = "D200/220/240/260|11135:2 11137:2 11139",	-- Enchant Chest - Lesser Stats
	[-13698] = "D200/220/240/260|11137 7392:3|11166",	-- Enchant Gloves - Skinning
	[-13746] = "D205/225/245/265|11137:3",	-- Enchant Cloak - Greater Defense
	[-13794] = "D205/225/245/265|11174",	-- Enchant Cloak - Resistance
	[-13822] = "D210/230/250/270|11174:2",	-- Enchant Bracer - Intellect
	[-13815] = "D210/230/250/270|11174 11137",	-- Enchant Gloves - Agility
	[-13817] = "D210/230/250/270|11137:5|11202",	-- Enchant Shield - Stamina
	[-13836] = "D215/235/255/275|11137:5",	-- Enchant Boots - Stamina
	[-13841] = "D215/235/255/275|11137:3 6037:3|11203",	-- Enchant Gloves - Advanced Mining
	[-13846] = "D220/240/260/280|11174:3 11137|11204",	-- Enchant Bracer - Greater Spirit
	[-13858] = "D220/240/260/280|11137:6",	-- Enchant Chest - Superior Health
	[-13890] = "D225/245/265/285|11177 7909 11174",	-- Enchant Boots - Minor Speed
	[-13882] = "D225/245/265/285|11174:2|11206",	-- Enchant Cloak - Lesser Agility
	[-13868] = "D225/245/265/285|11137:3 8838:3|11205",	-- Enchant Gloves - Advanced Herbalism
	[-13887] = "D225/245/265/285|11174:2 11137:3",	-- Enchant Gloves - Strength
	[-13917] = "D230/250/270/290|11175 11174:2",	-- Enchant Chest - Superior Mana
	[-13905] = "D230/250/270/290|11175 11176:2",	-- Enchant Shield - Greater Spirit
	[-13915] = "D230/250/270/290|11177 11176:2 9224|11208",	-- Enchant Weapon - Demonslaying
	[-13935] = "D235/255/275/295|11175:2",	-- Enchant Boots - Agility
	[-13931] = "D235/255/275/295|11175 11176:2|11223",	-- Enchant Bracer - Deflection
	[-13933] = "D235/255/275/295|11178 3829|11224",	-- Enchant Shield - Frost Resistance
	[-13937] = "D240/260/280/300|11178:2 11176:2",	-- Enchant 2H Weapon - Greater Impact
	[-13939] = "D240/260/280/300|11176:2 11175",	-- Enchant Bracer - Greater Strength
	[-13945] = "D245/265/285/305|11176:5|11225",	-- Enchant Bracer - Greater Stamina
	[-13941] = "D245/265/285/305|11178 11176:3 11175:2",	-- Enchant Chest - Stats
	[-13943] = "D245/265/285/305|11178:2 11175:2",	-- Enchant Weapon - Greater Striking
	[12810] = "17181|D250/250/255/260|8170 16202",	-- Enchanted Leather
	[12655] = "17180|D250/250/255/260|12359 11176:3",	-- Enchanted Thorium
	[20747] = "25127|D250/260/270/280|11176:3 8831:2 8925|20754||20747",	-- Lesser Mana Oil
	[-13948] = "D250/270/290/310|11178:2 8153:2",	-- Enchant Gloves - Minor Haste
	[-13947] = "D250/270/290/310|11178:2 11176:3|11226",	-- Enchant Gloves - Riding Skill
	[-20008] = "D255/275/295/315|16202:3|16214",	-- Enchant Bracer - Greater Intellect
	[-20020] = "D260/280/300/320|11176:10|16215",	-- Enchant Boots - Greater Stamina
	[11811] = "15596|D265/285/305/325|11382 7078 14343:3|11813",	-- Smoking Heart of the Mountain
	[-20014] = "D265/285/305/325|16202:2 7077 7075 7079 7081 7972|16216",	-- Enchant Cloak - Greater Resistance
	[-20017] = "D265/285/305/325|11176:10|16217",	-- Enchant Shield - Greater Stamina
	[-13898] = "D265/285/305/325|11177:4 7078|11207",	-- Enchant Weapon - Fiery Weapon
	[-20009] = "D270/290/310/330|16202:3 11176:10|16218",	-- Enchant Bracer - Superior Spirit
	[-20012] = "D270/290/310/330|16202:3 16204:3|16219",	-- Enchant Gloves - Greater Agility
	[20750] = "25128|D275/285/295/305|16204:3 4625:2 8925|20755||20750",	-- Wizard Oil
	[-20024] = "D275/295/315/335|16203:2 16202|16220",	-- Enchant Boots - Spirit
	[-20026] = "D275/295/315/335|16204:6 14343|16221",	-- Enchant Chest - Major Health
	[-20016] = "D280/300/320/340|16203:2 16204:4|16222",	-- Enchant Shield - Superior Spirit
	[-20015] = "D285/300/317/335|16204:8|16224",	-- Enchant Cloak - Superior Defense
	[-20029] = "D285/300/317/335|14343:4 7080 7082 13467|16223",	-- Enchant Weapon - Icy Chill
	[16207] = "20051|D290/305/322/340|16206 13926 16204:10 16203:4 11145 14344:2|16243",	-- Runed Arcanite Rod
	[-27837] = "D290/305/322/340|14344:10 16203:6 16204:14 7082:4|22392",	-- Enchant 2H Weapon - Agility
	[-23801] = "D290/305/322/340|16204:16 16203:4 7080:2|19446",	-- Enchant Bracer - Mana Regeneration
	[-20028] = "D290/305/322/340|16203:3 14343|16242",	-- Enchant Chest - Major Mana
	[-23800] = "D290/305/322/340|14344:6 16203:6 16204:4 7082:2|19445",	-- Enchant Weapon - Agility
	[-23799] = "D290/305/322/340|14344:6 16203:6 16204:4 7076:2|19444",	-- Enchant Weapon - Strength
	[-20030] = "D295/310/325/340|14344:4 16204:10|16247",	-- Enchant 2H Weapon - Superior Impact
	[-20023] = "D295/310/325/340|16203:8|16245",	-- Enchant Boots - Greater Agility
	[-20010] = "D295/310/325/340|16204:6 16203:6|16246",	-- Enchant Bracer - Superior Strength
	[-20013] = "D295/310/325/340|16203:4 16204:4|16244",	-- Enchant Gloves - Greater Strength
	[-20033] = "D295/310/325/340|14344:4 12808:4|16248",	-- Enchant Weapon - Unholy Weapon
	[20748] = "25130|D300/310/320/330|14344:2 8831:3 18256|20757",	-- Brilliant Mana Oil
	[20749] = "25129|D300/310/320/330|14344:2 4625:3 18256|20756",	-- Brilliant Wizard Oil
	[22461] = "32664|D300/310/325/340|25843 16203:4 14344:6 16207",	-- Runed Fel Iron Rod
	[19] = "42613|D300/300/300/305|20725|||22448", --Nexus Transformation
	[-20036] = "D300/310/325/340|16203:12 14344:2|16249",	-- Enchant 2H Weapon - Major Intellect
	[-20035] = "D300/310/325/340|16203:12 14344:2|16255",	-- Enchant 2H Weapon - Major Spirit
	[-34002] = "D300/310/325/340|22445:6",	-- Enchant Bracer - Assault
	[-23802] = "D300/310/325/340|14344:2 16204:20 16203:4 12803:6|19447",	-- Enchant Bracer - Healing Power
	[-20011] = "D300/310/325/340|16204:15|16251",	-- Enchant Bracer - Superior Stamina
	[-20025] = "D300/310/325/340|14344:4 16204:15 16203:10|16253",	-- Enchant Chest - Greater Stats
	[-33991] = "D300/310/325/340|22447:2 22445:2",	-- Enchant Chest - Restore Mana Prime
	[-25086] = "D300/310/325/340|22448:3 22446:3 22452:8|33148",	-- Enchant Cloak - Dodge
	[-25081] = "D300/310/325/340|22448:3 22446:3 7078:4|20732",	-- Enchant Cloak - Greater Fire Resistance
	[-25082] = "D300/310/325/340|22448:2 22446:3 12803:4|20733",	-- Enchant Cloak - Greater Nature Resistance
	[-25083] = "D300/310/325/340|22448:3 22446:3 22794:2|33149",	-- Enchant Cloak - Stealth
	[-25084] = "D300/310/325/340|22448:4 22446:2 22456:8|33150",	-- Enchant Cloak - Subtlety
	[-25078] = "D300/310/325/340|20725:2 14344:10 7078:4|20729",	-- Enchant Gloves - Fire Power
	[-25074] = "D300/310/325/340|20725:3 14344:10 7080:4|20728",	-- Enchant Gloves - Frost Power
	[-25079] = "D300/310/325/340|20725:3 14344:8 12811|20730",	-- Enchant Gloves - Healing Power
	[-25073] = "D300/310/325/340|20725:3 14344:10 12808:6|20727",	-- Enchant Gloves - Shadow Power
	[-25080] = "D300/310/325/340|22448:3 22446:3 22451:2|33152",	-- Enchant Gloves - Superior Agility
	[-25072] = "D300/310/325/340|22448:4 22446:2 21886:8|33153",	-- Enchant Gloves - Threat
	[-20034] = "D300/310/325/340|14344:4 12811:2|16252",	-- Enchant Weapon - Crusader
	[-22750] = "D300/310/325/340|14344:4 16203:8 12803:6 7080:6 12811|18260",	-- Enchant Weapon - Healing Power
	[-20032] = "D300/310/325/340|14344:6 12808:6 12803:6|16254",	-- Enchant Weapon - Lifestealing
	[-23804] = "D300/310/325/340|14344:15 16203:12 16204:20|19449",	-- Enchant Weapon - Mighty Intellect
	[-23803] = "D300/310/325/340|14344:10 16203:8 16204:15|19448",	-- Enchant Weapon - Mighty Spirit
	[-22749] = "D300/310/325/340|14344:4 16203:12 7078:4 7080:4 7082:4 13926:2|18259",	-- Enchant Weapon - Spell Power
	[-20031] = "D300/310/325/340|14344:2 16203:10|16250",	-- Enchant Weapon - Superior Striking
	[-27948] = "D305/315/330/345|22445:6 13446:4 13444:4|22542",	-- Enchant Boots - Vitality
	[-27899] = "D305/315/330/345|22445:6",	-- Enchant Bracer - Brawn
	[-34001] = "D305/315/330/345|22447:3",	-- Enchant Bracer - Major Intellect
	[-33993] = "D305/315/330/345|22447 22445:4",	-- Enchant Gloves - Blasting
	[22521] = "28016|D310/310/320/330|22445:3 22791 18256|22562||22521",	-- Superior Mana Oil
	[-34004] = "D310/320/335/350|22446 22445:4 22451",	-- Enchant Cloak - Greater Agility
	[-27961] = "D310/320/335/350|22445:8",	-- Enchant Cloak - Major Armor
	[-33996] = "D310/320/335/350|22445:8",	-- Enchant Gloves - Assault
	[-27944] = "D310/320/335/350|22445:6 22452:10",	-- Enchant Shield - Tough Shield
	[-27905] = "D315/325/340/355|22445:6 22447:6",	-- Enchant Bracer - Stats
	[-27957] = "D315/325/340/355|22445:8 13446:4 14344:2",	-- Enchant Chest - Exceptional Health
	[-27950] = "D320/330/345/360|22445:12|22543",	-- Enchant Boots - Fortitude
	[-27906] = "D320/330/345/360|22448:2 22445:10|22530",	-- Enchant Bracer - Major Defense
	[-33990] = "D320/330/345/360|22446:2",	-- Enchant Chest - Major Spirit
	[22460] = "28027|D325/325/330/335|22449:4",	-- Prismatic Sphere
	[-27911] = "D325/335/350/365|22446:4 21886:4|24000",	-- Enchant Bracer - Superior Healing
	[-34003] = "D325/335/350/365|22446:2 22445:6 22457:2|28274",	-- Enchant Cloak - Spell Penetration
	[-27945] = "D325/335/350/365|22446:4|22539",	-- Enchant Shield - Intellect
	[-34009] = "D325/335/350/365|22445:15|28282",	-- Enchant Shield - Major Stamina
	[-27962] = "D330/340/355/370|22446:4 21884:4 22451:4 22452:4 21885:4|22548",	-- Enchant Cloak - Major Resistance
	[-44383] = "D330/340/355/370|22449 22447:4", --Enchant Shield Resilience
	[21] = "28022|D335/0/0/335|22448:3|22565||22449",	-- Large Prismatic Shard
	[-27913] = "D335/345/360/375|22446:8|22532",	-- Enchant Bracer - Restore Mana Prime
	[20] = "42615|D335/0/335/335|22449|42615|3|22448", --Small Prismatic Shard
	[22522] = "28019|D340/340/350/360|22445:3 22792 18256|22563||22522",	-- Superior Wizard Oil
	[-27951] = "D340/350/365/380|22446:8 22445:8|22544",	-- Enchant Boots - Dexterity
	[-33995] = "D340/350/365/380|22445:12 22446",	-- Enchant Gloves - Major Strength
	[-27946] = "D340/350/365/380|22445:12 22446:4 22452:10|22540",	-- Enchant Shield - Shield Block
	[-27968] = "D340/350/365/380|22449:2 22446:10|22551",	-- Enchant Weapon - Major Intellect
	[-27967] = "D340/350/365/380|22449:2 22446:6 22445:6|22552",	-- Enchant Weapon - Major Striking
	[-27960] = "D345/355/367/380|22449:4 22445:4 22446:4|24003",	-- Enchant Chest - Exceptional Stats
	[-33992] = "D345/355/367/380|22446:4 22445:10|28270",	-- Enchant Chest - Major Resilience
	[22459] = "28028|D350/370/375/380|22450:2",	-- Void Sphere
	[22462] = "32665|D350/370/375/380|25844 22446:8 22449:8 23571 22461|25848",	-- Runed Adamantite Rod
	[-27971] = "D350/370/375/380|22449:4 22445:40|22554",	-- Enchant 2H Weapon - Savagery
	[-27914] = "D350/370/375/380|22449 22446:10 22445:20|22533",	-- Enchant Bracer - Fortitude
	[-34005] = "D350/370/375/380|22449:4 22457:8|28276",	-- Enchant Cloak - Greater Arcane Resistance
	[-34006] = "D350/370/375/380|22449:4 22456:8|28277",	-- Enchant Cloak - Greater Shadow Resistance
	[-33999] = "D350/370/375/380|22446:6 22449:6 21886:6|28273",	-- Enchant Gloves - Major Healing
	[-34010] = "D350/370/375/380|22449:8 21885:8 21886:8|28281",	-- Enchant Weapon - Major Healing
	[-27975] = "D350/370/375/380|22449:8 22446:8|22555",	-- Enchant Weapon - Major Spellpower
	[-27972] = "D350/370/375/380|22449:4 22446:5 22445:20|22553",	-- Enchant Weapon - Potency
   	[-42620] = "D350/360/367/375|22445:8 22446:4 22449:6 22451:2|33165",	-- Enchant Weapon - Greater Agility
	[-27977] = "D360/370/377/385|22449:8 22446:6 22445:20|22556",	-- Enchant 2H Weapon - Major Agility
	[-34008] = "D360/370/377/385|22449:8 22452:8|28280",	-- Enchant Boots - Boar's Speed
	[-34007] = "D360/370/377/385|22449:8 22451:8|28279",	-- Enchant Boots - Cat's Swiftness
	[-27917] = "D360/370/385/400|22449:6 21884:6 21885:6|22534",	-- Enchant Bracer - Spellpower
	[-33997] = "D360/370/377/385|22446:6 22449:6 22457:6|28272",	-- Enchant Gloves - Major Spellpower
	[-33994] = "D360/370/377/385|22446:8 22445:2 22449:2|28271",	-- Enchant Gloves - Spell Strike
	[-27924] = "D360/370/377/385|22449:2 22446:2|22536",	-- Enchant Ring - Spellpower
	[-27920] = "D360/370/377/385|22449:2 22445:6|22535",	-- Enchant Ring - Striking
	[-27947] = "D360/370/377/385|22449:2 22573 22574 22572 22578|22541",	-- Enchant Shield - Resistance
	[-28004] = "D360/370/377/385|22450:8 22449:8 21885:2|22557",	-- Enchant Weapon - Battlemaster
	[-28003] = "D360/370/377/385|22449:12 22446:10 22445:20|22558",	-- Enchant Weapon - Spellsurge
	[-27954] = "D370/380/385/390|22450:2 22449:4|22545",	-- Enchant Boots - Surefooted
	[-27926] = "D370/380/385/390|22449:2 22446:3 22445:5|22537",	-- Enchant Ring - Healing Power
	[22463] = "32667|D375/375/377/385|25845 22446:6 22445:6 22462|25849",	-- Runed Eternium Rod
	[-27927] = "D375/380/385/390|22450:2 22449:2|22538",	-- Enchant Ring - Stats
	[-27984] = "D375/380/385/390|22450:6 22449:10 22446:8 22445:40|22559",	-- Enchant Weapon - Mongoose
	[-27982] = "D375/380/385/390|22450:12 22449:10 22446:8 21885:6 22456:6|22561",	-- Enchant Weapon - Soulfrost
	[-27981] = "D375/0/375/390|22450:12 22449:10 22446:8 21884:6 23571|22560",	-- Enchant Weapon - Sunfire
	[-42974] = "D375/380/385/390|22450:6 22449:10 22446:6 22445:30 22824:3|33307", --Enchant Weapon: Executioner
--	[-27958] = "D375/360/370/380|22449 13444:4 22446:3",	-- Enchant Chest - Exceptional Mana
--[[ Engineering --]]
	[8067] = "3920|E1/30/45/60|4357 2840||200",	-- Crafted Light Shot
	[4357] = "3918|E1/20/30/40|2835",	-- Rough Blasting Powder
	[4358] = "3919|E1/30/45/60|4357:2 2589||2",	-- Rough Dynamite
	[4359] = "3922|E30/45/52/60|2840",	-- Handful of Copper Bolts
	[4360] = "3923|E30/60/75/90|2840 4359 4357:2 2589||2",	-- Rough Copper Bomb
	[4362] = "3925|E50/80/95/110|4361 4359 4399",	-- Rough Boomstick
	[6219] = "7430|E50/70/80/90|2840:6",	-- Arclight Spanner
	[4361] = "3924|E50/80/95/110|2840:2 2880",	-- Copper Tube
	[4405] = "3977|E60/90/105/120|4361 774 4359",	-- Crude Scope
	[4363] = "3926|E65/95/110/125|4359:2 2840 2589:2",	-- Copper Modulator
	[4364] = "3929|E75/85/90/95|2836",	-- Coarse Blasting Powder
	[4365] = "3931|E75/90/97/105|4364:3 2589||2",	-- Coarse Dynamite
	[8068] = "3930|E75/85/90/95|4364 2840||200",	-- Crafted Heavy Shot
	[4401] = "3928|E75/105/120/135|4363 4359 2840 774:2|4408||4401",	-- Mechanical Squirrel
	[4366] = "3932|E85/115/130/145|4363 4359:2 2841 2592",	-- Target Dummy
	[4404] = "3973|E90/110/125/140|2842||5",	-- Silver Contact
	[4368] = "3934|E100/130/145/160|2318:6 818:2",	-- Flying Tiger Goggles
	[6714] = "8339|E100/115/122/130|4364:4 2592|6716|2",	-- EZ-Thro Dynamite
	[6712] = "8334|E100/115/122/130|2841 4359:2 2880",	-- Practice Lock
	[4367] = "3933|E100/130/145/160|4364:2 4363 2318 159|4409",	-- Small Seaforium Charge
	[4369] = "3936|E105/130/142/155|4361:2 4359:4 4399 2319:2",	-- Deadly Blunderbuss
	[4371] = "3938|E105/105/130/155|2841:2 2880",	-- Bronze Tube
	[4370] = "3937|E105/105/130/155|2840:3 4364:4 4404||3",	-- Large Copper Bomb
	[4406] = "3978|E110/135/147/160|4371 1206",	-- Standard Scope
	[4372] = "3939|E120/145/157/170|4371:2 4359:2 4400 1206:3|13309",	-- Lovingly Crafted Boomstick
	[4373] = "3940|E120/145/157/170|2319:4 1210:2|4410",	-- Shadow Goggles
	[4374] = "3941|E120/120/145/170|4364:4 2841:2 4404 2592||2",	-- Small Bronze Bomb
	[7506] = "9269|E125/150/162/175|2841:6 4375 814:2 818 774|7560",	-- Gnomish Universal Remote
	[8069] = "3947|E125/125/135/145|4377 2841||200",	-- Crafted Solid Shot
	[4376] = "3944|E125/125/150/175|4375 4402|4411",	-- Flame Deflector
	[4377] = "3945|E125/125/135/145|2838",	-- Heavy Blasting Powder
	[4378] = "3946|E125/125/135/145|4377:2 2592||3",	-- Heavy Dynamite
	[21558] = "26416|E125/125/137/150|4364 2319|21724|3",	-- Small Blue Rocket
	[21559] = "26417|E125/125/137/150|4364 2319|21725|3",	-- Small Green Rocket
	[21557] = "26418|E125/125/137/150|4364 2319|21726|3",	-- Small Red Rocket
	[4375] = "3942|E125/125/150/175|2841:2 2592",	-- Whirring Bronze Gizmo
	[4379] = "3949|E130/155/167/180|4371:2 4375:2 4400 2842:3",	-- Silver-plated Shotgun
	[4381] = "3952|E140/165/177/190|4371 4375:2 2319:2 1206|14639",	-- Minor Recombobulator
	[5507] = "6458|E135/160/172/185|4371:2 4375:2 4363 1206",	-- Ornate Spyglass
	[4380] = "3950|E140/140/165/190|4377:2 2841:3 4404||3",	-- Big Bronze Bomb
	[4383] = "3954|E145/170/182/195|4371:3 4375:3 4400 1705:2|4412",	-- Moonsight Rifle
	[4382] = "3953|E145/145/170/195|2841:2 2319 2592",	-- Bronze Framework
	[4386] = "3957|E155/175/185/195|4375 3829|13308",	-- Ice Deflector
	[4385] = "3956|E150/175/187/200|2319:4 1206:2 4368",	-- Green Tinted Goggles
	[6533] = "9271|E150/150/160/170|2841:2 6530 4364||3",	-- Aquadynamic Fish Attractor
	[9312] = "23067|E150/150/162/175|4377 4234|18649|3",	-- Blue Firework
	[4388] = "3959|E160/180/190/200|4375:3 4306:2 1529 4371|4413",	-- Discombobulator Ray
	[4384] = "3955|E150/175/187/200|4382 4375 4377:2 2592:2",	-- Explosive Sheep
	[10558] = "12584|E150/150/170/190|3577||3",	-- Gold Power Core
	[9313] = "23068|E150/150/162/175|4377 4234|18648|3",	-- Green Firework
	[9318] = "23066|E150/150/162/175|4377 4234|18647|3",	-- Red Firework
	[4387] = "3958|E160/160/170/180|3575:2",	-- Iron Strut
	[7148] = "9273|E165/165/180/200|3575:6 4375:2 814:2 4306:2 1210:2 7191|7561",	-- Goblin Jumper Cables
	[4403] = "3960|E165/185/195/205|4371:4 4387 4377:4 2319:4|4414",	-- Portable Bronze Mortar
	[4407] = "3979|E180/200/210/220|4371 1529 3864|13310",	-- Accurate Scope
	[4389] = "3961|E170/170/190/210|3575 10558",	-- Gyrochronatom
	[10499] = "12587|E175/195/205/215|4234:6 3864:2|10601",	-- Bright-Eye Goggles
	[4391] = "3963|E175/175/195/215|4387:2 4382 4389:2 4234:4",	-- Compact Harvest Reaper Kit
	[10498] = "12590|E175/175/195/215|3859:4",	-- Gyromatic Micro-Adjustor
	[4390] = "3962|E175/175/195/215|3575 4377 4306||3",	-- Iron Grenade
	[21589] = "26420|E175/175/187/200|4377 4234|21727|3",	-- Large Blue Rocket
	[21590] = "26421|E175/175/187/200|4377 4234|21728|3",	-- Large Green Rocket
	[21592] = "26422|E175/175/187/200|4377 4234|21729|3",	-- Large Red Rocket
	[10505] = "12585|E175/175/185/195|7912:2",	-- Solid Blasting Powder
	[10507] = "12586|E175/175/185/195|10505 4306||2",	-- Solid Dynamite
	[4393] = "3966|E185/205/215/225|4234:6 3864:2|4415",	-- Craftsman's Monocle
	[4392] = "3965|E185/185/205/225|4387 4382 4389 4234:4",	-- Advanced Target Dummy
	[4852] = "8243|E185/185/205/225|4611 4377 4306|6672",	-- Flash Bomb
	[4394] = "3967|E190/190/210/230|3575:3 4377:3 4404||2",	-- Big Iron Bomb
	[4397] = "3971|E200/220/230/240|4389:4 1529:2 1705:2 3864:2 7191|7742",	-- Gnomish Cloaking Device
	[4396] = "3969|E200/220/230/240|4382 4387:4 4389:4 3864:2 7191|13311",	-- Mechanical Dragonling
	[17716] = "21940|E190/190/210/230|3860:8 4389:4 17202:4 3829|17720",	-- SnowMaster 9000
	[4395] = "3968|E195/215/225/235|4377:3 3575:2 4389|4416",	-- Goblin Land Mine
	[10559] = "12589|E195/195/215/235|3860:3",	-- Mithril Tube
	[18588] = "23069|E200/200/210/220|10505 4338:2|18650",	-- EZ-Thro Dynamite II
	[4398] = "3972|E200/200/220/240|10505:2 4234:2 159|4417",	-- Large Seaforium Charge
	[11590] = "15255|E200/200/220/240|3860 4338 10505",	-- Mechanical Repair Kit
	[10560] = "12591|E200/200/220/240|3860 4338 10505",	-- Unstable Trigger
	[10500] = "12594|E205/225/235/245|4385 3864:2 7068:2 4234:4",	-- Fire Goggles
	[10508] = "12595|E205/225/235/245|10559 10560 4400 3860:4 7068:2",	-- Mithril Blunderbuss
	[10512] = "12596|E210/210/230/250|3860 10505||200",	-- Hi-Impact Mithril Slugs
	[10546] = "12597|E210/230/240/250|10559 7909:2 4304:2|10602",	-- Deadly Scope
	[10721] = "12903|Eg215/235/245/255|7387 3860:4 6037:2 10560 7909:2",	-- Gnomish Harm Prevention Belt
	[10561] = "12599|E215/215/235/255|3860:3",	-- Mithril Casing
	[10514] = "12603|E215/215/235/255|10561 10560 10505||3",	-- Mithril Frag Bomb
	[10501] = "12607|E220/240/250/260|4304:4 7909:2 10592|10603",	-- Catseye Ultra Goggles
	[10510] = "12614|E220/240/250/260|10559:2 10560 4400 3860:6 3864:2|10604",	-- Mithril Heavy-bore Rifle
	[10518] = "12616|E225/245/255/265|4339:4 10285:2 10560 10505:4|10606",	-- Parachute Cloak
	[10502] = "12615|E225/245/255/265|4304:4 7910:2|10605",	-- Spellpower Goggles Xtreme
	[21571] = "26423|E225/225/237/250|10505 4304|21730|3",	-- Blue Rocket Cluster
	[21569] = "26442|E225/245/255/265|9060 9061 10560 10561|44919",	-- Firework Launcher
	[21574] = "26424|E225/225/237/250|10505 4304|21731|3",	-- Green Rocket Cluster
	[21576] = "26425|E225/225/237/250|10505 4304|21732|3",	-- Red Rocket Cluster
	[10506] = "12617|E230/250/260/270|3860:8 10561 6037 818:4 774:4|10607",	-- Deepdive Helmet
	[10503] = "12618|E230/250/260/270|4304:6 7910:2",	-- Rose Colored Goggles
	[10562] = "12619|E235/235/255/275|10561:2 10560 10505:2||4",	-- Hi-Explosive Bomb
	[10548] = "12620|E240/260/270/280|10559 7910 6037:2|10608",	-- Sniper Scope
	[10504] = "12622|E245/265/275/285|4304:8 1529:3 7909:3 10286:2 8153:2",	-- Green Lens
	[10513] = "12621|E245/245/265/285|3860:2 10505:2||200",	-- Mithril Gyro-Shot
	[15992] = "19788|E250/250/255/260|12365:2",	-- Dense Blasting Powder
	[18641] = "23070|E250/250/260/270|15992:2 14047:3||2",	-- Dense Dynamite
	[10576] = "12624|E250/270/280/290|3860:14 7077:4 6037:4 9060:2 9061:2 7910:2|10609",	-- Mithril Mechanical Dragonling
	[15846] = "19567|E250/270/280/290|10561 12359:6 10558 10560:4",	-- Salt Shaker
	[19026] = "23507|E250/250/260/270|15992:2 14047:2 8150|19027|4",	-- Snake Burst Firework
	[21277] = "26011|E250/320/330/340|15407 15994:4 7079:2 18631:2 10558",	-- Tranquil Mechanical Yeti
	[18634] = "23077|E260/280/290/300|15994:6 18631:2 12361:2 7078:4 3829:2 13467:4|18652",	-- Gyrofreeze Ice Reflector
	[15995] = "19792|E260/280/290/300|10559:2 10561:2 15994:2 12359:4 10546|16043",	-- Thorium Rifle
	[15993] = "19790|E260/280/290/300|15994 12359:3 15992:3 14047:3|16041|3",	-- Thorium Grenade
	[15994] = "19791|E260/280/290/300|12359:3 14047|16042",	-- Thorium Widget
	[18631] = "23071|E260/270/275/280|6037:2 7067:2 7069|18651",	-- Truesilver Transformer
	[15996] = "19793|E265/285/295/305|12803 15994:4 10558 8170|16044",	-- Lifelike Mechanical Toad
	[15999] = "19794|E270/290/300/310|10502 7910:4 12810:2 14047:8|16045",	-- Spellpower Goggles Xtreme Plus
	[16004] = "19796|E275/295/305/315|16000:2 11371:6 10546:2 12361:2 12799:2 8170:4|16048",	-- Dark Iron Rifle
	[18637] = "23079|E275/285/290/295|16000:2 18631 14047:2|18655",	-- Major Recombobulator
	[21570] = "26443|E275/295/305/315|9060:4 9061:4 18631:2 10561|44918",	-- Firework Cluster Launcher
	[7191] = "39895|E275/275/280/285|20816:3 7078:2|32381||7191",	-- Fused Wiring
	[21714] = "26426|E275/275/280/285|15992 8170|21733|3",	-- Large Blue Rocket Cluster
	[21716] = "26427|E275/275/280/285|15992 8170|21734|3",	-- Large Green Rocket Cluster
	[21718] = "26428|E275/275/280/285|15992 8170|21735|3",	-- Large Red Rocket Cluster
	[16023] = "19814|E275/295/305/315|10561 16000 15994:2 6037 8170:2 14047:4|16046",	-- Masterwork Target Dummy
	[18594] = "23080|E275/275/285/295|15994:2 15992:3 8170:2 159|18656",	-- Powerful Seaforium Charge
	[16000] = "19795|E275/295/305/315|12359:6|16047",	-- Thorium Tube
	[15997] = "19800|E285/295/300/305|12359:2 15992|16051|200",	-- Thorium Shells
	[16005] = "19799|E285/305/315/325|15994:2 11371 15992:3 14047:3|16049|3",	-- Dark Iron Bomb
	[16006] = "19815|E285/305/315/325|12360 14227|16050",	-- Delicate Arcanite Converter
	[18638] = "23081|E290/310/320/330|11371:4 18631:3 7080:6 7910:4 12800:2|18657",	-- Hyper-Radiant Flame Reflector
	[16008] = "19825|E290/310/320/330|10500 12364:2 12810:4|16053",	-- Master Engineer's Goggles
	[16009] = "19819|E290/310/320/330|16006:2 10558 15994 12799|16052",	-- Voice Amplification Modulator
	[18282] = "22795|E300/320/330/340|17010:4 17011:2 12360:6 16006:2 16000:2|18292",	-- Core Marksman Rifle
	[18168] = "22797|E300/320/330/340|12360:6 16006:2 7082:8 12803:12 7076:8|18291",	-- Force Reactive Disk
	[16022] = "19830|E300/320/330/340|10576 16006:8 12655:10 15994:6 10558:4 12810:6|16054",	-- Arcanite Dragonling
	[18283] = "22793|E300/320/330/340|17011:2 7076:2 16006:4 11371:6 16000|18290",	-- Biznicks 247x128 Accurascope
	[19999] = "24356|E300/320/330/340|19726:4 19774:5 16006:2 12804:8 12810:4|20000",	-- Bloodvine Goggles
	[19998] = "24357|E300/320/330/340|19726:5 19774:5 16006 12804:8 12810:4|20001",	-- Bloodvine Lens
	[16007] = "19833|E300/320/330/340|12360:10 16000:2 7078:2 7076:2 12800:2 12810:2|16056",	-- Flawless Arcanite Rifle
	[18639] = "23082|E300/320/330/340|11371:8 18631:4 12803:6 12808:4 12800:2 12799:2|18658",	-- Ultra-Flash Shadow Reflector
	[16040] = "19831|E300/320/330/340|16006 12359:3 14047|16055|3",	-- Arcane Bomb
	[23781] = "30303|E300/300/310/320|22574 22573:2||4",	-- Elemental Blasting Powder
	[23736] = "30310|E300/320/330/340|23782 23783:2 23781||4",	-- Fel Iron Bomb
	[23782] = "30304|E300/300/310/320|23445:3",	-- Fel Iron Casing
	[18232] = "22704|E300/320/330/340|12359:16 7191:2",	-- Field Repair Bot 74A (New Mats in 2.3)
	[23783] = "30305|E300/300/305/310|23445",	-- Handful of Fel Iron Bolts
	[23821] = "30548|E305/305/315/325|23782:2 23783:2 21886:4 16006|23888",	-- Zapthrottle Mote Extractor
	[23772] = "30346|E310/310/320/330|23445:2 23781||200",	-- Fel Iron Shells
	[23742] = "30312|E320/330/340/350|4400 23782:3 23783:6",	-- Fel Iron Musket
	[23774] = "30348|E325/325/335/345|23782 23445:5 23783:2|23816",	-- Fel Iron Toolbox
	[23784] = "30306|E325/325/330/335|23446:4 22452",	-- Adamantite Frame
	[23737] = "30311|E325/335/345/355|23446:4 23783:2 23781||3",	-- Adamantite Grenade
	[23767] = "30337|E325/335/345/355|23784 23782:2 10558 23783:2|23810",	-- Crashin' Thrashin' Robot
	[33092] = "30551|E330/330/340/350|23782 23783 21887:2 22829:20|23883", -- Healing Potion Injector, added after r45586 -- also 35310
	[33093] = "30552|E345/345/355/365|23782 23783 21887:2 22832:20|23884", -- Mana Potion Injector, added after r45586 -- also 35311
	[34504] = "30347|E335/335/345/355|23446 23781:2 4470:4|23815",	-- Adamantite Shell Machine (Changed in 2.3)
	[23764] = "30329|E335/345/355/365|23446:8 23112:2|23807",	-- Adamantite Scope
	[23771] = "30344|E335/335/345/355|23781 21877 2605|23814|3",	-- Green Smoke Flare
	[32423] = "39971|E335/335/340/345|21885 23781:2 21877:2||10",	-- Icy Blasting Primers
	[25886] = "32814|E335/335/345/355|23781 21877 4342|25887|3",	-- Purple Smoke Flare
	[23768] = "30341|E335/335/345/355|23781 21877|23811|3",	-- White Smoke Flare
	[20475] = "43676|E335/335/345/355|23446 4470:4 23783:2|33804", -- Adamantite Arrow Maker
	[23758] = "30316|E340/350/360/370|23793:4 23077:2 22445:8|23803",	-- Cogspinner Goggles
	[23761] = "30317|E340/350/360/370|23793:4 21929:2 22445:8|23804",	-- Power Amplification Goggles
	[32478] = "41317|E350/370/380/390|23793:6 23786 23785:2 23787:4 23572 23436:2",	-- Deathblow X11 Goggles
	[32494] = "41320|E350/370/380/390|23793:6 23786 23785:2 23787:4 23572 23438:2",	-- Destruction Holo-gogs
	[32461] = "40274|E350/370/380/390|23793:6 23786 23785:2 23787:4 23572 23436:2",	-- Furious Gizmatic Goggles
	[32476] = "41315|E350/370/380/390|23793:6 23786 23785:2 23787:4 23572 23436:2",	-- Gadgetstorm Goggles
	[32472] = "41311|E350/370/380/390|23793:6 23786 23785:2 23787:4 23572 23440:2",	-- Justicebringer 2000 Specs
	[32475] = "41316|E350/370/380/390|23793:6 23786 23785:2 23787:4 23572 23439:2",	-- Living Replicator Specs
	[32480] = "41319|E350/370/380/390|23793:6 23786 23785:2 23787:4 23572 23437:2",	-- Magnified Moon Specs
	[32495] = "41321|E350/370/380/390|23793:6 23786 23785:2 23787:4 23572 23439:2",	-- Powerheal 4000 Lens
	[32474] = "41314|E350/370/380/390|23793:6 23786 23785:2 23787:4 23572 23441:2",	-- Surestrike Goggles v2.0
	[32473] = "41312|E350/370/380/390|23793:6 23786 23785:2 23787:4 23572 23437:2",	-- Tankatronic Goggles
	[32479] = "41318|E350/370/380/390|23793:6 23786 23785:2 23787:4 23572 23440:2",	-- Wonderheal XT40 Shades
	[23762] = "30318|E350/360/370/380|23793:4 23449:2 23079:2 22448:2|23805",	-- Ultra-Spectropic Detection Goggles
	[23746] = "30313|E350/360/370/380|23782:3 23784:2 23783:4|23799",	-- Adamantite Rifle
	[23819] = "30547|E350/350/355/360|23781:2 23782 23783|23874|2",	-- Elemental Seaforium Charge
	[23787] = "30309|E340/350/360/370|23448:2",	-- Felsteel Stabilizer
	[23785] = "30307|E340/350/360/370|23573:3",	-- Hardened Adamantite Tube
	[23786] = "30308|E340/350/360/370|23449:3 21884",	-- Khorium Power Core
	[34060] = "44155|E350/375/380/385|23784:2 23445:30 23783:8 11291:8 23446:5 23819:4", -- Flying Machine Control
	[23824] = "30556|E355/365/375/385|23793:8 23786:2 23785:2 23787:4|23887",	-- Rocket Boots Xtreme
	[23747] = "30314|E360/370/380/390|23785 23787:4 23783:4|23800",	-- Felsteel Boomstick
	[23763] = "30325|E360/370/380/390|23793:4 23449:2 23441:2 22449:2|23806",	-- Hyper-Vision Goggles
	[23765] = "30332|E360/370/380/390|23785 23449:4 23440:2|23808",	-- Khorium Scope
	[34113] = "44391|E360/370/380/390|23446:8 23783:8 23786|34114|5", -- Field Repair Bot110g
	[32756] = "41307|E375/375/392/410|23785 23449:20 23787:4 21884:12 22451:12 23572",	-- Gyro-balanced Khorium Destroyer
	[23748] = "30315|E375/385/395/405|23785:2 23449:12 23783:4 23439:2|23802",	-- Ornate Khorium Rifle
	[23766] = "30334|E375/385/395/405|23785:2 23787:6 23438:2|23809",	-- Stabilized Eternium Scope
	--[23820] = "30549|E375|23784 23783:2 10558",	-- Critter Enlarger [currently not in game since TBC beta] 2.1.2
	[32413] = "39973|E335/345/355/365|32423 23782 23783||5",	-- Frost Grenades
--[[ Gnomish Engineering --]]
	[10716] = "12899|Eg205/225/235/245|10559 10560 3860:4 8151:4 1529:2",	-- Gnomish Shrink Ray
	[10713] = "12895|Eg205/0/0/205|10648 10647",	-- Inlaid Mithril Cylinder Plans
	[11826] = "15633|Eg205/0/0/205|7075 4389:2 7191 3860:2 6037|11827",	-- Lil' Smoky
	[10545] = "12897|Eg210/230/240/250|10500 10559 10558:2 8151:2 4234:2",	-- Gnomish Goggles
	[10720] = "12902|Eg210/230/240/250|10559 10285:2 4337:4 10505:2 3860:4",	-- Gnomish Net-o-Matic Projector
	[10724] = "12905|Eg225/245/255/265|10026 10559:2 4234:4 10505:8 4389:4",	-- Gnomish Rocket Boots
	[10725] = "12906|Eg230/250/260/270|10561 6037:6 3860:6 9060:2 10558 1529:2",	-- Gnomish Battle Chicken
	[10726] = "12907|Eg235/255/265/275|3860:10 6037:4 10558 7910:2 4338:4",	-- Gnomish Mind Control Cap
	[10645] = "12759|Eg240/260/270/280|10559:2 10560 12808 7972:4 9060",	-- Gnomish Death Ray
	[18986] = "23489|Eg260/285/295/305|3860:12 18631:2 7075:4 7079:2 7909:4 9060",	-- Ultrasafe Transporter - Gadgetzan
	[18660] = "23129|Eg260/260/265/270|10561 15994:2 10558 10560 3864|18661",	-- World Enlarger
	[18645] = "23096|Eg265/275/280/285|12359:4 15994:2 8170:4 7910 7191|18654",	-- Alarm-O-Bot
	[23841] = "30568|Eg325/335/345/355|23784 23783:2 23781:3 23782||3",	-- Gnomish Flame Turret
	[23835] = "30569|Eg340/360/370/380|23785:2 23786:2 22445:10 22449:2",	-- Gnomish Poultryizer
	[23825] = "30570|Eg350/360/370/380|23793:8 23786:4 21886:10 22456:10 16006:2",	-- Nigh-Invulnerability Belt
	[30544] = "36955|Eg350/350/360/370|23784 22451:2 23787:2 23783:4 23786",	-- Ultrasafe Transporter - Toshley's Station
	[23829] = "30575|Eg375/375/385/395|23793:8 22456:12 22452:12 21884:12 23436:2",	-- Gnomish Battle Goggles
	[23828] = "30574|Eg375/375/385/395|24271:4 21884:8 22451:8 22452:8 21885:8 23437:2",	-- Gnomish Power Goggles
--[[ Goblin Engineering --]]
	[10543] = "12718|Eb205/225/235/245|3860:8 3864 7068:4",	-- Goblin Construction Helmet
	[10542] = "12717|Eb205/225/235/245|3860:8 3864 7067:4",	-- Goblin Mining Helmet
	[10644] = "12715|Eb205/0/0/205|10648 10647",	-- Goblin Rocket Fuel Recipe
	[10646] = "12760|Eb205/205/225/245|4338 10505:3 10560",	-- Goblin Sapper Charge
	[11825] = "15628|Eb205/0/0/205|4394 7077 7191 3860:6|11828",	-- Pet Bombling
	[15] = "12716|Eb205/225/235/245|10559:2 3860:4 10505:5 10558 7068|||10577",	-- Goblin Mortar
	[16] = "13240|Eb205/0/0/205|10577 3860 10505:3|||10577",	-- The Mortar: Reloaded
	[7189] = "8895|Eb225/245/255/265|10026 10559:2 4234:4 9061:2 10560",	-- Goblin Rocket Boots
	[10587] = "12755|Eb230/230/250/270|10561:2 10505:4 6037:6 10560 4407:2",	-- Goblin Bomb Dispenser
	[10586] = "12754|Eb235/235/255/275|10561 9061 10507:6 10560||2",	-- The Big One
	[10727] = "12908|Eb240/260/270/280|10559:2 9061:4 3860:6 6037:6 10560",	-- Goblin Dragon Gun
	[10588] = "12758|Eb245/265/275/285|10543 9061:4 3860:4 10560",	-- Goblin Rocket Helmet
	[18984] = "23486|Eb260/285/295/305|3860:10 18631 7077:4 7910:2 10586",	-- Dimensional Ripper - Everlook
	[18587] = "23078|Eb265/285/295/305|15994:2 18631:2 7191:2 14227:2 7910:2|18653",	-- Goblin Jumper Cables XL
	[23826] = "30558|Eb325/325/335/345|23782:3 23781:6 17020:3 23783:2||3",	-- The Bigger One
	[23827] = "30560|Eb340/340/350/360|21877:4 23781:4 22457||2",	-- Super Sapper Charge
	[23836] = "30563|Eb350/360/370/380|23785:2 23786 23787:2 21884:6 22452:6 16006:2",	-- Goblin Rocket Launcher
	[30542] = "36954|Eb350/350/360/370|23784 21884:2 23826:2 23783:4 23786",	-- Dimensional Ripper - Area 52
	[23838] = "30565|Eb375/375/385/395|24272:4 22457:12 22451:12",	-- Foreman's Enchanted Helmet
	[23839] = "30566|Eb375/375/385/395|23573:8 22452:12 21884:12",	-- Foreman's Reinforced Helmet
--[[ First Aid --]]
	[1251] = "3275|X1/30/45/60|2589",	-- Linen Bandage
	[2581] = "3276|X40/50/75/100|2589:2",	-- Heavy Linen Bandage
	[6452] = "7934|X80/80/115/150|1475||3",	-- Anti-Venom
	[3530] = "3277|X80/80/115/150|2592",	-- Wool Bandage
	[3531] = "3278|X115/115/150/185|2592:2",	-- Heavy Wool Bandage
	[6453] = "7935|X130/130/165/200|1288|6454|3",	-- Strong Anti-Venom
	[6450] = "7928|X150/150/180/210|4306",	-- Silk Bandage
	[6451] = "7929|X180/180/210/240|4306:2|16112",	-- Heavy Silk Bandage
	[8544] = "10840|X210/210/240/270|4338|16113",	-- Mageweave Bandage
	[8545] = "10841|X240/240/270/300|4338:2",	-- Heavy Mageweave Bandage
	[14529] = "18629|X260/260/290/320|14047",	-- Runecloth Bandage
	[14530] = "18630|X290/290/320/350|14047:2",	-- Heavy Runecloth Bandage
	[19440] = "23787|X300/300/330/360|19441|19442",	-- Powerful Anti-Venom
	[21990] = "27032|X330/330/347/365|21877|21992",	-- Netherweave Bandage
	[21991] = "27033|X360/360/367/375|21877:2|21993",	-- Heavy Netherweave Bandage
--[[ Jewelcrafting --]]
	[20906] = "25493|J1/30/45/60|20816:2",	-- Braided Copper Ring
	[21931] = "26925|J1/30/45/60|20816:2 2840",	-- Woven Copper Ring
	[20816] = "25255|J1/20/35/50|2840:2",	-- Delicate Copper Wire
	[25498] = "32259|J1/30/40/50|2835:8",	-- Rough Stone Statue
	[21932] = "26926|J5/35/50/65|2840:4 20816:2",	-- Heavy Copper Ring
	[25438] = "32178|J20/50/65/80|774 20816",	-- Malachite Pendant
	[25439] = "32179|J20/50/65/80|818 20816",	-- Tigerseye Band
	[20821] = "25283|J30/60/75/90|774:2 2840:2",	-- Inlaid Malachite Ring
	[21934] = "26928|J30/60/75/90|818:2 2840:2 20816",	-- Ornate Tigerseye Necklace
	[20818] = "25280|J50/80/95/110|2842",	-- Elegant Silver Ring
	[20907] = "25490|J50/80/95/110|2841:4",	-- Solid Bronze Ring
	[21933] = "26927|J50/80/95/110|2841:2 1210 20816",	-- Thick Bronze Necklace
	[20817] = "25278|J50/70/80/90|2841:2",	-- Bronze Setting
	[25880] = "32801|J50/70/80/90|2836:8",	-- Coarse Stone Statue
	[20820] = "25284|J60/90/105/120|5498 20817 2840:2",	-- Simple Pearl Ring
	[30804] = "37818|J65/95/110/125|2841:2 20817 774:3 818:3 1210:2",	-- Bronze Band of Force
	[20823] = "25287|J70/100/115/130|1210:2 20817 20816:2",	-- Gloom Band
	[30419] = "36523|J75/105/120/135|2841:4 20817 1206",	-- Brilliant Necklace
	[31154] = "38175|J80/110/125/140|2841:6 20817 1705",	-- Bronze Torc
	[20827] = "25317|J80/110/125/140|2842:2",	-- Ring of Silver Might
	[20826] = "25305|J90/120/135/150|2842:2 20817 1206 1705",	-- Heavy Silver Ring
	[20828] = "25318|J100/130/145/160|1210:2 2841:2",	-- Ring of Twilight Shadows
	[30420] = "36524|J105/135/150/165|1529 20817 3575:2",	-- Heavy Jade Ring
	[20830] = "25339|J110/140/155/170|1705:2 20817|20854",	-- Amulet of the Moon
	[20909] = "25498|J110/140/155/170|3575:8 5637:2 20817:2",	-- Barbaric Iron Collar
	[25881] = "32807|J110/120/130/140|2838:8",	-- Heavy Stone Statue
	[20832] = "25321|J120/150/165/180|1705:3 5498:3 11083:4 2842:4 3827:2",	-- Moonsoul Crown
	[20950] = "25610|J120/150/165/180|1206 20817|20970",	-- Pendant of the Agate Shield
	[20954] = "25612|J125/155/170/185|3575:8 3391:2|20971",	-- Heavy Iron Knuckles
	[20833] = "25323|J125/155/170/185|1705 3824 3575:4|20855",	-- Wicked Moonstone Ring
	[20955] = "25613|J135/165/180/195|1529 3577:2 20816:2",	-- Golden Dragon Ring
	[20958] = "25617|J150/180/195/210|3864 20963|20973",	-- Blazing Citrine Ring
	[20831] = "25320|J150/180/195/210|3577 1206:2 3391|20856",	-- Heavy Golden Necklace of Battle
	[20963] = "25615|J150/170/180/190|3860:2",	-- Mithril Filigree
	[20966] = "25618|J160/190/205/220|1529 20963:2|20974",	-- Jade Pendant of Blasting
	[20960] = "25620|J170/200/215/230|6037 20963:2",	-- Engraved Truesilver Ring
	[20959] = "25619|J170/200/215/230|1529 7067:2|20975",	-- The Jade Eye
	[25882] = "32808|J175/175/185/195|7912:10",	-- Solid Stone Statue
	[29157] = "34955|J180/190/200/210|3577:4 1705 1529 3864",	-- Golden Ring of Power
	[20961] = "25621|J180/210/225/240|3864 7070:2 3860:2",	-- Citrine Ring of Rapid Healing
	[20967] = "25622|J190/220/235/250|3864 7070:2 3577:2 20817|20976",	-- Citrine Pendant of Golden Healing
	[29158] = "34959|J200/210/220/230|6037:3 7910:2 3864:2",	-- Truesilver Commander's Ring
	[21756] = "26873|J200/225/240/255|3577:6 3864:2|21940",	-- Figurine - Golden Hare
	[21748] = "26872|J200/225/240/255|1529:4 6037:2 11137:4 20963:4",	-- Figurine - Jade Owl
	[20964] = "26874|J210/235/250/265|7909:3 8151:4",	-- Aquamarine Signet
	[21758] = "26875|J215/240/255/270|7971:4 8151:4|21941",	-- Figurine - Black Pearl Panther
	[21755] = "26876|J220/245/260/275|7909 20963:3",	-- Aquamarine Pendant of the Warrior
	[20969] = "26878|J225/250/265/280|7910:2 7971:2 6037:4 21752:4 6149:4|21942",	-- Ruby Crown of Restoration
	[21760] = "26881|J225/250/265/280|7909:2 6037:4 7075:2 7079:2 8151:4|21943",	-- Figurine - Truesilver Crab
	[25883] = "32809|J225/225/235/245|12365:10",	-- Dense Stone Statue
	[21752] = "26880|J225/235/245/255|12359",	-- Thorium Setting
	[30421] = "36525|J230/255/270/285|7910 21752",	-- Red Ring of Destruction
	[21763] = "26882|J235/260/275/290|7910:2 6037:4 7077:2 7081:2 8151:4|21944",	-- Figurine - Truesilver Boar
	[21764] = "26883|J235/260/275/290|7910 21752",	-- Ruby Pendant of Fire
	[21765] = "26885|J240/265/280/295|6037:2 10286:2",	-- Truesilver Healing Ring
	[21754] = "26887|J245/270/285/300|7909 21752|21945",	-- The Aquamarine Ward
	[21753] = "26896|J250/275/290/305|7909:2 3864:2 21752:4 6037:2|21947",	-- Gem Studded Band
	[21766] = "26897|J250/275/290/305|12799:2 21752:2 6037:4 11178:2 20963:2|21948",	-- Opal Necklace of Impact
	[21769] = "26900|J260/280/290/300|7910:2 7078:2 8152:4 6037:2|21949",	-- Figurine - Ruby Serpent
	[21767] = "26902|J260/280/290/300|12799 21752",	-- Simple Opal Ring
	[30422] = "36526|J265/285/295/305|12800 21752",	-- Diamond Focus Ring
	[21774] = "26906|J275/285/295/305|12364:2 12799:2 12361:2 12360:2 12359:2|21952",	-- Emerald Crown of Destruction
	[21768] = "26903|J275/285/295/305|12361:4 6037:2 21752",	-- Sapphire Signet
	[29159] = "34960|J280/290/300/310|12800:2 21752",	-- Glowing Thorium Band
	[21775] = "26907|J280/290/300/310|21752 12804 7076",	-- Onslaught Ring
	[21790] = "26908|J280/290/300/310|12361 12808 21752",	-- Sapphire Pendant of Winter Night
	[21777] = "26909|J285/295/305/315|12364:2 12360:2 12359:2 12804:4|21953",	-- Figurine - Emerald Owl
	[21778] = "26910|J285/295/305/315|12363 12808:2 12662|21954",	-- Ring of Bitter Shadows
	[21791] = "26911|J290/300/310/320|12364:2 12803:4 12804:4",	-- Living Emerald Pendant
	[29160] = "34961|J290/300/310/320|12364:2 21752",	-- Emerald Lion Ring
	[21784] = "26912|J300/310/320/330|18335:4 11754:4 12800:2 12360:2 12359:4|21955",	-- Figurine - Black Diamond Crab
	[21789] = "26914|J300/310/320/330|11371:4 12360:2 7910:2|21956",	-- Figurine - Dark Iron Scorpid
	[23113] = "28938|J300/300/320/340|23112|23148",	-- Brilliant Golden Draenite
	[23108] = "28925|J300/300/320/340|23107|23144",	-- Glowing Shadow Draenite
	[23098] = "28910|J300/300/320/340|21929|23135",	-- Inscribed Flame Spessarite
	[23103] = "28916|J300/300/320/340|23079|23140",	-- Radiant Deep Peridot
	[23118] = "28950|J300/300/320/340|23117|23152",	-- Solid Azure Moonstone
	[23094] = "28903|J300/300/320/340|23077|23130",	-- Teardrop Blood Garnet
	[21792] = "26915|J305/315/325/335|12800:2 21752:2 12360:2|21957",	-- Necklace of the Diamond Tower
	[23095] = "28905|J305/305/325/345|23077|23131",	-- Bold Blood Garnet
	[28595] = "34590|J305/305/325/345|23077|28596",	-- Bright Blood Garnet
	[23114] = "28944|J305/305/325/345|23112|23149",	-- Gleaming Golden Draenite
	[23104] = "28917|J305/305/325/345|23079|23141",	-- Jagged Deep Peridot
	[23099] = "28912|J305/305/325/345|21929|23136",	-- Luminous Flame Spessarite
	[23109] = "28927|J305/305/325/345|23107|23145",	-- Royal Shadow Draenite
	[23119] = "28953|J305/305/325/345|23117|23153",	-- Sparkling Azure Moonstone
	[21779] = "26916|J310/320/330/340|21929 7078:4 12803:4",	-- Band of Natural Fire
	[24074] = "31048|J310/320/330/340|23445 23077:2",	-- Fel Iron Blood Ring
	[24075] = "31049|J310/320/335/350|23445 23112:2",	-- Golden Draenite Ring
	[23105] = "28918|J315/315/335/355|23079|23142",	-- Enduring Deep Peridot
	[23100] = "28914|J315/315/335/355|21929|23137",	-- Glinting Flame Spessarite
	[23096] = "28906|J315/315/335/355|23077|23133",	-- Runed Blood Garnet
	[23110] = "28933|J315/315/335/355|23107|23146",	-- Shifting Shadow Draenite
	[23120] = "28955|J315/315/335/355|23117|23154",	-- Stormy Azure Moonstone
	[23115] = "28947|J315/315/335/355|23112|23150",	-- Thick Golden Draenite
	[24076] = "31050|J320/330/340/350|23445 23117:2 23079",	-- Azure Moonstone Ring
	[32772] = "41414|J325/335/345/355|24478:8 23447:2",	-- Brilliant Pearl Band
	[31079] = "38068|J325/325/335/345|24243:4 22452",	-- Mercurial Adamantite
	[23106] = "28924|J325/325/340/355|23079|23143",	-- Dazzling Deep Peridot
	[23097] = "28907|J325/325/340/355|23077|23134",	-- Delicate Blood Garnet
	[23121] = "28957|J325/325/340/355|23117|23155",	-- Lustrous Azure Moonstone
	[23101] = "28915|J325/325/340/355|21929|23138",	-- Potent Flame Spessarite
	[32833] = "41420|J325/325/332/340|24478 27860",	-- Purified Jaggal Pearl
	[23116] = "28948|J325/325/340/355|23112|23151",	-- Rigid Golden Draenite
	[28290] = "34069|J325/325/340/355|23112|28291",	-- Smooth Golden Draenite
	[23111] = "28936|J325/325/340/355|23107|23147",	-- Sovereign Shadow Draenite
	[32774] = "41415|J330/340/350/360|24479 31079:4",	-- The Black Pearl
	[24078] = "31052|J335/345/355/365|23446 31079",	-- Heavy Adamantite Ring
	[24077] = "31051|J335/345/355/365|23446:2 31079",	-- Thick Adamantite Necklace
	[32508] = "40514|J340/340/355/370|22578:3 24478:10 24479",	-- Necklace of the Deep
	[24087] = "31058|J345/355/365/375|23448:2 31079:4|24163",	-- Heavy Felsteel Ring
	[31863] = "39463|J350/350/365/380|23441|31876",	-- Balanced Nightseye, pattern added
	[24027] = "31084|J350/350/365/380|23436|24193",	-- Bold Living Ruby, pattern added
	[24031] = "31089|J350/350/365/380|23436|24192",	-- Bright Living Ruby, pattern added --also 35306
	[24047] = "31096|J350/350/365/380|23440|24203",	-- Brilliant Dawnstone, pattern in
	[24065] = "31112|J350/350/365/380|23437|24219",	-- Dazzling Talasite, pattern in
	[24028] = "31085|J350/350/365/380|23436|24194",	-- Delicate Living Ruby, pattern in
	[24062] = "31110|J350/350/365/380|23437|24217",	-- Enduring Talasite, pattern in
	[24036] = "31091|J350/350/365/380|23436|24198",	-- Flashing Living Ruby, pattern in
	[24050] = "31099|J350/350/365/380|23440|24206",	-- Gleaming Dawnstone, pattern in
	[24061] = "31109|J350/350/365/380|23439|24216",	-- Glinting Noble Topaz, pattern in
	[24056] = "31104|J350/350/365/380|23441|24211",	-- Glowing Nightseye, pattern in
	[31861] = "39452|J350/350/365/380|23440|31875",	-- Great Dawnstone, pattern added
	[31865] = "39462|J350/350/365/380|23441|31877",	-- Infused Nightseye
	[24058] = "31106|J350/350/365/380|23439|24213",	-- Inscribed Noble Topaz, pattern in
	[24067] = "31113|J350/350/365/380|23437|24220",	-- Jagged Talasite, pattern in
	[24079] = "31053|J350/360/370/380|23449:2 31079:3 22456:3|24158",	-- Khorium Band of Shadows, pattern in
	[24060] = "31108|J350/350/365/380|23439|24215",	-- Luminous Noble Topaz, pattern in
	[24037] = "31094|J350/350/365/380|23438|24201",	-- Lustrous Star of Elune, pattern in
	[24053] = "31101|J350/350/365/380|23440|24208",	-- Mystic Dawnstone
	[24059] = "31107|J350/350/365/380|23439|24214",	-- Potent Noble Topaz, pattern in
	[32836] = "41429|J350/350/365/380|24479 27860",	-- Purified Shadow Pearl
	[24066] = "31111|J350/350/365/380|23437|24218",	-- Radiant Talasite, pattern in
	[24051] = "31098|J350/350/365/380|23440|24205",	-- Rigid Dawnstone, pattern in -- also 35307
	[24057] = "31105|J350/350/365/380|23441|24212",	-- Royal Nightseye, pattern in
	[24030] = "31088|J350/350/365/380|23436|24196",	-- Runed Living Ruby, pattern in  --also 35305
	[24055] = "31103|J350/350/365/380|23441|24210",	-- Shifting Nightseye, pattern in
	[24048] = "31097|J350/350/365/380|23440|24204",	-- Smooth Dawnstone, pattern in
	[24033] = "31092|J350/350/365/380|23438|24199",	-- Solid Star of Elune, pattern in -- also 35304
	[24054] = "31102|J350/350/365/380|23441|24209",	-- Sovereign Nightseye, pattern in
	[24035] = "31149|J350/350/365/380|23438|24200",	-- Sparkling Star of Elune, pattern in
	[24039] = "31095|J350/350/365/380|23438|24202",	-- Stormy Star of Elune, pattern in
	[24032] = "31090|J350/350/365/380|23436|24197",	-- Subtle Living Ruby, pattern in
	[24029] = "31087|J350/350/365/380|23436|24195",	-- Teardrop Living Ruby, pattern in
	[24052] = "31100|J350/350/365/380|23440|24207",	-- Thick Dawnstone, pattern in
	[31867] = "39470|J350/350/365/380|23439|31878",	-- Veiled Noble Topaz
	[31868] = "39471|J350/350/365/380|23439|31879",	-- Wicked Noble Topaz
	[33782] = "43493|J350/350/365/380|23437|33783|1|33782", --Steady Talasite
	[24088] = "31060|J355/365/375/385|23447 31079:5|24164",	-- Delicate Eternium Ring
	[24080] = "31054|J355/365/372/380|23449:2 31079:4 21885:3|24159",	-- Khorium Band of Frost
	[24082] = "31055|J355/365/372/380|23449:2 31079:4 21884:3|24160",	-- Khorium Inferno Band
	[24110] = "31068|J355/365/375/385|23449:4 31079 23436|24167",	-- Living Ruby Pendant
	[24106] = "31067|J355/365/375/385|23448:2 31079:3|24166",	-- Thick Felsteel Necklace
	[24114] = "31070|J360/370/377/385|23447:2 31079:3|24168",	-- Braided Eternium Chain
	[24116] = "31071|J360/370/375/380|23573:2 31079:2 23441|24169",	-- Eye of the Night
	[24085] = "31056|J360/370/375/380|23449:2 31079:4 21886:3|24161",	-- Khorium Band of Leaves
	[24092] = "31062|J360/370/375/380|23448:2 21885:6 21884:4 31079|24174",	-- Pendant of Frozen Flame
	[24097] = "31065|J360/370/375/380|23448:2 21886:6 22456:4 31079|24177",	-- Pendant of Shadow's End
	[24093] = "31063|J360/370/375/380|23448:2 21884:6 21885:4 31079|24175",	-- Pendant of Thawing
	[24098] = "31066|J360/370/375/380|23448:2 22457:8 31079|24178",	-- Pendant of the Null Rune
	[24095] = "31064|J360/370/375/380|23448:2 22456:6 21886:4 31079|24176",	-- Pendant of Withering
	[30825] = "37855|J360/370/375/380|23447:2 22457:8|30826",	-- Ring of Arcane Shielding
	[24086] = "31057|J365/370/375/380|23449:2 31079:4 22457:3|24162",	-- Arcane Khorium Band
	[24089] = "31061|J365/375/377/380|23447:2 31079:4 21884:4|24165",	-- Blazing Eternium Band
	[25897] = "32867|J365/375/377/380|25867|25903",	-- Bracing Earthstorm Diamond
	[25899] = "32869|J365/375/377/380|25867|25906",	-- Brutal Earthstorm Diamond
	[24121] = "31076|J365/375/380/385|23449:2 31079:4 23117:2|24171",	-- Chain of the Twilight Owl
	[32776] = "41418|J365/375/380/385|23449:12 31079:4 24478:20 24479:3",	-- Crown of the Sea Witch
	[25890] = "32871|J365/375/377/380|25868|25907",	-- Destructive Skyfire Diamond
	[24117] = "31072|J365/375/380/385|23447:2 31079:4 23112:2|24170",	-- Embrace of the Dawn
	[25895] = "32874|J365/375/377/380|25868|25910",	-- Enigmatic Skyfire Diamond
	[25901] = "32870|J365/375/377/380|25867|25904",	-- Insightful Earthstorm Diamond
	[25893] = "32872|J365/375/377/380|25868|25909",	-- Mystical Skyfire Diamond
	[25896] = "32866|J365/375/377/380|25867|25902",	-- Powerful Earthstorm Diamond
	[32409] = "39961|J365/375/377/380|25867|32412",	-- Relentless Earthstorm Diamond
	[25894] = "32873|J365/375/377/380|25868|25908",	-- Swift Skyfire Diamond
	[25898] = "32868|J365/375/377/380|25867|25905",	-- Tenacious Earthstorm Diamond
	[32410] = "39963|J365/375/377/380|25868|32411",	-- Thundering Skyfire Diamond
	[33140] = "42592|J360/365/370/375|23440|33159|1|33140", -- Blood of Amber
	[33131] = "42589|J360/365/370/375|23436|33156|1|33131", -- Crimson Sun
	[33133] = "42558|J360/365/370/375|23436|33305|1|33133", -- Don Julio's Heart
	[33144] = "42593|J360/365/370/375|23440|33160|1|33144", --Facet of Eternity
	[33135] = "42590|J360/365/370/375|23438|33157|1|33135", --Falling Star
	[33134] = "42588|J360/365/370/375|23436|33155|1|33134", --Kailee's Rose
	[33143] = "42591|J360/365/370/375|23440|33158|1|33143", --Stone of Blades
	[34220] = "44794|J365/375/377/380|25868|34689", --Chaotic Skyfire Diamond
	[24123] = "31078|J370/375/380/385|23448:20 22457:20 23438:2 31079:5|24173",	-- Circlet of Arcane Might
	[24122] = "31077|J370/375/380/385|23449:20 21886:20 23437:2 31079:5|24172",	-- Coronet of the Verdant Flame
	[24125] = "31080|J370/375/380/385|23449:4 23440:2 23112:4|24180",	-- Figurine - Dawnstone Crab
	[24124] = "31079|J370/375/380/385|23448:8 23077:2 22452:4|24179",	-- Figurine - Felsteel Boar
	[24126] = "31081|J370/375/380/385|23448:2 23436:2 21884:4|24181",	-- Figurine - Living Ruby Serpent
	[24128] = "31083|J370/375/380/385|23573:6 23441:2 22456:2|24183",	-- Figurine - Nightseye Panther
	[24127] = "31082|J370/375/380/385|23447:2 23437:2 22457:4|24182",	-- Figurine - Talasite Owl
	[32213] = "39729|J375/375/380/385|32230|32299",	-- Balanced Shadowsong Amethyst
	[32193] = "39705|J375/375/380/385|32227|32274",	-- Bold Crimson Spinel
	[32197] = "39712|J375/375/380/385|32227|32283",	-- Bright Crimson Spinel
	[32204] = "39719|J375/375/380/385|32229|32290",	-- Brilliant Lionseye
	[32225] = "39741|J375/375/380/385|32249|32311",	-- Dazzling Seaspray Emerald
	[32194] = "39706|J375/375/380/385|32227|32277",	-- Delicate Crimson Spinel
	[32223] = "39739|J375/375/380/385|32249|32309",	-- Enduring Seaspray Emerald
	[32199] = "39714|J375/375/380/385|32227|32285",	-- Flashing Crimson Spinel
	[32207] = "39722|J375/375/380/385|32229|32293",	-- Gleaming Lionseye
	[32220] = "39736|J375/375/380/385|32231|32306",	-- Glinting Pyrestone
	[32215] = "39731|J375/375/380/385|32230|32301",	-- Glowing Shadowsong Amethyst
	[32210] = "39725|J375/375/380/385|32229|32296",	-- Great Lionseye
	[32214] = "39730|J375/375/380/385|32230|32300",	-- Infused Shadowsong Amethyst
	[32217] = "39733|J375/375/380/385|32231|32303",	-- Inscribed Pyrestone
	[32226] = "39742|J375/375/380/385|32249|32312",	-- Jagged Seaspray Emerald
	[32219] = "39735|J375/375/380/385|32231|32305",	-- Luminous Pyrestone
	[32202] = "39717|J375/375/380/385|32228|32288",	-- Lustrous Empyrean Sapphire
	[32209] = "39724|J375/375/380/385|32229|32295",	-- Mystic Lionseye
	[32218] = "39734|J375/375/380/385|32231|32304",	-- Potent Pyrestone
	[32224] = "39740|J375/375/380/385|32249|32310",	-- Radiant Seaspray Emerald
	[32206] = "39721|J375|32229|32292", --Rigid Lionseye
	[32216] = "39732|J375/375/380/385|32230|32302",	-- Royal Shadowsong Amethyst
	[32196] = "39711|J375/375/380/385|32227|32282",	-- Runed Crimson Spinel
	[32212] = "39728|J375/375/380/385|32230|32298",	-- Shifting Shadowsong Amethyst
	[32205] = "39720|J375/375/380/385|32229|32291",	-- Smooth Lionseye
	[32200] = "39715|J375/375/380/385|32228|32286",	-- Solid Empyrean Sapphire
	[32211] = "39727|J375/375/380/385|32230|32297",	-- Sovereign Shadowsong Amethyst
	[32201] = "39716|J375/375/380/385|32228|32287",	-- Sparkling Empyrean Sapphire
	[32203] = "39718|J375/375/380/385|32228|32289",	-- Stormy Empyrean Sapphire
	[32198] = "39713|J375/375/380/385|32227|32284",	-- Subtle Crimson Spinel
	[32195] = "39710|J375/375/380/385|32227|32281",	-- Teardrop Crimson Spinel
	[31398] = "38503|J375/375/380/385|31079:4 23449:2 21885:6 21884:6|31401",	-- The Frozen Eye
	[31399] = "38504|J375/375/380/385|31079:4 23448:2 21886:6 22456:6|31402",	-- The Natural Ward
	[32208] = "39723|J375/375/380/385|32229|32294",	-- Thick Lionseye
	[32221] = "39737|J375/375/380/385|32231|32307",	-- Veiled Pyrestone
	[32222] = "39738|J375/375/380/385|32231|32308",	-- Wicked Pyrestone
	[32206] = "39721|J375/375/380/385|32229",	-- Rigid Lionseye
	[31862] = "39455|J325/325/340/355|23107|31871",	-- Balanced Shadow Draenite
	[31860] = "39451|J325/325/340/355|23112|31870",	-- Great Golden Draenite
	[31864] = "39458|J325/325/340/355|23107|31872",	-- Infused Shadow Draenite
	[31866] = "39466|J325/325/340/355|21929|31873",	-- Veiled Flame Spessarite
	[31869] = "39467|J325/325/340/355|21929|31874",	-- Wicked Flame Spessarite
--[[ Leatherworking --]]
	[2302] = "2149|L1/40/55/70|2318:2 2320",	-- Handstitched Leather Boots
	[7277] = "9059|L1/40/55/70|2318:2 2320:3",	-- Handstitched Leather Bracers
	[7276] = "9058|L1/40/55/70|2318:2 2320",	-- Handstitched Leather Cloak
	[5957] = "7126|L1/40/55/70|2318:3 2320",	-- Handstitched Leather Vest
	[2304] = "2152|L1/30/45/60|2318",	-- Light Armor Kit
	[2318] = "2881|L1/20/30/40|2934:3",	-- Light Leather
	[2303] = "2153|L15/45/60/75|2318:4 2320",	-- Handstitched Leather Pants
	[4237] = "3753|L25/55/70/85|2318:6 2320",	-- Handstitched Leather Belt
	[7278] = "9060|L30/60/75/90|2318:4 2320:2",	-- Light Leather Quiver
	[7279] = "9062|L30/60/75/90|2318:3 2320:4",	-- Small Leather Ammo Pouch
	[7280] = "9064|L35/65/80/95|2318:5 2320:5|7288",	-- Rugged Leather Pants
	[4231] = "3816|L35/55/65/75|783 4289",	-- Cured Light Hide
	[2300] = "2160|L40/70/85/100|2318:8 2320:4",	-- Embossed Leather Vest
	[5081] = "5244|L40/70/85/100|5082:3 2318:4 2320|5083",	-- Kodo Hide Bag
	[2309] = "2161|L55/85/100/115|2318:8 2320:5",	-- Embossed Leather Boots
	[4239] = "3756|L55/85/100/115|2318:3 2320:2",	-- Embossed Leather Gloves
	[2310] = "2162|L60/90/105/120|2318:5 2320:2",	-- Embossed Leather Cloak
	[2311] = "2163|L60/90/105/120|2318:8 2320:2 2324|2407",	-- White Leather Jerkin
	[7281] = "9065|L70/100/115/130|2318:6 2320:4",	-- Light Leather Bracers
	[4242] = "3759|L75/105/120/135|4231 2318:6 2320:2",	-- Embossed Leather Pants
	[2312] = "2164|L75/105/120/135|4231 2318:4 2320:2|2408",	-- Fine Leather Gloves
	[4246] = "3763|L80/110/125/140|2318:6 2320:2",	-- Fine Leather Belt
	[2308] = "2159|L85/105/120/135|2318:10 2321:2",	-- Fine Leather Cloak
	[4243] = "3761|L85/115/130/145|4231:3 2318:6 2320:4",	-- Fine Leather Tunic
	[6466] = "7953|L90/120/135/150|6470:4 4231 2321|6474",	-- Deviate Scale Cloak
	[6709] = "8322|L90/115/130/145|2318:6 4231 2320:4 5498|6710",	-- Moonglow Vest
	[5780] = "6702|L90/120/135/150|5784:8 2318:6 2321|5786",	-- Murloc Scale Belt
	[2307] = "2158|L90/120/135/150|2318:7 2320:2|2406",	-- Fine Leather Boots
	[7282] = "9068|L95/125/140/155|2318:10 4231 2321",	-- Light Leather Pants
	[5781] = "6703|L95/125/140/155|5784:12 4231 2318:8 2321|5787",	-- Murloc Scale Breastplate
	[7283] = "9070|L100/125/137/150|7286:12 2319:4 2321|7289",	-- Black Whelp Cloak
	[20575] = "24940|L100/125/137/150|2319:8 7286:8 4231 2321:2|20576",	-- Black Whelp Tunic
	[2317] = "2169|L100/125/137/150|2319:6 2321 4340|2409",	-- Dark Leather Tunic
	[4244] = "3762|L100/125/137/150|4243 4231:2 2320:2|4293",	-- Hillman's Leather Vest
	[4233] = "3817|L100/115/122/130|4232 4289",	-- Cured Medium Hide
	[2315] = "2167|L100/125/137/150|2319:4 2321:2 4340",	-- Dark Leather Boots
	[2313] = "2165|L100/115/122/130|2319:4 2320",	-- Medium Armor Kit
	[2319] = "20648|L100/100/105/110|2318:4",	-- Medium Leather
	[6467] = "7954|L105/130/142/155|6470:5 2321:2|6475",	-- Deviate Scale Gloves
	[5958] = "7133|L105/130/142/155|2319:8 2997 2321|5972",	-- Fine Leather Pants
	[2316] = "2168|L110/135/147/160|2319:8 2321 4340",	-- Dark Leather Cloak
	[6468] = "7955|L115/140/152/165|6471:6 6470:4 2321:2|6476",	-- Deviate Scale Belt
	[5961] = "7135|L115/140/152/165|2319:12 4340 2321",	-- Dark Leather Pants
	[4248] = "3765|L120/155/167/180|2312 4233 2321 4340|7360",	-- Dark Leather Gloves
	[4250] = "3767|L120/145/157/170|2319:8 3383 2321:2|4294",	-- Hillman's Belt
	[7285] = "9074|L120/145/157/170|2457 2319:6 2321",	-- Nimble Leather Gloves
	[7284] = "9072|L120/145/157/170|7287:6 2319:4 2321|7290",	-- Red Whelp Gloves
	[2314] = "2166|L120/145/157/170|2319:10 4231:2 2321:2",	-- Toughened Leather Armor
	[4249] = "3766|L125/150/162/175|4246 4233 2321:2 4340",	-- Dark Leather Belt
	[7348] = "9145|L125/150/162/175|2319:8 5116:4 2321:2",	-- Fletcher's Gloves
	[4251] = "3768|L130/155/167/180|4233 2319:4 2321",	-- Hillman's Shoulders
	[4253] = "3770|L135/160/172/185|2319:4 4233:2 3389:2 3182:2 2321:2",	-- Toughened Leather Gloves
	[7352] = "9147|L135/160/172/185|2319:6 7067 2321:2|7362",	-- Earthen Leather Shoulders
	[7349] = "9146|L135/160/172/185|2319:8 3356:4 2321:2|7361",	-- Herbalist's Gloves
	[4252] = "3769|L140/165/177/190|2319:12 3390 4340 2321:2|4296",	-- Dark Leather Shoulders
	[7358] = "9148|L140/165/177/190|2319:10 5373:2 2321:2|7363",	-- Pilferer's Gloves
	[4255] = "3772|L155/175/185/195|4234:9 2605:2 2321:4|7613",	-- Green Leather Armor
	[7359] = "9149|L145/170/182/195|2319:12 7067:2 2997:2 2321:2|7364",	-- Heavy Earthen Gloves
	[4247] = "3764|L145/170/182/195|2319:14 2321:4",	-- Hillman's Leather Gloves
	[4254] = "3771|L150/170/180/190|4234:6 5637:2 2321|4297",	-- Barbaric Gloves
	[7372] = "9194|L150/170/180/190|4234:8 2321:2",	-- Heavy Leather Ammo Pouch
	[7371] = "9193|L150/170/180/190|4234:8 2321:2",	-- Heavy Quiver
	[4236] = "3818|L150/160/165/170|4235 4289:3",	-- Cured Heavy Hide
	[4265] = "3780|L150/170/180/190|4234:5 2321",	-- Heavy Armor Kit
	[4234] = "20649|L150/150/155/160|2319:5",	-- Heavy Leather
	[18662] = "23190|L150/150/155/160|4234:2 2321|18731",	-- Heavy Leather Ball
	[3719] = "3760|L150/170/180/190|4234:5 2321:2",	-- Hillman's Cloak
	[18948] = "23399|L155/175/185/195|4234:8 4236:2 5498:4 4461 5637:4|18949",	-- Barbaric Bracers
	[4456] = "4097|L165/185/195/205|4461:4 4234:4 2321:2|13288",	-- Raptor Hide Belt
	[4455] = "4096|L165/185/195/205|4461:6 4234:4 2321:2|13287",	-- Raptor Hide Harness
	[4257] = "3774|L160/180/190/200|4236 4234:5 2321 2605 7071",	-- Green Leather Belt
	[5962] = "7147|L160/180/190/200|4234:12 4305:2 2321:2",	-- Guardian Pants
	[7373] = "9195|L165/185/195/205|4234:10 2325 2321:2|7449",	-- Dusky Leather Leggings
	[5963] = "7149|L170/190/200/210|4234:10 2321:2 1206|5973",	-- Barbaric Leggings
	[4258] = "3775|L170/190/200/210|4236:2 4234:4 2321 7071|4298",	-- Guardian Belt
	[5782] = "6704|L170/190/200/210|5785:12 4236 4234:10 2321:3|5788",	-- Thick Murloc Armor
	[4262] = "3778|L185/205/215/225|4236:4 5500:2 1529:2 3864 2321|14635",	-- Gem-studded Leather Belt
	[5964] = "7151|L175/195/205/215|4234:8 4236 2321:2",	-- Barbaric Shoulders
	[7374] = "9196|L175/195/205/215|4234:10 3824 2321:2",	-- Dusky Leather Armor
	[7375] = "9197|L175/195/205/215|7392:4 4234:10 2321:2|7450",	-- Green Whelp Armor
	[4256] = "3773|L175/195/205/215|4236:2 4234:12 3824 2321:2|4299",	-- Guardian Armor
	[7377] = "9198|L180/200/210/220|4234:6 7067:2 7070:2 2321:2",	-- Frost Leather Cloak
	[4259] = "3776|L180/200/210/220|4236:2 4234:6 2605 2321",	-- Green Leather Bracers
	[7378] = "9201|L185/205/215/225|4234:16 2325 4291:2",	-- Dusky Bracers
	[5965] = "7153|L185/205/215/225|4234:14 4305:2 4291:2|5974",	-- Guardian Cloak
	[17721] = "21943|L190/210/220/230|4234:8 7067:4 4291|17722",	-- Gloves of the Greatfather
	[7386] = "9202|L190/210/220/230|7392:6 4234:8 4291:2|7451",	-- Green Whelp Bracers
	[5783] = "6705|L190/210/220/230|5785:16 4236 4234:14 4291|5789",	-- Murloc Scale Bracers
	[5739] = "6661|L190/210/220/230|4234:14 2321:2 7071",	-- Barbaric Harness
	[5966] = "7156|L190/210/220/230|4234:4 4236 4291",	-- Guardian Gloves
	[7387] = "9206|L195/215/225/235|4234:10 4305:2 2325:2 7071",	-- Dusky Belt
	[4260] = "3777|L195/215/225/235|4234:6 4236:2 4291|4300",	-- Guardian Leather Bracers
	[18238] = "22711|L200/210/220/230|4304:6 7428:8 7971:2 4236:2 1210:4 8343|18239",	-- Shadowskin Gloves
	[4264] = "3779|L200/220/230/240|4234:6 4236:2 4096:2 5633 4291 7071|4301",	-- Barbaric Belt
	[8174] = "10490|L200/220/230/240|4234:12 4236:2 4291:2|8384",	-- Comfortable Leather Hat
	[7390] = "9207|L200/220/230/240|4234:8 7428:2 3824 4291:2|7452",	-- Dusky Boots
	[7391] = "9208|L200/220/230/240|4234:10 2459:2 4337:2 4291|7453",	-- Swift Boots
	[8172] = "10482|L200/0/0/200|8169 8150",	-- Cured Thick Hide
	[8173] = "10487|L200/220/230/240|4304:5 4291",	-- Thick Armor Kit
	[4304] = "20650|L200/200/202/205|4234:6",	-- Thick Leather
	[8176] = "10507|L205/225/235/245|4304:5 4291:2",	-- Nightscape Headband
	[8175] = "10499|L205/225/235/245|4304:7 4291:2",	-- Nightscape Tunic
	[8187] = "10509|L205/225/235/245|4304:6 8167:8 8343|8385",	-- Turtle Scale Gloves
	[8192] = "10516|L210/230/240/250|4304:8 4338:6 4291:3|8409",	-- Nightscape Shoulders
	[8198] = "10518|L210/230/240/250|4304:8 8167:12 8343",	-- Turtle Scale Bracers
	[8189] = "10511|L210/230/240/250|4304:6 8167:12 8343",	-- Turtle Scale Breastplate
	[8210] = "10529|L220/240/250/260|4304:10 8153 8172|8403",	-- Wild Leather Shoulders
	[8200] = "10520|L215/235/245/255|4304:10 8151:4 8343|8386",	-- Big Voodoo Robe
	[8214] = "10546|L225/245/255/265|4304:10 8153:2 8172|8405",	-- Wild Leather Helmet
	[8211] = "10544|L225/245/255/265|4304:12 8153:2 8172|8404",	-- Wild Leather Vest
	[8201] = "10531|L220/240/250/260|4304:8 8151:6 8343|8387",	-- Big Voodoo Mask
	[8205] = "10533|L220/240/250/260|4304:10 8154:4 4291:2|8397",	-- Tough Scorpid Bracers
	[8203] = "10525|L220/240/250/260|4304:12 8154:12 4291:4|8395",	-- Tough Scorpid Breastplate
	[8217] = "14930|L225/245/255/265|4304:12 8172 8949 4291:4",	-- Quickdraw Quiver
	[8218] = "14932|L225/245/255/265|4304:10 8172 8951 4291:6",	-- Thick Leather Ammo Pouch
	[8204] = "10542|L225/245/255/265|4304:6 8154:8 4291:2|8398",	-- Tough Scorpid Gloves
	[8347] = "10619|L225/245/255/265|4304:24 8165:12 8343:4 8172:2",	-- Dragonscale Gauntlets
	[8367] = "10650|L255/275/285/295|4304:40 8165:30 8343:4 8172:4",	-- Dragonscale Breastplate
	[8345] = "10621|L225/245/255/265|4304:18 8368:2 8146:8 8343:4 8172:2",	-- Wolfshead Helm
	[8193] = "10548|L230/250/260/270|4304:14 4291:4",	-- Nightscape Pants
	[8191] = "10552|L230/250/260/270|4304:14 8167:24 8343",	-- Turtle Scale Helm
	[8346] = "10630|L230/250/260/270|4304:20 7079:8 7075:2 8172 8343:4",	-- Gauntlets of the Sea
	[8197] = "10558|L235/255/265/275|4304:16 8343:2",	-- Nightscape Boots
	[8209] = "10554|L235/255/265/275|4304:12 8154:12 4291:6|8399",	-- Tough Scorpid Boots
	[8185] = "10556|L235/255/265/275|4304:14 8167:28 8343",	-- Turtle Scale Leggings
	[8213] = "10566|L245/265/275/285|4304:14 8153:4 8172:2|8406",	-- Wild Leather Boots
	[8216] = "10562|L240/260/270/280|4304:14 8152:4 8343:2|8390",	-- Big Voodoo Cloak
	[8202] = "10560|L240/260/270/280|4304:10 8152:6 8343:2|8389",	-- Big Voodoo Pants
	[8207] = "10564|L240/260/270/280|4304:12 8154:16 8343:2|8400",	-- Tough Scorpid Shoulders
	[8215] = "10574|L250/270/280/290|4304:16 8153:6 8172:2|8408",	-- Wild Leather Cloak
	[8212] = "10572|L250/270/280/290|4304:16 8153:6 8172:2|8407",	-- Wild Leather Leggings
	[8206] = "10568|L245/265/275/285|4304:14 8154:8 8343:2|8401",	-- Tough Scorpid Leggings
	[8208] = "10570|L250/270/280/290|4304:10 8154:20 8343:2|8402",	-- Tough Scorpid Helm
	[8348] = "10632|L250/270/280/290|4304:40 7077:8 7075:4 8172:2 8343:4",	-- Helm of Fire
	[8349] = "10647|L250/270/280/290|4304:40 8168:40 7971:2 8172:4 8343:4",	-- Feathered Breastplate
	[15407] = "19047|L250/250/255/260|8171 15409",	-- Cured Rugged Hide
	[15564] = "19058|L250/250/260/270|8170:5",	-- Rugged Armor Kit
	[8170] = "22331|L250/0/0/250|4304:6",	-- Rugged Leather
	[15077] = "19048|L255/275/285/295|8170:4 15408:4 14341|15724",	-- Heavy Scorpid Bracers
	[15045] = "19050|L260/280/290/300|8170:20 15412:25 14341:2|15726",	-- Green Dragonscale Breastplate
	[15083] = "19049|L260/280/290/300|8170:8 2325 14341|15725",	-- Wicked Leather Gauntlets
	[15074] = "19053|L265/285/295/305|8170:6 15423:6 14341|15729",	-- Chimeric Gloves
	[15076] = "19051|L265/285/295/305|8170:6 15408:6 14341|15727",	-- Heavy Scorpid Vest
	[15084] = "19052|L265/285/295/305|8170:8 2325 14341|15728",	-- Wicked Leather Bracers
	[15046] = "19060|L270/290/300/310|8170:20 15412:25 14341|15733",	-- Green Dragonscale Leggings
	[15067] = "19062|L270/290/300/310|8170:24 15420:80 1529:2 14341|15735",	-- Ironfeather Shoulders
	[15061] = "19061|L270/290/300/310|8170:12 12803:4 14341|15734",	-- Living Shoulders
	[15091] = "19055|L270/290/300/310|8170:10 14047:6 14341|15731",	-- Runic Leather Gauntlets
	[15054] = "19059|L270/290/300/310|8170:6 7078 7075 14341|15732",	-- Volcanic Leggings
	[15057] = "19067|L275/295/305/315|8170:16 7080:2 7082:2 14341|15741",	-- Stormshroud Pants
	[15064] = "19068|L275/295/305/315|8170:28 15419:12 14341|15742",	-- Warbear Harness
	[15073] = "19063|L275/295/305/315|8170:4 15423:8 14341|15737",	-- Chimeric Boots
	[15071] = "19066|L275/295/305/315|8170:4 15422:6 14341|15740",	-- Frostsaber Boots
	[15078] = "19064|L275/295/305/315|8170:6 15408:8 14341|15738",	-- Heavy Scorpid Gauntlets
	[15092] = "19065|L275/295/305/315|8170:6 7971 14047:6 14341|15739",	-- Runic Leather Bracers
	[15072] = "19073|L280/300/310/320|8170:8 15423:8 14341|15746",	-- Chimeric Leggings
	[15082] = "19070|L280/300/310/320|8170:6 15408:8 14341|15743",	-- Heavy Scorpid Belt
	[15093] = "19072|L280/300/310/320|8170:12 14047:10 14341|15745",	-- Runic Leather Belt
	[15086] = "19071|L280/300/310/320|8170:12 2325 14341|15744",	-- Wicked Leather Headband
	[20296] = "24655|L280/300/310/320|8170:20 15412:30 15407 14341:2",	-- Green Dragonscale Gauntlets
	[15048] = "19077|L285/305/315/325|8170:28 15415:30 15407 14341|15751",	-- Blue Dragonscale Breastplate
	[15060] = "19078|L285/305/315/325|8170:16 12803:6 15407 14341|15752",	-- Living Leggings
	[15056] = "19079|L285/305/315/325|8170:16 7080:3 7082:3 15407 14341|15753",	-- Stormshroud Armor
	[15065] = "19080|L285/305/315/325|8170:24 15419:14 14341|20254",	-- Warbear Woolies
	[15069] = "19074|L285/305/315/325|8170:6 15422:8 14341|15747",	-- Frostsaber Leggings
	[15079] = "19075|L285/305/315/325|8170:8 15408:12 14341|15748",	-- Heavy Scorpid Leggings
	[34086] = "44953|L285/0/0/285|2840 2997 8170:4 14341|34262", -- Winter Boots
	[15053] = "19076|L285/305/315/325|8170:8 7078 7076 14341|15749",	-- Volcanic Breastplate
	[15050] = "19085|L290/310/320/330|8170:40 15416:60 15407 14341:2|15759",	-- Black Dragonscale Breastplate
	[19052] = "23705|L290/310/320/330|8170:30 12809:2 7080:4 15407:2 14341:2|19328",	-- Dawn Treaders
	[15063] = "19084|L290/310/320/330|8170:30 15417:8 14341|15758",	-- Devilsaur Gauntlets
	[15066] = "19086|L290/310/320/330|8170:40 15420:120 1529 15407 14341|15760",	-- Ironfeather Breastplate
	[19044] = "23703|L290/310/320/330|8170:30 12804:2 12803:4 15407:2 14341:2|19326",	-- Might of the Timbermaw
	[15075] = "19081|L290/310/320/330|8170:10 15423:10 14341|15755",	-- Chimeric Vest
	[15094] = "19082|L290/310/320/330|8170:14 14047:10 14341|15756",	-- Runic Leather Headband
	[15087] = "19083|L290/310/320/330|8170:16 15407 2325:3 14341|15757",	-- Wicked Leather Pants
	[16982] = "20853|L295/315/325/335|17012:20 17010:6 17011:2 14341:2|17022",	-- Corehound Boots
	[15049] = "19089|L295/315/325/335|8170:28 15415:30 12810:2 15407 14341|15763",	-- Blue Dragonscale Shoulders
	[15058] = "19090|L295/315/325/335|8170:12 7080:3 7082:3 12810:2 14341|15764",	-- Stormshroud Shoulders
	[15070] = "19087|L295/315/325/335|8170:6 15422:10 14341|15761",	-- Frostsaber Gloves
	[15080] = "19088|L295/315/325/335|8170:8 15408:12 15407 14341|15762",	-- Heavy Scorpid Helm
	[16984] = "20855|L300/320/330/340|12810:6 15416:30 17010:4 17011:3 14341:2|17025",	-- Black Dragonscale Boots
	[18509] = "22926|L300/320/330/340|8170:30 12607:12 15416:30 15414:30 15407:5 14341:8|18517",	-- Chromatic Cloak
	[19157] = "23708|L300/320/330/340|17010:5 17011:2 17012:4 12607:4 15407:4 14227:4|19331",	-- Chromatic Gauntlets
	[19162] = "23709|L300/320/330/340|17010:8 17012:12 12810:10 15407:4 14227:4|19332",	-- Corehound Belt
	[20380] = "24703|L300/320/330/340|12810:12 20381:6 12803:4 15407:4 14227:6|20382",	-- Dreamscale Breastplate
	[18510] = "22927|L300/320/330/340|8170:30 12803:12 7080:10 18512:8 15407:3 14341:8|18518",	-- Hide of the Wild
	[22665] = "28224|L300/320/330/340|22682:4 15408:16 7080:2 15407:2 14227:4",	-- Icy Scale Bracers
	[22664] = "28222|L300/320/330/340|22682:7 15408:24 7080:2 15407:4 14227:4",	-- Icy Scale Breastplate
	[22666] = "28223|L300/320/330/340|22682:5 15408:16 7080:2 15407:3 14227:4",	-- Icy Scale Gauntlets
	[19149] = "23707|L300/320/330/340|17011:5 15407:4 14227:4|19330",	-- Lava Belt
	[19163] = "23710|L300/320/330/340|17010:2 17011:7 7076:6 15407:4 14227:4|19333",	-- Molten Belt
	[16983] = "20854|L300/320/330/340|17012:15 17010:3 17011:6 14341:2|17023",	-- Molten Helm
	[22663] = "28221|L300/320/330/340|22682:4 12810:12 7080:2 15407:2 14227:4",	-- Polar Bracers
	[22662] = "28220|L300/320/330/340|22682:5 12810:12 7080:2 15407:3 14227:4",	-- Polar Gloves
	[22661] = "28219|L300/320/330/340|22682:7 12810:16 7080:2 15407:4 14227:4",	-- Polar Tunic
	[18511] = "22928|L300/320/330/340|8170:30 7082:12 12753:4 12809:8 15407:4 14341:8|18519",	-- Shifting Cloak
	[15052] = "19107|L300/320/330/340|8170:40 15416:60 12810:4 15407 14341:2|15781",	-- Black Dragonscale Leggings
	[15051] = "19094|L300/320/330/340|8170:44 15416:45 12810:2 15407 14341|15770",	-- Black Dragonscale Shoulders
	[19688] = "24124|L300/320/330/340|19768:35 19726:2 15407:3 14341:3|19772",	-- Blood Tiger Breastplate
	[19689] = "24125|L300/320/330/340|19768:25 19726:2 15407:3 14341:3|19773",	-- Blood Tiger Shoulders
	[22761] = "28474|L300/320/330/340|12810:4 12803:2 15407|22769",	-- Bramblewood Belt
	[22760] = "28473|L300/320/330/340|12810:6 18512:2 12803:2 15407:2|22770",	-- Bramblewood Boots
	[22759] = "28472|L300/320/330/340|12810:12 19726:2 12803:2 15407:2|22771",	-- Bramblewood Helm
	[18251] = "22727|L300/320/330/340|17012:3 14341:2|18252",	-- Core Armor Kit
	[15062] = "19097|L300/320/330/340|8170:30 15417:14 15407 14341|15772",	-- Devilsaur Leggings
	[18504] = "22921|L300/320/330/340|8170:12 12804:12 15407:2 14341:4|18514",	-- Girdle of Insight
	[19058] = "23706|L300/320/330/340|12810:8 12803:4 12809:4 15407:2 14341:2|19329",	-- Golden Mantle of the Dawn
	[15059] = "19095|L300/320/330/340|8170:16 12803:8 14342:2 15407 14341:2|15771",	-- Living Breastplate
	[18506] = "22922|L300/320/330/340|8170:12 7082:6 11754:4 15407:2 14341:4|18515",	-- Mongoose Boots
	[15138] = "19093|L300/320/330/340|15410 14044 14341",	-- Onyxia Scale Cloak
	[19687] = "24123|L300/320/330/340|19767:8 15407:3 12803:4 14341:3|19771",	-- Primal Batskin Bracers
	[19686] = "24122|L300/320/330/340|19767:10 15407:4 12803:4 14341:3|19770",	-- Primal Batskin Gloves
	[19685] = "24121|L300/320/330/340|19767:14 15407:5 12803:4 14341:4|19769",	-- Primal Batskin Jerkin
	[15047] = "19054|L300/320/330/340|8170:40 15414:30 14341|15730",	-- Red Dragonscale Breastplate
	[20476] = "24849|L300/320/330/340|20501 20498:20 18512:2|20509",	-- Sandstalker Bracers
	[20478] = "24851|L300/320/330/340|20501:3 20498:40 18512:2 15407:2|20511",	-- Sandstalker Breastplate
	[20477] = "24850|L300/320/330/340|20501:2 20498:30 18512:2 15407|20510",	-- Sandstalker Gauntlets
	[20481] = "24846|L300/320/330/340|20500 20498:20 7078:2|20506",	-- Spitfire Bracers
	[20479] = "24848|L300/320/330/340|20500:3 20498:40 7078:2 15407:2|20508",	-- Spitfire Breastplate
	[20480] = "24847|L300/320/330/340|20500:2 20498:30 7078:2 15407|20507",	-- Spitfire Gauntlets
	[21278] = "26279|L300/320/330/340|12810:6 7080:4 7082:4 15407:2 14227:2|21548",	-- Stormshroud Gloves
	[18508] = "22923|L300/320/330/340|8170:12 18512:8 15420:60 15407:4 14341:4|18516",	-- Swift Flight Bracers
	[19049] = "23704|L300/320/330/340|12810:8 12804:6 12803:6 15407:2 14227:2|19327",	-- Timbermaw Brawlers
	[25654] = "32462|L300/310/320/330|21887:5 25700 14341:2",	-- Felscale Gloves
	[15068] = "19104|L300/320/330/340|8170:12 15422:12 15407 14341:2|15779",	-- Frostsaber Tunic
	[15081] = "19100|L300/320/330/340|8170:14 15408:14 15407 14341:2|15774",	-- Heavy Scorpid Shoulders
	[15090] = "19102|L300/320/330/340|8170:22 12810:4 14047:16 15407 14341:2|15776",	-- Runic Leather Armor
	[15095] = "19091|L300/320/330/340|8170:18 14047:12 12810:2 14341|15765",	-- Runic Leather Pants
	[15096] = "19103|L300/320/330/340|8170:16 12810:4 14047:18 15407 14341:2|15777",	-- Runic Leather Shoulders
	[25662] = "32466|L300/310/320/330|21887:6 25700:3 14341:2",	-- Scaled Draenic Pants
	[25669] = "32470|L300/310/320/330|21887:6 14341:2",	-- Thick Draenic Gloves
	[15055] = "19101|L300/320/330/340|8170:10 7078 7076 14341:2|15775",	-- Volcanic Shoulders
	[15085] = "19098|L300/320/330/340|8170:20 15407:2 14256:2 2325:4 14341:2|15773",	-- Wicked Leather Armor
	[15088] = "19092|L300/320/330/340|8170:14 2325:2 14341:2|15768",	-- Wicked Leather Belt
	[25673] = "32478|L300/310/320/330|21887:6 14341:3",	-- Wild Draenish Boots
	[25679] = "32482|L300/300/305/310|21887:2|25726",	-- Comfortable Insoles
	[25650] = "32456|L300/310/325/340|21887:4",	-- Knothide Armor Kit
	[21887] = "32454|L300/300/305/310|25649:5",	-- Knothide Leather
	[20295] = "24654|L300/320/330/340|8170:28 15415:36 15407:2 14341:2",	-- Blue Dragonscale Leggings
	[34482] = "45100|L300/310/320/330|21887:20 25700:4 25707:4 14341:3", -- Leatherworker's Satchel
	[25655] = "32463|L310/320/330/340|21887:8 25700 14341:2",	-- Felscale Boots
	[25661] = "32467|L310/320/330/340|21887:8 25700 14341:2",	-- Scaled Draenic Gloves
	[25674] = "32479|L310/320/330/340|21887:9 14341:3",	-- Wild Draenish Gloves
	[25670] = "32471|L315/325/335/345|21887:10 14341:2",	-- Thick Draenic Pants
	[34099] = "44343|L315/325/335/345|21887:24 14341:4 22451", -- Knothide Ammo Pouch
	[34100] = "44344|L315/325/335/345|21887:20 25719:30 14341:2", -- Knothide Quiver
	[25656] = "32464|L320/330/340/350|21887:10 25700:3 14341:3",	-- Felscale Pants
	[25668] = "32472|L320/330/340/350|21887:10 14341:3",	-- Thick Draenic Boots
	[25675] = "32480|L320/330/340/350|21887:13 14341:3",	-- Wild Draenish Leggings
	[29540] = "35530|L325/335/340/345|23793:6 22452:4|29664",	-- Reinforced Mining Bag
	[25660] = "32468|L325/335/345/355|21887:12 25700:3 14341:3",	-- Scaled Draenic Vest
	[23793] = "32455|L325/325/330/335|21887:5|25720",	-- Heavy Knothide Leather
	[25652] = "32458|L325/335/340/345|23793:3 22457|25722",	-- Magister's Armor Kit
	[25651] = "32457|L325/335/340/345|23793:3 22452|25721",	-- Vindicator's Armor Kit
	[25671] = "32473|L330/340/350/360|21887:14 14341:3",	-- Thick Draenic Vest
	[25676] = "32481|L330/340/350/360|21887:15 14341:3",	-- Wild Draenish Vest
	[29534] = "35555|L335/335/345/355|23793:4 25708:8 22452:4|29720",	-- Clefthide Leg Armor
	[29533] = "35549|L335/335/345/355|23793:4 29539:2 22451:4|29719",	-- Cobrahide Leg Armor
	[25657] = "32465|L335/345/355/365|21887:14 25700:3 14341:3",	-- Felscale Breastplate
	[25659] = "32469|L335/345/355/365|21887:12 25700:2 14341:3",	-- Scaled Draenic Boots
	[25685] = "32490|L340/350/360/370|23793:6 25707:6 22456:6 14341:3|25732",	-- Fel Leather Gloves
	[25694] = "32501|L340/350/360/370|23793:4 25699:8 21885:3 22457:3 14341:2|25741",	-- Netherfury Belt
	[25692] = "32502|L340/350/360/370|23793:8 25699:12 21885:5 22457:5 14341:2|25742",	-- Netherfury Leggings
	[29488] = "35524|L340/350/355/360|23793:4 22457:4|29675",	-- Arcane Armor Kit
	[29528] = "35540|L340/340/347/355|23793:3 25700:3",	-- Drums of War (Trainer)
	[29485] = "35521|L340/350/355/360|23793:4 21885:4|29672",	-- Flame Armor Kit
	[29486] = "35522|L340/350/355/360|23793:4 21884:4|29673",	-- Frost Armor Kit
	[29487] = "35523|L340/350/355/360|23793:4 22456:4|29674",	-- Nature Armor Kit
	[29483] = "35520|L340/350/355/360|23793:4 21886:4|29669",	-- Shadow Armor Kit
	[29530] = "35544|L345/345/352/360|23793:6 29547:4|34172",	-- Drums of Speed ****Kurenai
	[29500] = "35537|L350/360/370/380|23793:4 25707:6 21884:3 21885:3|29704",	-- Blastguard Belt
	[29499] = "35536|L350/360/370/380|23793:4 25707:8 21884:3 21885:3|29703",	-- Blastguard Boots
	[29498] = "35535|L350/360/370/380|23793:6 25707:10 21884:4 21885:4|29702",	-- Blastguard Pants
	[29497] = "35534|L350/360/370/380|23793:4 25708:16 22457:6|29701",	-- Enchanted Clefthoof Boots
	[29496] = "35533|L350/360/370/380|23793:4 25708:16 22457:6|29700",	-- Enchanted Clefthoof Gloves
	[29495] = "35532|L350/360/370/380|23793:6 25708:24 22457:8|29698",	-- Enchanted Clefthoof Leggings
	[29491] = "35527|L350/360/370/380|23793:4 25700:10 22457:6|29684",	-- Enchanted Felscale Boots
	[29490] = "35526|L350/360/370/380|23793:4 25700:10 22457:6|29682",	-- Enchanted Felscale Gloves
	[29489] = "35525|L350/360/370/380|23793:6 25700:12 22457:8|29677",	-- Enchanted Felscale Leggings
	[25686] = "32493|L350/360/370/380|23793:10 25707:8 22456:8 14341:3|25733",	-- Fel Leather Boots
	[25687] = "32494|L350/360/370/380|23793:10 25707:10 22456:10 14341:3|25734",	-- Fel Leather Leggings
	[25695] = "32498|L350/360/370/380|23793:6 25707:4 25699:8 22451:6 14341:2|25738",	-- Felstalker Belt
	[29494] = "35531|L350/360/370/380|23793:4 25699:8 21884:3 21885:3|29693",	-- Flamescale Belt
	[29493] = "35528|L350/360/370/380|23793:4 25699:8 21884:3 21885:3|29691",	-- Flamescale Boots
	[29492] = "35529|L350/360/370/380|23793:6 25699:12 21884:4 21885:4|29689",	-- Flamescale Leggings
	[25693] = "32503|L350/360/370/380|23793:6 25699:10 21885:4 22457:4 14341:2|25743",	-- Netherfury Boots
	[34207] = "44770|L350/355/360/365|23793:4 22452:3", -- Glove Reinforcements
	[25653] = "32461|L350/360/370/380|23793:4 23571 22445:6 22448|25725",	-- Riding Crop
	[25681] = "32487|L350/360/370/380|23793:6 29539:2 21886:8 2325:4 14341:3|25729",	-- Stylin' Adventure Hat
	[25683] = "32488|L350/360/370/380|23793:6 29539:2 21884:8 2604:4 14341:3|25731",	-- Stylin' Crimson Hat
	[25682] = "32489|L350/360/370/380|23793:6 29539:2 22452:8 14341:3|25730",	-- Stylin' Jungle Hat
	[25680] = "32485|L350/360/370/380|23793:6 29539:2 22456:8 4342:4 14341:3|25728",	-- Stylin' Purple Hat
	[29531] = "35539|L350/350/357/365|23793:6 29548:4|34174",	-- Drums of Restoration ---Kurenai
	[34105] = "44359|L350/360/370/380|23793:8 17056:99 22451:2 23572|34200", -- Quiver of a Thousand Feathers
	[34330] = "44970|L350/355/360/365|23793:3", -- Heavy Knothide Armor Kit
	[34106] = "44768|L350/360/370/380|23793:12 29548:12 22452:4 23572|34201", -- Netherscale Ammo Pouch
	[25691] = "32497|L355/365/375/385|23793:4 25708:20 22452:4 14341:2|25737",	-- Heavy Clefthoof Boots
	[25690] = "32496|L355/365/375/385|23793:6 25708:34 22452:4 14341:2|25736",	-- Heavy Clefthoof Leggings
	[25697] = "32499|L360/370/380/390|23793:6 25707:6 25699:6 22451:4 14341:2|25739",	-- Felstalker Bracer
	[25696] = "32500|L360/370/380/390|23793:10 25707:4 25699:8 22451:8 14341:2|25740",	-- Felstalker Breastplate
	[25689] = "32495|L360/370/380/390|23793:6 25708:40 22452:4 14341:2|25735",	-- Heavy Clefthoof Vest
	[33122] = "42546|L360/370/380/390|23793:8 21844:12 22456:12 23572:4|33124", -- Cloak of Darkness
	[34490] = "45117|L360/370/380/390|23793:15 29547:5 25707:5 29548:5 25708:5 14341:3|34491", -- Bag of Many Hides
	[29503] = "35559|L365/375/385/395|23793:4 29539:8 22451:12 22456:12 23572|29724",	-- Cobrascale Gloves -- also rid 35302******
	[29502] = "35558|L365/375/385/395|23793:6 29539:10 22451:15 22456:15 23572|29723",	-- Cobrascale Hood
	[29512] = "35567|L365/375/385/395|23793:4 29548:24 22452:22 22457:4 23572|29730",	-- Earthen Netherscale Boots
	[29506] = "35562|L365/375/385/395|23793:4 21886:16 22452:12 23572|29727",	-- Gloves of the Living Touch -- also rid 35303******
	[29505] = "35561|L365/375/385/395|23793:6 21886:20 21885:8 23572|29726",	-- Hood of Primal Life
	[29508] = "35564|L365/375/385/395|23793:6 29548:28 21886:12 22457:12 23572|29729",	-- Living Dragonscale Helm
	[29511] = "35573|L365/375/385/395|23793:4 29548:24 21884:14 22457:10 23572|29733",	-- Netherdrake Gloves -- also 35301
	[29510] = "35572|L365/375/385/395|23793:6 29548:28 21884:18 22457:12 23572|29732",	-- Netherdrake Helm
	[29514] = "35574|L365/375/385/395|23793:8 29548:32 22452:20 22451:8 23572|29734",	-- Thick Netherscale Breastplate
	[29504] = "35560|L365/375/385/395|23793:6 29547:20 22451:18 22457:10 23572|29725",	-- Windscale Hood
	[29507] = "35563|L365/375/385/395|23793:4 29547:12 22452:18 22451:8 23572|29728",	-- Windslayer Wraps
	[29509] = "35568|L365/375/385/395|23793:4 29547:14 22451:14 21884:10 23572|29731",	-- Windstrike Gloves -- also 35300
	[29529] = "35543|L365/365/372/380|23793:6 25708:4|29717",	-- Drums of Battle
	[29536] = "35557|L365/365/375/385|23793:4 25708:16 22452:8 23572|29721",	-- Nethercleft Leg Armor
	[29535] = "35554|L365/365/375/385|23793:4 29539:4 22451:8 23572|29722",	-- Nethercobra Leg Armor
	[29532] = "35538|L370/370/377/385|23793:6 25707:4|29713",	-- Drums of Panic
	[30040] = "36351|L375/385/395/405|30183:2 23793:4 22456:10 14341:2 22451:10|30302", --Belt of Deep Shadow
	[30042] = "36349|L375/385/395/405|30183:2 23793:4 21886:10 14341:2 22451:10|30301", --Belt of Natural Power
	[30046] = "36352|L375/385/395/405|30183:2 23793:4 22451:10 29547:10 14341:2|30303", --Belt of the Black Eagle
	[30041] = "36355|L375/385/395/405|23572:2 23793:4 21886:12 14341:2|30305", --Boots of Natural Grace
	[30045] = "36358|L375/385/395/405|23572:2 23793:4 22451:10 29547:6 14341:2|30307", --Boots of the Crimson Hawk
	[30043] = "36359|L375/385/395/405|23572:2 23793:4 21885:10 29547:6 14341:2|30308", --Hurricane Boots
	[30044] = "36353|L375/385/395/405|30183:2 23793:4 21885:10 29547:6 14341:2|30304", --Monsoon Belt
	[32574] = "41161|L375/385/395/405|23793:4 22451:4 21885:4 29547:12 32428:4|32748", -- Bindings of Lightning Reflexes - also rid 35517*****
	[32579] = "41164|L375/385/395/405|23793:6 22451:6 22452:6 29547:16 32428:2|32751", -- Living Earth Shoulders -- also 35521****
	[32580] = "41158|L375/385/395/405|23793:4 22451:10 32428:4|32746", --Swiftstrike Bracers
	[32582] = "41156|L375/385/395/405|23793:4 22451:6 21886:6 32428:4|32744", -- Bracers of Renewed Life - also rid 35519*****
	[32577] = "41163|L375/385/395/405|23793:4 22451:4 22452:4 29547:12 32428:4|32750", -- Living Earth Bindings - also rid 35520
	[32583] = "41157|L375/385/395/405|23793:6 22451:8 21886:8 32428:2|32745", -- Shoulders of Renewed Life
	[32575] = "41162|L375/385/395/405|23793:6 22451:6 21885:6 29547:16 32428:2|32749", -- Shoulders of Lightning Reflexes -- also 35524
	[32581] = "41160|L375/385/395/405|23793:6 22451:12 32428:2|32747", --Swiftstrike Shoulders -- also 35528
	[30039] = "36357|L375/385/395/405|23572:2 23793:4 22456:12 14341:2|30306", --Boots of Utter Darkness
	[32398] = "39997|L375/385/395/405|32428:2 22450 21886:2 22456:4 25700:4|32429", --Boots of Shackled Souls
	[32399] = "52733|L375/385/395/405|32428 22450 21886:2 22456:2 25700:2|32430", --Bracers of Shackled Souls
	[32400] = "40001|L375/385/395/405|32428:3 22450 21886:4 22456:6 25700:3|32431", --Greaves of Shackeled Souls
	[32397] = "40002|L375/385/395/405|32428:2 22450 21886:3 22456:4 25700:2|32429", --Waistguard of Shackeled Souls
	[32393] = "40006|L375/385/395/405|32428:2 22450 21886:3 22456:4 25707:2|32436", --Redeemed Cinch
	[32396] = "40005|L375/385/395/405|32428:3 22450 21886:4 22456:6 25707:3|32429", --Redeemed Legguards
	[32394] = "40003|L375/385/395/405|32428:2 22450 21886:2 22456:4 25707:4|32433", --Redeemed Moccassins
	[32395] = "40004|L375/385/395/405|32428 22450 21886:2 22456:2 25707:2|32434", --Redeemed Wristguards
	[33204] = "42731|L365/375/385/395|23793:10 21844:16 22452:12 22456:12 23572:2|33205", --Shadowprowler's Chestguard
--[[ Specialty Leatherworking --]]
	[29971] = "36076|Ld260/280/290/300|8170:10 8165:10 7077:2 8172:2 14341",	-- Dragonstrike Leggings
	[29975] = "36079|Ld330/350/360/370|21887:20 15416:8 21884:3 14341:2",	-- Golden Dragonstrike Breastplate
	[29516] = "35576|Ld375/385/395/405|23793:6 29548:24 21884:12 22456:12 23572",	-- Ebon Netherscale Belt
	[29517] = "35577|Ld375/385/395/405|23793:4 29548:18 21884:8 22456:8",	-- Ebon Netherscale Bracers
	[29515] = "35575|Ld375/385/395/405|23793:8 29548:30 21884:16 22456:16 23572:2",	-- Ebon Netherscale Breastplate
	[29520] = "35582|Ld375/385/395/405|23793:6 29548:24 22457:12 22451:12 23572",	-- Netherstrike Belt
	[29521] = "35584|Ld375/385/395/405|23793:4 29548:18 22457:8 22451:8",	-- Netherstrike Bracers
	[29519] = "35580|Ld375/385/395/405|23793:8 29548:30 22457:16 22451:16 23572:2",	-- Netherstrike Breastplate
	[29964] = "36074|Le260/280/290/300|8170:10 7081:8 8172:2 14341",	-- Blackstorm Leggings
	[29973] = "36077|Le330/350/360/370|21887:20 22451:2 22452:2 14341:2",	-- Primalstorm Breastplate
	[29526] = "35590|Le375/385/395/405|23793:6 23571:5 23572",	-- Primalstrike Belt
	[29527] = "35591|Le375/385/395/405|23793:4 23571:3",	-- Primalstrike Bracers
	[29525] = "35589|Le375/385/395/405|23793:8 23571:6 23572:2",	-- Primalstrike Vest
	[29970] = "36075|Lt260/280/290/300|8170:10 8168:40 8153:4 8172:2 14341",	-- Wildfeather Leggings
	[29974] = "36078|Lt330/350/360/370|21887:20 25699:12 21886:3 14341:2",	-- Living Crystal Breastplate
	[29524] = "35587|Lt375/385/395/405|23793:6 29547:16 22451:12 23571:2 23572",	-- Windhawk Belt
	[29523] = "35588|Lt375/385/395/405|23793:4 29547:12 22451:8 23571",	-- Windhawk Bracers
	[29522] = "35585|Lt375/385/395/405|23793:8 29547:20 22451:16 23571:3 23572:2",	-- Windhawk Hauberk
--[[ Smelting --]]
	[2840] = "2657|Y1/25/47/70|2770",	-- Smelt Copper
	[2841] = "2659|Y65/65/90/115|2840 3576||2",	-- Smelt Bronze
	[3576] = "3304|Y65/65/70/75|2771",	-- Smelt Tin
	[2842] = "2658|Y75/115/122/130|2775",	-- Smelt Silver
	[3575] = "3307|Y125/130/145/160|2772",	-- Smelt Iron
	[2] = "3308|Y155/170/177/185|2776|||3577",	-- Smelt Gold
	[3859] = "3569|Y165/0/0/165|3575 3857",	-- Smelt Steel
	[3860] = "10097|Y175/175/202/230|3858",	-- Smelt Mithril
	[4] = "10098|Y230/235/242/250|7911|||6037",	-- Smelt Truesilver
	[11371] = "14891|Y230/300/305/310|11370:8",	-- Smelt Dark Iron
	[12359] = "16153|Y250/250/270/290|10620",	-- Smelt Thorium
	[17771] = "22967|Y300/350/362/375|18562 12360:10 17010 18567:3",	-- Smelt Elementium
	[22573] = "35750|Y300/0/0/300|22452||10",	-- Earth Shatter
	[22574] = "35751|Y300/0/0/300|21884||10",	-- Fire Sunder
	[23445] = "29356|Y300/300/307/315|23424:2",	-- Smelt Fel Iron
	[23446] = "29358|Y325/325/332/340|23425:2",	-- Smelt Adamantite
	[23447] = "29359|Y350/350/357/365|23427:2",	-- Smelt Eternium
	[23448] = "29360|Y350/350/357/375|23445:3 23447:2",	-- Smelt Felsteel
	[23449] = "29361|Y375/0/0/375|23426:2",	-- Smelt Khorium
	[23573] = "29686|Y375/0/0/375|23446:10",	-- Smelt Hardened Adamantite
--[[ Tailoring --]]
	[2996] = "2963|T1/25/37/50|2589:2",	-- Bolt of Linen Cloth
	[4344] = "3915|T1/35/47/60|2996 2320",	-- Brown Linen Shirt
	[2570] = "2387|T1/35/47/60|2996 2320",	-- Linen Cloak
	[10045] = "12044|T1/35/47/60|2996 2320",	-- Simple Linen Pants
	[2576] = "2393|T1/35/47/60|2996 2320 2324",	-- White Linen Shirt
	[2568] = "2385|T10/45/57/70|2996 2320",	-- Brown Linen Vest
	[7026] = "8776|T15/50/67/85|2996 2320",	-- Linen Belt
	[10046] = "12045|T20/50/67/85|2996:2 2318 2320",	-- Simple Linen Boots
	[6238] = "7623|T30/55/72/90|2996:3 2320",	-- Brown Linen Robe
	[6241] = "7624|T30/55/72/90|2996:3 2320 2324",	-- White Linen Robe
	[4343] = "3914|T30/55/72/90|2996:2 2320",	-- Brown Linen Pants
	[4307] = "3840|T35/60/77/95|2996:2 2320",	-- Heavy Linen Gloves
	[2572] = "2389|T40/65/82/100|2996:3 2320:2 2604:2|2598",	-- Red Linen Robe
	[2577] = "2394|T40/65/82/100|2996:2 2320 6260",	-- Blue Linen Shirt
	[2575] = "2392|T40/65/82/100|2996:2 2320 2604",	-- Red Linen Shirt
	[6786] = "8465|T40/65/82/100|2996:2 2320 6260 2324",	-- Simple Dress
	[4238] = "3755|T45/70/87/105|2996:3 2320:3",	-- Linen Bag
	[6240] = "7630|T55/80/97/115|2996:3 2320 6260|6270",	-- Blue Linen Vest
	[6239] = "7629|T55/80/97/115|2996:3 2320 2604|6271",	-- Red Linen Vest
	[4308] = "3841|T60/85/102/120|2996:3 2320:2 2605",	-- Green Linen Bracers
	[2580] = "2397|T60/85/102/120|2996:2 2320:3",	-- Reinforced Linen Cape
	[2569] = "2386|T65/90/107/125|2996:3 2320 2318",	-- Linen Boots
	[2578] = "2395|T70/95/112/130|2996:4 2318 2321",	-- Barbaric Linen Vest
	[6242] = "7633|T70/95/112/130|2996:4 2320:2 6260:2|6272",	-- Blue Linen Robe
	[4309] = "3842|T70/95/112/130|2996:4 2321:2",	-- Handstitched Linen Britches
	[2579] = "2396|T70/95/112/130|2996:3 2321 2605",	-- Green Linen Shirt
	[5762] = "6686|T70/95/112/130|2996:4 2321 2604|5771",	-- Red Linen Bag
	[2997] = "2964|T75/90/97/105|2592:3",	-- Bolt of Woolen Cloth
	[10047] = "12046|T75/100/117/135|2996:4 2321",	-- Simple Kilt
	[2584] = "2402|T75/100/117/135|2997 2321",	-- Woolen Cape
	[4312] = "3845|T80/105/122/140|2996:5 2318:2 2321",	-- Soft-soled Linen Boots
	[4240] = "3757|T80/105/122/140|2997:3 2321",	-- Woolen Bag
	[4310] = "3843|T85/110/127/145|2997:3 2321",	-- Heavy Woolen Gloves
	[2582] = "2399|T85/110/127/145|2997:2 2321:2 2605",	-- Green Woolen Vest
	[5542] = "6521|T90/115/132/150|2997:3 2321:2 5498",	-- Pearl-clasped Cloak
	[4313] = "3847|T95/120/137/155|2997:4 2318:2 2321 2604:2|4345",	-- Red Woolen Boots
	[2583] = "2401|T95/120/137/155|2997:4 2321:2 2318:2",	-- Woolen Boots
	[4241] = "3758|T95/120/137/155|2997:4 2605 2321|4292",	-- Green Woolen Bag
	[6263] = "7639|T100/125/142/160|2997:4 2321:2 6260:2|6274",	-- Blue Overalls
	[4311] = "3844|T100/125/142/160|2997:3 2321:2 5498:2|4346",	-- Heavy Woolen Cloak
	[2587] = "2406|T100/110/120/130|2997:2 2321 4340",	-- Gray Woolen Shirt
	[2585] = "2403|T105/130/147/165|2997:4 2321:3 4340|2601",	-- Gray Woolen Robe
	[4316] = "3850|T110/135/152/170|2997:5 2321:4",	-- Heavy Woolen Pants
	[4314] = "3848|T110/135/152/170|2997:3 2321:2",	-- Double-stitched Woolen Shoulders
	[4330] = "3866|T110/135/152/170|2997:3 2604:2 2321",	-- Stylish Red Shirt
	[6787] = "8467|T110/135/152/170|2997:3 2324:4 2321",	-- White Woolen Dress
	[6264] = "7643|T115/140/157/175|2997:5 2321:3 2604:3|6275",	-- Greater Adept's Robe
	[4332] = "3869|T135/145/150/155|4305 4341 2321|14627",	-- Bright Yellow Shirt
	[5763] = "6688|T115/140/157/175|2997:4 2604 2321|5772",	-- Red Woolen Bag
	[10048] = "12047|T120/145/162/180|2997:5 2604:3 2321|10316",	-- Colorful Kilt
	[4315] = "3849|T120/145/162/180|2997:6 2319:2 2321:2|4347",	-- Reinforced Woolen Shoulders
	[6384] = "7892|T120/145/162/180|2997:4 6260:2 4340 2321|6390",	-- Stylish Blue Shirt
	[6385] = "7893|T120/145/162/180|2997:4 2605:2 4340 2321|6391",	-- Stylish Green Shirt
	[4320] = "3855|T125/150/167/185|4305:2 2319:4 3182:4 5500:2",	-- Spidersilk Boots
	[4331] = "3868|T125/150/167/185|2997:4 5500 2321:4 2324:2|4348",	-- Phoenix Gloves
	[4317] = "3851|T125/150/167/185|2997:6 5500 2321:3|4349",	-- Phoenix Pants
	[4305] = "3839|T125/135/140/145|4306:4",	-- Bolt of Silk Cloth
	[4318] = "3852|T130/150/165/180|2997:4 2321:3 3383",	-- Gloves of Meditation
	[4319] = "3854|T145/165/180/195|4305:3 4234:2 6260:2 2321:2|7114",	-- Azure Silk Gloves
	[5766] = "6690|T135/155/170/185|4305:2 2321:2 3182:2",	-- Lesser Wizard's Robe
	[7046] = "8758|T140/160/175/190|4305:4 6260:2 2321:3",	-- Azure Silk Pants
	[4321] = "3856|T140/160/175/190|4305:3 3182 2321:2|4350",	-- Spider Silk Slippers
	[7047] = "8780|T145/165/180/195|4305:3 4234:2 6048:2 2321:2|7092",	-- Hands of Darkness
	[7048] = "8760|T145/155/160/165|4305:2 6260:2 2321",	-- Azure Silk Hood
	[4324] = "3859|T150/170/185/200|4305:5 6260:4",	-- Azure Silk Vest
	[5770] = "6692|T150/170/185/200|4305:4 2321:2 3182:2|5773",	-- Robes of Arcana
	[7049] = "8782|T150/170/185/200|4305:3 4234:2 929:4 2321|7091",	-- Truefaith Gloves
	[4245] = "3813|T150/170/185/200|4305:3 4234:2 2321:3",	-- Small Silk Pack
	[4322] = "3857|T165/185/200/215|4305:3 2321:2 4337:2|14630",	-- Enchanter's Cowl
	[4333] = "3870|T155/165/170/175|4305:2 4340:2 2321|6401",	-- Dark Silk Shirt
	[7050] = "8762|T160/170/175/180|4305:3 2321:2",	-- Silk Headband
	[6795] = "8483|T160/170/175/180|4305:3 2324:2 4291",	-- White Swashbuckler's Shirt
	[7065] = "8784|T165/185/200/215|4305:5 2605:2 4291|7090",	-- Green Silk Armor
	[7051] = "8764|T170/190/205/220|4305:3 7067 2321:2",	-- Earthen Vest
	[4323] = "3858|T170/190/205/220|4305:4 4291 3824|4351",	-- Shadow Hood
	[4334] = "3871|T170/180/185/190|4305:3 2324:2 2321",	-- Formal White Shirt
	[7052] = "8766|T175/195/210/225|4305:4 7070 6260:2 2321:2 7071",	-- Azure Silk Belt
	[7053] = "8786|T175/195/210/225|4305:3 6260:2 2321:2|7089",	-- Azure Silk Cloak
	[4325] = "3860|T175/195/210/225|4305:4 4291 4337:2|4352",	-- Boots of the Enchanter
	[7055] = "8772|T175/195/210/225|4305:4 7071 2604:2 4291",	-- Crimson Silk Belt
	[4339] = "3865|T175/180/182/185|4338:5",	-- Bolt of Mageweave
	[5764] = "6693|T175/195/210/225|4305:4 4234:3 2321:3 2605|5774",	-- Green Silk Pack
	[6796] = "8489|T175/185/190/195|4305:3 2604:2 4291",	-- Red Swashbuckler's Shirt
	[7056] = "8789|T180/200/215/230|4305:5 2604:2 6371:2 4291|7087",	-- Crimson Silk Cloak
	[7057] = "8774|T180/200/215/230|4305:5 4291:2",	-- Green Silken Shoulders
	[4328] = "3863|T180/200/215/230|4305:4 4337:2 7071|4353",	-- Spider Belt
	[4336] = "3873|T200/210/215/220|4305:5 2325 4291|10728",	-- Black Swashbuckler's Shirt
	[4326] = "3861|T185/205/220/235|4305:4 3827 4291",	-- Long Silken Cloak
	[5765] = "6695|T185/205/220/235|4305:5 2325 2321:4|5775",	-- Black Silk Pack
	[7058] = "8791|T185/205/215/225|4305:4 2604:2 2321:2",	-- Crimson Silk Vest
	[4335] = "3872|T185/195/200/205|4305:4 4342 4291|4354",	-- Rich Purple Silk Shirt
	[7054] = "8770|T190/210/225/240|4339:2 7067:2 7070:2 7068:2 7069:2 4291:2",	-- Robe of Power
	[7060] = "8795|T190/210/225/240|4305:6 7072:2 6260:2 4291:2|7085",	-- Azure Shoulders
	[7059] = "8793|T190/210/225/240|4305:5 6371:2 2604:2 4291:2|7084",	-- Crimson Silk Shoulders
	[17723] = "21945|T190/200/205/210|4305:5 2605:4 4291|17724",	-- Green Holiday Shirt
	[7061] = "8797|T195/215/230/245|4305:5 7067:4 4234:4 7071 4291:2|7086",	-- Earthen Silk Belt
	[7062] = "8799|T195/215/225/235|4305:4 2604:2 4291:2",	-- Crimson Silk Pantaloons
	[10052] = "12064|T220/225/230/235|4339:2 6261:2 8343|10311",	-- Orange Martial Shirt
	[4327] = "3862|T200/220/235/250|4339:3 4291:2 3829 4337:2|4355",	-- Icy Cloak
	[4329] = "3864|T200/220/235/250|4339:4 4234:4 3864 7071 4291|4356",	-- Star Belt
	[9999] = "12049|T205/220/235/250|4339:2 4291:3",	-- Black Mageweave Leggings
	[9998] = "12048|T205/220/235/250|4339:2 4291:3",	-- Black Mageweave Vest
	[7063] = "8802|T205/220/235/250|4305:8 7068:4 3827:2 2604:4 4291|7088",	-- Crimson Silk Robe
	[10054] = "12075|T230/235/240/245|4339:2 4342:2 8343:2|10314",	-- Lavender Mageweave Shirt
	[10001] = "12050|T210/225/240/255|4339:3 8343",	-- Black Mageweave Robe
	[7064] = "8804|T210/225/240/255|4305:6 7068:2 6371:2 4304:2 2604:4 4291:2",	-- Crimson Silk Gloves
	[10002] = "12052|T210/225/240/255|4339:3 10285:2 8343",	-- Shadoweave Pants
	[10055] = "12080|T235/240/245/250|4339:3 10290 8343|10317",	-- Pink Mageweave Shirt
	[10003] = "12053|T215/230/245/260|4339:2 8343:2",	-- Black Mageweave Gloves
	[10009] = "12060|T215/230/245/260|4339:3 2604:2 8343|10302",	-- Red Mageweave Pants
	[10007] = "12056|T215/230/245/260|4339:3 2604:2 8343|10300",	-- Red Mageweave Vest
	[10004] = "12055|T215/230/245/260|4339:3 10285:2 8343",	-- Shadoweave Robe
	[10008] = "12059|T215/220/225/230|4339 2324 8343|10301",	-- White Bandit Mask
	[10056] = "12061|T215/220/225/230|4339 6261 8343",	-- Orange Mageweave Shirt
	[10034] = "12085|T240/245/250/255|4339:4 8343:2|10321",	-- Tuxedo Shirt
	[10035] = "12089|T245/250/255/260|4339:4 8343:3|10323",	-- Tuxedo Pants
	[10019] = "12067|T225/240/255/270|4339:4 8153:4 10286:2 8343:2",	-- Dreamweave Gloves
	[10021] = "12070|T225/240/255/270|4339:6 8153:6 10286:2 8343:2",	-- Dreamweave Vest
	[10030] = "12081|T240/255/270/285|4339:3 4589:6 8343:2|10318",	-- Admiral's Hat
	[10042] = "12069|T225/240/255/270|4339:5 7077:2 8343:2",	-- Cindercloth Robe
	[22246] = "27658|T225/240/255/270|4339:4 11137:4 8343:2|22307",	-- Enchanted Mageweave Pouch
	[10018] = "12066|T225/240/255/270|4339:3 2604:2 8343:2|10312",	-- Red Mageweave Gloves
	[10023] = "12071|T225/240/255/270|4339:5 10285:5 8343:2",	-- Shadoweave Gloves
	[10050] = "12065|T225/240/255/270|4339:4 4291:2",	-- Mageweave Bag
	[10040] = "12091|T250/255/260/265|4339:5 8343:3 2324|10325",	-- White Wedding Dress
	[10026] = "12073|T230/245/260/275|4339:3 8343:2 4304:2",	-- Black Mageweave Boots
	[10024] = "12072|T230/245/260/275|4339:3 8343:2",	-- Black Mageweave Headband
	[10027] = "12074|T230/245/260/275|4339:3 8343:2",	-- Black Mageweave Shoulders
	[10025] = "12086|T245/260/275/290|4339:2 10285:8 8343:2|10463",	-- Shadoweave Mask
	[10029] = "12078|T235/250/265/280|4339:4 2604:2 8343:3|10315",	-- Red Mageweave Shoulders
	[10028] = "12076|T235/250/265/280|4339:5 10285:4 8343:2",	-- Shadoweave Shoulders
	[10051] = "12079|T235/250/265/280|4339:4 2604:2 8343:2",	-- Red Mageweave Bag
	[10053] = "12077|T235/240/245/250|4339:3 2325 8343 2324",	-- Simple Black Dress
	[10036] = "12093|T250/265/280/295|4339:5 8343:3|10326",	-- Tuxedo Jacket
	[13868] = "18404|T255/270/285/300|14048:5 7079:2 14341|14467",	-- Frostweave Robe
	[10033] = "12084|T240/255/270/285|4339:4 2604:2 8343:2|10320",	-- Red Mageweave Headband
	[10031] = "12082|T240/255/270/285|4339:6 10285:6 8343:3 4304:2",	-- Shadoweave Boots
	[10044] = "12088|T245/260/275/290|4339:5 7077 8343:3 4304:2",	-- Cindercloth Boots
	[10041] = "12092|T250/265/280/295|4339:8 8153:4 10286:2 8343:3 6037 1529",	-- Dreamweave Circlet
	[14048] = "18401|T250/255/257/260|14047:5",	-- Bolt of Runecloth
	[21154] = "26403|T250/265/280/295|14048:4 4625:2 2604:2 14341|44916",	-- Festival Dress
	[21542] = "26407|T250/265/280/295|14048:4 4625:2 2604:2 14341|44917",	-- Festive Red Pant Suit
	[14342] = "18560|T250/290/305/320|14256:2|14526",	-- Mooncloth
	[13869] = "18403|T255/270/285/300|14048:5 7079:2 14341|14466",	-- Frostweave Tunic
	[13856] = "18402|T255/270/285/300|14048:3 14341",	-- Runecloth Belt
	[14042] = "18408|T260/275/290/305|14048:5 7077:2 14341|14471",	-- Cindercloth Vest
	[13858] = "18406|T260/275/290/305|14048:5 14227 14341|14469",	-- Runecloth Robe
	[13857] = "18407|T260/275/290/305|14048:5 14227 14341|14470",	-- Runecloth Tunic
	[21340] = "26085|T260/275/290/305|14048:6 8170:4 7972:2 14341|21358",	-- Soul Pouch
	[14046] = "18405|T260/275/290/305|14048:5 8170:2 14341|14468",	-- Runecloth Bag
	[13870] = "18411|T265/280/295/310|14048:3 7080 14341|14474",	-- Frostweave Gloves
	[14143] = "18410|T265/280/295/310|14048:3 9210:2 14227 14341|14473",	-- Ghostweave Belt
	[13860] = "18409|T265/280/295/310|14048:4 14227 14341|14472",	-- Runecloth Cloak
	[14101] = "18415|T270/285/300/315|14048:4 3577:2 14341|14479",	-- Brightcloth Gloves
	[14100] = "18414|T270/285/300/315|14048:5 3577:2 14341|14478",	-- Brightcloth Robe
	[14043] = "18412|T270/285/300/315|14048:4 7077:2 14341|14476",	-- Cindercloth Gloves
	[14142] = "18413|T270/285/300/315|14048:4 9210:2 14227 14341|14477",	-- Ghostweave Gloves
	[14134] = "18422|T275/290/305/320|14048:6 7078:4 7077:4 7068:4 14341|14486",	-- Cloak of Fire
	[14103] = "18420|T275/290/305/320|14048:4 3577:2 14341|14484",	-- Brightcloth Cloak
	[22251] = "27724|T275/290/305/320|14048:5 8831:10 11040:8 14341:2|22310",	-- Cenarion Herb Bag
	[14044] = "18418|T275/290/305/320|14048:5 7078 14341|14482",	-- Cindercloth Cloak
	[22248] = "27659|T275/290/305/320|14048:5 16203:2 14341:2|22308",	-- Enchanted Runecloth Bag
	[14107] = "18419|T275/290/305/320|14048:5 14256:2 14341|14483",	-- Felcloth Pants
	[14141] = "18416|T275/290/305/320|14048:6 9210:4 14227 14341|14480",	-- Ghostweave Vest
	[13863] = "18417|T275/290/305/320|14048:4 8170:4 14341|14481",	-- Runecloth Gloves
	[14132] = "18421|T275/290/305/320|14048:6 11176 14341|14485",	-- Wizardweave Leggings
	[21341] = "26086|T280/300/315/330|14256:12 12810:6 20520:2 14227:4",	-- Felcloth Bag
	[14045] = "18434|T280/295/310/325|14048:6 7078 14341|14490",	-- Cindercloth Pants
	[13871] = "18424|T280/295/310/325|14048:6 7080 14341|14489",	-- Frostweave Pants
	[13864] = "18423|T280/295/310/325|14048:4 14227:2 8170:4 14341|14488",	-- Runecloth Boots
	[14140] = "18452|T300/315/330/345|14048:4 14342:6 12800 12810:2 14341:2|14509",	-- Mooncloth Circlet
	[18486] = "22902|T300/315/330/345|14048:6 14342:4 13926:2 14341:2|18487",	-- Mooncloth Robe
	[14139] = "18448|T300/315/330/345|14048:5 14342:5 14341|14507",	-- Mooncloth Shoulders
	[14138] = "18447|T300/315/330/345|14048:6 14342:4 14341|14501",	-- Mooncloth Vest
	[14136] = "18436|T285/300/315/330|14048:10 14256:12 12808:4 7080:4 14341|14493",	-- Robe of Winter Night
	[14108] = "18437|T285/300/315/330|14048:6 14256:2 8170:4 14341|14492",	-- Felcloth Boots
	[13865] = "18438|T285/300/315/330|14048:6 14227:2 14341|14491",	-- Runecloth Pants
	[19056] = "23664|T290/305/320/335|14048:6 12810:4 13926:2 12809:2 14227:2|19216",	-- Argent Boots
	[15802] = "19435|T290/295/310/325|14048:6 14342:4 7971:2 14341",	-- Mooncloth Boots
	[14137] = "18440|T290/305/320/335|14048:6 14342:4 14341|14497",	-- Mooncloth Leggings
	[19047] = "23662|T290/305/320/335|14048:8 7076:3 12803:3 14227:2|19215",	-- Wisdom of the Timbermaw
	[14104] = "18439|T290/305/320/335|14048:6 3577:4 14227 14341|14494",	-- Brightcloth Pants
	[14111] = "18442|T290/305/320/335|14048:5 14256:2 14341|14496",	-- Felcloth Hood
	[14144] = "18441|T290/305/320/335|14048:6 9210:4 14341|14495",	-- Ghostweave Pants
	[13866] = "18444|T295/310/325/340|14048:4 14227:2 14341|14498",	-- Runecloth Headband
	[18405] = "22866|T300/315/330/345|14048:16 9210:10 14342:10 7080:12 7078:12 14344:6 14341:6|18414",	-- Belt of the Archmage
	[21342] = "26087|T300/315/330/345|14256:20 17012:16 19726:8 7078:4 14227:4|21371",	-- Core Felcloth Bag
	[16979] = "20849|T300/315/330/345|14048:8 17010:6 7078:4 12810:2 14341:2|17018",	-- Flarecore Gloves
	[19165] = "23667|T300/315/330/345|14342:8 17010:5 17011:3 7078:10 14227:4|19220",	-- Flarecore Leggings
	[16980] = "20848|T300/315/330/345|14048:12 17010:4 17011:4 12810:6 14341:2|17017",	-- Flarecore Mantle
	[19156] = "23666|T300/315/330/345|14342:10 17010:2 17011:3 7078:6 14227:4|19219",	-- Flarecore Robe
	[18263] = "22759|T300/320/335/350|14342:6 17010:8 7078:2 12810:6 14341:4|18265",	-- Flarecore Wraps
	[22658] = "28208|T300/315/330/345|22682:5 14048:4 7080:2 14227:4",	-- Glacial Cloak
	[22654] = "28205|T300/315/330/345|22682:5 14048:4 7080:4 14227:4",	-- Glacial Gloves
	[22652] = "28207|T300/315/330/345|22682:7 14048:8 7080:6 14227:8",	-- Glacial Vest
	[22655] = "28209|T300/315/330/345|22682:4 14048:2 7080:2 14227:4",	-- Glacial Wrists
	[14146] = "18454|T300/315/330/345|14048:10 14342:10 9210:10 13926:6 12364:6 12810:8 14341:2|14511",	-- Gloves of Spell Mastery
	[14152] = "18457|T300/315/330/345|14048:12 7078:10 7082:10 7076:10 7080:10 14341:2|14513",	-- Robe of the Archmage
	[14153] = "18458|T300/315/330/345|14048:12 12662:20 14256:40 7078:12 12808:12 14341:2|14514",	-- Robe of the Void
	[14154] = "18456|T300/315/330/345|14048:12 14342:10 12811:4 13926:4 9210:10 14341:2|14512",	-- Truefaith Vestments
	[19059] = "23665|T300/315/330/345|14342:5 12809:2 14227:2|19217",	-- Argent Shoulders
	[19684] = "24093|T300/315/330/345|14342:3 19726:3 12810:4 14048:4 14227:4|19766",	-- Bloodvine Boots
	[19683] = "24092|T300/315/330/345|14342:4 19726:4 12804:4 14048:4 14227:2|19765",	-- Bloodvine Leggings
	[19682] = "24091|T300/315/330/345|14342:3 19726:5 12804:4 14048:4 14227:2|19764",	-- Bloodvine Vest
	[14156] = "18455|T300/315/330/345|14048:8 14342:12 14344:2 17012:2 14341:2|14510",	-- Bottomless Bag
	[18413] = "22870|T300/315/330/345|14048:12 12809:4 12360 14341:2|18418",	-- Cloak of Warding
	[18407] = "22867|T300/315/330/345|14048:12 14256:20 12662:6 12808:8 14341:2|18415",	-- Felcloth Gloves
	[22660] = "28210|T300/315/330/345|19726 14342:2 12803:4 14227:4|22683",	-- Gaea's Embrace
	[18408] = "22868|T300/315/330/345|14048:12 7078:10 7910:2 14341:2|18416",	-- Inferno Gloves
	[19050] = "23663|T300/315/330/345|14342:5 7076:5 12803:5 14227:2|19218",	-- Mantle of the Timbermaw
	[18409] = "22869|T300/315/330/345|14048:12 14342:6 13926:2 14341:2|18417",	-- Mooncloth Gloves
	[20539] = "24902|T300/315/330/345|14048:2 20520:6 14256:2 12810:2 14227:2|20548",	-- Runed Stygian Belt
	[20537] = "24903|T300/315/330/345|14048:4 20520:6 14256:4 12810:2 14227:2|20547",	-- Runed Stygian Boots
	[20538] = "24901|T300/315/330/345|14048:6 20520:8 14256:6 14227:2|20546",	-- Runed Stygian Leggings
	[22757] = "28481|T300/315/330/345|14048:4 14342:2 12803:2 14227:2|22773",	-- Sylvan Crown
	[22758] = "28482|T300/315/330/345|14048:2 12803:4 14227:2|22772",	-- Sylvan Shoulders
	[22756] = "28480|T300/315/330/345|14048:4 19726:2 12803:2 14227:2|22774",	-- Sylvan Vest
	[22249] = "27660|T300/315/330/345|14048:6 14344:4 12810:4 14227:4|22309",	-- Big Bag of Enchantment
	[14106] = "18451|T300/315/330/345|14048:8 14256:3 12662:2 14341:2|14506",	-- Felcloth Robe
	[14112] = "18453|T300/315/330/345|14048:7 14256:3 12662:2 8170:4 14341:2|14508",	-- Felcloth Shoulders
	[17] = "22815|L300/285/290/295|8170:4 14048:2 18240 14341|||18258",	-- Gordok Ogre Suit
	[18] = "22813|T300/285/290/295|14048:2 8170:4 18240 14341|||18258",	-- Gordok Ogre Suit
	[14155] = "18445|T300/315/330/345|14048:4 14342 14341|14499",	-- Mooncloth Bag
	[13867] = "18449|T300/315/330/345|14048:7 14227:2 8170:4 14341|14504",	-- Runecloth Shoulders
	[22252] = "27725|T300/315/330/345|14048:6 14342:2 13468 14227:4|22312",	-- Satchel of Cenarius
	[14128] = "18446|T300/315/330/345|14048:8 11176:2 14341|14500",	-- Wizardweave Robe
	[14130] = "18450|T300/315/330/345|14048:6 11176:4 7910 14341|14505",	-- Wizardweave Turban
	[21840] = "26745|T300/305/315/325|21877:5",	-- Bolt of Netherweave
	[24268] = "31460|T300/300/310/320|21877:3||2",	-- Netherweave Net
	[21850] = "26765|T310/320/325/330|21840:3 14341",	-- Netherweave Belt
	[21849] = "26764|T310/320/325/330|21840:3 14341",	-- Netherweave Bracers
	[21841] = "26746|T315/320/330/340|21840:4 14341",	-- Netherweave Bag
	[21851] = "26770|T320/330/335/340|21840:4 21887:2 14341",	-- Netherweave Gloves
	[21842] = "26747|T325/330/335/340|21840:3 22445:2|21892",	-- Bolt of Imbued Netherweave
	[21852] = "26771|T325/335/340/345|21840:6 14341",	-- Netherweave Pants
--	[24269] = "31461|T325|21877:6|24315|2",	-- Heavy Netherweave Net; Removed during TBC beta
	[24273] = "31430|T335/345/350/355|14341 22457:5|24292",	-- Mystic Spellthread
	[24275] = "31431|T335/345/350/355|14341 21886:5|24293",	-- Silver Spellthread
	[21853] = "26772|T335/345/350/355|21840:6 21887:2 14341",	-- Netherweave Boots
	[21859] = "26775|T340/350/355/360|21842:5 21881:2 14341|21898",	-- Imbued Netherweave Pants
	[24270] = "31459|T340/350/355/360|21842:6 21887:4|24314",	-- Bag of Jewels
	[21843] = "26749|T340/340/345/350|21842:4 21881:2 22446|21893",	-- Imbued Netherweave Bag
	[21854] = "26773|T340/350/355/360|21840:8 14341:2|21896",	-- Netherweave Robe
	[21855] = "26774|T345/355/360/365|21840:8 14341:2|21897",	-- Netherweave Tunic
	[21844] = "26750|T345/345/350/355|21840 21882:8|21894",	-- Bolt of Soulcloth
	[21866] = "26782|T350/360/365/370|21840:6 22445:12 14341:2|21905",	-- Arcanoweave Bracers
	[24251] = "31437|T350/360/365/370|21842:4 21884:8|24298",	-- Blackstrike Bracers
	[24250] = "31435|T350/360/365/370|21842:4 22452:4 22456:4|24297",	-- Bracers of Havok
	[30831] = "37873|T350/360/365/370|21842:4 22457:3 21886:3 21881:2|30833",	-- Cloak of Arcane Evasion
	[24253] = "31440|T350/360/365/370|21842:6 22452:6|24300",	-- Cloak of Eternity
	[24252] = "31438|T350/360/365/370|21842:6 22457:3 22456:3|24299",	-- Cloak of the Black Void
	[30837] = "37882|T350/360/365/370|21840:5 21884:5 14341:2|30842",	-- Flameheart Bracers
	[21860] = "26776|T350/360/365/370|21842:4 21887:6 21881:2 14341|21899",	-- Imbued Netherweave Boots
	[21845] = "26751|T350/350/355/360|21842 21886 21885|21895",	-- Primal Mooncloth
	[24272] = "36686|T350/350/355/360|21842 22456 21884|30483",	-- Shadowcloth
	[24271] = "31373|T350/350/355/360|21842 22457 21884|24316",	-- Spellcloth
	[24249] = "31434|T350/360/365/370|21842:4 22452:8|24296",	-- Unyielding Bracers -- also 35308
	[24254] = "31441|T350/360/365/370|21842:6 21886:6|24301",	-- White Remedy Cape
	[21863] = "26779|T355/365/370/375|21844:5 21887:6 14341:4|21902",	-- Soulcloth Gloves
	[21867] = "26783|T360/370/375/380|21840:8 22445:16 14341:2|21906",	-- Arcanoweave Boots
	[30838] = "37883|T360/370/375/380|21840:7 21884:7 14341:2|30843",	-- Flameheart Gloves
	[21861] = "26777|T360/370/375/380|21842:6 21881:2 14341|21900",	-- Imbued Netherweave Robe
	[21862] = "26778|T360/370/375/380|21842:6 21881:2 14341|21901",	-- Imbued Netherweave Tunic
	[24257] = "31444|T365/375/380/385|21842:6 22457:14 23572|24304",	-- Black Belt of Knowledge
	[24256] = "31443|T365/375/380/385|24272:10 21884:16 23572|24303",	-- Girdle of Ruination
	[24260] = "31450|T365/375/380/385|24271:10 22457:12 23572|24307",	-- Manaweave Cloak
	[24258] = "31448|T365/375/380/385|21845:10 22452:12 23572|24305",	-- Resolute Cape
	[21864] = "26780|T365/375/380/385|21844:6 14341:4|21903",	-- Soulcloth Shoulders
	[24255] = "31442|T365/375/380/385|21845:8 22452:16 23572|24302",	-- Unyielding Girdle -- also 35309
	[24259] = "31449|T365/375/380/385|24272:10 22451:14 23572|24306",	-- Vengeance Wrap
	[21868] = "26784|T370/380/385/390|21840:12 22445:20 14341:2|21907",	-- Arcanoweave Robe
	[30839] = "37884|T370/380/385/390|21840:9 21884:9 14341:2|30844",	-- Flameheart Vest
	[24267] = "31456|T375/385/390/395|21842:12 23571:8 23572|24313",	-- Battlecast Hood
	[24263] = "31453|T375/385/390/395|21842:12 23571:8 23572|24310",	-- Battlecast Pants
	[24276] = "31433|T375/385/390/395|14341 21886:10 23572|24295",	-- Golden Spellthread
	[24274] = "31432|T375/385/390/395|14341 22457:10 23572|24294",	-- Runic Spellthread
	[21865] = "26781|T375/380/382/385|21844:8 14341:4|21904",	-- Soulcloth Vest
	[24266] = "31455|T375/385/390/395|24271:10 23571:5 23572|24312",	-- Spellstrike Hood
	[24262] = "31452|T375/385/390/395|24271:10 23571:5 23572|24309",	-- Spellstrike Pants
	[32585] = "41208|T375/385/390/395|21842:4 21845:2 21886:6 32428:2|32753",	-- Swiftheal Mantle -- also 35525
	[32584] = "41207|T375/385/390/395|21842:3 21845:4 21886:8 32428:4|32752",	-- Swiftheal Wraps -- also 35526
	[24264] = "31454|T375/385/390/395|21845:10 23571:5 23572|24311",	-- Whitemend Hood
	[24261] = "31451|T375/385/390/395|21845:10 23571:5 23572|24308",	-- Whitemend Pants
	[21872] = "26759|T375/385/390/395|24272:6 21881:4|21915",	-- Ebon Shadowbag
	[21876] = "26763|T375/385/390/395|21845:8 21881:4|21919",	-- Primal Mooncloth Bag
	[21858] = "26755|T375/385/390/395|24271:6 22446:4 21881:4|21911",	-- Spellfire Bag
	-- Not on live [30463] = "36670|T375|21840:6 21887:4 21885:3 21886:3 21881:2",	-- Lifeblood Belt
	-- Not on live [30464] = "36672|T375|21840:4 21887:4 21885:2 21886:2 21881:2",	-- Lifeblood Bracers
	-- Not on live [30465] = "36669|T375|21840:10 21885:5 21886:5 21881:2",	-- Lifeblood Leggings
	-- Not on live [30460] = "36667|T375/365/370/375|21840:6 21887:4 21884:3 22456:4 21881:2",	-- Netherflame Belt
	-- Not on live [30461] = "36668|T375/365/370/375|21840:6 21887:4 21884:2 22456:6 21881:2",	-- Netherflame Boots
	-- Not on live [30459] = "36665|T375/365/370/375|21840:10 21884:5 22456:6 21881:2",	-- Netherflame Robe
	[21873] = "26760|Tm355/365/370/375|21845:4 21881:2 21886:8|21916",	-- Primal Mooncloth Belt
	[21874] = "26761|Tm365/375/380/385|21845:8 21881:2 21886:8|21918",	-- Primal Mooncloth Shoulders
	[21875] = "26762|Tm375/385/390/395|21845:14 22457:12 21881:4|21917",	-- Primal Mooncloth Robe
	[21869] = "26756|Ts355/365/370/375|24272:4 21885:10 21881:2|21912",	-- Frozen Shadoweave Shoulders
	[21870] = "26757|Ts365/375/380/385|24272:8 21885:12 21881:2|21914",	-- Frozen Shadoweave Boots
	[21871] = "26758|Ts375/385/390/395|24272:14 21885:16 21881:4|21913",	-- Frozen Shadoweave Robe
	[21846] = "26752|Tp355/365/370/375|24271:4 21884:10 21881:2|21908",	-- Spellfire Belt
	[21847] = "26753|Tp365/375/380/385|24271:8 21884:12 21881:4|21909",	-- Spellfire Gloves
	[21848] = "26754|Tp375/385/390/395|24271:14 21884:16 21881:4|21910",	-- Spellfire Robe
	[30038] = "36315|T375/385/390/395|30183:2 21842:4 21884:15 14341:2|30280", --Belt of Blasting
	[30036] = "36316|T375/385/390/395|30183:2 21842:4 21886:10 14341:2 21885:10|30281", --Belt of the Long Road
	[30037] = "36317|T375/385/390/395|23572:2 24272:4 24271:4 14341:2|30282", --Boots of Blasting
	[30035] = "36318|T375/385/390/395|23572:2 21845:4 24271:4 14341:2|30283", -- Boots of the Long Road
	[32587] = "41206|T375/385/390/395|21842:4 24271:2 22457:6 32428:2|32755", -- Mantle of Nimble Thought -- also rid 35522****
	[32586] = "41205|T375/385/390/395|21842:3 24271:4 22457:8 32428:4|32754", --Bracers of Nimble Thought - also rid35518*******
	[32420] = "40060|T375/385/390/395|32428 22450 21886:2 22456:2 21842|32447", --Night's End
	[32392] = "40021|T375/385/390/395|32428 22450 21886:2 22456:2 21842|32438", --Soulguard Bracers
	[32390] = "40024|T375/385/390/395|32428:2 22450 21886:3 22456:4 21842|32440", --Soulguard Girdle
	[32389] = "40023|T375/385/390/395|32428:3 22450 21886:4 22456:6 21842:2|32439", --Soulguard Leggings
	[32391] = "40020|T375/385/390/395|32428:2 22450 21886:2 22456:4 21842|32437", --Soulguard Slippers
	[34087] = "44950|T250/0/0/250|14048:4 2997 2605:2 14341|34261", -- Green Winter Clothes
	[34085] = "44958|T250/0/0/250|14048:4 2997 2604:2 14341|34319", -- Red Winter Clothes
--~ --[[ New in 2.4 --]]
	[34360] = "46126|J365/375/380/385|31079:6 32249:6|35205", -- Amulet of Flowing Life - also recipe 35533
	[34361] = "46124|J365/375/380/385|35128:4 22451:20 31079:12 34664:5|35200", -- Hard Khorium Band
	[34358] = "46127|J365/375/380/385|35128:6 23572:9|35203", -- Hard Khorium Choker - also 35535
	[34359] = "46125|J365/375/380/385|31079:12 32227:3 32228:3|35201", -- Pendant of Sunfire - also 35537
	[34362] = "46122|J365/375/380/385|35128:4 23571:4 31079:12 34664:5|35198", -- Loop of Forged Power
	[34363] = "46123|J365/375/380/385|35128:4 21886:20 31079:12 34664:5|35199", -- Ring of Flowing Life - also 35538
	[34369] = "46138|L365/375/392/410|23793:40 25707:24 23571:6 23572:6|35218", -- Carapace of Sun and Shadow - also 35539
	[34373] = "46137|L365/375/392/410|23793:40 29547:24 23571:6 23572:6|35217", -- Embrace of the Phoenix
	[34374] = "46133|L365/375/392/410|23793:30 29547:16 22451:18 23571:8 34664:6|35213", -- Fletcher's Gloves of the Phoenix - also 35541
	[34370] = "46134|L365/375/392/410|23793:30 25707:16 22456:18 23571:8 34664:6|35214", -- Gloves of Immortal Dusk
	[34367] = "46129|T365/375/392/410|21845:18 21886:12 21885:12 34664:6|35205", -- Hands of Eternal Light -- also 35544
	[34371] = "46136|L365/375/392/410|23793:40 25708:24 23571:6 23572:6|35216", -- Leather Chestguard of the Sun -- also 35545
	[34372] = "46132|L365/375/392/410|23793:30 25708:16 21886:18 23571:8 34664:6|35212", -- Leather Gauntlets of the Sun -- also 35546
	[34365] = "46131|T365/375/392/410|21845:20 23572:2|35207", -- Robe of Eternal Light -- also 35548
	[34375] = "46139|L365/375/392/410|23793:40 29548:24 23571:6 23572:6|35219", -- Sun-Drenched Scale Chestguard
	[34376] = "46135|L365/375/392/410|23793:30 29548:16 21886:18 23571:8 34664:6|35215", -- Sun-Drenched Scale Gloves -- also 35550
	[34366] = "46128|T365/375/392/410|24271:10 24272:10 34664:6|35204", -- Sunfire Handwraps -- also 35551
	[34364] = "46130|T365/375/392/410|24271:12 24272:12 23572:2|35206", -- Sunfire Robe
	[34378] = "46141|B365/375/392/410|35128:10 21884:12 22456:12 22451:12 34664:6|35209", -- Hard Khorium Battlefists --also 35553
	[34377] = "46144|B365/375/392/410|23449:20 23573:4 21884:10 22456:10 23572:6|35211", -- Hard Khorium Battleplate
	[34379] = "46142|B365/375/392/410|23449:20 23573:4 21886:15 21885:15 23572:6|35210", -- Sunblessed Breastplate
	[34380] = "46140|B365/375/392/410|35128:8 21886:20 23571:6 34664:6|35208", -- Sunblessed Gauntlets
	[34847] = "46111|E375/390/410/430|32494 22456:4 21884:4 22457:4 23572:4|35186", -- Annihilator Holo-Gogs (Requires Mage, Priest, Warlock)
	[34357] = "46115|E375/390/410/430|32473 35128:2 23571 23572:4|35196", -- Hard Khorium Goggles
	[35182] = "46109|E375/390/410/430|32480 21885:6 21886:12 23572:4|35190", -- Hyper-Magnified Moon Specs (Requires Druid)
	[35185] = "46107|E375/390/410/430|32472 21886:8 22457:8 22452:8 23572:4|35187", -- Justicebringer 3000 Specs (Requires Paladin)
	[34355] = "46112|E375/390/410/430|32476 23571:2 22451:2 23572:4|35193", -- Lightning Etched Specs (Requires Shaman)
	[34354] = "46114|E375/390/410/430|32461 21884:10 23572:4|35195", -- Mayhem Projection Goggles (Requires Warrior, Paladin)
	[35181] = "46108|E375/390/410/430|32495 21886:8 22457:8 23572:4|35189", -- Powerheal 9000 Lens (Requires Priest)
	[35184] = "46110|E375/390/410/430|32475 21886:5 22457:5 21885:5 23572:4|35192", -- Primal-Attuned Goggles (Requires Shaman)
	[34353] = "46116|E375/390/410/430|32478 22456:12 23572:4|35197", -- Quad Deathblow X44 Goggles (Requires Rogue, Druid)
	[34356] = "46113|E375/390/410/430|32474 22451:12 23572:4|35194", -- Surestrike Goggles v3.0 (Requires Hunter, Shaman)
	[35183] = "46106|E375/390/410/430|32479 21885:4 22457:8 23572:4|35191", -- Wonderheal XT68 Shades (Requires Druid)
	[34832] = "45695|W100/100/105/110|2596 2594|34834|5", -- Captain Rumsey's Lager
	[35503] = "46601|J370/375/377/380|25868|35505", -- Ember Skyfire Diamond, requires Shattered Sun Offensive Revered
	[35501] = "46597|J370/375/377/380|25867|35502", -- Eternal Earthstorm Diamond, Requires Shattered Sun Offesnive Revered
	[22] = "45765|D360/0/0/375|22450|34872|2|22449", -- Void Shatter, Requires Shattered Sun Offensive Honored
	[35563] = "46684|W250/275/285/295|35562|35564", -- Charred Bear Kabobs
	[35565] = "46688|W250/275/285/295|35562|35566", -- Juicy Bear Burger
   	[35128] = "46353|Y375/0/0/375|23449:3 23573|35273",	-- Smelt Hardened Khorium
	[35759] = "47053|J375/375/380/385|32249|35769", --Forceful Seaspray Emerald
	[35761] = "47056|J375/375/380/385|32229|35768", -- Quick Lionseye
	[35760] = "47055|J375/375/380/385|32231|35767", -- Reckless Pyrestone
	[35758] = "47054|J375/375/380/385|32249|35766", -- Steady Seaspray Emerald
	[35581] = "46697|E355/365/375/385|21840:8 23786:2 23785:2 23787:4|35582", -- Rocket Boots Xtreme Lite
	[35700] = "46777|J375/375/380/385|23447:8 32227:2 21884:8|35697", -- Figurine - Crimson Serpent
	[35693] = "46775|J375/375/380/385|23449:8 32228:2 23440:6|35696", -- Figurine - Empyrean Tortoise
	[35694] = "46776|J375/375/380/385|23449:8 32231:2 22452:8|35696", -- Figurine - Khorium Boar
	[35703] = "46779|J375/375/380/385|23447:8 32249:2 22457:8|35699", -- Figurine - Seaspray Albatross
	[35702] = "46778|J375/375/380/385|23573:4 32230:2 22456:8|35698", -- Figurine - Shadowsong Panther
	[35707] = "46803|J350/350/365/380|23441|35708", -- Regal Nightseye
	[-46594] = "D360/370/385/400|22446:4 22445:8 23427:4|35500", -- Enchant Chest - Defense
	[35751] = "47050|A375/380/385/390|13503 22456:6 30183:2|35755", -- Assassin's Alchemist Stone
	[35748] = "47046|A375/380/385/390|13503 22451:6 30183:2|35752", -- Guardian's Alchemist Stone
	[35750] = "47049|A375/380/385/390|13503 21886:6 30183:2|35754", -- Redeemer's Alchemist Stone
	[35749] = "47048|A375/380/385/390|13503 21884:6 30183:2|35753", -- Sorcerer's Alchemist Stone
	[-47051] = "D375/380/385/390|22446:8 22452:8|35756", -- Enchant Cloak - Steelweave
	[35318] = "46405|J350/350/365/380|23437|35325", --Forceful Talasite
	[35315] = "46403|J350/350/365/380|23440|35322", --Quick Dawnstone
	[35316] = "46404|J350/350/365/380|23439|35323", --Reckless Noble Topaz
--~ --[[New in 3.0.2]]
--[[ Inscription --]]
	-- Insciption (Ink)
	[37101] = "52738|I1/15/22/30|39151", -- Ivory Ink
	[39469] = "52843|I35/45/60/75|39151:2", -- Moonglow Ink
	[43115] = "57703|I85/85/90/95|43103", -- Hunter's Ink
	[39774] = "53462|I75/75/77/80|39334:2", -- Midnight Ink
	[43116] = "57704|I100/100/100/105|39338:2", -- Lion's Ink
	[43117] = "57706|I125/125/130/135|43104", -- Dawnstar Ink
	[43118] = "57707|I150/150/150/155|39339:2", -- Jadefire Ink
	[43119] = "57708|I175/175/175/180|43105", -- Royal Ink
	[43120] = "57709|I200/200/200/205|39340:2", -- Celestial Ink
	[43121] = "57710|I225/225/225/230|43106", -- Fiery Ink
	[43122] = "57711|I250/250/250/255|39341:2", -- Shimmering Ink
	[43123] = "57712|I275/290/295/300|43107", -- Ink of the Sky
	[43124] = "57713|I290/295/300/305|39342:2", -- Ethereal Ink
	[43125] = "57714|I325/325/325/330|43108", -- Darkflame Ink
	[43126] = "57715|I350/350/350/355|39343:2", -- Ink of the Sea
	[43127] = "57716|I375/375/375/380|43109:2", -- Snowfall Ink
	-- Insciption (Enchant)
	-- TODO: Levels for Vellum III
	[38682] = "52739|I35/75/87/100|39469 39354:2", -- Armor Vellum
	[39349] = "52840|I75/100/112/125|39774:3 39354:2||2", -- Weapon Vellum
	[37602] = "59499|I200/210/215/220|43120 10648:2", -- Armor Vellum II
	[39350] = "59488|I235/250/255/260|43121 39501:2 43120||2", -- Weapon Vellum II
	[43145] = "59500|I350/355/370/385|43126 39502:2||2", -- Armor Vellum III
	[43146] = "59501|I400/405/410/415|43126:3 39502:2||2", -- Weapon Vellum III
	-- Inscription (Scrolls)
	-- TODO: verify levels for scrolls VII and VIII.  Also, Recall III.
	[1180] = "45382|I1/35/40/45|37101 39354", -- Scroll of Stamina
	[3012] = "58472|I15/35/40/45|37101:2 39354", -- Scroll of Agility
	[955] = "48114|I15/35/40/45|37101 39354", -- Scroll of Intellect
	[1181] = "48116|I15/35/40/45|37101 39354", -- Scroll of Spirit
	[954] = "58484|I15/35/40/45|37101:2 39354", -- Scroll of Strength
	[37118] = "48248|I35/60/67/75|39354 39469", -- Scroll of Recall
	[2290] = "50598|I75/75/80/85|39774 39354", -- Scroll of Intellect II
	[1712] = "50605|I75/75/80/85|39774 39354", -- Scroll of Spirit II
	[1711] = "50612|I75/75/80/85|39774 39354", -- Scroll of Stamina II
	[2289] = "58485|I80/80/85/90|39774 39354", -- Scroll of Strength II
	[1477] = "58473|I85/85/90/95|39774 39354", -- Scroll of Agility II
	[4422] = "50614|I155/160/165/170|43118 10648:2||2", -- Scroll of Stamina III
	[4424] = "50606|I160/165/170/175|43118 10648:2||2", -- Scroll of Spirit III
	[4419] = "50599|I165/170/175/180|43118 10648:2||5", -- Scroll of Intellect III
	[4426] = "58486|I170/175/180/185|43118 10648:2||5", -- Scroll of Strength III
	[4425] = "58476|I175/180/185/190|43118 10648:2||5", -- Scroll of Agility III
	[44314] = "60336|I200/215/220/225|10648 43120", -- Scroll of Recall II
	[10307] = "50616|I205/210/215/220|43120 39501:2||2", -- Scroll of Stamina IV
	[10306] = "50607|I210/215/220/225|43120 39501:2||2", -- Scroll of Spirit IV
	[10308] = "50600|I215/220/225/230|43120 39501:2||2", -- Scroll of Intellect IV
	[10310] = "58487|I220/225/230/235|43120 39501:2||2", -- Scroll of Strength IV
	[10309] = "58478|I225/230/235/240|43120 39501:2||2", -- Scroll of Agility IV
	[27502] = "50617|I250/255/260/265|43122 39501:2||2", -- Scroll of Stamina V
	[27501] = "50608|I255/260/265/270|43122 39501:2||2", -- Scroll of Spirit V
	[27499] = "50601|I260/265/270/275|43122 39501:2||2", -- Scroll of Intellect V
	[27503] = "58488|I265/270/275/280|43122 39501:2||2", -- Scroll of Strength V
	[27498] = "58480|I270/275/280/285|43122 39501:2||2", -- Scroll of Agility V
	[33461] = "50618|I290/300/305/310|43122 39501:2||2", -- Scroll of Stamina VI
	[33460] = "50609|I295/305/310/315|43122 39501:2||2", -- Scroll of Spirit VI
	[33458] = "50602|I310/310/315/320|43124 39501:2||2", -- Scroll of Intellect VI
	[33462] = "58489|I305/315/320/325|43124 39501:2||2", -- Scroll of Strength VI
	[33457] = "58481|I310/320/325/330|43124 39501:2||2", -- Scroll of Agility VI
	[37093] = "50619|I350/355/360/365|43126 39502:2||2", -- Scroll of Stamina VII
	[37097] = "50610|I355/360/365/370|43126 39502:2||2", -- Scroll of Spirit VII
	[37091] = "50603|I360/365/370/375|43126 39502:2||2", -- Scroll of Intellect VII
	[43465] = "58490|I365/370/375/380|43126 39502:2||2", -- Scroll of Strength VII
	[43463] = "58482|I370/375/380/385|43126 39502:2||2", -- Scroll of Agility VII
	[37094] = "50620|I400/405/410/415|43126 39502:2||2", -- Scroll of Stamina VIII
	[37098] = "50611|I405/410/415/420|43126 39502:2||2", -- Scroll of Spirit VIII
	[37092] = "50604|I410/415/420/425|43126 39502:2||2", -- Scroll of Intellect VIII
	[43466] = "58491|I415/420/425/430|43126 39502:2||2", -- Scroll of Strength VIII
	[43464] = "58483|I420/425/430/435|43126 39502:2||2", -- Scroll of Agility VIII
	[44315] = "60337|I350/350/350/355|43126 39502", -- Scroll of Recall III
	-- Inscription (Special)
	[37] = "61288|I75/125/137/150|43126:3 43127 39502:5", -- Minor Inscription Research
	[38] = "61177|I385/425/437/450|43126:3 43127 39502:5", -- Northrend Inscription Research
	[43515] = "58565|I110/125/137/150|39354:10 43115:5 39774:2", -- Mystic Tome
	[43655] = "59478|I125/150/162/175|43117:5 10648:10 43116:2", -- Book of Survival
	[43654] = "59475|I125/150/162/175|43117:5 10648:10 43116:2", -- Tome of the Dawn
	[43657] = "59486|I175/200/205/210|43119:5 10648:10 43118:2", -- Royal Guide of Escape Routes
	[43656] = "59484|I175/200/205/210|43119:5 10648:10 43118:2", -- Tome of Kings
	[43850] = "59387|I200/205/210/215|43120:2 10648", -- Certificate of Ownership
	[43661] = "59490|I225/240/245/250|43121:5 43120:2 39501:10", -- Book of Stars
	[43660] = "59489|I225/240/245/250|43121:5 39501:10 43120:2", -- Fire Eater's Guide
	[43664] = "59494|I275/290/295/300|43123:8 39501:10 43122:4", -- Manual of Clouds
	[43663] = "59493|I275/290/295/300|43123:8 39501 43122:4", -- Stormbound Tome
	[43667] = "59496|I325/340/345/350|43125:6 39502:10 43124:3", -- Book of Clever Tricks
	[43666] = "59495|I325/340/345/350|43125:6 39502:10 43124:3", -- Hellfire Tome
	[44210] = "59498|I400/425/437/450|43127:5 39502:10 43102 43126:2", -- Faces of Doom
	[38322] = "59497|I400/425/437/450|43127:5 39502:10 43102 43126:2", -- Iron-bound Tome
	-- Inscription (Tarot)
	-- TODO: add tarots above 325?
	[37168] = "48247|I110/125/137/150|39354 43115 39774", -- Mysterious Tarot
	[44142] = "59480|I125/150/162/175|43117:2 10648 43116", -- Strange Tarot
	[44161] = "59487|I175/200/205/210|43119:2 10648 43118", -- Arcane Tarot
	[44163] = "59491|I225/240/245/250|43121:2 39501 43120", -- Shadowy Tarot
	[44316] = "59502|I275/290/295/300|43123:5 39501 43122:2", -- Darkmoon Card
	[44317] = "59503|I325/340/345/350|43125:3 39502 21886:3 43124", -- Greater Darkmoon Card
	[44318] = "59504|I400/425/450/475|39502 43127:6 35625:3 43126:3", -- Darkmoon Card of the North
	-- Inscription (Glyphs - Trainer)
	[42956] = "57114|I80/90/100/110|39774 39354", -- Glyph of Backstab
	[42741] = "56976|I80/90/100/110|39774 39354", -- Glyph of Frost Nova
	[42907] = "57004|I80/90/100/110|39774 39354", -- Glyph of Hunter's Mark
	[42408] = "57194|I80/90/100/110|39774 39354", -- Glyph of Power Word: Shield
	[40913] = "56955|I80/90/100/110|39774 39354", -- Glyph of Rejuvenation
	[41096] = "57022|I80/90/100/110|39774 39354", -- Glyph of Spiritual Attunement
	[42455] = "57259|I85/95/105/115|39774 39354", -- Glyph of Corruption
	[43413] = "57162|I85/95/105/115|39774 39354", -- Glyph of Rapid Charge
	[41531] = "57239|I85/95/105/115|39774 39354", -- Glyph of Flame Shock
	[40922] = "56963|I85/95/105/115|39774 39354", -- Glyph of Wrath
	[41095] = "57027|I90/100/110/120|39774 39354", -- Glyph of Hammer of Justice
	[42743] = "56978|I90/100/110/120|39774 39354", -- Glyph of Ice Armor
	[40897] = "56961|I90/100/110/120|39774 39354", -- Glyph of Maul
	[42912] = "57009|I90/100/110/120|39774 39354", -- Glyph of Serpent Sting
	[42960] = "57119|I95/105/115/125|39774:2 39354", -- Glyph of Evasion
	[42462] = "57266|I95/105/115/125|39774:2 39354", -- Glyph of Healthstone
	[43418] = "57158|I95/105/115/125|39774:2 39354", -- Glyph of Heroic Strike
	[41537] = "57246|I95/105/115/125|39774:2 39354", -- Glyph of Lightning Shield
	[42410] = "57196|I95/105/115/125|39774:2 39354", -- Glyph of Psychic Scream
	[42734] = "56968|I100/105/110/115|43116 39354", -- Glyph of Arcane Explosion
	[42898] = "56995|I100/105/110/115|43116 39354", -- Glyph of Arcane Shot
	[40924] = "48121|I100/105/110/115|43116 39354", -- Glyph of Entangling Roots
	[42961] = "57120|I105/110/115/120|43116 10648", -- Glyph of Eviscerate
	[42398] = "57184|I105/110/115/120|43116 10648", -- Glyph of Fade
	[41106] = "57029|I105/110/115/120|43116 10648", -- Glyph of Holy Light
	[41530] = "57238|I110/115/120/125|43116 10648", -- Glyph of Fire Nova Totem
	[42461] = "57265|I110/115/120/125|43116 10648", -- Glyph of Health Funnel
	[43423] = "57163|I110/115/120/125|43116 10648", -- Glyph of Rending
	[42735] = "56971|I115/120/125/130|43116 10648", -- Glyph of Arcane Missiles
	[42900] = "56997|I115/120/125/130|43116 10648", -- Glyph of Aspect of the Monkey
	[40914] = "56945|I115/120/125/130|43116 10648", -- Glyph of Healing Touch
	[42962] = "57121|I120/125/130/135|43116:2 10648", -- Glyph of Expose Armor
	[42400] = "57186|I120/125/130/135|43116:2 10648", -- Glyph of Flash Heal
	[41092] = "57030|I120/125/130/135|43116:2 10648", -- Glyph of Judgement
	[42458] = "57262|I125/130/135/140|43116:2 10648", -- Glyph of Fear
	[41532] = "57240|I125/130/135/140|43116:2 10648", -- Glyph of Flametongue Weapon
	[43417] = "57157|I125/130/135/140|43116:2 10648", -- Glyph of Hamstring
	[42737] = "56973|I130/135/140/145|43116:2 10648", -- Glyph of Blink
	[42908] = "57005|I130/135/140/145|43116:2 10648", -- Glyph of Immolation Trap
	[40923] = "56951|I130/135/140/145|43116:2 10648", -- Glyph of Moonfire
	[41108] = "57031|I135/140/145/150|43116:2 10648", -- Glyph of Divinity
	[42964] = "57123|I135/140/145/150|43116:2 10648", -- Glyph of Garrote
	[42402] = "57188|I135/140/145/150|43116:2 10648", -- Glyph of Inner Fire
	[42465] = "57269|I140/145/150/155|43116:2 10648", -- Glyph of Imp
	[41536] = "57245|I140/145/150/155|43116:2 10648", -- Glyph of Lightning Bolt
	[43427] = "57167|I140/145/150/155|43116:2 10648", -- Glyph of Sunder Armor
	[40919] = "56948|I150/155/160/165|43118 10648", -- Glyph of Insect Swarm
	[42910] = "57007|I150/155/160/165|43118 10648", -- Glyph of Multi-Shot
	[42738] = "56974|I155/160/165/170|43118 10648", -- Glyph of Evocation
	[41100] = "57032|I155/160/165/170|43118 10648", -- Glyph of Righteous Defense
	[42966] = "57125|I160/165/170/175|43118 10648", -- Glyph of Gouge
	[42411] = "57197|I160/165/170/175|43118 10648", -- Glyph of Renew
	[41540] = "57249|I165/170/175/180|43118 10648", -- Glyph of Lava Lash
	[42467] = "57271|I165/170/175/180|43118 10648", -- Glyph of Shadow Bolt
	[43422] = "57161|I170/175/180/185|43118 10648", -- Glyph of Overpower
	[40909] = "56953|I170/175/180/185|43118:2 10648", -- Glyph of Rebirth
	[42897] = "56994|I175/180/185/190|43118:2 10648", -- Glyph of Aimed Shot
	[42746] = "56981|I175/180/185/190|43118:2 10648", -- Glyph of Icy Veins
	[41104] = "57020|I180/185/190/195|43118:2 10648", -- Glyph of Cleansing
	[42415] = "57200|I180/185/190/195|43118:2 10648", -- Glyph of Shadow Word: Pain
	[41547] = "57241|I185/190/195/200|43118:2 10648", -- Glyph of Frost Shock
	[42970] = "57129|I185/190/195/200|43118:2 10648", -- Glyph of Sap
	[43424] = "57165|I190/195/200/205|43118:2 10648", -- Glyph of Revenge
	[42473] = "57277|I190/195/200/205|43118:2 10648", -- Glyph of Voidwalker
	[42903] = "57000|I200/205/210/215|43120 10648", -- Glyph of Deterrence
	[40902] = "56956|I200/205/210/215|43120 10648", -- Glyph of Rip
	[41099] = "57023|I205/210/215/220|43120 39501", -- Glyph of Consecration
	[42747] = "56982|I205/210/215/220|43120 39501", -- Glyph of Improved Scorch
	[42972] = "57131|I210/215/220/225|43120 39501", -- Glyph of Sinister Strike
	[42416] = "57201|I210/215/220/225|43120 39501", -- Glyph of Smite
	[41533] = "57242|I215/220/225/230|43120 39501", -- Glyph of Healing Stream Totem
	[42466] = "57270|I215/220/225/230|43120 39501", -- Glyph of Searing Pain
	[43420] = "57151|I220/225/230/235|43120 39501", -- Glyph of Barbaric Insults
	[40916] = "56959|I220/225/230/235|43120 39501", -- Glyph of Starfire
	[42904] = "57001|I225/230/235/240|43120:2 39501", -- Glyph of Disengage
	[42744] = "56979|I225/230/235/240|43120:2 39501", -- Glyph of Ice Block
	[41098] = "57024|I230/235/240/245|43120:2 39501", -- Glyph of Crusader Strike
	[42397] = "57183|I230/235/240/245|43120 39501", -- Glyph of Dispel Magic
	[41535] = "57244|I235/240/245/250|43120:2 39501", -- Glyph of Lesser Healing Wave
	[42973] = "57132|I235/240/245/250|43120:2 39501", -- Glyph of Slice and Dice
	[43414] = "57154|I240/245/250/255|43120 39501", -- Glyph of Cleaving
	[42470] = "57274|I240/245/250/255|43120:2 39501", -- Glyph of Soulstone
	[42905] = "57002|I260/265/270/275|43122 39501", -- Glyph of Freezing Trap
	[40901] = "56957|I260/265/270/275|43122 39501", -- Glyph of Shred
	[43536] = "57210|I265/270/275/280|43122 39501", -- Glyph of Bone Shield
	[41103] = "57025|I265/270/275/280|43122 39501", -- Glyph of Exorcism
	[42399] = "57185|I270/275/280/285|43122 39501", -- Glyph of Fear Ward
	[43543] = "57216|I270/275/280/285|43122 39501", -- Glyph of Frost Strike
	[42468] = "57272|I275/280/285/290|43122 39501", -- Glyph of Shadowburn
	[41541] = "57251|I275/280/285/290|43122 39501", -- Glyph of Water Mastery
	[43546] = "57219|I280/285/290/295|43122 39501", -- Glyph of Icy Touch
	[42750] = "56985|I280/285/290/295|43122 39501", -- Glyph of Mana Gem
	[43541] = "57213|I285/290/295/300|43122 39501", -- Glyph of Death Grip
	[43416] = "57156|I285/290/295/300|43122 39501", -- Glyph of Execution
	[42974] = "57133|I285/290/295/300|43122 39501", -- Glyph of Sprint
	[41105] = "57026|I300/305/310/315|43124 39501", -- Glyph of Flash of Light
	[41527] = "57236|I300/305/310/315|43124 39501", -- Glyph of Earthliving Weapon
	[43548] = "57221|I300/305/310/315|43124 39501", -- Glyph of Plague Strike
	[42963] = "57122|I305/310/315/320|43124 39501", -- Glyph of Feint
	[43553] = "57226|I305/310/315/320|43124 39502", -- Glyph of Unbreakable Armor
	[40903] = "56952|I310/315/320/325|43124 39502", -- Glyph of Rake
	[43825] = "59338|I310/315/320/325|43124 39502", -- Glyph of Rune Tap
	[42401] = "57187|I315/320/325/330|43124 39502", -- Glyph of Holy Nova
	[42911] = "57008|I315/320/325/330|43124 39502", -- Glyph of Rapid Fire
	[43826] = "59339|I320/325/330/335|43124 39502", -- Glyph of Blood Strike
	[43428] = "57168|I320/325/330/335|43124 39502", -- Glyph of Sweeping Strikes
	[42749] = "56984|I325/330/335/340|43124:2 39502", -- Glyph of Mage Armor
	[42471] = "57275|I325/330/335/340|43124:2 39502", -- Glyph of Succubus
	[43551] = "57224|I330/335/340/345|43124:2 39502", -- Glyph of Scourge Strike
	[41542] = "57252|I330/335/340/345|43124:2 39502", -- Glyph of Windfury Weapon
	[42736] = "56972|I335/340/345/350|43124:2 39502", -- Glyph of Arcane Power
	[41094] = "57033|I335/340/345/350|43124:2 39502", -- Glyph of Seal of Command
	[42955] = "57113|I340/345/350/355|43124:2 39502", -- Glyph of Ambush
	[43827] = "59340|I340/345/350/355|43124:2 39502", -- Glyph of Death Strike
	[43554] = "57227|I345/350/355/360|43124:2 39502", -- Glyph of Vampiric Blood
	[43432] = "57172|I345/350/355/360|43124 39502", -- Glyph of Whirlwind
	[42453] = "57257|I350/355/360/365|43124:2 39502", -- Glyph of Banish
	[40896] = "56943|I350/355/360/365|43124:2 39502", -- Glyph of Frenzied Regeneration
	[42906] = "57003|I350/355/360/365|43124:2 39502", -- Glyph of Frost Trap
	[42406] = "57192|I350/355/360/365|43124:2 39502", -- Glyph of Mind Flay
	[43549] = "57222|I350/355/360/365|43124:2 39502", -- Glyph of the Ghoul
	-- Inscription (Glyphs - Discoverable)
	-- Inscription (Glyphs - TODO)
	-- TODO: Verify level for all following glyphs
	[43367] = "58313|I75/80/85/90|39774 39354", -- Glyph of Lay on Hands (deprecated?)
	[41102] = "57036|I375/380/385/390|43126 39502", -- Glyph of Turn Evil
	[42899] = "56996|I385/390/397/405|43126 39502", -- Glyph of Aspect of the Beast
	[41518] = "57233|I385/390/397/405|43126 39502", -- Glyph of Chain Lightning
	[42958] = "57116|I385/390/397/405|43126 39502", -- Glyph of Crippling Poison
	[42460] = "57264|I385/390/397/405|43126 39502", -- Glyph of Felhunter
	[40920] = "56946|I385/390/397/405|43126 39502", -- Glyph of Hurricane
	[42407] = "57193|I385/390/397/405|43126 39502", -- Glyph of Mind Soothe
	[42754] = "56989|I385/390/397/405|43126 39502", -- Glyph of Water Elemental
	[42745] = "56980|I375/380/385/390|43126 39502", -- Glyph of Ice Lance
	[42412] = "57198|I375/380/385/390|43126 39502", -- Glyph of Scourge Imprisonment
	[41539] = "57248|I375/380/385/390|43126 39502", -- Glyph of Stormstrike
	[42902] = "56999|I385/390/397/405|43126 39502", -- Glyph of Bestial Wrath
	[42957] = "57115|I385/390/397/405|43126 39502", -- Glyph of Blade Flurry
	[41517] = "57232|I385/390/397/405|43126 39502", -- Glyph of Chain Heal
	[42454] = "57258|I385/390/397/405|43126 39502", -- Glyph of Conflagrate
	[42965] = "57124|I385/390/397/405|43126 39502", -- Glyph of Ghostly Strike
	[42463] = "57267|I385/390/397/405|43126 39502", -- Glyph of Howl of Terror
	[40908] = "56947|I385/390/397/405|43126 39502", -- Glyph of Innervate
	[42748] = "56983|I385/390/397/405|43126 39502", -- Glyph of Invisibility
	[41538] = "57247|I385/390/397/405|43126 39502", -- Glyph of Mana Tide Totem
	[40900] = "56950|I385/390/397/405|43126 39502", -- Glyph of Mangle
	[42405] = "57191|I385/390/397/405|43126 39502", -- Glyph of Mind Control
	[42751] = "56986|I385/390/397/405|43126 39502", -- Glyph of Molten Armor
	[42409] = "57195|I385/390/397/405|43126 39502", -- Glyph of Prayer of Healing
	[42969] = "57128|I385/390/397/405|43126 39502", -- Glyph of Rupture
	[41110] = "57034|I385/390/397/405|43126 39502", -- Glyph of Seal of Light
	[41109] = "57035|I385/390/397/405|43126 39502", -- Glyph of Seal of Wisdom
	[42469] = "57273|I385/390/397/405|43126 39502", -- Glyph of Siphon Life
	[40906] = "56960|I385/390/397/405|43126 39502", -- Glyph of Swiftmend
	[42915] = "57012|I385/390/397/405|43126 39502", -- Glyph of Trueshot Aura
	[42916] = "57013|I385/390/397/405|43126 39502", -- Glyph of Volley
	[42909] = "57006|I375/380/385/390|43126 39502", -- Glyph of Improved Aspect of the Hawk
	[41524] = "57234|I385/390/395/400|43126 39502", -- Glyph of Lava
	[42954] = "57112|I385/390/397/405|43126 39502", -- Glyph of Adrenaline Rush
	[42901] = "56998|I385/390/397/405|43126 39502", -- Glyph of Aspect of the Viper
	[41101] = "57019|I385/390/397/405|43126 39502", -- Glyph of Avenger's Shield
	[41107] = "57021|I385/390/397/405|43126 39502", -- Glyph of Avenging Wrath
	[42396] = "57181|I385/390/397/405|43126 39502", -- Glyph of Circle of Healing
	[42456] = "57260|I385/390/397/405|43126 39502", -- Glyph of Curse of Agony
	[42959] = "57117|I385/390/397/405|43126 39502", -- Glyph of Deadly Throw
	[42457] = "57261|I385/390/397/405|43126 39502", -- Glyph of Death Coil
	[41526] = "57235|I385/390/397/405|43126 39502", -- Glyph of Earth Shock
	[41552] = "57250|I385/390/397/405|43126 39502", -- Glyph of Elemental Mastery
	[42459] = "57263|I385/390/397/405|43126 39502", -- Glyph of Felguard
	[42740] = "57719|I385/390/397/405|43126 39502", -- Glyph of Fire Blast
	[41529] = "57237|I385/390/397/405|43126 39502", -- Glyph of Fire Elemental Totem
	[42739] = "56975|I385/390/397/405|43126 39502", -- Glyph of Fireball
	[42742] = "56977|I385/390/397/405|43126 39502", -- Glyph of Frostbolt
	[40899] = "56944|I385/390/397/405|43126 39502", -- Glyph of Growl
	[41097] = "57028|I385/390/397/405|43126 39502", -- Glyph of Hammer of Wrath
	[41534] = "57243|I385/390/397/405|43126 39502", -- Glyph of Healing Wave
	[42967] = "57126|I385/390/397/405|43126 39502", -- Glyph of Hemorrhage
	[42464] = "57268|I385/390/397/405|43126 39502", -- Glyph of Immolate
	[40915] = "56949|I385/390/397/405|43126 39502", -- Glyph of Lifebloom
	[42403] = "57189|I385/390/397/405|43126 39502", -- Glyph of Lightwell
	[42404] = "57190|I385/390/397/405|43126 39502", -- Glyph of Mass Dispel
	[42752] = "56987|I400/0/400/405|43126 39502", -- Glyph of Polymorph
	[42968] = "57127|I385/390/397/405|43126 39502", -- Glyph of Preparation
	[40912] = "56954|I385/390/397/405|43126 39502", -- Glyph of Regrowth
	[42753] = "56988|I385/390/397/405|43126 39502", -- Glyph of Remove Curse
	[42414] = "57199|I385/390/397/405|43126 39502", -- Glyph of Shadow Word: Death
	[42913] = "57010|I385/390/397/405|43126 39502", -- Glyph of Snake Trap
	[42417] = "57202|I385/390/397/405|43126 39502", -- Glyph of Spirit of Redemption
	[40921] = "56958|I385/390/397/405|43126 39502", -- Glyph of Starfall
	[42914] = "57011|I385/390/397/405|43126 39502", -- Glyph of Steady Shot
	[42472] = "57276|I385/390/397/405|43126 39502", -- Glyph of Unstable Affliction
	[42971] = "57130|I385/390/397/405|43126 39502", -- Glyph of Vigor
	[43339] = "58303|I75/80/85/90|39774 39354", -- Glyph of Arcane Intellect
	[43395] = "58342|I75/80/85/90|39774 39354", -- Glyph of Battle
	[43340] = "58314|I75/80/85/90|39774 39354", -- Glyph of Blessing of Might
	[43366] = "58312|I75/80/85/90|39774 39354", -- Glyph of Blessing of Wisdom
	[43396] = "58343|I75/80/85/90|39774 39354", -- Glyph of Bloodrage
	[43379] = "58323|I75/80/85/90|39774 39354", -- Glyph of Blurred Speed
	[43397] = "58344|I75/80/85/90|39774 39354", -- Glyph of Charge
	[43390] = "58337|I75/80/85/90|39774 39354", -- Glyph of Drain Soul
	[43342] = "58317|I75/80/85/90|39774 39354", -- Glyph of Fading
	[43371] = "58318|I75/80/85/90|39774 39354", -- Glyph of Fortitude
	[43359] = "58306|I75/80/85/90|39774 39354", -- Glyph of Frost Armor
	[43350] = "58301|I75/80/85/90|39774 39354", -- Glyph of Mend Pet
	[43343] = "58326|I75/80/85/90|39774 39354", -- Glyph of Pick Pocket
	[43354] = "58300|I75/80/85/90|39774 39354", -- Glyph of Possessed Strength
	[43338] = "58299|I75/80/85/90|39774 39354", -- Glyph of Revive Pet
	[43356] = "58298|I75/80/85/90|39774 39354", -- Glyph of Scare Beast
	[43364] = "58308|I75/80/85/90|39774 39354", -- Glyph of Slow Fall
	[43361] = "58310|I75/80/85/90|39774 39354", -- Glyph of the Penguin
	[43335] = "58296|I75/80/85/90|39774 39354", -- Glyph of the Wild
	[43332] = "58289|I75/80/85/90|39774 39354", -- Glyph of Thorns
	[43399] = "58346|I75/80/85/90|39774 39354", -- Glyph of Thunder Clap
	[43316] = "58286|I75/105/110/115|43116 39354", -- Glyph of Aquatic Form
	[43365] = "58311|I75/105/110/115|43116 39354", -- Glyph of Blessing of Kings
	[43357] = "58305|I75/105/110/115|43116 39354", -- Glyph of Fire Ward
	[43725] = "59326|I75/105/110/115|43116 39354", -- Glyph of Ghost Wolf
	[43398] = "58345|I75/105/110/115|43116 39354", -- Glyph of Mocking Blow
	[43377] = "58325|I75/105/110/115|43116 39354", -- Glyph of Pick Lock
	[43368] = "58315|I75/105/110/115|43116 39354", -- Glyph of Sense Undead
	[43373] = "58320|I75/105/110/115|43116 39354", -- Glyph of Shackle Undead
	[43331] = "58288|I75/105/110/115|43116 39354", -- Glyph of Unburdened Rebirth
	[43389] = "58336|I75/105/110/115|43116 39354", -- Glyph of Unending Breath
	[43386] = "58332|I75/105/110/115|43116 39354", -- Glyph of Water Shield
	[43376] = "58324|I75/130/135/140|43116 10648", -- Glyph of Distract
	[43360] = "58307|I75/130/135/140|43116 10648", -- Glyph of Frost Ward
	[43391] = "58340|I75/130/135/140|43116 10648", -- Glyph of Kilrogg
	[43380] = "58328|I75/130/135/140|43116 10648", -- Glyph of Vanish
	[43344] = "58331|I75/130/135/140|43116 10648", -- Glyph of Water Breathing
	[43381] = "58329|I75/155/160/165|43118 10648", -- Glyph of Astral Recall
	[43334] = "58287|I75/155/160/165|43118 10648", -- Glyph of Challenging Roar
	[43392] = "58338|I75/155/160/165|43118 10648", -- Glyph of Curse of Exhaustion
	[43674] = "59315|I75/155/160/165|43118 10648", -- Glyph of Dash
	[43393] = "58339|I75/155/160/165|43118 10648", -- Glyph of Enslave Demon
	[43351] = "58302|I75/155/160/165|43118 10648", -- Glyph of Feign Death
	[43385] = "58330|I75/155/160/165|43118 10648", -- Glyph of Renewed Life
	[43372] = "58321|I75/155/160/165|43118 10648", -- Glyph of Shadow Protection
	[43369] = "58316|I75/155/160/165|43118 10648", -- Glyph of the Wise
	[43388] = "58333|I75/155/160/165|43118 10648", -- Glyph of Water Walking
	[43370] = "58319|I75/180/185/190|43118 10648", -- Glyph of Levitate
	[43378] = "58327|I75/205/210/215|43120 10648", -- Glyph of Safe Fall
	[43355] = "58297|I75/205/210/215|43120 10648", -- Glyph of the Pack
	[43671] = "57229|I75/305/310/315|43124 39501", -- Glyph of Corpse Explosion
	[43539] = "57215|I75/305/310/315|43124 39501", -- Glyph of Death's Embrace
	[43672] = "57230|I75/305/310/315|43124 39501", -- Glyph of Pestilence
	[43673] = "57228|I75/305/310/315|43124 39501", -- Glyph of Raise Dead
	[43535] = "57209|I75/330/335/340|43124 39502", -- Glyph of Blood Tap
	[43400] = "58347|I75/330/335/340|43124 39502", -- Glyph of Enduring Victory
	[43544] = "57217|I75/330/335/340|43124 39502", -- Glyph of Horn of Winter
	[43374] = "58322|I75/355/360/365|43126 39502", -- Glyph of Shadowfiend
	[43394] = "58341|I75/355/360/365|43126 39502", -- Glyph of Souls
	[43552] = "57225|I375/380/385/390|43126 39502", -- Glyph of Strangulate
	[43533] = "57207|I385/390/397/405|43126 39502", -- Glyph of Anti-Magic Shell
	[43425] = "57152|I385/390/397/405|43126 39502", -- Glyph of Blocking
	[43534] = "57208|I385/390/397/405|43126 39502", -- Glyph of Blood Boil
	[43412] = "57153|I385/390/397/405|43126 39502", -- Glyph of Bloodthirst
	[43537] = "57211|I385/390/397/405|43126 39502", -- Glyph of Chains of Ice
	[43538] = "57212|I385/390/397/405|43126 39502", -- Glyph of Dark Command
	[43542] = "57214|I385/390/397/405|43126 39502", -- Glyph of Death and Decay
	[43415] = "57155|I385/390/397/405|43126 39502", -- Glyph of Devastate
	[44684] = "61677|I385/390/397/405|43126 39502", -- Glyph of Frostfire
	[43545] = "57218|I385/390/397/405|43126 39502", -- Glyph of Icebound Fortitude
	[43419] = "57159|I385/390/397/405|43126 39502", -- Glyph of Intervene
	[43426] = "57166|I385/390/397/405|43126 39502", -- Glyph of Last Stand
	[43421] = "57160|I385/390/397/405|43126 39502", -- Glyph of Mortal Strike
	[43547] = "57220|I385/390/397/405|43126 39502", -- Glyph of Obliterate
	[43430] = "57164|I385/390/397/405|43126 39502", -- Glyph of Resonating Power
	[43550] = "57223|I385/390/397/405|43126 39502", -- Glyph of Rune Strike
	[43867] = "59559|I385/390/397/405|43126 39502", -- Glyph of Seal of Blood
	[43868] = "59560|I385/390/397/405|43126 39502", -- Glyph of Seal of Righteousness
	[43869] = "59561|I385/390/397/405|43126 39502", -- Glyph of Seal of Vengeance
	[43429] = "57169|I385/390/397/405|43126 39502", -- Glyph of Taunt
	[43431] = "57170|I385/390/397/405|43126 39502", -- Glyph of Victory Rush
	[42917] = "57014|I385/390/397/405|43126 39502", -- Glyph of Wyvern Sting
	[44920] = "56990|I385/355/360/365|39502 43126", -- Glyph of Blast Wave
	[44922] = "56965|I385/355/360/365|39502 43126", -- Glyph of Typhoon
	[44923] = "57253|I385/355/360/365|39502 43126", -- Glyph of Thunderstorm
	[44928] = "62162|I385/380/385/390|39502 43126", -- Glyph of Focus
	[44955] = "56991|I385/310/315/320|43124 39502", -- Glyph of Arcane Blast
	[-61120] = "I400/400/400/405|43127", -- Master's Inscription of the Storm
	[-61119] = "I400/400/400/405|43127", -- Master's Inscription of the Pinnacle
	[-61118] = "I400/400/400/405|43127", -- Master's Inscription of the Crag
	[-61117] = "I400/400/400/405|43127", -- Master's Inscription of the Axe
	-- WotLK Alchemy combines
	[8827] = "62410|A999/415/422/430|44958:3 18256", -- Elixir of Water Walking
	[33447] = "53836|A405/410/417/425|36901 36906:2 18256", -- Runic Healing Potion
	[33448] = "53837|A410/415/422/430|36905:2 36901 18256", -- Runic Mana Potion
	[25] = "53776|A385/405/415/425|35623|||35622",	-- Transmute: Eternal Air to Water
	[26] = "53774|A385/405/415/425|36860|||35622",	-- Transmute: Eternal Fire to Water
	[27] = "53781|A385/405/415/425|35624|||35623",	-- Transmute: Eternal Earth to Air
	[28] = "53783|A385/405/415/425|35622|||35623",	-- Transmute: Eternal Water to Air
	[23] = "53777|A385/405/415/425|35623|||35624",	-- Transmute: Eternal Air to Earth
	[24] = "53779|A385/405/415/425|35627|||35624",	-- Transmute: Eternal Shadow to Earth
	[31] = "53775|A385/405/415/425|36860|||35625",	-- Transmute: Eternal Fire to Life
	[32] = "53780|A385/405/415/425|35627|||35625",	-- Transmute: Eternal Shadow to Life
	[29] = "53782|A385/405/415/425|35624|||35627",	-- Transmute: Eternal Earth to Shadow
	[30] = "53771|A385/405/415/425|35625|||35627",	-- Transmute: Eternal Life to Shadow
	[33] = "53773|A385/405/415/425|35625|||36860",	-- Transmute: Eternal Life to Fire
	[34] = "53784|A385/405/415/425|35622|||36860",	-- Transmute: Eternal Water to Fire
	[39666] = "53840|A395/400/407/415|36901:2 36903:2 18256", -- Elixir of Mighty Agility
	[39671] = "53838|A350/360/370/380|36901:2 18256", -- Resurgent Healing Potion
	[40067] = "53839|A360/365/375/385|36907:2 18256", -- Icy Mana Potion
	[40068] = "53841|A355/365/375/385|36901 37921:2 18256", -- Wrath Elixir
	[40070] = "53842|A365/375/382/390|36901 36904 18256", -- Spellpower Elixir
	[40072] = "53847|A385/390/395/400|36907:3 18256", -- Elixir of Spirit
	[40073] = "54218|A385/390/395/400|36904:2 18256", -- Elixir of Mighty Strength
	[40076] = "53848|A375/380/385/390|40195:3 18256", -- Guru's Elixir
	[40077] = "53895|A400/415/422/430|36901:2 18256", -- Crazy Alchemist's Potion
	[40078] = "53898|A390/395/400/405|36901:4 18256", -- Elixir of Mighty Fortitude
	[40079] = "53899|A375/380/385/390|37921:4 36901 18256", -- Lesser Flask of Toughness
	[40081] = "53900|A380/385/390/395|36901 36907:2 18256", -- Potion of Nightmares
	[40082] = "53901|A435/450/457/465|36906:5 36905:5 36908 40411", -- Flask of the Frost Wyrm
	[40083] = "53902|A435/450/457/465|36905:7 37704:3 36908 40411", -- Flask of Stoneblood
	[40084] = "53903|A435/450/457/465|36905:7 39970:3 36908 40411", -- Flask of Endless Rage
	[40087] = "53904|A400/415/422/430|36907:2 36905:2 18256", -- Powerful Rejuvenation Potion
	[40093] = "53905|A395/415/422/430|36906:2 18256", -- Indestructible Potion
	[40097] = "54220|A400/415/422/430|36906:2 37701 18256", -- Elixir of Protection
	[40109] = "56519|A400/415/422/430|36901 36905:2 18256", -- Elixir of Mighty Mageblood
	[40195] = "53812|A375/380/385/390|40199", -- Pygmy Oil
	[40211] = "54221|A400/415/422/430|36903:2 40195 18256", -- Potion of Speed
	[40212] = "54222|A400/415/422/430|36905:2 40195 18256", -- Potion of Wild Magic
	[40213] = "53936|A400/410/415/420|37701:2 18256|44564", -- Mighty Arcane Protection Potion
	[40214] = "53939|A400/410/415/420|37705:2 18256|44565", -- Mighty Fire Protection Potion
	[40215] = "53937|A400/410/415/420|37702:2 18256|44566", -- Mighty Frost Protection Potion
	[40216] = "53942|A400/410/415/420|37703:2 18256|44567", -- Mighty Nature Protection Potion
	[40217] = "53938|A400/410/415/420|37704:2 18256|44568", -- Mighty Shadow Protection Potion
	[40248] = "54020|A430/445/452/460|35623 35624 36860 35622", -- Transmute: Eternal Might
	[40404] = "54213|A435/450/457/465|36906:7 40195:3 36908 40411", -- Flask of Pure Mojo
	[35] = "60350|A395/420/430/440|36913:8|||41163", -- Transmute: Titanium
	[41266] = "57425|A430/440/445/450|36917 36923 35623", -- Transmute: Skyflare Diamond
	[41334] = "57427|A425/435/440/445|36932 36929 36860", -- Transmute: Earthsiege Diamond
	[43569] = "58871|A410/410/412/415|33447:10 40411", -- Endless Healing Potion
	[43570] = "58868|A410/415/417/420|33448:10 40411", -- Endless Mana Potion
	[44322] = "60396|A400/420/425/430|36901:20 35625:2 36908", -- Mercurial Alchemist Stone
	[44323] = "60403|A400/420/425/430|37921:20 40195:12 36908", -- Indestructible Alchemist Stone
	[44324] = "60405|A400/420/425/430|36903:15 36904:15 36908", -- Mighty Alchemist Stone
	[44325] = "60354|A400/415/422/430|36904:2 36907 18256", -- Elixir of Accuracy
	[44327] = "60355|A400/415/422/430|36901 36903:2 18256", -- Elixir of Deadly Strikes
	[44328] = "60356|A400/415/422/430|36906:2 37704 18256", -- Elixir of Mighty Defense
	[44329] = "60357|A400/415/422/430|36901 36903:2 18256", -- Elixir of Expertise
	[44330] = "60365|A400/415/422/430|36904:2 18256", -- Elixir of Armor Piercing
	[44331] = "60366|A400/415/422/430|37921 37704 18256", -- Elixir of Lightning Speed
	[44332] = "60367|A395/400/407/415|37921:2 36907 18256", -- Elixir of Mighty Thoughts
	[44508] = "60893|A400/415/422/430|36901:10 36903:10 36907:4 40411:4||0", -- Northrend Alchemy Research
	[44939] = "62213|A999/390/395/400|39970:4 18256||", -- Lesser Flask of Resistance
	[44958] = "62409|A999/380/385/390|41814:2||", -- Ethereal Oil
	-- WotLK Blacksmithing combines
	[12625] = "16660|B290/310/320/330|12359:20 12360:4 12364:2 7080:2", -- Dawnbringer Shoulders
	[23526] = "29648|B370/380/390/400|23448:6 22449:2 22831:4 22451:4", -- Swiftsteel Gloves
	[39083] = "52572|B360/370/375/380|36916:4", -- Cobalt Shoulders
	[39084] = "52571|B370/375/380/385|36916:5", -- Cobalt Helm
	[39085] = "52570|B375/380/385/390|36916:6", -- Cobalt Chestpiece
	[39086] = "52567|B370/375/380/385|36916:5", -- Cobalt Legplates
	[39087] = "52568|B350/360/370/380|36916:4", -- Cobalt Belt
	[39088] = "52569|B350/360/370/380|36916:4", -- Cobalt Boots
	[40668] = "54550|B360/370/375/380|36916:4", -- Cobalt Triangle Shield
	[40669] = "54551|B395/400/405/410|36916:6 36913:5", -- Tempered Saronite Belt
	[40670] = "54557|B390/395/400/405|36916:6 36913:4", -- Saronite Defender
	[40671] = "54552|B400/405/410/415|36916:3 36913:8", -- Tempered Saronite Boots
	[40672] = "54553|B400/405/410/415|36916:6 36913:5 37701", -- Tempered Saronite Breastplate
	[40673] = "54555|B405/410/415/420|36913:12 37701", -- Tempered Saronite Helm
	[40674] = "54554|B395/400/405/410|36916:5 36913:5 37701", -- Tempered Saronite Legplates
	[40675] = "54556|B405/410/415/420|36913:12", -- Tempered Saronite Shoulders
	[40942] = "54917|B375/380/385/390|36916:7", -- Spiked Cobalt Helm
	[40943] = "54947|B395/400/405/410|36916:12", -- Spiked Cobalt Legplates
	[40949] = "54918|B380/385/390/395|36916:7", -- Spiked Cobalt Boots
	[40950] = "54941|B385/390/395/400|36916:7", -- Spiked Cobalt Shoulders
	[40951] = "54944|B385/390/395/400|36916:8", -- Spiked Cobalt Chestpiece
	[40952] = "54945|B390/395/400/405|36916:12", -- Spiked Cobalt Gauntlets
	[40953] = "54946|B395/400/405/410|36916:12", -- Spiked Cobalt Belt
	[40954] = "54948|B400/405/410/415|36916:12", -- Spiked Cobalt Bracers
	[40955] = "54949|B400/405/410/415|36916:8", -- Horned Cobalt Helm
	[40956] = "54978|B375/395/400/405|36916:8 37705:2|41124", -- Reinforced Cobalt Shoulders
	[40957] = "54979|B375/405/410/415|36916:8 37705:2|41123", -- Reinforced Cobalt Helm
	[40958] = "54980|B375/410/415/420|36916:8 37705:2|41120", -- Reinforced Cobalt Legplates
	[40959] = "54981|B375/415/420/425|36916:8 37705:2|41122", -- Reinforced Cobalt Chestpiece
	[41113] = "55014|B410/415/420/425|36913:14", -- Saronite Bulwark
	[41114] = "55015|B415/420/425/430|36913:14", -- Tempered Saronite Gauntlets
	[41116] = "55017|B410/415/420/425|36913:13", -- Tempered Saronite Bracers
	[41117] = "55013|B390/395/400/405|36916:6 36913:4", -- Saronite Protector
	[41126] = "55055|B395/400/405/410|36916:5 36913:5 37705", -- Brilliant Saronite Legplates
	[41127] = "55056|B400/405/410/415|36916:3 36913:8", -- Brilliant Saronite Gauntlets
	[41128] = "55057|B405/410/415/420|36913:12", -- Brilliant Saronite Boots
	[41129] = "55058|B415/420/425/430|36913:14 37705", -- Brilliant Saronite Breastplate
	[41181] = "55174|B390/395/400/405|36916:12 36913:4 37702:2", -- Honed Cobalt Cleaver
	[41182] = "55177|B395/400/405/410|36916:8 36913:6 37702:2", -- Savage Cobalt Slicer
	[41183] = "55179|B400/405/410/415|36916:12 36913:4 37703", -- Saronite Ambusher
	[41184] = "55181|B405/410/415/420|36913:12 37703:2", -- Saronite Shiv
	[41185] = "55182|B410/415/420/425|36913:15 37701:2", -- Furious Saronite Beatstick
	[41186] = "55183|B415/420/425/430|36913:16 37702", -- Corroded Saronite Edge
	[41187] = "55184|B415/420/425/430|36913:14 37702", -- Corroded Saronite Woundbringer
	[41188] = "55185|B415/420/425/430|36913:20 37702:2", -- Saronite Mindcrusher
	[41189] = "55186|B415/420/425/430|36913:14 37701:2", -- Chestplate of Conquest
	[41190] = "55187|B415/420/425/430|36913:3 37701:2", -- Legplates of Conquest
	[41239] = "55200|B380/385/390/395|36916:8", -- Sturdy Cobalt Quickblade
	[41240] = "55201|B380/385/390/395|36916:8", -- Cobalt Tenderizer
	[41241] = "55202|B385/390/395/400|36916:7", -- Sure-fire Shuriken
	[41242] = "55203|B385/390/395/400|36916:10", -- Forged Cobalt Claymore
	[41243] = "55204|B390/395/400/405|36916:10", -- Notched Cobalt War Axe
	[41245] = "55206|B405/415/420/425|36913:7 37700:2", -- Deadly Saronite Dirk
	[41257] = "55369|B440/450/460/470|36913:8 37663:8 43102:2", -- Titansteel Destroyer
	[41344] = "55302|B425/435/445/455|36913:14 36860", -- Helm of Command
	[41345] = "55303|B425/435/445/455|36913:14 35624", -- Daunting Legplates
	[41346] = "55304|B425/435/445/455|36913:14 35622", -- Righteous Greaves
	[41347] = "55310|B425/435/445/455|36913:14 35623", -- Savage Saronite Legplates
	[41348] = "55308|B420/430/440/450|36913:12 35627", -- Savage Saronite Walkers
	[41349] = "55309|B420/430/440/450|36913:12 36860", -- Savage Saronite Gauntlets
	[41350] = "55312|B425/435/445/455|36913:14 35627", -- Savage Saronite Skullshield
	[41351] = "55306|B420/430/440/450|36913:12 35622", -- Savage Saronite Pauldrons
	[41352] = "55307|B420/430/440/450|36913:12 35622", -- Savage Saronite Waistguard
	[41353] = "55311|B425/435/445/455|36913:14 35624", -- Savage Saronite Hauberk
	[41354] = "55305|B420/425/430/435|36913:12 35623", -- Savage Saronite Bracers
	[41355] = "55298|B420/425/430/435|36913:12 36860", -- Vengeance Bindings
	[41356] = "55300|B420/430/440/450|36913:12 35622", -- Righteous Gauntlets
	[41357] = "55301|B420/430/440/450|36913:12 35624", -- Daunting Handguards
	[41383] = "55370|B440/450/460/470|36913:6 37663:6 43102:2", -- Titansteel Bonecrusher
	[41384] = "55371|B440/450/460/470|36913:6 37663:6 43102:2", -- Titansteel Guardian
	[41386] = "55372|B440/450/460/470|36913:4 37663:4 43102", -- Spiked Titansteel Helm
	[41387] = "55373|B440/450/460/470|36913:4 37663:4 43102", -- Tempered Titansteel Helm
	[41388] = "55374|B440/450/460/470|36913:4 37663:4 43102", -- Brilliant Titansteel Helm
	[41391] = "55375|B440/450/460/470|36913:4 37663:3 43102", -- Spiked Titansteel Treads
	[41392] = "55376|B440/450/460/470|36913:4 37663:3 43102", -- Tempered Titansteel Treads
	[41394] = "55377|B440/450/460/470|36913:4 37663:3 43102", -- Brilliant Titansteel Treads
	[41611] = "55656|B415/420/425/430|36913:4 35624 35622 35627", -- Eternal Belt Buckle
	[41745] = "55732|B420/425/430/435|36913:2 41163", -- Titanium Rod
	[41974] = "55834|B360/370/375/380|36916:4", -- Cobalt Bracers
	[41975] = "55835|B370/380/385/390|36916:5", -- Cobalt Gauntlets
	[41976] = "55839|B420/425/430/435|36913:2 41163", -- Titanium Weapon Chain
	[42435] = "56234|B440/450/460/470|36913:6 37663:6 43102:2", -- Titansteel Shanker
	[42443] = "56280|B410/415/420/425|36913:15 37705:2", -- Cudgel of Saronite Justice
	[42500] = "56357|B420/425/430/435|36913:2 41163", -- Titanium Shield Spike
	[42508] = "56400|B440/450/460/470|36913:4 37663:3 43102", -- Titansteel Shield Wall
	[42723] = "56549|B420/425/430/435|36913:12 35623", -- Ornate Saronite Bracers
	[42724] = "56553|B420/430/440/450|36913:12 36860", -- Ornate Saronite Gauntlets
	[42725] = "56555|B425/435/445/455|36913:14 35624", -- Ornate Saronite Hauberk
	[42726] = "56554|B425/435/445/455|36913:14 35623", -- Ornate Saronite Legplates
	[42727] = "56550|B420/430/440/450|36913:12 35622", -- Ornate Saronite Pauldrons
	[42728] = "56556|B425/435/445/455|36913:14 35627", -- Ornate Saronite Skullshield
	[42729] = "56551|B420/430/440/450|36913:12 35622", -- Ornate Saronite Waistguard
	[42730] = "56552|B420/430/440/450|36913:12 35627", -- Ornate Saronite Walkers
	[43586] = "61008|B425/435/445/455|36913:16 36860:3 35622:3 43102", -- Icebane Chestguard
	[43587] = "61009|B420/430/440/450|36913:12 36860:2 35622:2 43102", -- Icebane Girdle
	[43588] = "61010|B420/430/440/450|36913:12 36860:2 35622:2 43102", -- Icebane Treads
	[43853] = "59406|B430/435/440/445|36913:4 41163||20", -- Titanium Skeleton Key
	[43854] = "59405|B350/360/365/370|36916:4||10", -- Cobalt Skeleton Key
	[43860] = "59436|B395/400/405/410|36916:6 36913:5", -- Brilliant Saronite Belt
	[43864] = "59438|B400/405/410/415|36916:3 36913:8", -- Brilliant Saronite Bracers
	[43865] = "59440|B405/410/415/420|36913:12", -- Brilliant Saronite Pauldrons
	[43870] = "59441|B415/420/425/430|36913:14 37705", -- Brilliant Saronite Helm
	[43871] = "59442|B410/415/420/425|36913:15 37702:2", -- Saronite Spellblade
	[44936] = "62202|B450/455/460/465|41163:4 35627:4|44937", -- Titanium Plating
	[-55641] = "B400/400/400/405|36913:4 35627", -- Socket Gloves
	[-55628] = "B400/400/400/405|36913:4 35624", -- Socket Bracer
	-- WotLK Engineering combines
	[23769] = "30342|E315/335/345/355|23781 21877 2604||3", -- Red Smoke Flare
	[23775] = "30349|E405/425/432/440|36913:8 41163:8 39681:4|23817", -- Titanium Toolbox
	[23820] = "30549|E305/325/335/345|23784 23783:2 10558", -- Critter Enlarger
	[23831] = "30561|E295/325/330/335|23782 23783:4 10558", -- Goblin Tonk Controller
	[23832] = "30573|E295/325/330/335|23782 23783:4 10558", -- Gnomish Tonk Controller
	[34061] = "44157|E375/385/390/395|23784:4 23786:8 23787:8 34249", -- Turbo-Charged Flying Machine
	[37567] = "56476|E410/415/420/425|36913:12 39681:2||5", -- Healing Injector Kit
	[39681] = "56349|E350/360/370/380|36916:2", -- Handful of Cobalt Bolts
	[39682] = "56464|E375/380/385/390|36916:4 37701", -- Overcharged Capacitor
	[39683] = "56471|E390/395/400/405|36916:8 37705", -- Froststeel Tube
	[39688] = "54353|E400/405/410/415|36913:10 39683:2 39684 40533", -- Mark "S" Boomstick
	[39690] = "53281|E350/366/375/385|36916:3 37705||2", -- Volatile Blasting Trigger
	[40536] = "56463|E375/385/390/395|33470 39690:3", -- Explosive Decoy
	[40767] = "56466|E420/435/440/445|39683:2 39682:4 39681:2", -- Sonic Booster
	[40768] = "56472|E425/430/432/435|36913:8 35623:8", -- MOLL-E
	[40769] = "55252|E410/415/417/420|36913:10||5", -- Scrapbot Construction Kit
	[40771] = "56460|E350/375/382/390|39681:2 39690", -- Cobalt Frag Bomb
	[40772] = "56462|E435/440/445/450|36913:10 7005 2901 5956", -- Gnomish Army Knife
	[40865] = "56467|E420/435/440/445|39683:2 39682:2 39681:8", -- Noise Machine
	[40892] = "56459|E375/380/385/390|36916:5", -- Hammer Pick
	[40893] = "56461|E375/380/385/390|36916:5", -- Bladed Pickaxe
	[40895] = "56473|Eg425/430/435/440|41163:6 34052:2 39681:2", -- Gnomish X-Ray Specs
	[41112] = "56465|E420/425/432/440|36913:8 33568:2 35627", -- Mechanized Snow Goggles
	[41119] = "56468|E405|36913:5 39690||2", -- Saronite Bomb
	[41121] = "56469|E425/430/435/440|41163:2 36913:8 35622:2 35623:2", -- Gnomish Lightning Generator
	[41146] = "56470|E425/430/432/435|39683 36920 36921", -- Sun Scope
	[41167] = "56478|E430/435/445/455|36913:10 36927:2", -- Heartseeker Scope
	[41168] = "56479|E450/455/460/465|41163:10 36913:20 35623:15 35622:15 43102 40533", -- Armor Plated Combat Shotgun
	[41508] = "60866|E450/480/485/490|37663:12 39681:40 44128:2 44499 44501:8 44500|44502", -- Mechano-hog
	[42546] = "56477|E415/420/425/430|36913:12 37705:2||5", -- Mana Injector Kit
	[42549] = "56480|E440/450/455/460|41163:8 38425:4 36924:2 35624:4 43102", -- Armored Titanium Goggles
	[42550] = "56481|E440/450/455/460|41163:8 38425:4 36918:2 35623:4 43102", -- Weakness Spectralizers
	[42551] = "56574|E440/450/455/460|41163:8 38425:4 36927:2 35622:4 43102", -- Truesight Ice Blinders
	[42552] = "56483|E440/450/455/460|41163:8 38425:4 36930:2 36860:4 43102", -- Charged Titanium Specs
	[42553] = "56484|E440/450/455/460|41163:8 38425:4 36918:2 35627:4 43102", -- Visage Liquification Goggles
	[42554] = "56486|E440/450/455/460|41163:8 38425:4 36933:2 35625:4 43102", -- Greensight Gogs
	[42555] = "56487|E440/450/455/460|41163:8 38425:4 36921:2 35623:4 43102", -- Electroflux Sight Enhancers
	[42641] = "56514|En425/425/430/435|36913 39690", -- Global Thermal Sapper Charge
	[44413] = "60867|E450/480/485/490|37663:12 39681:40 44128:2 44499 44501:8 44500|44503", -- Mekgineer's Chopper
	[44504] = "60874|E450/455/460/465|41163:10 43102 36860:12 35627:12 41146:3 40533", -- Nesingwary 4000
	[44506] = "56475|E415/420/422/425|36913:15", -- Saronite Arrow Maker
	[44507] = "56474|E410/415/417/420|36913:6 39690:4", -- Ultrasafe Bullet Machine
	[44739] = "61471|E390/400/407/415|39683 39681:2", -- Diamond-cut Refractor Scope
	[44740] = "61481|E410/425/432/440|36913:8 33568:2 35627", -- Mechanized Snow Goggles
	[44741] = "61482|E410/425/432/440|36913:8 33568:2 35627", -- Mechanized Snow Goggles
	[44742] = "61483|E420/425/432/440|36913:8 33568:2 35627", -- Mechanized Snow Goggles
	[44949] = "62271|E440/450/455/460|41163:8 38425:4 36933:2 35624:4 43102", -- Unbreakable Healing Amplifiers
	[44951] = "56468|E405/410/415/420|36913:5 39690", -- Box of Bombs
	[-55016] = "E405/405/405/410|39690:6 39681:6", -- Nitro Boosts
	[-55002] = "E380/380/382/385|33470:12 39682", -- Flexweave Underlay
	[-54999] = "E400/400/402/405|36913:6 37700:4", -- Hyperspeed Accelerators
	[-54998] = "E400/400/402/405|36913:6 37702:4", -- Hand-Mounted Pyro Rocket
	[-54793] = "E380/380/382/385|36916:4 36920:2", -- Belt-Clipped Spynoculars
	[-54736] = "E390/390/392/395|39682:4", -- Personal Electromagnetic Pulse Generator
	-- WotLK Jewelcrafting combines
	[21780] = "26920|J315/335/345/355|12359:8 11382:2 7910:4 12938:2", -- Blood Crown
	[21793] = "26918|J305/325/335/345|12360:4 7076:4 7082:4", -- Arcanite Sword Pendant
	[35945] = "47280|J350/350/365/380|23117:3 23077:3 23079:3 21929:3 23112:3 23107:3", -- Brilliant Glass
	[36766] = "56054|J370/390/415/440|42225|42299", -- Bright Dragon's Eye
	[36767] = "56086|J370/390/415/440|42225|42311", -- Solid Dragon's Eye
	[37503] = "48789|J375/375/380/385|32230|37504", -- Purified Shadowsong Amethyst
	[39900] = "53831|J350/375/395/415|36917", -- Bold Bloodstone
	[39905] = "53832|J350/375/395/415|36917", -- Delicate Bloodstone
	[39906] = "53835|J350/375/395/415|36917", -- Bright Bloodstone
	[39907] = "53843|J360/375/395/415|36917", -- Subtle Bloodstone
	[39908] = "53844|J350/375/395/415|36917", -- Flashing Bloodstone
	[39909] = "53845|J350/375/395/415|36917", -- Fractured Bloodstone
	[39910] = "54017|J350/375/395/415|36917", -- Precise Bloodstone
	[39911] = "53834|J350/375/395/415|36917", -- Runed Bloodstone
	[39912] = "53852|J350/375/395/415|36920", -- Brilliant Sun Crystal
	[39914] = "53853|J350/375/395/415|36920", -- Smooth Sun Crystal
	[39915] = "53854|J350/375/395/415|36920", -- Rigid Sun Crystal
	[39916] = "53855|J350/375/395/415|36920", -- Thick Sun Crystal
	[39917] = "53857|J350/375/395/415|36920|41559", -- Mystic Sun Crystal
	[39918] = "53856|J350/375/395/415|36920", -- Quick Sun Crystal
	[39919] = "53934|J350/375/395/415|36923", -- Solid Chalcedony
	[39920] = "53940|J350/375/395/415|36923", -- Sparkling Chalcedony
	[39927] = "53941|J350/375/395/415|36923", -- Lustrous Chalcedony
	[39932] = "53943|J350/375/395/415|36923|41560", -- Stormy Chalcedony
	[39933] = "53870|J350/375/395/415|36926", -- Puissant Shadow Crystal
	[39934] = "53859|J350/375/395/415|36926", -- Sovereign Shadow Crystal
	[39935] = "53860|J350/375/395/415|36926", -- Shifting Shadow Crystal
	[39936] = "53862|J350/375/395/415|36926", -- Glowing Shadow Crystal
	[39937] = "53866|J350/375/395/415|36926", -- Balanced Shadow Crystal
	[39938] = "53868|J360/375/395/415|36926", -- Regal Shadow Crystal
	[39939] = "53869|J350/375/395/415|36926|41574", -- Defender's Shadow Crystal
	[39940] = "53871|J350/375/395/415|36926", -- Guardian's Shadow Crystal
	[39941] = "53863|J350/375/395/415|36926", -- Purified Shadow Crystal
	[39942] = "53861|J350/375/395/415|36926", -- Tenuous Shadow Crystal
	[39943] = "53864|J350/375/395/415|36926", -- Royal Shadow Crystal
	[39944] = "53867|J350/375/395/415|36926", -- Infused Shadow Crystal
	[39945] = "53865|J350/375/395/415|36926|41575", -- Mysterious Shadow Crystal
	[39946] = "53881|J350/375/395/415|36929", -- Luminous Huge Citrine
	[39947] = "53872|J350/375/395/415|36929", -- Inscribed Huge Citrine
	[39948] = "53873|J350/375/395/415|36929", -- Etched Huge Citrine
	[39949] = "53874|J350/375/395/415|36929", -- Champion's Huge Citrine
	[39950] = "53875|J350/375/395/415|36929|41566", -- Resplendent Huge Citrine
	[39951] = "53876|J350/375/395/415|36929", -- Fierce Huge Citrine
	[39952] = "53877|J350/375/395/415|36929|41562", -- Deadly Huge Citrine
	[39953] = "53878|J350/375/395/415|36929", -- Glinting Huge Citrine
	[39954] = "53879|J350/375/395/415|36929|41565", -- Lucent Huge Citrine
	[39955] = "53880|J350/375/395/415|36929", -- Deft Huge Citrine
	[39956] = "53882|J350/375/395/415|36929", -- Potent Huge Citrine
	[39957] = "53883|J350/375/395/415|36929", -- Veiled Huge Citrine
	[39958] = "53884|J350/375/395/415|36929|41563", -- Durable Huge Citrine
	[39959] = "53885|J350/375/395/415|36929|41561", -- Reckless Huge Citrine
	[39960] = "53886|J350/375/395/415|36929", -- Wicked Huge Citrine
	[39961] = "53887|J350/375/395/415|36929", -- Pristine Huge Citrine
	[39962] = "53888|J350/375/395/415|36929|41564", -- Empowered Huge Citrine
	[39963] = "53889|J350/375/395/415|36929", -- Stark Huge Citrine
	[39964] = "53890|J350/375/395/415|36929", -- Stalwart Huge Citrine
	[39965] = "53891|J360/375/395/415|36929", -- Glimmering Huge Citrine
	[39966] = "53892|J350/375/395/415|36929", -- Accurate Huge Citrine
	[39967] = "53893|J350/375/395/415|36929", -- Resolute Huge Citrine
	[39968] = "53894|J350/375/395/415|36932", -- Timeless Dark Jade
	[39974] = "53916|J350/375/395/415|36932", -- Jagged Dark Jade
	[39975] = "53917|J350/375/395/415|36932|41567", -- Vivid Dark Jade
	[39976] = "53918|J350/375/395/415|36932", -- Enduring Dark Jade
	[39977] = "53919|J350/375/395/415|36932|41572", -- Steady Dark Jade
	[39978] = "53920|J350/375/395/415|36932", -- Forceful Dark Jade
	[39979] = "53921|J350/375/395/415|36932|41568", -- Seer's Dark Jade
	[39980] = "53922|J350/375/395/415|36932", -- Misty Dark Jade
	[39981] = "53923|J350/375/395/415|36932", -- Shining Dark Jade
	[39982] = "53924|J350/375/395/415|36932|41571", -- Turbid Dark Jade
	[39983] = "53925|J350/375/395/415|36932", -- Intricate Dark Jade
	[39984] = "53926|J350/375/395/415|36932", -- Dazzling Dark Jade
	[39985] = "53927|J350/375/395/415|36932", -- Sundered Dark Jade
	[39986] = "53928|J350/375/395/415|36932", -- Lambent Dark Jade
	[39988] = "53929|J350/375/395/415|36932|41573", -- Opaque Dark Jade
	[39989] = "53930|J350/375/395/415|36932", -- Energized Dark Jade
	[39990] = "53931|J350/375/395/415|36932", -- Radiant Dark Jade
	[39991] = "53932|J350/375/395/415|36932|41570", -- Tense Dark Jade
	[39992] = "53933|J350/375/395/415|36932|41569", -- Shattered Dark Jade
	[39996] = "53830|J390/410/425/440|36918|41576", -- Bold Scarlet Ruby
	[39997] = "53945|J390/410/425/440|36918|41577", -- Delicate Scarlet Ruby
	[39998] = "53946|J390/410/425/440|36918|41718", -- Runed Scarlet Ruby
	[39999] = "53947|J390/410/425/440|36918", -- Bright Scarlet Ruby
	[40000] = "53948|J380/410/425/440|36918", -- Subtle Scarlet Ruby
	[40001] = "53949|J390/410/425/440|36918|41578", -- Flashing Scarlet Ruby
	[40002] = "53950|J390/410/425/440|36918|41817", -- Fractured Scarlet Ruby
	[40003] = "53951|J390/410/425/440|36918|41790", -- Precise Scarlet Ruby
	[40008] = "53952|J390/410/425/440|36924|42138", -- Solid Sky Sapphire
	[40009] = "53953|J390/410/425/440|36924", -- Sparkling Sky Sapphire
	[40010] = "53954|J390/410/425/440|36924|41581", -- Lustrous Sky Sapphire
	[40011] = "53955|J390/410/425/440|36924|41728", -- Stormy Sky Sapphire
	[40012] = "53956|J390/410/425/440|36921", -- Brilliant Autumn's Glow
	[40013] = "53957|J390/410/425/440|36921|41720", -- Smooth Autumn's Glow
	[40014] = "53958|J390/410/425/440|36921|41580", -- Rigid Autumn's Glow
	[40015] = "53959|J390/410/425/440|36921|41791", -- Thick Autumn's Glow
	[40016] = "53960|J390/410/425/440|36921|41727", -- Mystic Autumn's Glow
	[40017] = "53961|J390/410/425/440|36921|41579", -- Quick Autumn's Glow
	[40022] = "53962|J390/410/425/440|36927|41784", -- Sovereign Twilight Opal
	[40023] = "53963|J380/410/425/440|36927", -- Shifting Twilight Opal
	[40024] = "53964|J380/410/425/440|36927|41785", -- Tenuous Twilight Opal
	[40025] = "53965|J390/410/425/440|36927|41725", -- Glowing Twilight Opal
	[40026] = "53966|J380/410/425/440|36927|41783", -- Purified Twilight Opal
	[40027] = "53967|J390/410/425/440|36927|41701", -- Royal Twilight Opal
	[40028] = "53968|J390/410/425/440|36927|41740", -- Mysterious Twilight Opal
	[40029] = "53969|J390/410/425/440|36927", -- Balanced Twilight Opal
	[40030] = "53970|J390/410/425/440|36927|41796", -- Infused Twilight Opal
	[40031] = "53971|J390/410/425/440|36927|41703", -- Regal Twilight Opal
	[40032] = "53972|J390/410/425/440|36927|41820", -- Defender's Twilight Opal
	[40033] = "53973|J390/410/425/440|36927|41702", -- Puissant Twilight Opal
	[40034] = "53974|J390/410/425/440|36927|41726", -- Guardian's Twilight Opal
	[40037] = "53975|J390/410/425/440|36930|41789", -- Inscribed Monarch Topaz
	[40038] = "53976|J380/410/425/440|36930|41777", -- Etched Monarch Topaz
	[40039] = "53977|J380/410/425/440|36930|41780", -- Champion's Monarch Topaz
	[40040] = "53978|J390/410/425/440|36930|41734", -- Resplendent Monarch Topaz
	[40041] = "54019|J390/410/425/440|36930|41793", -- Fierce Monarch Topaz
	[40043] = "53979|J390/410/425/440|36930|41794", -- Deadly Monarch Topaz
	[40044] = "53980|J390/410/425/440|36930|41582", -- Glinting Monarch Topaz
	[40045] = "53981|J390/410/425/440|36930|41733", -- Lucent Monarch Topaz
	[40046] = "53982|J390/410/425/440|36930|41792", -- Deft Monarch Topaz
	[40047] = "53983|J390/410/425/440|36930|41689", -- Luminous Monarch Topaz
	[40048] = "53984|J390/410/425/440|36930|41686", -- Potent Monarch Topaz
	[40049] = "53985|J390/410/425/440|36930|41688", -- Veiled Monarch Topaz
	[40050] = "53986|J390/410/425/440|36930|41730", -- Durable Monarch Topaz
	[40051] = "53987|J390/410/425/440|36930|41690", -- Reckless Monarch Topaz
	[40052] = "53988|J390/410/425/440|36930|41721", -- Wicked Monarch Topaz
	[40053] = "53989|J390/410/425/440|36930", -- Pristine Monarch Topaz
	[40054] = "53990|J390/410/425/440|36930|41732", -- Empowered Monarch Topaz
	[40055] = "53991|J390/410/425/440|36930|41687", -- Stark Monarch Topaz
	[40056] = "53992|J390/410/425/440|36930|41779", -- Stalwart Monarch Topaz
	[40057] = "53993|J390/410/425/440|36930|41722", -- Glimmering Monarch Topaz
	[40058] = "53994|J390/410/425/440|36930|41818", -- Accurate Monarch Topaz
	[40059] = "54023|J380/410/425/440|36930|41778", -- Resolute Monarch Topaz
	[40085] = "53995|J390/410/425/440|36933|41795", -- Timeless Forest Emerald
	[40086] = "53996|J390/410/425/440|36933|41723", -- Jagged Forest Emerald
	[40088] = "53997|J390/410/425/440|36933|41698", -- Vivid Forest Emerald
	[40089] = "53998|J390/410/425/440|36933|41697", -- Enduring Forest Emerald
	[40090] = "54000|J390/410/425/440|36933|41738", -- Steady Forest Emerald
	[40091] = "54001|J390/410/425/440|36933|41693", -- Forceful Forest Emerald
	[40092] = "54002|J390/410/425/440|36933|41699", -- Seer's Forest Emerald
	[40094] = "54007|J390/410/425/440|36933", -- Dazzling Forest Emerald
	[40095] = "54003|J380/410/425/440|36933|41781", -- Misty Forest Emerald
	[40096] = "54008|J390/410/425/440|36933|41724", -- Sundered Forest Emerald
	[40098] = "54012|J390/410/425/440|36933|41819", -- Radiant Forest Emerald
	[40099] = "54004|J380/410/425/440|36933|41782", -- Shining Forest Emerald
	[40100] = "54009|J390/410/425/440|36933|41696", -- Lambent Forest Emerald
	[40101] = "54013|J390/410/425/440|36933|41736", -- Tense Forest Emerald
	[40102] = "54005|J390/410/425/440|36933|41737", -- Turbid Forest Emerald
	[40103] = "54010|J390/410/425/440|36933|41739", -- Opaque Forest Emerald
	[40104] = "54006|J390/410/425/440|36933|41694", -- Intricate Forest Emerald
	[40105] = "54011|J390/410/425/440|36933|41692", -- Energized Forest Emerald
	[40106] = "54014|J390/410/425/440|36933|41735", -- Shattered Forest Emerald
	[41285] = "55389|J420/440/450/460|41266|41704", -- Chaotic Skyflare Diamond
	[41307] = "55390|J420/440/450/460|41266|41786", -- Destructive Skyflare Diamond
	[41333] = "55392|J420/440/450/460|41266|41706", -- Ember Skyflare Diamond
	[41335] = "55393|J420/440/450/460|41266|41742", -- Enigmatic Skyflare Diamond
	[41339] = "55394|J420/440/450/460|41266", -- Swift Skyflare Diamond
	[41367] = "56205|J350/360/370/380|36932", -- Dark Jade Focusing Lens
	[41375] = "55386|J420/440/450/460|41266", -- Tireless Skyflare Diamond
	[41376] = "55407|J420/440/450/460|41266|41707", -- Revitalizing Skyflare Diamond
	[41377] = "55384|J420/440/450/460|41266|41705", -- Effulgent Skyflare Diamond
	[41378] = "55387|J420/440/450/460|41266|41743", -- Forlorn Skyflare Diamond
	[41379] = "55388|J420/440/450/460|41266|41744", -- Impassive Skyflare Diamond
	[41380] = "55401|J420/440/450/460|41334|41797", -- Austere Earthsiege Diamond
	[41381] = "55402|J420/440/450/460|41334", -- Persistent Earthsiege Diamond
	[41382] = "55403|J420/440/450/460|41334|41711", -- Trenchant Earthsiege Diamond
	[41385] = "55404|J420/440/450/460|41334|41709", -- Invigorating Earthsiege Diamond
	[41389] = "55405|J420/440/450/460|41334|41788", -- Beaming Earthsiege Diamond
	[41395] = "55397|J420/440/450/460|41334|41798", -- Bracing Earthsiege Diamond
	[41396] = "55398|J420/440/450/460|41334|41799", -- Eternal Earthsiege Diamond
	[41397] = "55399|J420/440/450/460|41334", -- Powerful Earthsiege Diamond
	[41398] = "55400|J420/440/450/460|41334|41710", -- Relentless Earthsiege Diamond
	[41400] = "55395|J420/440/450/460|41266|41787", -- Thundering Skyflare Diamond
	[41401] = "55396|J420/440/450/460|41334|41708", -- Insightful Earthsiege Diamond
	[42142] = "56049|J370/390/415/440|42225|42298", -- Bold Dragon's Eye
	[42143] = "56052|J370/390/415/440|42225|42301", -- Delicate Dragon's Eye
	[42144] = "56053|J370/390/415/440|42225|42309", -- Runed Dragon's Eye
	[42145] = "56087|J370/390/415/440|42225|42312", -- Sparkling Dragon's Eye
	[42146] = "56077|J370/390/415/440|42225|42304", -- Lustrous Dragon's Eye
	[42148] = "56074|J370/390/415/440|42225|42300", -- Brilliant Dragon's Eye
	[42149] = "56085|J370/390/415/440|42225|42310", -- Smooth Dragon's Eye
	[42150] = "56083|J370/390/415/440|42225|42307", -- Quick Dragon's Eye
	[42151] = "56055|J370/390/415/440|42225|42314", -- Subtle Dragon's Eye
	[42152] = "56056|J370/390/415/440|42225|42302", -- Flashing Dragon's Eye
	[42153] = "56076|J370/390/415/440|42225|42303", -- Fractured Dragon's Eye
	[42154] = "56081|J370/390/415/440|42225|42306", -- Precise Dragon's Eye
	[42155] = "56088|J370/390/415/440|42225|42313", -- Stormy Dragon's Eye
	[42156] = "56084|J370/390/415/440|42225|42308", -- Rigid Dragon's Eye
	[42157] = "56089|J370/390/415/440|42225|42315", -- Thick Dragon's Eye
	[42158] = "56079|J370/390/415/440|42225|42305", -- Mystic Dragon's Eye
	[42336] = "56193|J350/380/400/420|37701:2 36917", -- Bloodstone Band
	[42337] = "56194|J350/380/400/420|37701:2 36920", -- Sun Rock Ring
	[42338] = "56195|J380/400/410/420|35624 36929:2 36932:2", -- Jade Dagger Pendant
	[42339] = "56196|J380/400/410/420|35624 36917 36920:2 36923", -- Blood Sun Necklace
	[42340] = "56197|J420/440/450/460|41163 36933 34052", -- Dream Signet
	[42341] = "56199|J400/430/440/450|41163:2 36918:2 36921", -- Ruby Hare
	[42395] = "56201|J400/430/440/450|41163:2 36927:2 36930", -- Twilight Serpent
	[42413] = "56202|J400/430/440/450|41163:2 36924:2 36933", -- Sapphire Owl
	[42418] = "56203|J400/430/440/450|41163:2 36933:2 36918", -- Emerald Boar
	[42420] = "56206|J360/370/380/390|36926", -- Shadow Crystal Focusing Lens
	[42421] = "56208|J370/380/390/400|36926 36932", -- Shadow Jade Focusing Lens
	[42642] = "56496|J430/450/455/460|41163:2 42225:4 36860:4 35627:4 43102|42648", -- Titanium Impact Band
	[42643] = "56497|J430/450/455/460|41163:2 42225:4 35624:4 35625:4 43102|42649", -- Titanium Earthguard Ring
	[42644] = "56498|J430/450/455/460|41163:2 42225:4 35622:4 35623:4 43102|42650", -- Titanium Spellshock Ring
	[42645] = "56499|J440/450/455/460|41163:2 42225:4 35623:6 36860:6 43102|42651", -- Titanium Impact Choker
	[42646] = "56500|J440/450/455/460|41163:2 42225:4 35625:6 35624:6 43102|42652", -- Titanium Earthguard Chain
	[42647] = "56501|J440/450/455/460|41163:2 42225:4 35627:6 35622:6 43102|42653", -- Titanium Spellshock Necklace
	[42701] = "56530|J360/380/400/420|36783 34054||0", -- Enchanted Pearl
	[42702] = "56531|J390/410/425/440|36784 34054:4||0", -- Enchanted Tear
	[43244] = "58141|J350/380/400/420|37701:2 36929", -- Crystal Citrine Necklace
	[43245] = "58142|J350/380/400/420|37701:2 36923", -- Crystal Chalcedony Amulet
	[43246] = "58143|J370/390/405/420|35624 36926:2", -- Earthshadow Ring
	[43247] = "58144|J370/390/405/420|35624 36932:2", -- Jade Ring of Slaying
	[43248] = "58145|J390/410/420/430|35624:2", -- Stoneguard Band
	[43249] = "58146|J390/410/420/430|35624 35627", -- Shadowmight Ring
	[43250] = "58147|J420/440/450/460|41163:2 35624:2|43317", -- Ring of Earthen Might
	[43251] = "58148|J420/440/450/460|41163:2 35627:3 36918|43318", -- Ring of Scarlet Shadows
	[43252] = "58149|J420/440/450/460|41163:2 35623 36860:2|43319", -- Windfire Band
	[43253] = "58150|J420/440/450/460|41163:2 35622 36783:4|43320", -- Ring of Northern Tears
	[43482] = "58492|J420/440/450/460|41163:4 36860:4|43485", -- Savage Titanium Ring
	[43498] = "58507|J420/440/450/460|41163:4 36860:4|43497", -- Savage Titanium Band
	[43582] = "58954|J420/440/450/460|41163:2 35622:3 36860:3 43102|43597", -- Titanium Frostguard Ring
	[44063] = "59759|J400/430/440/450|41163:2 36930:2 36933", -- Monarch Crab
	[44943] = "62242|J9999/445/457/470|43102 36923:3 36926:3 36932:3", -- Icy Prism
	-- WotLK Leatherworking combines
	[38347] = "50971|L415/420/422/425|38425:8|44510", -- Mammoth Mining Bag
	[38371] = "50964|L405/410/415/420|38425:5 38561", -- Jormungar Leg Armor
	[38372] = "50966|L400/405/410/415|38425:4 38558", -- Nerubian Leg Armor
	[38373] = "50965|L425/435/440/445|44128:2 38558:2 43102", -- Frosthide Leg Armor
	[38374] = "50967|L425/435/440/445|44128:2 38557:2 43102", -- Icescale Leg Armor
	[38375] = "50962|L350/375/380/385|33568:4", -- Borean Armor Kit
	[38376] = "50963|L395/400/402/405|38425:4", -- Heavy Borean Armor Kit
	[38399] = "50970|L415/420/422/425|38425:8|44509", -- Trapper's Traveling Pack
	[38400] = "50944|L370/385/395/405|33568:12", -- Arctic Chestpiece
	[38401] = "50945|L375/390/400/410|33568:12", -- Arctic Leggings
	[38402] = "50946|L380/395/405/415|33568:10", -- Arctic Shoulderpads
	[38403] = "50947|L375/390/400/410|33568:10", -- Arctic Gloves
	[38404] = "50948|L370/385/395/405|33568:8", -- Arctic Boots
	[38405] = "50949|L380/395/405/415|33568:10", -- Arctic Belt
	[38406] = "50943|L380/380/387/395|33568:10", -- Iceborne Belt
	[38407] = "50942|L375/390/400/410|33568:10", -- Iceborne Boots
	[38408] = "50938|L375/390/400/410|33568:12", -- Iceborne Chestguard
	[38409] = "50941|L370/385/395/405|33568:8", -- Iceborne Gloves
	[38410] = "50939|L370/385/395/405|33568:12", -- Iceborne Leggings
	[38411] = "50940|L380/395/405/415|33568:10", -- Iceborne Shoulderpads
	[38412] = "50955|L370/385/395/405|33568:8", -- Frostscale Belt
	[38413] = "50954|L380/395/405/415|33568:10", -- Frostscale Boots
	[38414] = "50950|L375/390/400/410|33568:12", -- Frostscale Chestguard
	[38415] = "50953|L380/395/405/415|33568:10", -- Frostscale Gloves
	[38416] = "50951|L370/385/395/405|33568:12", -- Frostscale Leggings
	[38417] = "50958|L380/395/405/415|33568:10", -- Nerubian Shoulders
	[38418] = "50961|L375/390/400/410|33568:10", -- Nerubian Belt
	[38419] = "50960|L380/395/405/415|33568:10", -- Nerubian Boots
	[38420] = "50956|L375/390/400/410|33568:12", -- Nerubian Chestguard
	[38421] = "50959|L370/385/395/405|33568:12", -- Nerubian Gloves
	[38422] = "50957|L370/385/395/405|33568:8", -- Nerubian Legguards
	[38424] = "50952|L375/390/400/410|33568:10", -- Frostscale Shoulders
	[38425] = "50936|L390/390/395/405|33568:6", -- Heavy Borean Leather
	[38433] = "51571|L385/400/410/420|33568:12", -- Arctic Wristguards
	[38434] = "60607|L385/400/410/420|33568:12", -- Iceborne Wristguards
	[38435] = "60622|L385/400/410/420|33568:12", -- Nerubian Bracers
	[38436] = "60599|L385/400/410/420|33568:12", -- Frostscale Bracers
	[38437] = "51572|L385/400/410/420|33568:14", -- Arctic Helm
	[38438] = "60608|L385/400/410/420|33568:14", -- Iceborne Helm
	[38439] = "60624|L385/400/410/420|33568:14", -- Nerubian Helm
	[38440] = "60600|L385/400/410/420|33568:14", -- Frostscale Helm
	[38441] = "60631|L380/390/400/410|33568:16 37700:4", -- Cloak of Harsh Winds
	[38590] = "51568|L400/415/425/435|38558:25 37705:6", -- Black Chitinguard Boots
	[38591] = "51569|L395/410/420/430|38425:6 37703:4", -- Dark Arctic Leggings
	[38592] = "51570|L395/410/420/430|38425:5 37703:5", -- Dark Arctic Chestpiece
	[41238] = "55199|L395/405/415/425|38425:6 37700:5 37705:5", -- Cloak of Tormented Skies
	[42731] = "60660|L425/430/435/440|38425:12 35623:2", -- Leggings of Visceral Strikes
	[43129] = "60649|L425/430/435/440|38425:15 35623", -- Razorstrike Breastplate
	[43130] = "60651|L420/425/430/435|38425:12 36860:2", -- Virulent Spaulders
	[43131] = "60652|L420/425/430/435|38557:40", -- Eaglebane Bracers
	[43132] = "60655|L425/430/435/440|38425:14 35627:2", -- Nightshock Hood
	[43133] = "60658|L420/425/430/435|38425:10 35627:2", -- Nightshock Girdle
	[43255] = "60665|L420/425/430/435|38425:10 35622:2", -- Seafoam Gauntlets
	[43256] = "60666|L420/425/430/435|38425:6 38561:20", -- Jormscale Footpads
	[43257] = "60669|L425/430/435/440|38425:25", -- Wildscale Breastplate
	[43258] = "60671|L420/425/430/435|38558:30", -- Purehorn Spaulders
	[43260] = "60697|L420/425/430/435|38425:12 35623|44513", -- Eviscerator's Facemask
	[43261] = "60715|L420/425/430/435|38425:12 35622|44521", -- Overcast Headguard
	[43262] = "60716|L420/425/430/435|38425:10 35622|44522", -- Overcast Spaulders
	[43263] = "60718|L420/425/430/435|38425:12 35622|44523", -- Overcast Chestguard
	[43264] = "60720|L420/425/430/435|38425:8 35622|44524", -- Overcast Bracers
	[43265] = "60721|L425/430/435/440|38425:10 35622|44525", -- Overcast Handwraps
	[43266] = "60723|L425/430/435/440|38425:10 35622|44526", -- Overcast Belt
	[43271] = "60725|L425/430/435/440|38425:12 35622|44527", -- Overcast Leggings
	[43273] = "60727|L425/430/435/440|38425:10 35622|44528", -- Overcast Boots
	[43433] = "60702|L420/425/430/435|38425:10 35623|44514", -- Eviscerator's Shoulderpads
	[43434] = "60703|L420/425/430/435|38425:12 35623|44515", -- Eviscerator's Chestguard
	[43435] = "60704|L420/425/430/435|38425:8 35623|44516", -- Eviscerator's Bindings
	[43436] = "60705|L425/430/435/440|38425:10 35623|44517", -- Eviscerator's Gauntlets
	[43437] = "60706|L425/430/435/440|38425:10 35623|44518", -- Eviscerator's Waistguard
	[43438] = "60711|L425/430/435/440|38425:12 35623|44519", -- Eviscerator's Legguards
	[43439] = "60712|L425/430/435/440|38425:10 35623|44520", -- Eviscerator's Treads
	[43442] = "60734|L425/430/435/440|38425:10 35623|44535", -- Swiftarrow Belt
	[43443] = "60737|L425/430/435/440|38425:10 35623|44537", -- Swiftarrow Boots
	[43444] = "60731|L420/425/430/435|38425:8 35623|44533", -- Swiftarrow Bracers
	[43445] = "60730|L420/425/430/435|38425:12 35623|44532", -- Swiftarrow Hauberk
	[43446] = "60732|L425/430/435/440|38425:10 35623|44534", -- Swiftarrow Gauntlets
	[43447] = "60728|L420/425/430/435|38425:12 35623|44530", -- Swiftarrow Helm
	[43448] = "60735|L425/430/435/440|38425:12 35623|44536", -- Swiftarrow Leggings
	[43449] = "60729|L420/425/430/435|38425:10 35623|44531", -- Swiftarrow Shoulderguards
	[43450] = "60750|L425/430/435/440|38425:10 35622|44543", -- Stormhide Belt
	[43451] = "60752|L425/430/435/440|38425:10 35622|44545", -- Stormhide Stompers
	[43452] = "60748|L420/425/430/435|38425:8 35622|44541", -- Stormhide Wristguards
	[43453] = "60747|L420/425/430/435|38425:12 35622|44540", -- Stormhide Hauberk
	[43454] = "60749|L425/430/435/440|38425:10 35622|44542", -- Stormhide Grips
	[43455] = "60743|L420/425/430/435|38425:12 35622|44538", -- Stormhide Crown
	[43456] = "60751|L425/430/435/440|38425:12 35622|44544", -- Stormhide Legguards
	[43457] = "60746|L420/425/430/435|38425:10 35622|44539", -- Stormhide Shoulders
	[43458] = "60754|L440/450/455/460|38425:12 35622:6 35623:6 43102|44546", -- Giantmaim Legguards
	[43459] = "60755|L440/450/455/460|38425:10 35622:5 35623:5 43102|44547", -- Giantmaim Bracers
	[43461] = "60756|L440/450/455/460|38425:12 35622:12 43102|44548", -- Revenant's Breastplate
	[43469] = "60757|L440/450/455/460|38425:10 35622:10 43102|44549", -- Revenant's Treads
	[43481] = "60758|L440/450/455/460|38425:10 36860:6 35627:6 43102|44550", -- Trollwoven Spaulders
	[43484] = "60759|L440/450/455/460|38425:10 36860:5 35627:5 43102|44551", -- Trollwoven Girdle
	[43495] = "60760|L440/450/455/460|38425:12 35625:6 35622:6 43102|44552", -- Earthgiving Legguards
	[43502] = "60761|L440/450/455/460|38425:10 35625:5 35622:5 43102|44553", -- Earthgiving Boots
	[43565] = "60640|L440/450/455/460|44128:2 38558:40 43102", -- Durable Nerubhide Cape
	[43566] = "60637|L440/450/455/460|44128:2 36860:6 35627:4 43102", -- Ice Striker's Cloak
	[43590] = "60996|L425/435/445/455|38425:10 36860:3 35622:3 38558:8 43102|44584", -- Polar Vest
	[43591] = "60997|L420/430/440/450|38425:8 36860:2 35622:2 38558:4 43102|44585", -- Polar Cord
	[43592] = "60998|L420/430/440/450|38425:8 36860:2 35622:2 38558:4 43102|44586", -- Polar Boots
	[43593] = "60999|L425/435/445/455|38425:10 36860:3 35622:3 38557:8 43102|44587", -- Icy Scale Chestguard
	[43594] = "61000|L420/430/440/450|38425:8 36860:2 35622:2 38557:4 43102|44588", -- Icy Scale Belt
	[43595] = "61002|L420/430/440/450|38425:8 36860:2 35622:2 38557:4 43102|44589", -- Icy Scale Boots
	[44436] = "60601|L395/410/420/430|38425:4 37705:5", -- Dark Frostscale Leggings
	[44437] = "60604|L395/410/420/430|38425:6 37705:4", -- Dark Frostscale Breastplate
	[44438] = "60605|L400/415/425/435|38557:35", -- Dragonstompers
	[44440] = "60611|L395/410/420/430|38425:4 37703:5", -- Dark Iceborne Leggings
	[44441] = "60613|L395/410/420/430|38425:6 37703:4", -- Dark Iceborne Chestguard
	[44442] = "60620|L400/415/425/435|38558:35", -- Bugsquashers
	[44443] = "60627|L395/410/420/430|38425:4 37705:5", -- Dark Nerubian Leggings
	[44444] = "60629|L395/410/420/430|38425:6 37705:4", -- Dark Nerubian Chestpiece
	[44445] = "60630|L400/415/425/435|38557:30 37703:2", -- Scaled Icewalkers
	[44446] = "60643|L415/420/422/425|38425:8", -- Pack of Endless Pockets
	[44447] = "60645|L415/420/422/425|38557:20 38425:2|44511", -- Dragonscale Ammo Pouch
	[44448] = "60647|L415/420/422/425|38558:20 38425:2|44512", -- Nerubian Reinforced Quiver
	[44930] = "62176|L440/450/455/460|38425:10 35623:5 35622:5 43102|44932", -- Windripper Boots
	[44931] = "62177|L440/450/455/460|38425:12 35623:6 35622:6 43102|44933", -- Windripper Leggings
	[44963] = "62448|L9999/435/440/445|44128:2 35624:4 43102||", -- Earthen Leg Armor
	[-60584] = "L400/400/400/405|38558:2", -- Nerubian Leg Reinforcements
	[-60583] = "L405/405/405/410|38561:2", -- Jormungar Leg Reinforcements
	[-57701] = "L400/425/430/435|44128", -- Fur Lining - Arcane Resist
	[-57699] = "L400/425/430/435|44128", -- Fur Lining - Nature Resist
	[-57696] = "L400/425/430/435|44128", -- Fur Lining - Shadow Resist
	[-57694] = "L400/425/430/435|44128", -- Fur Lining - Frost Resist
	[-57692] = "L400/425/430/435|44128", -- Fur Lining - Fire Resist
	[-57691] = "L400/425/430/435|44128", -- Fur Lining - Spell Power
	[-57690] = "L400/425/430/435|44128", -- Fur Lining - Stamina
	[-57683] = "L400/425/430/435|44128", -- Fur Lining - Attack Power
	-- WotLK Tailoring combines
	[6836] = "49677|T250/255/270/285|4339:4 4304:2|37915", -- Dress Shoes
	[38225] = "50194|T375/385/390/395|21845:4 22794:2|38229", -- Mycah's Botanical Bag
	[38277] = "50644|T250/265/280/295|4339:5 2325:2 2604 8343:3|38327", -- Haliscan Jacket
	[38278] = "50647|T245/250/255/260|4339:4 8343:3 2325:3|38328", -- Haliscan Pantaloons
	[41248] = "55993|T400/400/405/410|41510:4 2604|42172", -- Red Lumberjack Shirt
	[41249] = "55994|T400/400/405/410|41510:4 6260|42173", -- Blue Lumberjack Shirt
	[41250] = "55996|T400/400/405/410|41510:4 2605|42175", -- Green Lumberjack Shirt
	[41251] = "55995|T400/400/405/410|41510:4 4341", -- Yellow Lumberjack Shirt
	[41252] = "55997|T400/400/405/410|41510:4 2604|42177", -- Red Workman's Shirt
	[41253] = "55998|T400/400/405/410|41510:4 6260|42176", -- Blue Workman's Shirt
	[41254] = "55999|T400/400/405/410|41510:4 4341|42178", -- Rustic Workman's Shirt
	[41255] = "56000|T400/400/405/410|41510:4 2605", -- Green Workman's Shirt
	[41509] = "55898|T360/370/375/380|33470:6||5", -- Frostweave Net
	[41510] = "55899|T350/370/372/375|33470:5", -- Bolt of Frostweave
	[41511] = "55900|T400/400/402/405|41510:2 34054:2", -- Bolt of Imbued Frostweave
	[41512] = "56031|T350/360/370/380|41510:3 38426", -- Frostwoven Wristwraps
	[41513] = "55902|T350/360/370/380|41510:3 38426", -- Frostwoven Shoulders
	[41515] = "55903|T360/370/380/390|41510:4 38426", -- Frostwoven Robe
	[41516] = "59586|T420/430/440/450|41511:3 37702:4 37701:4 38426:2", -- Frostsavage Gloves
	[41519] = "56030|T380/390/400/410|41510:5 38426", -- Frostwoven Leggings
	[41520] = "55906|T375/385/395/405|41510:4 38426", -- Frostwoven Boots
	[41521] = "55907|T380/390/400/410|41510:5 38426", -- Frostwoven Cowl
	[41522] = "55908|T370/380/390/400|41510:3 38426", -- Frostwoven Belt
	[41523] = "55910|T385/395/405/415|41510:7 38426:4 36783", -- Mystic Frostwoven Shoulders
	[41525] = "55911|T390/400/410/420|41510:8 38426:4 36783", -- Mystic Frostwoven Robe
	[41528] = "55913|T385/395/405/415|41510:5 38426:4 36783:2", -- Mystic Frostwoven Wristwraps
	[41543] = "55914|T395/400/405/410|41510:7 38426", -- Duskweave Belt
	[41544] = "55924|T410/420/425/430|41510:10 38426", -- Duskweave Boots
	[41545] = "55922|T405/415/420/425|41510:9 38426", -- Duskweave Gloves
	[41546] = "55919|T395/405/410/415|41510:8 38426", -- Duskweave Cowl
	[41548] = "55901|T395/405/410/415|41510:8 38426", -- Duskweave Leggings
	[41549] = "55921|T405/415/420/425|41510:10 38426", -- Duskweave Robe
	[41550] = "55923|T410/420/425/430|41510:10 38426", -- Duskweave Shoulders
	[41551] = "55920|T400/410/415/420|41510:8 38426", -- Duskweave Wristwraps
	[41553] = "55925|T415/425/430/435|41511:5 42253:2 38426:2", -- Black Duskweave Leggings
	[41554] = "55941|T420/430/435/440|41511:5 42253:2 38426:2", -- Black Duskweave Robe
	[41555] = "55943|T415/425/430/435|41511:4 42253:2 38426:2", -- Black Duskweave Wristwraps
	[41593] = "56002|T415/425/430/435|41511 35627:2", -- Ebonweave
	[41594] = "56001|T415/425/430/435|41511 35625:2", -- Moonshroud
	[41595] = "56003|T415/425/430/435|41511 36860:2", -- Spellweave
	[41597] = "56004|T435/440/445/450|41593:4 41595:2 38426|42183", -- Abyssal Bag
	[41598] = "56006|T440/445/450/455|41595:4 41594:2 38426|42185", -- Mysterious Bag
	[41599] = "56007|T410/430/440/450|41511:6 38426:2", -- Frostweave Bag
	[41600] = "56005|T445/450/455/460|41594:4 41593:4 38426|42184", -- Glacial Bag
	[41601] = "56008|T400/400/405/410|37704:2 42253:2", -- Shining Spellthread
	[41602] = "56009|T430/435/440/445|35625:4 42253:4 43102|42187", -- Brilliant Spellthread
	[41603] = "56010|T400/400/405/410|37702:2 42253:2", -- Azure Spellthread
	[41604] = "56011|T430/435/440/445|36860:4 42253:4 43102|42188", -- Sapphire Spellthread
	[41607] = "56014|T390/395/400/405|41510:7 36783", -- Cloak of the Moon
	[41608] = "56015|T395/400/405/410|41510:8 36783", -- Cloak of Frozen Spirits
	[41609] = "56016|T415/435/445/455|41511:5 35625:6 35622:4 36784 43102", -- Wispcloak
	[41610] = "56017|T415/435/445/455|41511:5 36860:6 35627:4 36784 43102", -- Deathchill Cloak
	[41984] = "56018|T425/435/440/445|41593 41511:6 42253:4 38426", -- Hat of Wintry Doom
	[41985] = "56019|T420/430/440/450|41595 41511:5 38425:2 42253:4 38426", -- Silky Iceshard Boots
	[41986] = "56020|T420/430/440/450|41595 41511:4 42253:4 38426", -- Deep Frozen Cord
	[42093] = "56021|T425/435/440/445|41594 41511:6 42253:4 38426", -- Frostmoon Pants
	[42095] = "56022|T420/430/440/450|41594 41511:4 42253:4 38426", -- Light Blessed Mittens
	[42096] = "56023|T420/430/440/450|41594 41511:4 38425:2 42253:4 38426", -- Aurora Slippers
	[42100] = "56024|T440/450/455/460|41594:8 41511:6 38426 43102", -- Moonshroud Robe
	[42101] = "56026|T440/450/455/460|41593:8 41511:6 38426 43102", -- Ebonweave Robe
	[42102] = "56028|T440/450/455/460|41595:8 41511:6 38426 43102", -- Spellweave Robe
	[42103] = "56025|T435/445/450/455|41594:4 41511:4 38426 43102", -- Moonshroud Gloves
	[42111] = "56027|T435/445/450/455|41593:4 41511:4 38426 43102", -- Ebonweave Gloves
	[42113] = "56029|T435/445/450/455|41595:4 41511:4 38426 43102", -- Spellweave Gloves
	[43583] = "60993|T425/435/445/455|41511:6 36860:3 35622:3 38426:3 43102", -- Glacial Robe
	[43584] = "60990|T420/430/440/450|41511:4 36860:2 35622:2 38426:2 43102", -- Glacial Waistband
	[43585] = "60994|T420/430/440/450|41511:4 36860:2 35622:2 38426:2 43102", -- Glacial Slippers
	[43969] = "59582|T415/425/435/445|41511:3 37702:3 37701:3 38426:2", -- Frostsavage Belt
	[43970] = "59585|T420/430/440/450|41511:3 37702:4 37701:4 38426:2", -- Frostsavage Boots
	[43971] = "59589|T420/430/440/450|41511:4 37702:5 37701:5 38426:2", -- Frostsavage Cowl
	[43972] = "59587|T420/430/440/450|41511:4 37702:5 37701:5 38426:2", -- Frostsavage Robe
	[43973] = "59584|T420/430/440/450|41511:3 37702:4 37701:4 38426:2", -- Frostsavage Shoulders
	[43974] = "59583|T415/425/435/445|41511:3 37702:3 37701:3 38426:2", -- Frostsavage Bracers
	[43975] = "59588|T420/430/440/450|41511:4 37702:5 37701:5 38426:2", -- Frostsavage Leggings
	[44211] = "55904|T360/370/380/390|41510:3 38426", -- Frostwoven Gloves
	[44554] = "60969|T410/420/425/430|41511:4 36920:4 2605:4 4341:2 42253:2", -- Flying Carpet
	[44558] = "60971|T425/435/445/455|41511:12 36930:4 2604:4 4341:2 42253:4", -- Magnificent Flying Carpet
	[-55769] = "T420/0/0/420|41593 38426", -- Darkglow Embroidery
	[-55642] = "T420/0/0/420|41594 38426", -- Lightweave Embroidery
	[-55777] = "T420/0/0/420|41595 38426", -- Swordguard Embroidery
	[-56034] = "T405/0/0/405|38426", -- Master's spellthread
	[-56039] = "T405/0/0/405|38426", -- Sanctified spellthread
	-- WotLK Enchanting combines
	[-62256] = "D450/460/470/480|34055:4 34057|44944", -- Enchant Bracers - Major Stamina
	[-60767] = "D440/450/460/470|34054:6 34055:6 34052|44498", -- Enchant Bracers - Superior Spellpower
	[-60763] = "D440/450/460/470|34055:4 34052:4|44490", -- Enchant Boots - Greater Assault
	[-60714] = "D435/445/455/465|34054:30 34052:6 34057:6|44487", -- Enchant Weapon - Mighty Spellpower
	[-60707] = "D435/445/455/465|34054:10 34055:2 34052:2 34057:4|44486", -- Enchant Weapon - Superior Potency
	[-60692] = "D440/450/460/470|34052:4 34057:4|44489", -- Enchant Chest - Powerful Stats
	[-60691] = "D430/440/450/460|34054:40 34055:6 34057:6|44483", -- Enchant 2H Weapon - Massacre
	[-60668] = "D425/435/445/455|34054:20 34055:4 34052", -- Enchant Gloves - Crusher
	[-60663] = "D420/430/440/450|34054:8 34055:2 34052:2", -- Enchant Cloak - Major Agility
	[-60653] = "D395/405/415/425|34054:12", -- Enchant Shield - Greater Intellect
	[-60623] = "D385/395/405/415|34054:8 37705", -- Enchant Boots - Icewalker
	[-60621] = "D380/390/400/410|34054:2 34056:4", -- Enchant Weapon - Greater Potency
	[-60616] = "D360/370/380/390|34054:6", -- Enchant Bracers - Striking
	[-60609] = "D350/360/370/380|34054:6", -- Enchant Cloak - Speed
	[-60606] = "D375/385/395/405|34054:4 34056:4", -- Enchant Boots - Assault
	[-59636] = "D400/400/407/415|34054:8 34055", -- Enchant Ring - Stamina
	[-59625] = "D440/450/460/470|34055:6 34052:6 34057:6|44495", -- Enchant Weapon - Black Magic
	[-59621] = "D440/450/460/470|34054:12 34055:4 34052:4 34057:10|44492", -- Enchant Weapon - Berserking
	[-59619] = "D440/450/460/470|34054:20 34055:4 34052:4 34057:6|44496", -- Enchant Weapon - Accuracy
	[-47901] = "D440/450/460/470|34054:10 34055:2 34052:2|44491", -- Enchant Boots - Tuskarr's Vitality
	[-47900] = "D425/435/445/455|34054:20 34055:4", -- Enchant Chest - Super Health
	[-47899] = "D440/450/460/470|34055:6 34057|44488", -- Enchant Cloak - Wisdom
	[-47898] = "D430/440/450/460|34054:16 34055:4|44472", -- Enchant Cloak - Greater Speed
	[-47766] = "D400/410/420/430|34054:10 35624", -- Enchant Chest - Greater Defense
	[-47672] = "D430/440/450/460|34054:15 34055:2|44471", -- Enchant Cloak - Mighty Armor
	[-46578] = "D350/350/357/365|22456:2 21885:2|35498", -- Enchant Weapon - Deathfrost
	[-44645] = "D400/400/407/415|34054:8 34055", -- Enchant Ring - Assault
	[-44636] = "D400/400/407/415|34054:8 34055", -- Enchant Ring - Greater Spellpower
	[-44635] = "D395/405/415/425|34054:8 34056:4", -- Enchant Bracers - Greater Spellpower
	[-44633] = "D410/420/430/440|34052:4 35623:4", -- Enchant Weapon - Exceptional Agility
	[-44631] = "D440/450/460/470|34054:12 34057|37349", -- Enchant Cloak - Shadow Armor
	[-44630] = "D390/400/410/420|34054:6 34055:2", -- Enchant 2H Weapon - Greater Savagery
	[-44629] = "D395/405/415/425|34054:10 34055:2", -- Enchant Weapon - Exceptional Spellpower
	[-44625] = "D435/445/455/465|34052:2 35624:8|44485", -- Enchant Gloves - Armsman
	[-44623] = "D370/380/390/400|34054:4 34056:2", -- Enchant Chest - Super Stats
	[-44621] = "D430/440/450/460|34055:2 34052:6|37339", -- Enchant Weapon - Giant Slayer
	[-44616] = "D400/410/420/430|34054:16 34055:3", -- Enchant Bracers - Greater Stats
	[-44598] = "D415/425/435/445|34054:14 34055:3", -- Enchant Bracers - Expertise
	[-44596] = "D400/415/425/435|34054:20 35624|37330", -- Enchant Cloak - Superior Arcane Resistance
	[-44595] = "D430/440/450/460|34054:6 34052:6|44473", -- Enchant 2H Weapon - Scourgebane
	[-44593] = "D420/430/440/450|34054:16 34055:4", -- Enchant Bracers - Major Spirit
	[-44592] = "D360/370/380/390|34054:4 34056", -- Enchant Gloves - Exceptional Spellpower
	[-44591] = "D435/445/455/465|34054:8 41163:2 34052:2|37347", -- Enchant Cloak - Titanweave
	[-44590] = "D400/415/425/435|34054:8 34056:2 35625|37334", -- Enchant Cloak - Superior Shadow Resistance
	[-44589] = "D415/425/435/445|34054:16 34055:4", -- Enchant Boots - Superior Agility
	[-44588] = "D410/435/445/455|34055:2 34052:2|37340", -- Enchant Chest - Exceptional Resilience
	[-44584] = "D405/415/425/435|34054:8 34055:2", -- Enchant Boots - Greater Vitality
	[-44582] = "D395/395/402/410|34054:15", -- Enchant Cloak - Spell Piercing
	[-44576] = "D440/450/460/470|34057:4|44494", -- Enchant Weapon - Lifeward
	[-44575] = "D430/440/450/460|34054:24 34055:6|44484", -- Enchant Bracers - Greater Assault
	[-44556] = "D400/415/425/435|34055:4 35622|37331", -- Enchant Cloak - Superior Fire Resistance
	[-44555] = "D375/385/392/400|34054:10", -- Enchant Bracers - Exceptional Intellect
	[-44529] = "D415/425/435/445|34055:4 34052", -- Enchant Gloves - Major Agility
	[-44528] = "D385/385/390/400|34056:3 34054:3", -- Enchant Boots - Greater Fortitude
	[-44524] = "D425/435/445/455|34052:4 36860:4|37344", -- Enchant Weapon - Icebreaker
	[-44513] = "D395/405/415/425|34054:6 34055", -- Enchant Gloves - Greater Assault
	[-44510] = "D410/420/430/440|34054:16 34052:4", -- Enchant Weapon - Exceptional Spirit
	[-44509] = "D420/430/440/450|34054:4 34055:4", -- Enchant Chest - Greater Mana Restoration
	[-44508] = "D410/420/430/440|34054:10 34055", -- Enchant Boots - Greater Spirit
	[-44506] = "D375/375/380/390|34055", -- Enchant Gloves - Gatherer
	[-44500] = "D395/405/415/425|34054:9", -- Enchant Cloak - Superior Agility
	[-44494] = "D400/415/425/435|34054:15 34055 35627|37333", -- Enchant Cloak - Superior Nature Resistance
	[-44492] = "D395/405/415/425|34055:3", -- Enchant Chest - Mighty Health
	[-44489] = "D420/430/440/450|34054:6 35624:6", -- Enchant Shield - Defense
	[-44488] = "D410/420/430/440|34055:4", -- Enchant Gloves - Precision
	[-44484] = "D405/415/425/435|34054:12", -- Enchant Gloves - Expertise
	[-44483] = "D400/415/425/435|34054:6 34055:3 36860|37332", -- Enchant Cloak - Superior Frost Resistance
	[44452] = "60619|D425/435/445/455|41745 34054:40 34055:12 34052:8 22463", -- Runed Titanium Rod
	-- WotLK Cooking combines
	[34747] = "57421|W320/350/365/380|43013", -- Northern Stew
	[34748] = "45549|W350/350/382/415|34736", -- Mammoth Meal
	[34749] = "45550|W350/350/382/415|43009", -- Shoveltusk Steak
	[34750] = "45551|W350/350/382/415|43010", -- Wyrm Delight
	[34751] = "45552|W350/350/382/415|43011", -- Roasted Worg
	[34752] = "45553|W350/350/382/415|43012", -- Rhino Dogs
	[34753] = "45554|W375/375/400/425|34736 43009 43010 43013:2", -- Great Feast
	[34754] = "45555|W400/400/402/425|34736:2 43007|43018", -- Mega Mammoth Meal
	[34755] = "45556|W400/400/402/425|43009:2 43007|43019", -- Tender Shoveltusk Steak
	[34756] = "45557|W400/400/402/425|43010:2 43007|43020", -- Spiced Wyrm Burger
	[34757] = "45558|W400/400/402/425|43011 43007|43021", -- Very Burnt Worg
	[34758] = "45559|W400/400/402/425|43012:2 43007|43022", -- Mighty Rhino Dogs
	[34759] = "45560|W350/350/365/380|41803", -- Smoked Rockfin
	[34760] = "45561|W350/350/365/380|41808", -- Grilled Bonescale
	[34761] = "45562|W350/350/365/380|41812", -- Sauteed Goby
	[34762] = "45563|W350/350/382/415|41806", -- Grilled Sculpin
	[34763] = "45564|W350/350/382/415|41809", -- Smoked Salmon
	[34764] = "45565|W350/350/382/415|41813", -- Poached Nettlefish
	[34765] = "45566|W350/350/382/415|41810", -- Pickled Fangtooth
	[34766] = "45567|W400/400/402/425|41806 43007|43023", -- Poached Northern Sculpin
	[34767] = "45568|W400/400/402/425|41809 43007|43024", -- Firecracker Salmon
	[34768] = "45571|W400/400/402/425|41813 43007|43025", -- Spicy Blue Nettlefish
	[34769] = "45570|W400/400/402/425|41802 43007|43026", -- Imperial Manta Steak
	[39520] = "53056|W375/375/387/400|35949:2 35948|39644|5", -- Kungaloosh
	[42942] = "45569|W350/350/382/415|41802", -- Baked Manta Ray
	[42993] = "57433|W400/400/402/425|41810 43007|43027", -- Spicy Fried Herring
	[42994] = "57434|W400/400/415/450|43010 43012 43007|43028", -- Rhinolicious Wyrmsteak
	[42995] = "57436|W400/400/415/450|43012 43007|43030", -- Hearty Rhino
	[42996] = "57437|W400/400/415/450|41808:3 43007|43031", -- Snapper Extreme
	[42997] = "57438|W400/400/415/450|43011 43007|43032", -- Blackened Worg Steak
	[42998] = "57439|W400/400/415/450|41801 43007|43033", -- Cuttlesteak
	[42999] = "57441|W400/400/415/450|41807:2 43007|43035", -- Blackened Dragonfin
	[43000] = "57442|W400/400/415/450|41807 43007|43036", -- Dragonfin Filet
	[43001] = "57443|W400/400/415/450|43009 43007|43037", -- Tracker Snacks
	[43004] = "57435|W400/400/415/450|43013:2 43007|43029|4", -- Critter Bites
	[43005] = "57440|W400/400/415/450|34736 43007|43034", -- Spiced Mammoth Treats
	[43015] = "57423|W450/455/460/465|41806:2 41809:2 41813:2 43007|43017", -- Fish Feast
	[43268] = "58065|W350/350/382/415|36782:2", -- Dalaran Clam Chowder
	[43478] = "58527|W425/425/450/475|41800:2 34736:2 41803:2 43007|43505", -- Gigantic Feast
	[43480] = "58528|W425/425/450/475|41813:2 43012:2 41809:2 43007|43506", -- Small Feast
	[43488] = "58521|W350/350/357/365|34736|43508|5", -- Last Week's Mammoth
	[43490] = "58512|W350/350/357/365|30817:2 43501|43507|5", -- Tasty Cupcake
	[43491] = "58523|W350/350/357/365|36782 22577|43509|5", -- Bad Clams
	[43492] = "58525|W350/350/357/365|41810 12808|43510|5", -- Haunted Herring
	[44953] = "62350|W400/0/400/415|43011:2 43007|44954", -- Worg Tartare
	-- WotLK Smelting combines
	[36] = "55211|Y450/0/0/450|36910:2|||41163", -- Smelt Titanium
	[36913] = "49258|Y400/0/0/400|36912:2", -- Smelt Saronite
	[36916] = "49252|Y350/350/362/375|36909", -- Smelt Cobalt
	[37663] = "55208|Y450/0/0/450|41163:3 36860 35624 35627", -- Smelt Titansteel
	-- WotLK First Aid Recipes
	[34721] = "45545|X350/375/392/410|33470", -- Frostweave Bandage
	[34722] = "45546|X400/400/430/470|33470:2|39152", -- Manual: Heavy Frostweave Bandage
}

TradeskillInfo.vars.components = {
	[2454] = "20/Ca",
	[5997] = "5/Ca",
	[118] = "5/Ca",
	[3382] = "10/Ca",
	[2455] = "10/Ca",
	[2456] = "15/Ca",
	[4596] = "25/Ca",
	[2457] = "15/Ca",
	[2458] = "15/Ca",
	[858] = "25/Ca",
	[5631] = "30/Ca",
	[2459] = "25/Ca",
	[6370] = "10/Ca",
	[6662] = "95/Ca",
	[5996] = "95/Ca",
	[3383] = "100/Ca",
	[6051] = "62/Ca",
	[6372] = "35/Ca",
	[929] = "75/Ca",
	[3384] = "20/Ca",
	[3385] = "30/Ca",
	[3386] = "35/Ca",
	[3388] = "40/Ca",
	[3389] = "40/Ca",
	[6371] = "12/Ca",
	[6048] = "100/Ca",
	[6373] = "35/Ca",
	[3390] = "35/Ca",
	[3391] = "20/Ca",
	[5634] = "75/Ca",
	[1710] = "125/Ca",
	[3827] = "120/Ca",
	[3824] = "150/Ca",
	[6049] = "170/Ca",
	[3823] = "100/Ca",
	[3826] = "105/Ca",
	[3825] = "110/Ca",
	[5633] = "150/Ca",
	[8949] = "200/Ca",
	[17708] = "35/Ca",
	[3829] = "150/Ca",
	[6050] = "300/Ca",
	[6052] = "300/Ca",
	[3828] = "150/Ca",
	[8951] = "200/Ca",
	[9061] = "250/Ca",
	[10592] = "150/Ca",
	[6149] = "120/Ca",
	[8956] = "200/Ca",
	[1] = "0/Ca",
	[3577] = "600/Cs",
	[3] = "0/Ca",
	[6037] = "1250/Cs",
	[9036] = "20/Ca",
	[9149] = "250/Ca",
	[18294] = "250/Ca",
	[4623] = "375/Ca",
	[3928] = "250/Ca",
	[9144] = "250/Ca",
	[9030] = "250/Ca", -- Restorative Potion, added 8/7/2007
	[12190] = "250/Ca",
	[9154] = "300/Ca",
	[9210] = "750/Ca",
	[9155] = "400/Ca",
	[9179] = "1000/Ca",
	[9264] = "35/Ca",
	[9172] = "500/Ca",
	[9197] = "600/Ca",
	[9187] = "600/Ca",
	[9088] = "250/Ca",
	[9206] = "700/Ca",
	[9224] = "700/Ca",
	[9233] = "500/Ca",
	[21546] = "35/Ca",
	[3387] = "30/Ca",
	[13423] = "125/Ca",
	[13442] = "500/Ca",
	[13443] = "400/Ca",
	[13445] = "500/Ca",
	[13447] = "1250/Ca",
	[7078] = "400/D",
	[12360] = "5000/Ca",
	[12803] = "500/D",
	[5] = "0/Ca",
	[6] = "0/Ca",
	[7080] = "400/D",
	[7] = "0/Ca",
	[8] = "0/Ca",
	[7076] = "400/D",
	[7082] = "400/D",
	[12808] = "1000/D",
	[13453] = "1250/Ca",
	[20002] = "1000/Ca",
	[20007] = "1000/Ca",
	[13446] = "1000/Ca",
	[13452] = "1250/Ca",
	[13455] = "750/Ca",
	[13454] = "750/Ca",
	[20008] = "600/Ca",
	[13462] = "750/Ca",
	[9030] = "200/Ca",
	[13461] = "750/Ca",
	[13457] = "750/Ca",
	[13456] = "750/Ca",
	[13458] = "750/Ca",
	[13459] = "100/Ca",
	[20004] = "1000/Ca",
	[13444] = "1500/Ca",
	[19931] = "0/Ca",
	[28103] = "2500/Ca",
	[13513] = "5000/Ca",
	[13511] = "5000/Ca",
	[13506] = "5000/Ca",
	[13512] = "5000/Ca",
	[13510] = "5000/Ca",
	[18253] = "15/Ca",
	[28102] = "2500/Ca",
	[7068] = "400/D",
	[28100] = "1000/Ca",
	[22823] = "2500/Ca",
	[22824] = "2500/Ca",
	[22825] = "2500/Ca",
	[32062] = "0/Ca",
	[28101] = "1500/Ca",
	[28104] = "2500/Ca",
	[22826] = "2500/Ca",
	[32063] = "0/Ca",
	[32067] = "0/Ca",
	[22827] = "2500/Ca",
	[22828] = "2500/Ca",
	[31080] = "4000/Ca",
	[22830] = "4000/Ca",
	[22829] = "5000/Ca",
	[32068] = "0/Ca",
	[22831] = "4000/Ca",
	[31679] = "3000/Ca",
	[22871] = "5000/Ca",
	[22832] = "5000/Ca",
	[22834] = "4000/Ca",
	[22833] = "2500/Ca",
	[31676] = "5000/Ca",
	[13503] = "25000/Ca",
	[25867] = "30000/Ca",
	[23571] = "16000/Ca",
	[25868] = "30000/Ca",
	[9] = "0/Ca",
	[10] = "0/Ca",
	[21884] = "4000/C",
	[11] = "0/Ca",
	[21885] = "4000/C",
	[13] = "0/Ca",
	[22452] = "4000/C",
	[22451] = "4000/C",
	[22839] = "5000/Ca",
	[22835] = "6000/Ca",
	[22838] = "5000/Ca",
	[22837] = "5000/Ca",
	[22836] = "5000/Ca",
	[22840] = "6000/Ca",
	[31677] = "5000/Ca",
	[22861] = "20000/Ca",
	[22851] = "20000/Ca",
	[22853] = "20000/Ca",
	[22866] = "20000/Ca",
	[22854] = "20000/Ca",
	[22845] = "6000/Ca",
	[22841] = "6000/Ca",
	[22842] = "6000/Ca",
	[22847] = "6000/Ca",
	[22844] = "6000/Ca",
	[22846] = "6000/Ca",
	[22850] = "7000/Ca",
	[22848] = "7000/Ca",
	[22849] = "7000/Ca",
	[21886] = "4000/C",
	[22457] = "4000/C",
	[14] = "0/Ca",
	[12] = "0/Ca",
	[22456] = "4000/C",
	[32839] = "0/Ca",
	[32849] = "0/Ca",
	[32850] = "0/Ca",
	[32851] = "0/Ca",
	[32852] = "0/Ca",
	[2853] = "17/Cb",
	[2852] = "67/Cb",
	[10421] = "32/Cb",
	[2862] = "3/Cb",
	[3239] = "3/Cb",
	[2844] = "106/Cb",
	[2845] = "109/Cb",
	[3469] = "49/Cb",
	[2847] = "110/Cb",
	[3470] = "5/Cb",
	[7955] = "241/Cb",
	[7166] = "194/Cb",
	[3488] = "613/Cb",
	[3471] = "142/Cb",
	[2851] = "56/Cb",
	[3472] = "71/Cb",
	[3473] = "299/Cb",
	[3474] = "216/Cb",
	[2863] = "10/Cb",
	[3240] = "10/Cb",
	[6214] = "595/Cb",
	[3489] = "937/Cb",
	[2857] = "198/Cb",
	[3478] = "10/Cb",
	[2864] = "630/Cb",
	[2854] = "225/Cb",
	[3487] = "1498/Cb",
	[6350] = "295/Cb",
	[6731] = "871/Cb",
	[15869] = "50/Cb",
	[29201] = "150/Cb",
	[6338] = "125/Cb",
	[3848] = "1426/Cb",
	[2865] = "962/Cb",
	[2866] = "752/Cb",
	[2848] = "1119/Cb",
	[3480] = "532/Cb",
	[5540] = "2107/Cb",
	[2849] = "1269/Cb",
	[2868] = "807/Cb",
	[2850] = "1439/Cb",
	[3490] = "2731/Cb",
	[3481] = "1284/Cb",
	[7956] = "1944/Cb",
	[3486] = "100/Cb",
	[2871] = "40/Cb",
	[3241] = "40/Cb",
	[3491] = "2741/Cb",
	[3482] = "1317/Cb",
	[2869] = "1831/Cb",
	[7957] = "2205/Cb",
	[3483] = "965/Cb",
	[7958] = "2435/Cb",
	[5541] = "3693/Cb",
	[2870] = "2935/Cb",
	[3484] = "1767/Cb",
	[3492] = "4552/Cb",
	[15870] = "300/Cb",
	[3485] = "1295/Cb",
	[3851] = "6258/Cb",
	[11128] = "500/Cb",
	[7071] = "100/Cb",
	[6042] = "250/Cb",
	[7914] = "3330/Cb",
	[3842] = "2906/Cb",
	[3849] = "5468/Cb",
	[10423] = "2842/Cb",
	[7913] = "2500/Cb",
	[3840] = "2571/Cb",
	[3835] = "1106/Cb",
	[6043] = "500/Cb",
	[3852] = "8360/Cb",
	[3843] = "3882/Cb",
	[3836] = "3053/Cb",
	[7915] = "3337/Cb",
	[3841] = "3106/Cb",
	[3850] = "7304/Cb",
	[3853] = "10153/Cb",
	[3844] = "5658/Cb",
	[7916] = "3700/Cb",
	[12259] = "8072/Cb",
	[3855] = "11248/Cb",
	[7917] = "2711/Cb",
	[3846] = "3937/Cb",
	[6040] = "1649/Cb",
	[17704] = "9178/Cb",
	[3837] = "4405/Cb",
	[12260] = "10395/Cb",
	[6041] = "1500/Cb",
	[3845] = "6558/Cb",
	[3854] = "14120/Cb",
	[3847] = "4977/Cb",
	[3856] = "14221/Cb",
	[7963] = "6488/Cb",
	[15871] = "625/Cb",
	[29202] = "600/Cb",
	[9060] = "1000/Cb",
	[7966] = "200/Cb",
	[7964] = "40/Cb",
	[7965] = "40/Cb",
	[11144] = "1000/Cb",
	[9366] = "3689/Cb",
	[7919] = "2476/Cb",
	[7918] = "3701/Cb",
	[7941] = "12520/Cb",
	[7921] = "5387/Cb",
	[7920] = "8053/Cb",
	[7924] = "4103/Cb",
	[7967] = "250/Cb",
	[7922] = "2377/Cb",
	[7942] = "14659/Cb",
	[7927] = "2987/Cb",
	[7926] = "5952/Cb",
	[7928] = "4857/Cb",
	[7943] = "15891/Cb",
	[7945] = "17291/Cb",
	[7930] = "7045/Cb",
	[7931] = "7955/Cb",
	[7933] = "5769/Cb",
	[7932] = "8661/Cb",
	[7969] = "250/Cb",
	[7944] = "20092/Cb",
	[7934] = "5790/Cb",
	[7946] = "21660/Cb",
	[12405] = "9239/Cb",
	[12406] = "4636/Cb",
	[12644] = "200/Cb",
	[12404] = "75/Cb",
	[12643] = "75/Cb",
	[7947] = "24892/Cb",
	[12408] = "4998/Cb",
	[11606] = "19255/Cb",
	[12416] = "7595/Cb",
	[11608] = "45760/Cb",
	[12424] = "5533/Cb",
	[12428] = "8646/Cb",
	[12624] = "20642/Cb",
	[11605] = "10776/Cb",
	[12425] = "6044/Cb",
	[12415] = "17003/Cb",
	[11607] = "51225/Cb",
	[12774] = "36044/Cb",
	[15872] = "625/Cb",
	[12773] = "33079/Cb",
	[12645] = "500/Cb",
	[16206] = "1000/Cb",
	[12777] = "38648/Cb",
	[12776] = "48124/Cb",
	[12775] = "39949/Cb",
	[12409] = "10336/Cb",
	[12410] = "10372/Cb",
	[11604] = "19428/Cb",
	[12628] = "16640/Cb",
	[12781] = "42721/Cb",
	[12418] = "10242/Cb",
	[12782] = "56808/Cb",
	[12631] = "8919/Cb",
	[19051] = "9365/Cb",
	[19043] = "13291/Cb",
	[12419] = "16421/Cb",
	[12792] = "39255/Cb",
	[17014] = "12637/Cb",
	[16989] = "18610/Cb",
	[17193] = "122310/Cb",
	[12632] = "14099/Cb",
	[12426] = "12062/Cb",
	[12427] = "12106/Cb",
	[12417] = "17034/Cb",
	[19166] = "46447/Cb",
	[22194] = "33521/Cb",
	[19167] = "116531/Cb",
	[19168] = "102890/Cb",
	[20039] = "31709/Cb",
	[19164] = "22425/Cb",
	[19148] = "25399/Cb",
	[17013] = "26441/Cb",
	[19170] = "103689/Cb",
	[16988] = "31460/Cb",
	[22671] = "60635/Cb",
	[22669] = "119683/Cb",
	[22670] = "60406/Cb",
	[12641] = "43836/Cb",
	[22198] = "67440/Cb",
	[12640] = "21894/Cb",
	[19169] = "129112/Cb",
	[22191] = "73128/Cb",
	[22384] = "80554/Cb",
	[22383] = "80019/Cb",
	[12639] = "15271/Cb",
	[22196] = "48043/Cb",
	[22385] = "25276/Cb",
	[12798] = "57150/Cb",
	[12790] = "74619/Cb",
	[12784] = "73036/Cb",
	[19690] = "39683/Cb",
	[19692] = "19980/Cb",
	[19691] = "29675/Cb",
	[17016] = "63973/Cb",
	[17015] = "63738/Cb",
	[20550] = "23051/Cb",
	[20549] = "11484/Cb",
	[20551] = "17352/Cb",
	[19693] = "24192/Cb",
	[19694] = "23555/Cb",
	[19695] = "18285/Cb",
	[12618] = "23972/Cb",
	[12620] = "17245/Cb",
	[12619] = "24058/Cb",
	[12797] = "56943/Cb",
	[19057] = "11606/Cb",
	[12796] = "70912/Cb",
	[12783] = "58215/Cb",
	[22197] = "14282/Cb",
	[19048] = "28061/Cb",
	[12636] = "24285/Cb",
	[22764] = "15864/Cb",
	[22762] = "31492/Cb",
	[22763] = "15806/Cb",
	[22195] = "22752/Cb",
	[12794] = "56304/Cb",
	[12633] = "14859/Cb",
	[18262] = "1250/Cb",
	[29203] = "10000/Cb",
	[23493] = "27683/Cb",
	[23482] = "20269/Cb",
	[12422] = "16204/Cb",
	[12429] = "17923/Cb",
	[12420] = "25330/Cb",
	[12613] = "18205/Cb",
	[12611] = "12293/Cb",
	[12612] = "12956/Cb",
	[12614] = "18272/Cb",
	[12610] = "12247/Cb",
	[12414] = "17376/Cb",
	[25843] = "8000/Cb",
	[23528] = "750/Cb",
	[28420] = "750/Cb",
	[23484] = "20969/Cb",
	[23491] = "18866/Cb",
	[23497] = "58164/Cb",
	[23494] = "19615/Cb",
	[23498] = "8813/Cb",
	[23487] = "33419/Cb",
	[23488] = "44805/Cb",
	[23490] = "39760/Cb",
	[23499] = "795830/Cb",
	[23502] = "82647/Cb",
	[23489] = "47475/Cb",
	[23559] = "750/Cb",
	[23503] = "85143/Cb",
	[23504] = "68364/Cb",
	[23506] = "28586/Cb",
	[23508] = "28793/Cb",
	[23505] = "70380/Cb",
	[23507] = "58548/Cb",
	--[29] = "0/Cb",
	[23575] = "1500/Cb",
	[29204] = "1223/Cb",
	[23515] = "29607/Cb",
	[23529] = "1000/Cb",
	[28421] = "1000/Cb",
	[25844] = "32000/Cb",
	[23576] = "3000/Cb",
	[23510] = "31529/Cb",
	[23511] = "47104/Cb",
	[23516] = "44599/Cb",
	[23509] = "62984/Cb",
	[23517] = "30311/Cb",
	[23518] = "60504/Cb",
	[23514] = "32234/Cb",
	[23524] = "31103/Cb",
	[23523] = "61628/Cb",
	[23530] = "12000/Cb",
	[23537] = "35904/Cb",
	[23539] = "36174/Cb",
	[23538] = "5282/Cb",
	[23555] = "13877/Cb",
	[23554] = "91813/Cb",
	[23542] = "103904/Cb",
	[23546] = "5395/Cb",
	[23531] = "29918/Cb",
	[23540] = "103139/Cb",
	[23543] = "130359/Cb",
	[23532] = "35238/Cb",
	[23556] = "101609/Cb",
	[23535] = "53053/Cb",
	[23541] = "129402/Cb",
	[23536] = "53248/Cb",
	[23544] = "104659/Cb",
	[23533] = "35369/Cb",
	[23534] = "45389/Cb",
	[23512] = "64163/Cb",
	[23519] = "45822/Cb",
	[23513] = "64391/Cb",
	[23525] = "46837/Cb",
	[23520] = "30896/Cb",
	[23521] = "46159/Cb",
	[23527] = "54020/Cb",
	[23522] = "61891/Cb",
	[31369] = "73884/Cb",
	[31371] = "55708/Cb",
	[31370] = "74152/Cb",
	[31364] = "72552/Cb",
	[31368] = "55107/Cb",
	[31367] = "73355/Cb",
	[25845] = "40000/Cb",
	[25521] = "1250/Cb",
	[7929] = "7739/Cb",
	[7936] = "6739/Cb",
	[7935] = "8368/Cb",
	[7937] = "6763/Cb",
	[7938] = "4028/Cb",
	[7939] = "10899/Cb",
	[30069] = "22391/Cb",
	[30070] = "19263/Cb",
	[30074] = "51597/Cb",
	[30076] = "44570/Cb",
	[28483] = "71734/Cb",
	[23563] = "67081/Cb",
	[28484] = "84902/Cb",
	[28485] = "98174/Cb",
	[23565] = "87849/Cb",
	[23564] = "75985/Cb",
	[7954] = "23159/Cb",
	[7961] = "25508/Cb",
	[7959] = "33857/Cb",
	[30071] = "32222/Cb",
	[30073] = "33297/Cb",
	[30072] = "32340/Cb",
	[7960] = "38548/Cb",
	[30088] = "97120/Cb",
	[30087] = "77416/Cb",
	[28434] = "133370/Cb",
	[28431] = "102808/Cb",
	[28432] = "117066/Cb",
	[28436] = "170435/Cb",
	[28435] = "151832/Cb",
	[28433] = "134904/Cb",
	[30093] = "101472/Cb",
	[30089] = "80037/Cb",
	[28437] = "107834/Cb",
	[28440] = "123276/Cb",
	[28441] = "140395/Cb",
	[28438] = "122767/Cb",
	[28439] = "124657/Cb",
	[28442] = "157642/Cb",
	[30086] = "96412/Cb",
	[30077] = "74563/Cb",
	[28425] = "100534/Cb",
	[28428] = "127089/Cb",
	[28427] = "128528/Cb",
	[28426] = "114486/Cb",
	[28429] = "144720/Cb",
	[28430] = "162480/Cb",
	[6290] = "1/Cc",
	[2679] = "5/Cc",
	[12224] = "10/Cc",
	[17197] = "10/Cc",
	[6888] = "10/Cc",
	[27635] = "6/Cc",
	[2681] = "6/Cc",
	[24105] = "6/Cc",
	[787] = "1/Cc",
	[30816] = "5/Cc",
	[2888] = "10/Cc",
	[5472] = "10/Cc",
	[2680] = "10/Cc",
	[5473] = "10/Cc",
	[17198] = "9/Cc",
	[5474] = "9/Cc",
	[6890] = "6/Cc",
	[27636] = "25/Cc",
	[5525] = "20/Cc",
	[2684] = "20/Cc",
	[5476] = "3/Cc",
	[724] = "25/Cc",
	[6316] = "3/Cc",
	[4592] = "1/Cc",
	[5095] = "3/Cc",
	[5477] = "18/Cc",
	[3220] = "40/Cc",
	[22645] = "25/Cc",
	[7676] = "30/Cc",
	[2683] = "25/Cc",
	[733] = "100/Cc",
	[3662] = "25/Cc",
	[2687] = "25/Cc",
	[21072] = "40/Cc",
	[2682] = "25/Cc",
	[6657] = "5/Cc",
	[5526] = "75/Cc",
	[5478] = "70/Cc",
	[3663] = "125/Cc",
	[4593] = "4/Cc",
	[5479] = "125/Cc",
	[1082] = "150/Cc",
	[1017] = "100/Cc",
	[3726] = "125/Cc",
	[3666] = "100/Cc",
	[5480] = "95/Cc",
	[2685] = "75/Cc",
	[3664] = "100/Cc",
	[5527] = "95/Cc",
	[3727] = "125/Cc",
	[12209] = "95/Cc",
	[3665] = "150/Cc",
	[20074] = "300/Cc",
	[3728] = "300/Cc",
	[4457] = "300/Cc",
	[12213] = "300/Cc",
	[6038] = "312/Cc",
	[10841] = "85/Cc",
	[13851] = "312/Cc",
	[12212] = "300/Cc",
	[31] = "0/Cc",
	[8364] = "6/Cc",
	[12214] = "300/Cc",
	[12210] = "300/Cc",
	[4594] = "6/Cc",
	[21217] = "125/Cc",
	[3729] = "300/Cc",
	[12217] = "300/Cc",
	[12215] = "300/Cc",
	[17222] = "300/Cc",
	[13927] = "8/Cc",
	[13930] = "5/Cc",
	[12218] = "300/Cc",
	[12216] = "300/Cc",
	[6887] = "5/Cc",
	[18045] = "300/Cc",
	[16766] = "100/Cc",
	[13928] = "8/Cc",
	[13929] = "10/Cc",
	[13931] = "12/Cc",
	[13932] = "12/Cc",
	[13935] = "10/Cc",
	[13933] = "14/Cc",
	[13934] = "18/Cc",
	[18254] = "18/Cc",
	[20452] = "250/Cc",
	[27661] = "150/Cc",
	[27651] = "150/Cc",
	[30155] = "150/Cc",
	[21023] = "250/Cc",
	[27662] = "150/Cc",
	[27655] = "150/Cc",
	[27663] = "150/Cc",
	[27656] = "150/Cc",
	[27657] = "150/Cc",
	[27664] = "150/Cc",
	[27665] = "150/Cc",
	[27666] = "150/Cc",
	[27658] = "150/Cc",
	[27660] = "150/Cc",
	[27659] = "150/Cc",
	[31673] = "150/Cc",
	[31672] = "150/Cc",
	[27667] = "150/Cc",
	[33052] = "0/Cc",
	[33053] = "0/Cc",
	[33048] = "0/Cc",
	[6218] = "24/Cn",
	[11287] = "104/Cn",
	[20744] = "100/Cn",
	[11288] = "466/Cn",
	[6339] = "24/Cn",
	[20745] = "1000/Cn",
	[11130] = "500/Cn",
	[11289] = "2148/Cn",
	[11290] = "3157/Cn",
	[20746] = "1000/Cn",
	[11145] = "1250/Cn",
	[12810] = "500/Cn",
	[12655] = "500/Cn",
	[20747] = "1000/Cn",
	[11811] = "1500/Cn",
	[20750] = "1000/Cn",
	[16207] = "1250/Cn",
	[20748] = "800/Cn",
	[20749] = "600/Cn",
	[22461] = "1250/Cn",
	[22521] = "1500/Cn",
	[22460] = "0/Cn",
	[22449] = "0/E",
	[22522] = "1500/Cn",
	[22459] = "0/Cn",
	[22462] = "32000/Cn",
	[22463] = "40000/Cn",
	[8067] = "0/Ce",
	[4357] = "4/Ce",
	[4358] = "30/Ce",
	[4359] = "12/Ce",
	[4360] = "60/Ce",
	[4362] = "187/Ce",
	[6219] = "144/Ce",
	[4361] = "120/Ce",
	[4405] = "125/Ce",
	[4363] = "50/Ce",
	[4364] = "12/Ce",
	[4365] = "75/Ce",
	[8068] = "0/Ce",
	[33] = "0/Ce",
	[4401] = "100/Ce",
	[4366] = "75/Ce",
	[4404] = "25/Ce",
	[4368] = "408/Ce",
	[6714] = "75/Ce",
	[6712] = "12/Ce",
	[4367] = "150/Ce",
	[4369] = "1179/Ce",
	[4371] = "200/Ce",
	[4370] = "175/Ce",
	[4406] = "600/Ce",
	[4372] = "1800/Ce",
	[4373] = "722/Ce",
	[4374] = "200/Ce",
	[7506] = "500/Ce",
	[8069] = "0/Ce",
	[4376] = "200/Ce",
	[4377] = "150/Ce",
	[4378] = "350/Ce",
	[21558] = "6/Ce",
	[21559] = "6/Ce",
	[21557] = "6/Ce",
	[4375] = "115/Ce",
	[4379] = "2357/Ce",
	[4381] = "600/Ce",
	[5507] = "600/Ce",
	[4380] = "500/Ce",
	[4383] = "3183/Ce",
	[4382] = "600/Ce",
	[4386] = "175/Ce",
	[4385] = "1410/Ce",
	[6533] = "62/Ce",
	[9312] = "12/Ce",
	[4388] = "1000/Ce",
	[4384] = "1000/Ce",
	[10558] = "250/Ce",
	[9313] = "12/Ce",
	[9318] = "12/Ce",
	[4387] = "400/Ce",
	[7148] = "21/Ce",
	[4403] = "2000/Ce",
	[4407] = "1200/Ce",
	[4389] = "750/Ce",
	[10499] = "2105/Ce",
	[4391] = "4000/Ce",
	[10498] = "16/Ce",
	[4390] = "500/Ce",
	[21589] = "12/Ce",
	[21590] = "12/Ce",
	[21592] = "12/Ce",
	[10505] = "250/Ce",
	[10507] = "350/Ce",
	[4393] = "2632/Ce",
	[4392] = "2500/Ce",
	[4852] = "300/Ce",
	[4394] = "750/Ce",
	[4397] = "5000/Ce",
	[4396] = "6000/Ce",
	[17716] = "7500/Ce",
	[4395] = "1600/Ce",
	[10559] = "750/Ce",
	[18588] = "200/Ce",
	[4398] = "900/Ce",
	[11590] = "250/Ce",
	[10560] = "1000/Ce",
	[10500] = "3478/Ce",
	[10508] = "8958/Ce",
	[10512] = "2/Ce",
	[10546] = "1500/Ce",
	[10721] = "3317/Ce",
	[10561] = "1000/Ce",
	[10514] = "750/Ce",
	[10501] = "4398/Ce",
	[10510] = "11369/Ce",
	[10518] = "4696/Ce",
	[10502] = "4088/Ce",
	[21571] = "25/Ce",
	[21569] = "0/Ce",
	[21574] = "25/Ce",
	[21576] = "25/Ce",
	[10506] = "5227/Ce",
	[10503] = "5169/Ce",
	[10562] = "750/Ce",
	[10548] = "2500/Ce",
	[10504] = "7770/Ce",
	[10513] = "5/Ce",
	[15992] = "250/Ce",
	[18641] = "500/Ce",
	[10576] = "6000/Ce",
	[15846] = "7500/Ce",
	[19026] = "250/Ce",
	[21277] = "1250/Ce",
	[18634] = "12500/Ce",
	[15995] = "19739/Ce",
	[15993] = "1500/Ce",
	[15994] = "2500/Ce",
	[18631] = "3000/Ce",
	[15996] = "2500/Ce",
	[15999] = "9002/Ce",
	[16004] = "29152/Ce",
	[18637] = "600/Ce",
	[21570] = "0/Ce",
	[7191] = "0/D",
	[21714] = "50/Ce",
	[21716] = "50/Ce",
	[21718] = "50/Ce",
	[16023] = "10000/Ce",
	[18594] = "3000/Ce",
	[16000] = "3750/Ce",
	[15997] = "10/Ce",
	[16005] = "1250/Ce",
	[16006] = "10000/Ce",
	[18638] = "12500/Ce",
	[16008] = "11739/Ce",
	[16009] = "5930/Ce",
	[18282] = "66347/Ce",
	[18168] = "56416/Ce",
	[16022] = "40000/Ce",
	[18283] = "25000/Ce",
	[19999] = "18639/Ce",
	[19998] = "23211/Ce",
	[16007] = "40625/Ce",
	[18639] = "12500/Ce",
	[16040] = "4000/Ce",
	[23781] = "500/Ce",
	[23736] = "2500/Ce",
	[23782] = "8000/Ce",
	[18232] = "10000/Ce",
	[23783] = "1500/Ce",
	[23821] = "15000/Ce",
	[23772] = "20/Ce",
	[23742] = "5538/Ce",
	[23774] = "30000/Ce",
	[23784] = "10000/Ce",
	[23737] = "2500/Ce",
	[23767] = "16179/Ce",
	[33092] = "0/Ce",
	[33093] = "0/Ce",
	[34504] = "25/Ce",
	[23764] = "2500/Ce",
	[23771] = "80/Ce",
	[32423] = "0/Ce",
	[25886] = "0/Ce",
	[23768] = "19489/Ce",
	[23758] = "29667/Ce",
	[23761] = "20534/Ce",
	[32478] = "0/Ce",
	[32494] = "0/Ce",
	[32461] = "0/Ce",
	[32476] = "0/Ce",
	[32472] = "0/Ce",
	[32475] = "0/Ce",
	[32480] = "0/Ce",
	[32495] = "0/Ce",
	[32474] = "0/Ce",
	[32473] = "0/Ce",
	[32479] = "0/Ce",
	[23762] = "25324/Ce",
	[23746] = "55725/Ce",
	[23819] = "0/Ce",
	[23787] = "12000/Ce",
	[23785] = "30000/Ce",
	[23786] = "12000/Ce",
	[23824] = "32734/Ce",
	[23747] = "62413/Ce",
	[23763] = "31774/Ce",
	[23765] = "2500/Ce",
	[32756] = "0/Ce",
	[23748] = "66312/Ce",
	[23766] = "20000/Ce",
	[23820] = "0/Ce",
	[32413] = "0/Ce",
	[23769] = "0/Ce",
	[10716] = "750/Ce",
	[10713] = "500/Ce",
	[11826] = "2500/Ce",
	[10545] = "3929/Ce",
	[10720] = "750/Ce",
	[10724] = "4696/Ce",
	[10725] = "1500/Ce",
	[10726] = "5520/Ce",
	[10645] = "750/Ce",
	[18986] = "5000/Ce",
	[18660] = "7500/Ce",
	[18645] = "1500/Ce",
	[23841] = "3000/Ce",
	[23835] = "22500/Ce",
	[23825] = "11565/Ce",
	[30544] = "5000/Ce",
	[23829] = "38321/Ce",
	[23828] = "30547/Ce",
	[10543] = "3517/Ce",
	[10542] = "5255/Ce",
	[10644] = "500/Ce",
	[10646] = "500/Ce",
	[11825] = "2500/Ce",
	[15] = "0/Ce",
	[16] = "0/Ce",
	[7189] = "4712/Ce",
	[10587] = "1500/Ce",
	[10586] = "750/Ce",
	[10727] = "2000/Ce",
	[10588] = "5834/Ce",
	[18984] = "5000/Ce",
	[18587] = "2000/Ce",
	[23826] = "3000/Ce",
	[23827] = "4000/Ce",
	[23836] = "4000/Ce",
	[30542] = "5000/Ce",
	[23838] = "29454/Ce",
	[23839] = "44345/Ce",
	[1251] = "10/Cf",
	[2581] = "20/Cf",
	[6452] = "28/Cf",
	[3530] = "28/Cf",
	[3531] = "57/Cf",
	[6453] = "62/Cf",
	[6450] = "200/Cf",
	[6451] = "400/Cf",
	[8544] = "400/Cf",
	[8545] = "600/Cf",
	[14529] = "500/Cf",
	[14530] = "1000/Cf",
	[19440] = "500/Cf",
	[21990] = "1500/Cf",
	[21991] = "2250/Cf",
	[20906] = "250/Cj",
	[21931] = "250/Cj",
	[20816] = "20/Cj",
	[25498] = "25/Cj",
	[21932] = "250/Cj",
	[25438] = "750/Cj",
	[25439] = "250/Cj",
	[20821] = "1064/Cj",
	[21934] = "1500/Cj",
	[20818] = "625/Cj",
	[20907] = "300/Cj",
	[21933] = "750/Cj",
	[20817] = "100/Cj",
	[25880] = "150/Cj",
	[20820] = "1064/Cj",
	[30804] = "1064/Cj",
	[20823] = "837/Cj",
	[30419] = "750/Cj",
	[31154] = "750/Cj",
	[20827] = "875/Cj",
	[20826] = "2207/Cj",
	[20828] = "677/Cj",
	[30420] = "677/Cj",
	[20830] = "1535/Cj",
	[20909] = "1010/Cj",
	[25881] = "25/Cj",
	[20832] = "1800/Cj",
	[20950] = "1535/Cj",
	[20954] = "5681/Cj",
	[20833] = "54/Cj",
	[20955] = "665/Cj",
	[20958] = "1130/Cj",
	[20831] = "1535/Cj",
	[20963] = "900/Cj",
	[20966] = "3482/Cj",
	[20960] = "1720/Cj",
	[20959] = "1720/Cj",
	[25882] = "1000/Cj",
	[29157] = "1500/Cj",
	[20961] = "21633/Cj",
	[20967] = "3482/Cj",
	[29158] = "1750/Cj",
	[21756] = "1500/Cj",
	[21748] = "1500/Cj",
	[20964] = "6646/Cj",
	[21758] = "1500/Cj",
	[21755] = "1230/Cj",
	[20969] = "5989/Cj",
	[21760] = "1500/Cj",
	[25883] = "14087/Cj",
	[21752] = "1250/Cj",
	[30421] = "2542/Cj",
	[21763] = "1500/Cj",
	[21764] = "6420/Cj",
	[21765] = "2542/Cj",
	[21754] = "4307/Cj",
	[21753] = "5000/Cj",
	[21766] = "830/Cj",
	[21769] = "1500/Cj",
	[21767] = "8375/Cj",
	[30422] = "8375/Cj",
	[21774] = "1/Cj",
	[21768] = "12500/Cj",
	[29159] = "8375/Cj",
	[21775] = "8375/Cj",
	[21790] = "7767/Cj",
	[21777] = "3750/Cj",
	[21778] = "18662/Cj",
	[21791] = "14059/Cj",
	[29160] = "9125/Cj",
	[21784] = "15000/Cj",
	[21789] = "15000/Cj",
	[23113] = "10000/Cj",
	[23108] = "10000/Cj",
	[23098] = "10000/Cj",
	[23103] = "10000/Cj",
	[23118] = "10000/Cj",
	[23094] = "10000/Cj",
	[21792] = "25218/Cj",
	[23095] = "10000/Cj",
	[28595] = "10000/Cj",
	[23114] = "10000/Cj",
	[23104] = "10000/Cj",
	[23099] = "10000/Cj",
	[23109] = "10000/Cj",
	[23119] = "10000/Cj",
	[21779] = "21305/Cj",
	[24074] = "24491/Cj",
	[24075] = "24491/Cj",
	[23105] = "10000/Cj",
	[23100] = "10000/Cj",
	[23096] = "10000/Cj",
	[23110] = "10000/Cj",
	[23120] = "10000/Cj",
	[23115] = "10000/Cj",
	[24076] = "3769/Cj",
	[32772] = "0/Cj",
	[31079] = "10000/Cj",
	[23106] = "20000/Cj",
	[23097] = "10000/Cj",
	[23121] = "10000/Cj",
	[23101] = "10000/Cj",
	[32833] = "0/Cj",
	[23116] = "10000/Cj",
	[28290] = "10000/Cj",
	[23111] = "10000/Cj",
	[32774] = "0/Cj",
	[24078] = "16134/Cj",
	[24077] = "10715/Cj",
	[32508] = "0/Cj",
	[24087] = "37037/Cj",
	[31863] = "0/Cj",
	[24027] = "30000/Cj",
	[24031] = "30000/Cj",
	[24047] = "30000/Cj",
	[24065] = "30000/Cj",
	[24028] = "30000/Cj",
	[24062] = "30000/Cj",
	[24036] = "30000/Cj",
	[24050] = "30000/Cj",
	[24061] = "30000/Cj",
	[24056] = "30000/Cj",
	[31861] = "0/Cj",
	[31865] = "0/Cj",
	[24058] = "30000/Cj",
	[24067] = "30000/Cj",
	[24079] = "38775/Cj",
	[24060] = "30000/Cj",
	[24037] = "30000/Cj",
	[24053] = "0/Cj",
	[24059] = "4815/Cj",
	[32836] = "0/Cj",
	[24066] = "1767/Cj",
	[24051] = "500/Cj",
	[24057] = "3183/Cj",
	[24030] = "30000/Cj",
	[24055] = "30000/Cj",
	[24048] = "1433/Cj",
	[24033] = "30000/Cj",
	[24054] = "30000/Cj",
	[24035] = "30000/Cj",
	[24039] = "30000/Cj",
	[24032] = "30000/Cj",
	[24029] = "30000/Cj",
	[24052] = "30000/Cj",
	[31867] = "0/Cj",
	[31868] = "0/Cj",
	[24088] = "39122/Cj",
	[24080] = "39122/Cj",
	[24082] = "39122/Cj",
	[24110] = "39122/Cj",
	[24106] = "39122/Cj",
	[24114] = "39470/Cj",
	[24116] = "39470/Cj",
	[24085] = "39470/Cj",
	[24092] = "39470/Cj",
	[24097] = "39470/Cj",
	[24093] = "39470/Cj",
	[24098] = "39470/Cj",
	[24095] = "39470/Cj",
	[30825] = "37037/Cj",
	[24086] = "39818/Cj",
	[24089] = "39818/Cj",
	[25897] = "30000/Cj",
	[25899] = "30000/Cj",
	[24121] = "39818/Cj",
	[32776] = "0/Cj",
	[25890] = "30000/Cj",
	[24117] = "39818/Cj",
	[25895] = "4522/Cj",
	[25901] = "30000/Cj",
	[25893] = "30000/Cj",
	[25896] = "30000/Cj",
	[32409] = "0/Cj",
	[25894] = "30000/Cj",
	[25898] = "8226/Cj",
	[32410] = "0/Cj",
	[24123] = "30712/Cj",
	[24122] = "30597/Cj",
	[24125] = "15000/Cj",
	[24124] = "12000/Cj",
	[24126] = "2/Cj",
	[24128] = "15000/Cj",
	[24127] = "15000/Cj",
	[32213] = "0/Cj",
	[32193] = "0/Cj",
	[32197] = "0/Cj",
	[32204] = "0/Cj",
	[32225] = "0/Cj",
	[32194] = "0/Cj",
	[32223] = "0/Cj",
	[32199] = "0/Cj",
	[32207] = "0/Cj",
	[32220] = "0/Cj",
	[32215] = "0/Cj",
	[32210] = "0/Cj",
	[32214] = "0/Cj",
	[32217] = "0/Cj",
	[32226] = "0/Cj",
	[32219] = "0/Cj",
	[32202] = "0/Cj",
	[32209] = "0/Cj",
	[32218] = "0/Cj",
	[32224] = "0/Cj",
	[32216] = "0/Cj",
	[32196] = "0/Cj",
	[32212] = "0/Cj",
	[32205] = "0/Cj",
	[32200] = "0/Cj",
	[32211] = "0/Cj",
	[32201] = "0/Cj",
	[32203] = "0/Cj",
	[32198] = "0/Cj",
	[32195] = "0/Cj",
	[31398] = "60256/Cj",
	[31399] = "60256/Cj",
	[32208] = "0/Cj",
	[32221] = "0/Cj",
	[32222] = "0/Cj",
	[32206] = "0/Cj",
	[31862] = "0/Cj",
	[31860] = "0/Cj",
	[31864] = "0/Cj",
	[31866] = "0/Cj",
	[31869] = "0/Cj",
	[2302] = "29/Cl",
	[7277] = "28/Cl",
	[7276] = "34/Cl",
	[5957] = "40/Cl",
	[2304] = "15/Cl",
	[2318] = "15/SCl",
	[2303] = "71/Cl",
	[4237] = "34/Cl",
	[7278] = "25/Cl",
	[7279] = "25/Cl",
	[7280] = "162/Cl",
	[4231] = "110/Cl",
	[2300] = "192/Cl",
	[5081] = "250/Cl",
	[2309] = "268/Cl",
	[4239] = "71/Cl",
	[2310] = "112/Cl",
	[2311] = "150/Cl",
	[7281] = "84/Cl",
	[4242] = "347/Cl",
	[2312] = "181/Cl",
	[4246] = "125/Cl",
	[2308] = "267/Cl",
	[4243] = "461/Cl",
	[6466] = "413/Cl",
	[6709] = "545/Cl",
	[5780] = "156/Cl",
	[2307] = "243/Cl",
	[7282] = "599/Cl",
	[5781] = "601/Cl",
	[7283] = "519/Cl",
	[20575] = "743/Cl",
	[2317] = "689/Cl",
	[4244] = "723/Cl",
	[4233] = "200/Cl",
	[2315] = "307/Cl",
	[2313] = "200/Cl",
	[2319] = "50/S",
	[6467] = "420/Cl",
	[5958] = "829/Cl",
	[2316] = "408/Cl",
	[6468] = "658/Cl",
	[5961] = "1089/Cl",
	[4248] = "791/Cl",
	[4250] = "705/Cl",
	[7285] = "588/Cl",
	[7284] = "586/Cl",
	[2314] = "743/Cl",
	[4249] = "703/Cl",
	[7348] = "690/Cl",
	[4251] = "1199/Cl",
	[4253] = "962/Cl",
	[7352] = "1306/Cl",
	[7349] = "861/Cl",
	[4252] = "1457/Cl",
	[7358] = "885/Cl",
	[4255] = "2366/Cl",
	[7359] = "978/Cl",
	[4247] = "1049/Cl",
	[4254] = "1071/Cl",
	[7372] = "500/Cl",
	[7371] = "500/Cl",
	[4236] = "225/Cl",
	[4265] = "650/Cl",
	[4234] = "150/S",
	[18662] = "5/Cl",
	[3719] = "1027/Cl",
	[18948] = "1589/Cl",
	[4456] = "1553/Cl",
	[4455] = "3096/Cl",
	[4257] = "1311/Cl",
	[5962] = "2794/Cl",
	[7373] = "3097/Cl",
	[5963] = "3151/Cl",
	[4258] = "1592/Cl",
	[5782] = "3211/Cl",
	[4262] = "2652/Cl",
	[5964] = "2609/Cl",
	[7374] = "3760/Cl",
	[7375] = "3773/Cl",
	[4256] = "3477/Cl",
	[7377] = "2269/Cl",
	[4259] = "1934/Cl",
	[7378] = "2146/Cl",
	[5965] = "2536/Cl",
	[17721] = "2268/Cl",
	[7386] = "2387/Cl",
	[5783] = "2316/Cl",
	[5739] = "2738/Cl",
	[5966] = "1374/Cl",
	[7387] = "2587/Cl",
	[4260] = "2559/Cl",
	[18238] = "3321/Cl",
	[4264] = "2804/Cl",
	[8174] = "4131/Cl",
	[7390] = "4237/Cl",
	[7391] = "4253/Cl",
	[8172] = "500/Cl",
	[8173] = "1000/Cl",
	[4304] = "300/S",
	[8176] = "4495/Cl",
	[8175] = "5971/Cl",
	[8187] = "3477/Cl",
	[8192] = "4782/Cl",
	[8198] = "4013/Cl",
	[8189] = "7567/Cl",
	[8210] = "5537/Cl",
	[8200] = "7275/Cl",
	[8214] = "6230/Cl",
	[8211] = "8002/Cl",
	[8201] = "5350/Cl",
	[8205] = "4346/Cl",
	[8203] = "8628/Cl",
	[8217] = "1000/Cl",
	[8218] = "1000/Cl",
	[8204] = "4676/Cl",
	[8193] = "8708/Cl",
	[8191] = "7780/Cl",
	[8197] = "7158/Cl",
	[8209] = "8375/Cl",
	[8185] = "10952/Cl",
	[8213] = "8150/Cl",
	[8216] = "6323/Cl",
	[8202] = "9022/Cl",
	[8207] = "8978/Cl",
	[8215] = "9017/Cl",
	[8212] = "11585/Cl",
	[8206] = "12704/Cl",
	[8208] = "10272/Cl",
	[15407] = "500/Cl",
	[15564] = "1000/Cl",
	[8170] = "500/S",
	[15077] = "7615/Cl",
	[15045] = "19938/Cl",
	[15083] = "6872/Cl",
	[15074] = "6867/Cl",
	[15076] = "16604/Cl",
	[15084] = "7311/Cl",
	[15046] = "22482/Cl",
	[15067] = "12758/Cl",
	[15061] = "13803/Cl",
	[15091] = "7195/Cl",
	[15054] = "14559/Cl",
	[15057] = "18728/Cl",
	[15064] = "19717/Cl",
	[15073] = "11530/Cl",
	[15071] = "11443/Cl",
	[15078] = "9649/Cl",
	[15092] = "7656/Cl",
	[15072] = "16233/Cl",
	[15082] = "10375/Cl",
	[15093] = "8368/Cl",
	[15086] = "13154/Cl",
	[15048] = "24409/Cl",
	[15060] = "21277/Cl",
	[15056] = "20966/Cl",
	[15065] = "22233/Cl",
	[15069] = "17012/Cl",
	[15079] = "21760/Cl",
	[15053] = "17275/Cl",
	[15050] = "26071/Cl",
	[19052] = "17621/Cl",
	[15063] = "11701/Cl",
	[15066] = "23650/Cl",
	[19044] = "11116/Cl",
	[15075] = "18449/Cl",
	[15094] = "14155/Cl",
	[15087] = "17892/Cl",
	[16982] = "24397/Cl",
	[15049] = "20543/Cl",
	[15058] = "14692/Cl",
	[15070] = "9504/Cl",
	[15080] = "18230/Cl",
	[16984] = "32653/Cl",
	[18509] = "23006/Cl",
	[19157] = "31943/Cl",
	[19162] = "27831/Cl",
	[20380] = "52455/Cl",
	[18510] = "20889/Cl",
	[22665] = "50516/Cl",
	[22664] = "100642/Cl",
	[22666] = "50712/Cl",
	[19149] = "21248/Cl",
	[19163] = "27931/Cl",
	[16983] = "25709/Cl",
	[22663] = "46175/Cl",
	[22662] = "44851/Cl",
	[22661] = "89377/Cl",
	[18511] = "20971/Cl",
	[15052] = "31933/Cl",
	[15051] = "21736/Cl",
	[19688] = "31546/Cl",
	[19689] = "24082/Cl",
	[22761] = "19607/Cl",
	[22760] = "29302/Cl",
	[22759] = "29190/Cl",
	[18251] = "5000/Cl",
	[15062] = "25709/Cl",
	[18504] = "14126/Cl",
	[19058] = "21845/Cl",
	[15059] = "24776/Cl",
	[18506] = "21340/Cl",
	[15138] = "15198/Cl",
	[19687] = "15939/Cl",
	[19686] = "15270/Cl",
	[19685] = "29288/Cl",
	[15047] = "29836/Cl",
	[20476] = "16401/Cl",
	[20478] = "33917/Cl",
	[20477] = "16898/Cl",
	[20481] = "17139/Cl",
	[20479] = "34036/Cl",
	[20480] = "17078/Cl",
	[21278] = "13212/Cl",
	[18508] = "17194/Cl",
	[19049] = "15576/Cl",
	[25654] = "17436/Cl",
	[15068] = "21835/Cl",
	[15081] = "20261/Cl",
	[15090] = "22002/Cl",
	[15095] = "20885/Cl",
	[15096] = "17332/Cl",
	[25662] = "32525/Cl",
	[25669] = "14274/Cl",
	[15055] = "16019/Cl",
	[15085] = "22732/Cl",
	[15088] = "9901/Cl",
	[25673] = "21717/Cl",
	[25679] = "466/Cl",
	[25650] = "7500/Cl",
	[21887] = "1250/Cl",
	[25655] = "26106/Cl",
	[25661] = "29461/Cl",
	[25674] = "15897/Cl",
	[25670] = "32249/Cl",
	[25656] = "36782/Cl",
	[25668] = "24047/Cl",
	[25675] = "30530/Cl",
	[29540] = "30000/Cl",
	[25660] = "38316/Cl",
	[23793] = "6250/SCl",
	[25652] = "22500/Cl",
	[25651] = "22500/Cl",
	[25671] = "35070/Cl",
	[25676] = "32311/Cl",
	[29534] = "20000/Cl",
	[29533] = "20000/Cl",
	[25657] = "39930/Cl",
	[25659] = "62470/Cl",
	[25685] = "20771/Cl",
	[25694] = "25734/Cl",
	[25692] = "51110/Cl",
	[29488] = "15000/Cl",
	[29528] = "5000/Cl",
	[29485] = "15000/Cl",
	[29486] = "15000/Cl",
	[29487] = "15000/Cl",
	[29483] = "15000/Cl",
	[29530] = "5000/Cl",
	[29500] = "21281/Cl",
	[29499] = "31803/Cl",
	[29498] = "42245/Cl",
	[29497] = "31564/Cl",
	[29496] = "20965/Cl",
	[29495] = "41772/Cl",
	[29491] = "40049/Cl",
	[29490] = "26486/Cl",
	[29489] = "52781/Cl",
	[25686] = "32862/Cl",
	[25687] = "43976/Cl",
	[25695] = "24563/Cl",
	[29494] = "24968/Cl",
	[29493] = "40332/Cl",
	[29492] = "53353/Cl",
	[25693] = "36667/Cl",
	[25653] = "17500/Cl",
	[25681] = "66290/Cl",
	[25683] = "37986/Cl",
	[25682] = "31539/Cl",
	[25680] = "31300/Cl",
	[29531] = "5000/Cl",
	[25691] = "33726/Cl",
	[25690] = "44808/Cl",
	[25697] = "25155/Cl",
	[25696] = "50116/Cl",
	[25689] = "45010/Cl",
	[29503] = "24742/Cl",
	[29502] = "533/Cl",
	[29512] = "42922/Cl",
	[29506] = "25014/Cl",
	[29505] = "37384/Cl",
	[29508] = "45350/Cl",
	[29511] = "28381/Cl",
	[29510] = "42408/Cl",
	[29514] = "57415/Cl",
	[29504] = "37247/Cl",
	[29507] = "34308/Cl",
	[29509] = "30343/Cl",
	[29529] = "5000/Cl",
	[29536] = "40000/Cl",
	[29535] = "40000/Cl",
	[29532] = "5000/Cl",
	[8347] = "5979/Cl",
	[8367] = "18455/Cl",
	[29971] = "9022/Cl",
	[20296] = "12590/Cl",
	[20295] = "31083/Cl",
	[29975] = "79950/Cl",
	[29516] = "31638/Cl",
	[29517] = "31758/Cl",
	[29515] = "63043/Cl",
	[29520] = "32114/Cl",
	[29521] = "19896/Cl",
	[29519] = "34629/Cl",
	[8346] = "5363/Cl",
	[8348] = "10819/Cl",
	[29964] = "15290/Cl",
	[29973] = "38564/Cl",
	[29526] = "28074/Cl",
	[29527] = "28172/Cl",
	[29525] = "54518/Cl",
	[8345] = "7421/Cl",
	[8349] = "14478/Cl",
	[29970] = "1361/Cl",
	[29974] = "474/Cl",
	[29524] = "27169/Cl",
	[29523] = "19065/Cl",
	[29522] = "53924/Cl",
	[2840] = "10/Cs",
	[2841] = "50/Cs",
	[3576] = "35/Cs",
	[2842] = "100/Cs",
	[3575] = "200/Cs",
	[2] = "0/Cs",
	[3859] = "60/Cs",
	[3860] = "400/Cs",
	[4] = "0/Cs",
	[11371] = "600/Cs",
	[12359] = "600/Cs",
	[17771] = "0/Cs",
	[22573] = "400/MD",
	[22574] = "400/DM",
	[23445] = "2000/Cs",
	[23446] = "3000/Cs",
	[23447] = "2500/Cs",
	[23448] = "22500/Cs",
	[23449] = "12500/Cs",
	[23573] = "30000/Cs",
	[2996] = "40/Ct",
	[4344] = "11/Ct",
	[2570] = "11/Ct",
	[10045] = "23/Ct",
	[2576] = "75/Ct",
	[2568] = "31/Ct",
	[7026] = "22/Ct",
	[10046] = "32/Ct",
	[6238] = "98/Ct",
	[6241] = "99/Ct",
	[4343] = "60/Ct",
	[4307] = "29/Ct",
	[2572] = "99/Ct",
	[2577] = "75/Ct",
	[2575] = "25/Ct",
	[6786] = "59/Ct",
	[4238] = "200/Ct",
	[6240] = "161/Ct",
	[6239] = "160/Ct",
	[4308] = "45/Ct",
	[2580] = "67/Ct",
	[2569] = "87/Ct",
	[2578] = "224/Ct",
	[6242] = "243/Ct",
	[4309] = "226/Ct",
	[2579] = "37/Ct",
	[5762] = "250/Ct",
	[2997] = "100/Ct",
	[10047] = "164/Ct",
	[2584] = "142/Ct",
	[4312] = "237/Ct",
	[4240] = "300/Ct",
	[4310] = "180/Ct",
	[2582] = "216/Ct",
	[5542] = "370/Ct",
	[4313] = "416/Ct",
	[2583] = "359/Ct",
	[4241] = "450/Ct",
	[6263] = "589/Ct",
	[4311] = "475/Ct",
	[2587] = "200/Ct",
	[2585] = "638/Ct",
	[4316] = "743/Ct",
	[4314] = "331/Ct",
	[4330] = "250/Ct",
	[6787] = "466/Ct",
	[6264] = "884/Ct",
	[4332] = "500/Ct",
	[5763] = "700/Ct",
	[10048] = "935/Ct",
	[4315] = "425/Ct",
	[6384] = "250/Ct",
	[6385] = "250/Ct",
	[4320] = "979/Ct",
	[4331] = "526/Ct",
	[4317] = "1076/Ct",
	[4305] = "600/Ct",
	[4318] = "610/Ct",
	[4319] = "815/Ct",
	[5766] = "1338/Ct",
	[4333] = "1200/Ct",
	[7046] = "1494/Ct",
	[4321] = "1120/Ct",
	[7047] = "824/Ct",
	[7048] = "745/Ct",
	[4324] = "1874/Ct",
	[5770] = "1807/Ct",
	[7049] = "914/Ct",
	[4245] = "2000/Ct",
	[4322] = "1810/Ct",
	[7050] = "999/Ct",
	[6795] = "500/Ct",
	[7065] = "2398/Ct",
	[7051] = "2696/Ct",
	[4323] = "1999/Ct",
	[4334] = "550/Ct",
	[7052] = "1488/Ct",
	[7053] = "2240/Ct",
	[4325] = "2272/Ct",
	[7055] = "1503/Ct",
	[4339] = "1250/Ct",
	[5764] = "3000/Ct",
	[6796] = "750/Ct",
	[7056] = "2314/Ct",
	[7057] = "2323/Ct",
	[4328] = "1524/Ct",
	[4336] = "1500/Ct",
	[4326] = "2496/Ct",
	[5765] = "4000/Ct",
	[7058] = "2052/Ct",
	[4335] = "1500/Ct",
	[7054] = "4700/Ct",
	[7060] = "2791/Ct",
	[7059] = "2781/Ct",
	[17723] = "750/Ct",
	[7061] = "2017/Ct",
	[7062] = "2430/Ct",
	[10052] = "1500/Ct",
	[4327] = "3788/Ct",
	[4329] = "2120/Ct",
	[9999] = "4832/Ct",
	[9998] = "4815/Ct",
	[7063] = "4741/Ct",
	[10054] = "3000/Ct",
	[10001] = "5257/Ct",
	[7064] = "2569/Ct",
	[10002] = "5276/Ct",
	[10055] = "3000/Ct",
	[10003] = "2859/Ct",
	[10009] = "5284/Ct",
	[10007] = "5799/Ct",
	[10004] = "5738/Ct",
	[10008] = "4365/Ct",
	[10056] = "1500/Ct",
	[10034] = "2000/Ct",
	[10035] = "1735/Ct",
	[10019] = "3944/Ct",
	[10021] = "7946/Ct",
	[10030] = "6007/Ct",
	[10042] = "6644/Ct",
	[22246] = "2500/Ct",
	[10018] = "3275/Ct",
	[10023] = "3334/Ct",
	[10050] = "2500/Ct",
	[10040] = "1767/Ct",
	[10026] = "5459/Ct",
	[10024] = "5421/Ct",
	[10027] = "5479/Ct",
	[10025] = "6790/Ct",
	[10029] = "5391/Ct",
	[10028] = "5938/Ct",
	[10051] = "2500/Ct",
	[10053] = "4499/Ct",
	[10036] = "1741/Ct",
	[13868] = "9665/Ct",
	[10033] = "6075/Ct",
	[10031] = "6030/Ct",
	[10044] = "6765/Ct",
	[10041] = "7161/Ct",
	[14048] = "2000/Ct",
	[21154] = "1/Ct",
	[21542] = "1/Ct",
	[14342] = "4000/Ct",
	[13869] = "9702/Ct",
	[13856] = "5112/Ct",
	[14042] = "10561/Ct",
	[13858] = "10917/Ct",
	[13857] = "10878/Ct",
	[21340] = "5000/Ct",
	[14046] = "5000/Ct",
	[13870] = "5471/Ct",
	[14143] = "5763/Ct",
	[13860] = "8741/Ct",
	[14101] = "6066/Ct",
	[14100] = "12089/Ct",
	[14043] = "5955/Ct",
	[14142] = "6087/Ct",
	[14134] = "11280/Ct",
	[14103] = "9716/Ct",
	[22251] = "10000/Ct",
	[14044] = "9503/Ct",
	[22248] = "10000/Ct",
	[14107] = "13140/Ct",
	[14141] = "12859/Ct",
	[13863] = "6617/Ct",
	[14132] = "12441/Ct",
	[21341] = "20000/Ct",
	[14045] = "13480/Ct",
	[13871] = "13436/Ct",
	[13864] = "9553/Ct",
	[14140] = "16693/Ct",
	[18486] = "21683/Ct",
	[14139] = "15840/Ct",
	[14138] = "20042/Ct",
	[14136] = "17025/Ct",
	[14108] = "11112/Ct",
	[13865] = "13555/Ct",
	[19056] = "12941/Ct",
	[15802] = "11648/Ct",
	[14137] = "18113/Ct",
	[19047] = "9232/Ct",
	[14104] = "15484/Ct",
	[14111] = "10775/Ct",
	[14144] = "14374/Ct",
	[13866] = "11358/Ct",
	[18405] = "14744/Ct",
	[21342] = "80000/Ct",
	[16979] = "14901/Ct",
	[19165] = "45006/Ct",
	[16980] = "21365/Ct",
	[19156] = "34911/Ct",
	[18263] = "16911/Ct",
	[22658] = "53045/Ct",
	[22654] = "34846/Ct",
	[22652] = "69171/Ct",
	[22655] = "34973/Ct",
	[14146] = "14084/Ct",
	[14152] = "28815/Ct",
	[14153] = "28920/Ct",
	[14154] = "29028/Ct",
	[19059] = "17541/Ct",
	[19684] = "18915/Ct",
	[19683] = "25129/Ct",
	[19682] = "24872/Ct",
	[14156] = "40000/Ct",
	[18413] = "17070/Ct",
	[18407] = "11139/Ct",
	[22660] = "24601/Ct",
	[18408] = "11178/Ct",
	[19050] = "18758/Ct",
	[18409] = "11219/Ct",
	[20539] = "11908/Ct",
	[20537] = "17736/Ct",
	[20538] = "22703/Ct",
	[22757] = "24961/Ct",
	[22758] = "25051/Ct",
	[22756] = "33164/Ct",
	[22249] = "30000/Ct",
	[14106] = "18053/Ct",
	[14112] = "13509/Ct",
	[17] = "0/Cl",
	[18] = "0/Ct",
	[14155] = "20000/Ct",
	[13867] = "12570/Ct",
	[22252] = "30000/Ct",
	[14128] = "16093/Ct",
	[14130] = "12768/Ct",
	[21840] = "4000/Ct",
	[24268] = "100/Ct",
	[21850] = "12306/Ct",
	[21849] = "12261/Ct",
	[21841] = "10000/Ct",
	[21851] = "13059/Ct",
	[21842] = "8000/Ct",
	[21852] = "26926/Ct",
	[24269] = "100/Ct",
	[24273] = "20000/Ct",
	[24275] = "20000/Ct",
	[21853] = "21336/Ct",
	[21859] = "31883/Ct",
	[24270] = "30000/Ct",
	[21843] = "10000/Ct",
	[21854] = "29267/Ct",
	[21855] = "30091/Ct",
	[21844] = "8000/Ct",
	[21866] = "17197/Ct",
	[24251] = "16690/Ct",
	[24250] = "16626/Ct",
	[30831] = "25066/Ct",
	[24253] = "25223/Ct",
	[24252] = "25128/Ct",
	[30837] = "17088/Ct",
	[21860] = "24616/Ct",
	[21845] = "4000/Ct",
	[24272] = "4000/Ct",
	[24271] = "4000/Ct",
	[24249] = "16563/Ct",
	[24254] = "26001/Ct",
	[21863] = "20474/Ct",
	[21867] = "26309/Ct",
	[30838] = "17430/Ct",
	[21861] = "34308/Ct",
	[21862] = "34437/Ct",
	[24257] = "21095/Ct",
	[24256] = "21018/Ct",
	[24260] = "31984/Ct",
	[24258] = "31757/Ct",
	[21864] = "30824/Ct",
	[24255] = "20942/Ct",
	[24259] = "31869/Ct",
	[21868] = "35486/Ct",
	[30839] = "35267/Ct",
	[24267] = "29676/Ct",
	[24263] = "43100/Ct",
	[24276] = "50000/Ct",
	[24274] = "50000/Ct",
	[21865] = "41251/Ct",
	[24266] = "30889/Ct",
	[24262] = "42951/Ct",
	[32585] = "0/Ct",
	[32584] = "0/Ct",
	[24264] = "32440/Ct",
	[24261] = "42798/Ct",
	[21872] = "40000/Ct",
	[21876] = "50000/Ct",
	[21858] = "20000/Ct",
	[30463] = "0/Ct",
	[30464] = "0/Ct",
	[30465] = "0/Ct",
	[30460] = "0/Ct",
	[30461] = "0/Ct",
	[30459] = "0/Ct",
	[21873] = "22185/Ct",
	[21874] = "33398/Ct",
	[21875] = "41510/Ct",
	[21869] = "32801/Ct",
	[21870] = "32921/Ct",
	[21871] = "44055/Ct",
	[21846] = "21632/Ct",
	[21847] = "21712/Ct",
	[21848] = "43584/Ct",
	[2449] = "20/H",
	[765] = "10/H",
	[3371] = "4/V",
	[2447] = "10/H",
	[785] = "20/H",
	[3164] = "33/D",
	[2452] = "15/H",
	[2450] = "25/H",
	[5635] = "45/D",
	[6358] = "4/F",
	[6522] = "4/F",
	[3820] = "100/H",
	[2453] = "25/H",
	[3372] = "40/V",
	[3355] = "50/H",
	[1288] = "185/D",
	[6359] = "5/F",
	[3369] = "25/H",
	[3356] = "30/H",
	[3357] = "75/H",
	[3818] = "125/H",
	[4402] = "250/D",
	[3821] = "150/H",
	[5637] = "75/D",
	[3819] = "100/H",
	[3358] = "175/H",
	[4625] = "250/H",
	[9260] = "400/D",
	[8925] = "500/V",
	[8831] = "300/H",
	[9262] = "1000/MR",
	[7972] = "400/D",
	[3858] = "250/M175",
	[8838] = "60/H",
	[8153] = "5/H",
	[8836] = "95/H",
	[8845] = "375/H",
	[4342] = "2500/V",
	[8839] = "375/H",
	[8846] = "250/H",
	[13422] = "10/F",
	[13463] = "100/H",
	[13466] = "250/H",
	[12363] = "2000/M",
	[13464] = "100/H",
	[13465] = "150/H",
	[10620] = "250/M250",
	[13467] = "250/H",
	[10286] = "400/D",
	[7067] = "400/D",
	[11176] = "0/E",
	[7070] = "400/D",
	[12938] = "0/D",
	[19943] = "2000/D",
	[12804] = "2000/D",
	[13468] = "1000/H",
	[22785] = "500/H",
	[18256] = "6000/V",
	[7077] = "400/D",
	[22787] = "600/H",
	[22786] = "500/H",
	[22789] = "500/H",
	[22578] = "400/DF",
	[22790] = "750/H",
	[22791] = "1000/H",
	[22792] = "1250/H",
	[22794] = "10000/H",
	[23079] = "10000/DMR",
	[23107] = "10000/DMR",
	[23112] = "10000/DMR",
	[23077] = "10000/DMR",
	[21929] = "10000/DMR",
	[23117] = "10000/DMR",
	[22793] = "2500/H",
	[2835] = "2/M",
	[2589] = "13/D",
	[2880] = "100/V",
	[774] = "15/DMR",
	[2321] = "100/V",
	[818] = "100/DMR",
	[2836] = "15/M65",
	[2592] = "33/D",
	[1210] = "250/DMR",
	[3466] = "2000/V",
	[5498] = "200/DG",
	[2838] = "60/M125",
	[1206] = "400/DMR",
	[5500] = "750/DG",
	[1705] = "600/DMR",
	[2605] = "100/V",
	[3864] = "800/DMR",
	[1529] = "700/DMR",
	[7069] = "400/D",
	[7912] = "100/M175",
	[4306] = "150/D",
	[4338] = "250/D",
	[7909] = "1000/DMR",
	[7971] = "1000/DG",
	[7075] = "400/D",
	[12361] = "7000/DMR",
	[11188] = "0/G",
	[11186] = "0/G",
	[12365] = "250/M250",
	[14047] = "400/D",
	[7910] = "5000/DMR",
	[11184] = "0/G",
	[12364] = "10000/DMR",
	[12799] = "7000/DMR",
	[12800] = "10000/DMR",
	[11185] = "0/G",
	[12662] = "600/D",
	[12811] = "20000/D",
	[17010] = "2000/D",
	[17011] = "2000/D",
	[17203] = "100000/D",
	[11382] = "750/DMR",
	[22203] = "5000/DM",
	[22202] = "2500/DM",
	[12809] = "10000/D",
	[17012] = "1000/S315",
	[22682] = "20000/D",
	[8146] = "500/D",
	[20520] = "2000/D",
	[15417] = "500/S",
	[12753] = "0/D",
	[20725] = "0/E",
	[19774] = "5000/DMR",
	[19726] = "500/H",
	[11754] = "0/DMR",
	[8168] = "100/D",
	[21877] = "800/D",
	[22445] = "0/E",
	[23572] = "16000/D",
	[30183] = "20000/D",
	[32428] = "0/D",
	[22450] = "0/E",
	[7081] = "400/D",
	[4470] = "34/V",
	[6291] = "1/F",
	[2672] = "4/D",
	[12223] = "4/D",
	[2678] = "2/V",
	[6889] = "4/D",
	[17194] = "10/V",
	[27668] = "5/D",
	[769] = "3/D",
	[23676] = "5/D",
	[6303] = "1/F",
	[30817] = "1/V",
	[2886] = "5/D",
	[2894] = "12/V",
	[5465] = "3/D",
	[5466] = "8/D",
	[1179] = "6/VD",
	[17196] = "12/V",
	[5467] = "7/D",
	[3173] = "15/D",
	[27669] = "5/D",
	[5503] = "16/DG",
	[159] = "5/V",
	[2673] = "10/D",
	[5468] = "12/D",
	[723] = "15/D",
	[6317] = "2/F",
	[6289] = "1/F",
	[6361] = "2/F",
	[5469] = "9/D",
	[4536] = "5/V",
	[3172] = "18/D",
	[3174] = "16/D",
	[22644] = "12/D",
	[2674] = "12/D",
	[729] = "17/D",
	[730] = "16/D",
	[731] = "27/D",
	[2924] = "16/D",
	[2677] = "15/D",
	[21071] = "25/F",
	[2675] = "11/D",
	[5051] = "1/D",
	[1468] = "28/D",
	[2692] = "40/V",
	[6308] = "2/F",
	[5470] = "28/D",
	[1081] = "50/D",
	[1080] = "78/D",
	[1015] = "24/D",
	[2665] = "20/V",
	[3730] = "45/D",
	[2251] = "12/D",
	[5471] = "30/D",
	[3667] = "25/D",
	[5504] = "22/DG",
	[3731] = "55/D",
	[3685] = "71/D",
	[3713] = "160/V",
	[3404] = "181/D",
	[12037] = "87/D",
	[4655] = "71/DG",
	[12203] = "87/D",
	[12202] = "87/D",
	[8365] = "4/D",
	[2596] = "120/V",
	[12184] = "87/D",
	[6362] = "4/F",
	[21153] = "125/D",
	[3712] = "87/D",
	[12204] = "112/D",
	[12205] = "112/D",
	[13754] = "6/F",
	[13758] = "4/F",
	[12207] = "150/D",
	[12206] = "112/D",
	[4603] = "4/F",
	[12208] = "150/D",
	[7974] = "50/DG",
	[13755] = "7/F",
	[13756] = "9/F",
	[13759] = "10/F",
	[13760] = "10/F",
	[13889] = "5/F",
	[13888] = "12/F",
	[13893] = "15/F",
	[18255] = "15/G",
	[20424] = "175/D",
	[27422] = "8/D",
	[27671] = "200/D",
	[24477] = "100/D",
	[8150] = "250/D",
	[21024] = "0/D",
	[27425] = "8/D",
	[27674] = "200/D",
	[27429] = "914/D",
	[27676] = "200/D",
	[27677] = "200/D",
	[27435] = "8/D",
	[27437] = "8/D",
	[27438] = "8/D",
	[27678] = "200/D",
	[27682] = "200/D",
	[27681] = "200/D",
	[31671] = "200/D",
	[31670] = "200/D",
	[27439] = "8/D",
	[27515] = "0/D",
	[4539] = "0/D",
	[27516] = "0/D",
	[2593] = "0/D",
	[6217] = "124/V",
	[10940] = "0/E",
	[10938] = "0/E",
	[17034] = "200/V",
	[10939] = "0/E",
	[10978] = "0/E",
	[10998] = "0/E",
	[11083] = "0/E",
	[11082] = "0/E",
	[11084] = "0/E",
	[2772] = "150/M125",
	[11291] = "4050/V",
	[11134] = "0/E",
	[11138] = "0/E",
	[11135] = "0/E",
	[11137] = "0/E",
	[11139] = "0/E",
	[17035] = "400/V",
	[7392] = "200/S",
	[11174] = "0/E",
	[11177] = "0/E",
	[11175] = "0/E",
	[11178] = "0/E",
	[16202] = "0/E",
	[14343] = "0/E",
	[7079] = "400/D",
	[16204] = "0/E",
	[16203] = "0/E",
	[13926] = "10000/DG",
	[14344] = "0/E",
	[22447] = "0/E",
	[22448] = "0/ECn",
	[22446] = "0/E",
	[4399] = "200/V",
	[4400] = "2000/V",
	[814] = "25/D",
	[6530] = "100/VD",
	[4611] = "50/G",
	[17202] = "0/DC",
	[10285] = "1000/D",
	[14227] = "2500/D",
	[23436] = "30000/MRD",
	[23438] = "30000/MRD",
	[23440] = "30000/MRD",
	[23439] = "30000/MRD",
	[23437] = "30000/MRD",
	[23441] = "30000/MRD",
	[2604] = "50/V",
	[6260] = "50/V",
	[8151] = "250/D",
	[10648] = "500/V",
	[10647] = "2000/V",
	[4337] = "750/D",
	[10577] = "2000/Ce",
	[17020] = "250/V",
	[1475] = "82/D",
	[19441] = "1500/D",
	[8152] = "500/D",
	[18335] = "2520/D",
	[24478] = "0/D",
	[24243] = "2250/RD",
	[27860] = "0/D",
	[24479] = "0/D",
	[32230] = "0/DMV",
	[32227] = "0/DMV",
	[32229] = "0/DMV",
	[32249] = "0/DMV",
	[32231] = "0/DMV",
	[32228] = "0/DMV",
	[2320] = "10/V",
	[2934] = "7/S",
	[783] = "50/S",
	[4289] = "50/V",
	[5082] = "25/D",
	[2324] = "25/V",
	[6470] = "20/DS",
	[5784] = "75/D",
	[7286] = "25/S",
	[4340] = "350/V",
	[4232] = "125/S",
	[6471] = "500/DS",
	[7287] = "100/S",
	[5116] = "303/D",
	[3182] = "387/D",
	[5373] = "72/P",
	[4235] = "200/S",
	[4461] = "208/S",
	[2325] = "1000/V",
	[5785] = "500/D",
	[4291] = "500/V",
	[7428] = "250/S",
	[8343] = "2000/V",
	[4096] = "608/D",
	[8169] = "500/S",
	[8167] = "100/S",
	[8154] = "250/S",
	[8171] = "500/S",
	[15409] = "1000/Cl",
	[15408] = "500/S",
	[14341] = "4500/V",
	[15412] = "500/S",
	[15423] = "500/S",
	[15420] = "100/D",
	[15419] = "600/S",
	[15422] = "500/S",
	[15415] = "500/S",
	[15416] = "1000/S",
	[12607] = "8048/D",
	[15414] = "1500/S",
	[20381] = "5000/S315",
	[18512] = "4000/D",
	[19768] = "2000/S",
	[15410] = "5000/S315",
	[19767] = "2000/S",
	[20501] = "2000/S",
	[20498] = "1000/D",
	[20500] = "2000/S",
	[25700] = "1250/S",
	[18240] = "0/S",
	[14256] = "2000/D",
	[25649] = "250/S",
	[25708] = "750/S",
	[29539] = "1250/S",
	[25707] = "6250/S",
	[25699] = "1250/S",
	[25703] = "100/S",
	[29548] = "2000/S",
	[29547] = "1250/S",
	[8165] = "500/S",
	[8368] = "1000/S",
	[2770] = "5/M",
	[2771] = "25/M65",
	[2775] = "75/M75",
	[2776] = "500/M55",
	[3857] = "500/VD",
	[7911] = "500/M230",
	[11370] = "500/M275",
	[18562] = "0/D",
	[18567] = "0/D",
	[23424] = "1000/M",
	[23425] = "1500/M",
	[23427] = "1250/M",
	[23426] = "2500/M",
	[4341] = "500/V",
	[7072] = "150/D",
	[6261] = "1000/V",
	[10290] = "2500/V",
	[4589] = "530/D",
	[11040] = "1/DMH",
	[21881] = "5000/D",
	[21882] = "2500/D",
	[21927] = "125/Cp",
	[3776] = "175/Cp",
	[22053] = "150/Cp",
	[12625] = "22847/Cb",
	[8927] = "100/Cp",
--	[5530] = "125/Cp",
	[10918] = "42/Cp",
	[12772] = "38871/Cb",
	[5173] = "100/V",
	[6949] = "20/Cp",
	[2928] = "20/V",
	[8928] = "125/Cp",
	[6947] = "5/Cp",
	[21835] = "125/Cp",
	[22055] = "175/Cp",
	[22728] = "1879/Ce",
	[5237] = "18/Cp",
	[2931] = "250/V",
	[10922] = "175/Cp",
	[3777] = "40/V",
	[8985] = "150/Cp",
	[10921] = "125/Cp",
	[20844] = "150/Cp",
	[8984] = "100/Cp",
	[6950] = "30/Cp",
	[3775] = "13/Cp",
	[18258] = "0/Cl",
	[8923] = "180/V",
	[22054] = "150/Cp",
	[2930] = "50/V",
	[6951] = "75/Cp",
	[2893] = "55/Cp",
	[9186] = "175/Cp",
	[2892] = "30/Cp",
	[8924] = "100/V",
	[10920] = "67/Cp",
	[8926] = "75/Cp",
--new
	[30038] = "0/Ct",
	[30040] = "0/Cl",
	[30042] = "0/Cl",
	[30046] = "0/Cl",
	[30036] = "0/Ct",
	[30037] = "0/Ct",
	[30041] = "0/Cl",
	[30045] = "0/Cl",
	[30035] = "0/Ct",
	[30043] = "0/Cl",
	[30044] = "0/Cl",
	[30034] = "0/Cb",
	[30033] = "0/Cb",
	[30032] = "0/Cb",
	[30031] = "0/Cb",
	[32199] = "0/Cj",
	[32210] = "0/Cj",
	[32217] = "0/Cj",
	[32209] = "0/Cj",
	[32212] = "0/Cj",
	[32211] = "0/Cj",
	[32203] = "0/Cj",
	[32221] = "0/Cj",
	[32574] = "0/Cl",
	[32579] = "0/Cl",
	[32587] = "0/Ct",
	[32583] = "0/Cl",
	[32580] = "0/Cl",
	[32573] = "0/Cb",
	[32568] = "0/Cb",
	[32586] = "0/Ct",
	[32582] = "0/Cl",
	[32577] = "0/Cl",
	[32583] = "0/Cl",
	[32575] = "0/Cl",
	[32581] = "0/Cl",
	[32571] = "0/Cb",
	[32570] = "0/Cb",
	[30039] = "0/Cl",
	[32398] = "0/Cl",
	[32399] = "0/Cl",
	[32400] = "0/Cl",
	[32397] = "0/Cl",
	[32393] = "0/Cl",
	[32396] = "0/Cl",
	[32394] = "0/Cl",
	[32395] = "0/Cl",
	[32420] = "0/Ct",
	[32392] = "0/Ct",
	[32390] = "0/Ct",
	[32389] = "0/Ct",
	[32391] = "0/Ct",
	[32403] = "0/Cb",
	[32401] = "0/Cb",
	[32404] = "0/Cb",
	[32402] = "0/Cb",
	[33173] = "0/Cb",
	[32213] = "0/Cj",
	[32193] = "0/Cj",
	[32197] = "0/Cj",
	[32204] = "0/Cj",
	[32225] = "0/Cj",
	[32194] = "0/Cj",
	[32223] = "0/Cj",
	[32207] = "0/Cj",
	[32220] = "0/Cj",
	[32215] = "0/Cj",
	[32214] = "0/Cj",
	[32226] = "0/Cj",
	[32219] = "0/Cj",
	[32202] = "0/Cj",
	[32218] = "0/Cj",
	[32224] = "0/Cj",
	[32206] = "0/Cj",
	[32216] = "0/Cj",
	[32196] = "0/Cj",
	[32205] = "0/Cj",
	[32200] = "0/Cj",
	[32201] = "0/Cj",
	[32198] = "0/Cj",
	[32195] = "0/Cj",
	[32208] = "0/Cj",
	[32222] = "0/Cj",
	[33140] = "0/Cj",
	[33131] = "0/Cj",
	[33133] = "0/Cj",
	[33144] = "0/Cj",
	[33135] = "0/Cj",
	[33134] = "0/Cj",
	[33143] = "0/Cj",
   	[-42620] = "0/Cn",
	[-42613] = "0/Cn",
	[33204] = "0/Cl",
	[33122] = "0/Cl",
	[33208] = "0/Ca",
	[7191] = "0/CeD",
	[33782] = "0/Cj",
	[17056] = "0/D",
	[25719] = "0/D",
	[34249] = "0/D",
	[27503] = "0/DV",
	[34220] = "0/Cj",
	[33867] = "0/Cc",
	[33924] = "0/Cc",
	[34411] = "0/Cc",
	[33874] = "0/Cc",
	[33825] = "0/Cc",
	[33872] = "0/Cc",
	[33866] = "0/Cc",
	[34060] = "0/Ce",
	[34061] = "0/Ce",
	[34113] = "0/Ce",
	[20475] = "0/Ce",
	[34440] = "0/Ca",
	[-42974] = "0/Cn",
	[-44383] = "0/Cn",
	[32854] = "0/Cb",
	[33185] = "0/Cb",
	[33791] = "0/Cb",
	[34207] = "0/Cb",
	[34099] = "0/Cl",
	[34100] = "0/Cl",
	[34105] = "0/Cl",
	[34106] = "0/Cl",
	[34490] = "0/Cl",
	[34482] = "0/Cl",
	[34086] = "0/Cl",
	[34087] = "0/Ct",
	[34085] = "0/Ct",
	[34330] = "0/Cl",
	[33823] = "0/F",
	[34412] = "0/Q",
	[33824] = "0/F",
	[13757] = "0/F",
	[34360] = "0/Cj",
	[34361] = "0/Cj",
	[34358] = "0/Cj",
	[34359] = "0/Cj",
	[34362] = "0/Cj",
	[34363] = "0/Cj",
	[34369] = "0/Cl",
	[34373] = "0/Cl",
	[34374] = "0/Cl",
	[34370] = "0/Ct",
	[34367] = "0/Ct",
	[34371] = "0/Cl",
	[34372] = "0/Cl",
	[34365] = "0/Ct",
	[34375] = "0/Cl",
	[34376] = "0/Cl",
	[34366] = "0/Ct",
	[34364] = "0/Ct",
	[34378] = "0/Cb",
	[34377] = "0/Cb",
	[34379] = "0/Cb",
	[34380] = "0/Cb",
	[34847] = "0/Ce",
	[34357] = "0/Ce",
	[35182] = "0/Ce",
	[35185] = "0/Ce",
	[34355] = "0/Ce",
	[34354] = "0/Ce",
	[35181] = "0/Ce",
	[35184] = "0/Ce",
	[34353] = "0/Ce",
	[34356] = "0/Ce",
	[35183] = "0/Ce",
	[34832] = "0/Cc",
	[35503] = "0/Cj",
	[35501] = "0/Cj",
	[35563] = "0/Cc",
	[35565] = "0/Cc",
   	[35128] = "0/Cs",
	[35759] = "0/Cj",
	[35761] = "0/Cj",
	[35760] = "0/Cj",
	[35758] = "0/Cj",
	[35581] = "0/Cj",
	[35700] = "0/Cj",
	[35693] = "0/Cj",
	[35694] = "0/Cj",
	[35703] = "0/Cj",
	[35702] = "0/Cj",
	[35707] = "0/Cj",
	[35751] = "0/Cj",
	[35748] = "0/Cj",
	[35750] = "0/Cj",
	[35749] = "0/Cj",
	[34664] = "0/D",
	[35562] = "0/D",
	[35318] = "0/Cj",
	[35315] = "0/Cj",
	[35316] = "0/Cj",
--~ [[New in 3.0.2]]
	-- New components
	-- TODO: Check price on Frozen Orb
	[43102] = "100/DV",
	-- Inscription (Pigment)
	[39151] = "25/I",
	[39334] = "25/I",
	[39338] = "25/I",
	[43103] = "25/I",
	[39339] = "25/I",
	[43104] = "25/I",
	[39340] = "25/I",
	[43105] = "25/I",
	[39341] = "25/I",
	[43106] = "25/I",
	[39342] = "25/I",
	[43107] = "25/I",
	[39343] = "25/I",
	[43108] = "25/I",
	[43109] = "25/I",
	-- Inscription (Parchment)
	[39354] = "3/V",
	[10648] = "31/V",
	[39501] = "312/V",
	[39502] = "1250/V",
	-- Insciption (Ink)
	[37101] = "12/Ci",
	[39469] = "5/Ci",
	[39774] = "750/Ci",
	[43115] = "500/Ci",
	[43116] = "500/Ci",
	[43117] = "500/Ci",
	[43118] = "500/Ci",
   	[43119] = "500/Ci",
	[43120] = "500/Ci",
	[43121] = "500/Ci",
	[43122] = "500/Ci",
	[43123] = "500/Ci",
	[43124] = "500/Ci",
	[43125] = "500/Ci",
	[43126] = "500/Ci",
	[43127] = "500/Ci",
	-- Insciption (Enchant)
	[38682] = "0/Ci",
	[39349] = "0/Ci",
	[37602] = "0/Ci",
	[39350] = "0/Ci",
	[43145] = "0/Ci",
	[43146] = "0/Ci",
	-- Inscription (Scrolls)
	-- TODO: Prices for scrolls VII and VIII, plus Recall III
	[1180] = "37/DVCi",
	[3012] = "50/DVCi",
	[955] = "37/DVCi",
	[1181] = "25/DVCi",
	[954] = "50/DVCi",
	[37118] = "37/DVCi",
	[2290] = "75/DVCi",
	[1712] = "62/DVCi",
	[1711] = "75/DVCi",
	[2289] = "87/DVCi",
	[1477] = "87/DVCi",
	[4422] = "112/DVCi",
	[4424] = "100/DVCi",
	[4419] = "112/DVCi",
	[4426] = "125/DVCi",
	[4425] = "125/DVCi",
	[44314] = "37/DVCi",
	[10306] = "100/DVCi",
	[10308] = "112/DVCi",
	[10310] = "125/DVCi",
	[10309] = "125/DVCi",
	[10307] = "125/DVCi",
	[27502] = "112/DVCi",
	[27501] = "100/DVCi",
	[27499] = "112/DVCi",
	[27503] = "125/DVCi",
	[27498] = "125/DVCi",
	[33461] = "270/DVCi",
	[33460] = "247/DVCi",
	[33458] = "270/DVCi",
	[33462] = "225/DVCi",
	[33457] = "225/DVCi",
	[37093] = "999999/Ci",
	[37097] = "999999/Ci",
	[37091] = "999999/Ci",
	[43465] = "999999/Ci",
	[43463] = "999999/Ci",
	[37094] = "999999/Ci",
	[37098] = "999999/Ci",
	[37092] = "999999/Ci",
	[43466] = "999999/Ci",
	[43464] = "999999/Ci",
	[44315] = "999999/Ci",
	-- Inscription (Special)
	-- TODO: Pricing of tomes above 325?
	[44680] = "0/Ci",
	[43515] = "1400/Ci",
	[43655] = "1400/Ci",
	[43654] = "1400/Ci",
	[43657] = "1400/Ci",
	[43656] = "1400/Ci",
	[43850] = "2500/Ci",
	[43661] = "1400/Ci",
	[43660] = "1400/Ci",
	[43664] = "1400/Ci",
	[43663] = "1400/Ci",
	[43667] = "1400/Ci",
	[43666] = "1400/Ci",
	[44210] = "999999/Ci",
	[38322] = "999999/Ci",
	-- Inscription (Tarot - Skills)
	[37168] = "125/Ci",
	[44142] = "125/Ci",
	[44161] = "625/Ci",
	[44163] = "625/Ci",
	[44316] = "12500/Ci",
	[44317] = "25000/Ci",
	-- Inscription (Tarot - Cards)
	[37140] = "125/Ci",
	[37143] = "125/Ci",
	[37156] = "125/Ci",
	[37145] = "125/Ci",
	[37147] = "125/Ci",
	[37159] = "125/Ci",
	[37160] = "125/Ci",
	[44165] = "625/Ci",
	[44144] = "625/Ci",
	[44145] = "625/Ci",
	[44146] = "625/Ci",
	[44147] = "625/Ci",
	[44143] = "625/Ci",
	[44154] = "625/Ci",
	[44155] = "625/Ci",
	[44156] = "625/Ci",
	[44157] = "625/Ci",
	[19258] = "12500/DCi",
	[19259] = "12500/DCi",
	[19260] = "12500/DCi",
	[19261] = "12500/DCi",
	[19262] = "12500/DCi",
	[19263] = "12500/DCi",
	[19264] = "12500/DCi",
	[19265] = "12500/DCi",
	[19227] = "12500/DCi",
	[19230] = "12500/DCi",
	[19231] = "12500/DCi",
	[19232] = "12500/DCi",
	[19233] = "12500/DCi",
	[19234] = "12500/DCi",
	[19235] = "12500/DCi",
	[19236] = "12500/DCi",
	[19268] = "12500/DCi",
	[19269] = "12500/DCi",
	[19270] = "12500/DCi",
	[19271] = "12500/DCi",
	[19272] = "12500/DCi",
	[19273] = "12500/DCi",
	[19274] = "12500/DCi",
	[19275] = "12500/DCi",
	[19276] = "12500/DCi",
	[19278] = "12500/DCi",
	[19279] = "12500/DCi",
	[19280] = "12500/DCi",
	[19281] = "12500/DCi",
	[19282] = "12500/DCi",
	[19283] = "12500/DCi",
	[19284] = "12500/DCi",
	[31901] = "25000/DCi",
	[31909] = "25000/DCi",
	[31908] = "25000/DCi",
	[31904] = "25000/DCi",
	[31903] = "25000/DCi",
	[31906] = "25000/DCi",
	[31905] = "25000/DCi",
	[31902] = "25000/DCi",
	[31892] = "25000/DCi",
	[31900] = "25000/DCi",
	[31899] = "25000/DCi",
	[31895] = "25000/DCi",
	[31894] = "25000/DCi",
	[31898] = "25000/DCi",
	[31896] = "25000/DCi",
	[31893] = "25000/DCi",
	[31882] = "25000/DCi",
	[31889] = "25000/DCi",
	[31888] = "25000/DCi",
	[31885] = "25000/DCi",
	[31884] = "25000/DCi",
	[31887] = "25000/DCi",
	[31886] = "25000/DCi",
	[31883] = "25000/DCi",
	[31910] = "25000/DCi",
	[31918] = "25000/DCi",
	[31917] = "25000/DCi",
	[31913] = "25000/DCi",
	[31912] = "25000/DCi",
	[31916] = "25000/DCi",
	[31915] = "25000/DCi",
	[31911] = "25000/DCi",
	-- Inscription (Glyphs - Trainer)
	-- TODO: Verify prices of glyphs over 210
	[42956] = "100/Ci",
	[42741] = "100/Ci",
	[42907] = "100/Ci",
	[42408] = "100/Ci",
	[40913] = "100/Ci",
	[41096] = "100/Ci",
	[42455] = "100/Ci",
	[41531] = "100/Ci",
	[43413] = "100/Ci",
	[40922] = "100/Ci",
	[41095] = "100/Ci",
	[42743] = "100/Ci",
	[40897] = "100/Ci",
	[42912] = "100/Ci",
	[42960] = "100/Ci",
	[42462] = "100/Ci",
	[43418] = "100/Ci",
	[41537] = "100/Ci",
	[42410] = "100/Ci",
	[42734] = "100/Ci",
	[42898] = "100/Ci",
	[40924] = "100/Ci",
	[42961] = "100/Ci",
	[42398] = "100/Ci",
	[41106] = "100/Ci",
	[41530] = "100/Ci",
	[42461] = "100/Ci",
	[43423] = "100/Ci",
	[42735] = "100/Ci",
	[42900] = "100/Ci",
	[40914] = "100/Ci",
	[42962] = "100/Ci",
	[42400] = "100/Ci",
	[41092] = "100/Ci",
	[42458] = "100/Ci",
	[41532] = "100/Ci",
	[43417] = "100/Ci",
	[42737] = "100/Ci",
	[42908] = "100/Ci",
	[40923] = "100/Ci",
	[41108] = "100/Ci",
	[42964] = "100/Ci",
	[42402] = "100/Ci",
	[43367] = "100/Ci",
	[42465] = "100/Ci",
	[41536] = "100/Ci",
	[43427] = "100/Ci",
	[40919] = "100/Ci",
	[42910] = "100/Ci",
	[42738] = "100/Ci",
	[41100] = "100/Ci",
	[42966] = "100/Ci",
	[42411] = "100/Ci",
	[42467] = "100/Ci",
	[41540] = "100/Ci",
	[43422] = "100/Ci",
	[40909] = "100/Ci",
	[42897] = "100/Ci",
	[42746] = "100/Ci",
	[41104] = "100/Ci",
	[42415] = "100/Ci",
	[41547] = "100/Ci",
	[42970] = "100/Ci",
	[43424] = "100/Ci",
	[42473] = "100/Ci",
	[42903] = "100/Ci",
	[40902] = "100/Ci",
	[41099] = "100/Ci",
	[42747] = "100/Ci",
	[42972] = "100/Ci",
	[42416] = "100/Ci",
	[41533] = "100/Ci",
	[42466] = "100/Ci",
	[43420] = "100/Ci",
	[40916] = "100/Ci",
	[42904] = "100/Ci",
	[42744] = "100/Ci",
	[41098] = "100/Ci",
	[42397] = "100/Ci",
	[41535] = "100/Ci",
	[42973] = "100/Ci",
	[43414] = "100/Ci",
	[42470] = "100/Ci",
	[42905] = "100/Ci",
	[40901] = "100/Ci",
	[43536] = "100/Ci",
	[41103] = "100/Ci",
	[42399] = "100/Ci",
	[43543] = "100/Ci",
	[42468] = "100/Ci",
	[41541] = "100/Ci",
	[43546] = "100/Ci",
	[42750] = "100/Ci",
	[43541] = "100/Ci",
	[43416] = "100/Ci",
	[42974] = "100/Ci",
	[41105] = "100/Ci",
	[41527] = "100/Ci",
	[43548] = "100/Ci",
	[42963] = "100/Ci",
	[43553] = "100/Ci",
	[40903] = "100/Ci",
	[43825] = "100/Ci",
	[42401] = "100/Ci",
	[42911] = "100/Ci",
	[43826] = "100/Ci",
	[43428] = "100/Ci",
	[42749] = "100/Ci",
	[42471] = "100/Ci",
	[43551] = "100/Ci",
	[41542] = "100/Ci",
	[42736] = "100/Ci",
	[41094] = "100/Ci",
	[42955] = "100/Ci",
	[43827] = "100/Ci",
	[43554] = "100/Ci",
	[43432] = "100/Ci",
	[42453] = "100/Ci",
	[40896] = "100/Ci",
	[42906] = "100/Ci",
	[42406] = "100/Ci",
	[43549] = "100/Ci",
	-- Inscription (Glyphs - Discoverable)
	-- Inscription (Glyphs - TODO)
	-- TODO: Verify price for all glyphs in this section
	[40899] = "100/Ci",
	[40900] = "100/Ci",
	[40906] = "100/Ci",
	[40908] = "100/Ci",
	[40912] = "100/Ci",
	[40915] = "100/Ci",
	[40920] = "100/Ci",
	[40921] = "100/Ci",
	[41097] = "100/Ci",
	[41101] = "100/Ci",
	[41102] = "100/Ci",
	[41107] = "100/Ci",
	[41109] = "100/Ci",
	[41110] = "100/Ci",
	[41517] = "100/Ci",
	[41518] = "100/Ci",
	[41524] = "100/Ci",
	[41526] = "100/Ci",
	[41529] = "100/Ci",
	[41534] = "100/Ci",
	[41538] = "100/Ci",
	[41539] = "100/Ci",
	[41552] = "100/Ci",
	[42396] = "100/Ci",
	[42403] = "100/Ci",
	[42404] = "100/Ci",
	[42405] = "100/Ci",
	[42407] = "100/Ci",
	[42409] = "100/Ci",
	[42412] = "100/Ci",
	[42414] = "100/Ci",
	[42417] = "100/Ci",
	[42454] = "100/Ci",
	[42456] = "100/Ci",
	[42457] = "100/Ci",
	[42459] = "100/Ci",
	[42460] = "100/Ci",
	[42463] = "100/Ci",
	[42464] = "100/Ci",
	[42469] = "100/Ci",
	[42472] = "100/Ci",
	[42739] = "100/Ci",
	[42740] = "100/Ci",
	[42742] = "100/Ci",
	[42745] = "100/Ci",
	[42748] = "100/Ci",
	[42751] = "100/Ci",
	[42752] = "100/Ci",
	[42753] = "100/Ci",
	[42754] = "100/Ci",
	[42899] = "100/Ci",
	[42901] = "100/Ci",
	[42902] = "100/Ci",
	[42909] = "100/Ci",
	[42913] = "100/Ci",
	[42914] = "100/Ci",
	[42915] = "100/Ci",
	[42916] = "100/Ci",
	[42917] = "100/Ci",
	[42954] = "100/Ci",
	[42957] = "100/Ci",
	[42958] = "100/Ci",
	[42959] = "100/Ci",
	[42965] = "100/Ci",
	[42967] = "100/Ci",
	[42968] = "100/Ci",
	[42969] = "100/Ci",
	[42971] = "100/Ci",
	[43316] = "100/Ci",
	[43331] = "100/Ci",
	[43332] = "100/Ci",
	[43334] = "100/Ci",
	[43335] = "100/Ci",
	[43338] = "100/Ci",
	[43339] = "100/Ci",
	[43340] = "100/Ci",
	[43342] = "100/Ci",
	[43343] = "100/Ci",
	[43344] = "100/Ci",
	[43350] = "100/Ci",
	[43351] = "100/Ci",
	[43354] = "100/Ci",
	[43355] = "100/Ci",
	[43356] = "100/Ci",
	[43357] = "100/Ci",
	[43359] = "100/Ci",
	[43360] = "100/Ci",
	[43361] = "100/Ci",
	[43364] = "100/Ci",
	[43365] = "100/Ci",
	[43366] = "100/Ci",
	[43368] = "100/Ci",
	[43369] = "100/Ci",
	[43370] = "100/Ci",
	[43371] = "100/Ci",
	[43372] = "100/Ci",
	[43373] = "100/Ci",
	[43374] = "100/Ci",
	[43376] = "100/Ci",
	[43377] = "100/Ci",
	[43378] = "100/Ci",
	[43379] = "100/Ci",
	[43380] = "100/Ci",
	[43381] = "100/Ci",
	[43385] = "100/Ci",
	[43386] = "100/Ci",
	[43388] = "100/Ci",
	[43389] = "100/Ci",
	[43390] = "100/Ci",
	[43391] = "100/Ci",
	[43392] = "100/Ci",
	[43393] = "100/Ci",
	[43394] = "100/Ci",
	[43395] = "100/Ci",
	[43396] = "100/Ci",
	[43397] = "100/Ci",
	[43398] = "100/Ci",
	[43399] = "100/Ci",
	[43400] = "100/Ci",
	[43412] = "100/Ci",
	[43415] = "100/Ci",
	[43419] = "100/Ci",
	[43421] = "100/Ci",
	[43425] = "100/Ci",
	[43426] = "100/Ci",
	[43429] = "100/Ci",
	[43430] = "100/Ci",
	[43431] = "100/Ci",
	[43533] = "100/Ci",
	[43534] = "100/Ci",
	[43535] = "100/Ci",
	[43537] = "100/Ci",
	[43538] = "100/Ci",
	[43539] = "100/Ci",
	[43542] = "100/Ci",
	[43544] = "100/Ci",
	[43545] = "100/Ci",
	[43547] = "100/Ci",
	[43550] = "100/Ci",
	[43552] = "100/Ci",
	[43671] = "100/Ci",
	[43672] = "100/Ci",
	[43673] = "100/Ci",
	[43674] = "100/Ci",
	[43725] = "100/Ci",
	[43867] = "100/Ci",
	[43868] = "100/Ci",
	[43869] = "100/Ci",
	[44318] = "100/Ci",
	[44684] = "100/Ci",
	[44920] = "100/Ci",
	[44922] = "100/Ci",
	[44923] = "100/Ci",
	[44928] = "100/Ci",
	[44955] = "100/Ci",
	-- WotLK Alchemy components
	[8827] = "125/Ca",
	[33447] = "999/H",
	[33448] = "999999/Ca",
	[35622] = "4000/CCa",
	[35623] = "4000/CCa",
	[35624] = "4000/CCa",
	[35625] = "4000/CCa",
	[35627] = "4000/CCa",
	[36860] = "4000/CCa",
	[36901] = "999999/H",
	[36903] = "999999/H",
	[36904] = "999999/H",
	[36905] = "999999/H",
	[36906] = "999999/H",
	[36907] = "999999/H",
	[36908] = "999999/H",
	[36913] = "12500/Cs",
	[36916] = "3750/Cs",
	[36917] = "2500/MR",
	[36923] = "2500/MR",
	[36929] = "2500/MR",
	[37701] = "400/DM",
	[37702] = "400/DM",
	[37703] = "400/DM",
	[37704] = "400/DM",
	[37705] = "400/DM",
	[37921] = "999999/H",
	[39666] = "999999/Ca",
	[39671] = "999999/Ca",
	[39970] = "999999/H",
	[40067] = "999999/Ca",
	[40068] = "999999/Ca",
	[40070] = "999999/Ca",
	[40072] = "999999/Ca",
	[40073] = "999999/Ca",
	[40076] = "999999/Ca",
	[40077] = "999999/Ca",
	[40078] = "999999/Ca",
	[40079] = "999999/Ca",
	[40081] = "999999/Ca",
	[40082] = "999999/Ca",
	[40083] = "999999/Ca",
	[40084] = "999999/Ca",
	[40087] = "999999/Ca",
	[40093] = "999999/Ca",
	[40097] = "999999/Ca",
	[40109] = "999999/Ca",
	[40195] = "999999/Ca",
	[40199] = "999999/H",
	[40211] = "999999/Ca",
	[40212] = "999999/Ca",
	[40213] = "999999/Ca",
	[40214] = "999999/Ca",
	[40215] = "999999/Ca",
	[40216] = "999999/Ca",
	[40217] = "999999/Ca",
	[40248] = "999999/Ca",
	[40404] = "999999/Ca",
	[40411] = "999999/V",
	[41163] = "18750/CsCa",
	[41266] = "999999/Ca",
	[41814] = "8/F",
	[43569] = "999999/Ca",
	[43570] = "999999/Ca",
	[44322] = "999999/Ca",
	[44323] = "999999/Ca",
	[44324] = "999999/Ca",
	[44325] = "999999/Ca",
	[44327] = "999999/Ca",
	[44328] = "999999/Ca",
	[44329] = "999999/Ca",
	[44330] = "999999/Ca",
	[44331] = "999999/Ca",
	[44332] = "999999/Ca",
	[44508] = "0/Ca",
	[44939] = "3500/Ca",
	[44958] = "10/Ca",
	-- WotLK Blacksmithing components
	[23526] = "999999/Cb",
	[37663] = "12500/Cs",
	[37700] = "400/D",
	[39083] = "999999/Cb",
	[39084] = "999999/Cb",
	[39085] = "999999/Cb",
	[39086] = "999999/Cb",
	[39087] = "999999/Cb",
	[39088] = "999999/Cb",
	[40668] = "999999/Cb",
	[40669] = "999999/Cb",
	[40670] = "999999/Cb",
	[40671] = "999999/Cb",
	[40672] = "999999/Cb",
	[40673] = "999999/Cb",
	[40674] = "999999/Cb",
	[40675] = "999999/Cb",
	[40942] = "999999/Cb",
	[40943] = "999999/Cb",
	[40949] = "999999/Cb",
	[40950] = "999999/Cb",
	[40951] = "999999/Cb",
	[40952] = "999999/Cb",
	[40953] = "999999/Cb",
	[40954] = "999999/Cb",
	[40955] = "999999/Cb",
	[40956] = "999999/Cb",
	[40957] = "999999/Cb",
	[40958] = "999999/Cb",
	[40959] = "999999/Cb",
	[41113] = "999999/Cb",
	[41114] = "999999/Cb",
	[41116] = "999999/Cb",
	[41117] = "999999/Cb",
	[41126] = "999999/Cb",
	[41127] = "999999/Cb",
	[41128] = "999999/Cb",
	[41129] = "999999/Cb",
	[41181] = "999999/Cb",
	[41182] = "999999/Cb",
	[41183] = "999999/Cb",
	[41184] = "999999/Cb",
	[41185] = "999999/Cb",
	[41186] = "999999/Cb",
	[41187] = "999999/Cb",
	[41188] = "999999/Cb",
	[41189] = "999999/Cb",
	[41190] = "999999/Cb",
	[41239] = "999999/Cb",
	[41240] = "999999/Cb",
	[41241] = "999999/Cb",
	[41242] = "999999/Cb",
	[41243] = "999999/Cb",
	[41245] = "999999/Cb",
	[41257] = "999999/Cb",
	[41344] = "999999/Cb",
	[41345] = "999999/Cb",
	[41346] = "999999/Cb",
	[41347] = "999999/Cb",
	[41348] = "999999/Cb",
	[41349] = "999999/Cb",
	[41350] = "999999/Cb",
	[41351] = "999999/Cb",
	[41352] = "999999/Cb",
	[41353] = "999999/Cb",
	[41354] = "999999/Cb",
	[41355] = "999999/Cb",
	[41356] = "999999/Cb",
	[41357] = "999999/Cb",
	[41383] = "999999/Cb",
	[41384] = "999999/Cb",
	[41386] = "999999/Cb",
	[41387] = "999999/Cb",
	[41388] = "999999/Cb",
	[41391] = "999999/Cb",
	[41392] = "999999/Cb",
	[41394] = "999999/Cb",
	[41611] = "999999/Cb",
	[41745] = "999999/Cb",
	[41974] = "999999/Cb",
	[41975] = "999999/Cb",
	[41976] = "999999/Cb",
	[42435] = "999999/Cb",
	[42443] = "999999/Cb",
	[42500] = "999999/Cb",
	[42508] = "999999/Cb",
	[42723] = "999999/Cb",
	[42724] = "999999/Cb",
	[42725] = "999999/Cb",
	[42726] = "999999/Cb",
	[42727] = "999999/Cb",
	[42728] = "999999/Cb",
	[42729] = "999999/Cb",
	[42730] = "999999/Cb",
	[43586] = "999999/Cb",
	[43587] = "999999/Cb",
	[43588] = "999999/Cb",
	[43853] = "999999/Cb",
	[43854] = "999999/Cb",
	[43860] = "999999/Cb",
	[43864] = "999999/Cb",
	[43865] = "999999/Cb",
	[43870] = "999999/Cb",
	[43871] = "999999/Cb",
	[44936] = "30000/Ca",
	-- WotLK Engineering components
	[2901] = "16/V",
	[5956] = "3/V",
	[7005] = "16/V",
	[23775] = "999999/Ce",
	[23831] = "999999/Ce",
	[23832] = "999999/Ce",
	[33470] = "1250/D",
	[33568] = "2250/SCl",
	[34052] = "999999/EC",
	[36920] = "2500/MR",
	[37567] = "999999/Ce",
	[38425] = "2250/Cl",
	[39681] = "999999/Ce",
	[39682] = "999999/Ce",
	[39683] = "999999/Ce",
	[39684] = "2250/DS",
	[39688] = "999999/Ce",
	[39690] = "999999/Ce",
	[40533] = "12500/V",
	[40536] = "999999/Ce",
	[40767] = "999999/Ce",
	[40768] = "999999/Ce",
	[40769] = "999999/Ce",
	[40771] = "999999/Ce",
	[40772] = "999999/Ce",
	[40865] = "999999/Ce",
	[40892] = "999999/Ce",
	[40893] = "999999/Ce",
	[40895] = "999999/Ce",
	[41112] = "999999/Ce",
	[41119] = "999999/Ce",
	[41121] = "999999/Ce",
	[41146] = "999999/Ce",
	[41167] = "999999/Ce",
	[41168] = "999999/Ce",
	[41508] = "999999/Ce",
	[42546] = "999999/Ce",
	[42549] = "999999/Ce",
	[42550] = "999999/Ce",
	[42551] = "999999/Ce",
	[42552] = "999999/Ce",
	[42553] = "999999/Ce",
	[42554] = "999999/Ce",
	[42555] = "999999/Ce",
	[42641] = "999999/Ce",
	[44128] = "30000/S",
	[44413] = "999999/Ce",
	[44499] = "7500000/V",
	[44500] = "3750000/V",
	[44501] = "2500000/V",
	[44504] = "999999/Ce",
	[44506] = "999999/Ce",
	[44507] = "999999/Ce",
	[44739] = "999999/Ce",
	[44740] = "999999/Ce",
	[44741] = "999999/Ce",
	[44742] = "999999/Ce",
	[44949] = "105472/Ce",
	[44951] = "0/Ce",
	-- WotLK Jewelcrafting components
	[21780] = "999999/Cj",
	[21793] = "999999/Cj",
	[34054] = "999999/E",
	[35945] = "999999/Cj",
	[36766] = "11250/Cj",
	[36767] = "11250/Cj",
	[36783] = "5000/DFV",
	[36784] = "10000/DFV",
	[36918] = "30000/MR",
	[36921] = "30000/MR",
	[36924] = "30000/MR",
	[36926] = "2500/MR",
	[36927] = "30000/MR",
	[36929] = "2500/MR",
	[36930] = "30000/MR",
	[36932] = "2500/MR",
	[36933] = "30000/MR",
	[37503] = "999999/Cj",
	[39900] = "999999/Cj",
	[39905] = "999999/Cj",
	[39906] = "999999/Cj",
	[39907] = "999999/Cj",
	[39908] = "999999/Cj",
	[39909] = "999999/Cj",
	[39910] = "999999/Cj",
	[39911] = "999999/Cj",
	[39912] = "999999/Cj",
	[39914] = "999999/Cj",
	[39915] = "999999/Cj",
	[39916] = "999999/Cj",
	[39917] = "999999/Cj",
	[39918] = "999999/Cj",
	[39919] = "999999/Cj",
	[39920] = "999999/Cj",
	[39927] = "999999/Cj",
	[39932] = "999999/Cj",
	[39933] = "999999/Cj",
	[39934] = "999999/Cj",
	[39935] = "999999/Cj",
	[39936] = "999999/Cj",
	[39937] = "999999/Cj",
	[39938] = "999999/Cj",
	[39939] = "5000/Cj",
	[39940] = "999999/Cj",
	[39941] = "999999/Cj",
	[39942] = "999999/Cj",
	[39943] = "999999/Cj",
	[39944] = "999999/Cj",
	[39945] = "999999/Cj",
	[39946] = "999999/Cj",
	[39947] = "999999/Cj",
	[39948] = "999999/Cj",
	[39949] = "999999/Cj",
	[39950] = "999999/Cj",
	[39951] = "999999/Cj",
	[39952] = "5000/Cj",
	[39953] = "999999/Cj",
	[39954] = "999999/Cj",
	[39955] = "999999/Cj",
	[39956] = "999999/Cj",
	[39957] = "999999/Cj",
	[39958] = "999999/Cj",
	[39959] = "5000/Cj",
	[39960] = "999999/Cj",
	[39961] = "999999/Cj",
	[39962] = "999999/Cj",
	[39963] = "999999/Cj",
	[39964] = "999999/Cj",
	[39965] = "999999/Cj",
	[39966] = "999999/Cj",
	[39967] = "999999/Cj",
	[39968] = "999999/Cj",
	[39974] = "999999/Cj",
	[39975] = "5000/Cj",
	[39976] = "999999/Cj",
	[39977] = "999999/Cj",
	[39978] = "999999/Cj",
	[39979] = "5000/Cj",
	[39980] = "999999/Cj",
	[39981] = "999999/Cj",
	[39982] = "999999/Cj",
	[39983] = "999999/Cj",
	[39984] = "999999/Cj",
	[39985] = "999999/Cj",
	[39986] = "999999/Cj",
	[39988] = "999999/Cj",
	[39989] = "999999/Cj",
	[39990] = "999999/Cj",
	[39991] = "999999/Cj",
	[39992] = "999999/Cj",
	[39996] = "45000/Cj",
	[39997] = "45000/Cj",
	[39998] = "45000/Cj",
	[39999] = "999999/Cj",
	[40000] = "999999/Cj",
	[40001] = "45000/Cj",
	[40002] = "45000/Cj",
	[40003] = "45000/Cj",
	[40008] = "45000/Cj",
	[40009] = "999999/Cj",
	[40010] = "45000/Cj",
	[40011] = "45000/Cj",
	[40012] = "999999/Cj",
	[40013] = "45000/Cj",
	[40014] = "45000/Cj",
	[40015] = "45000/Cj",
	[40016] = "45000/Cj",
	[40017] = "45000/Cj",
	[40022] = "999999/Cj",
	[40023] = "999999/Cj",
	[40024] = "999999/Cj",
	[40025] = "45000/Cj",
	[40026] = "999999/Cj",
	[40027] = "45000/Cj",
	[40028] = "45000/Cj",
	[40029] = "999999/Cj",
	[40030] = "45000/Cj",
	[40031] = "45000/Cj",
	[40032] = "45000/Cj",
	[40033] = "45000/Cj",
	[40034] = "45000/Cj",
	[40037] = "999999/Cj",
	[40038] = "999999/Cj",
	[40039] = "999999/Cj",
	[40040] = "45000/Cj",
	[40041] = "45000/Cj",
	[40043] = "45000/Cj",
	[40044] = "45000/Cj",
	[40045] = "45000/Cj",
	[40046] = "45000/Cj",
	[40047] = "45000/Cj",
	[40048] = "45000/Cj",
	[40049] = "45000/Cj",
	[40050] = "45000/Cj",
	[40051] = "45000/Cj",
	[40052] = "45000/Cj",
	[40053] = "999999/Cj",
	[40054] = "45000/Cj",
	[40055] = "45000/Cj",
	[40056] = "999999/Cj",
	[40057] = "45000/Cj",
	[40058] = "45000/Cj",
	[40059] = "999999/Cj",
	[40085] = "45000/Cj",
	[40086] = "45000/Cj",
	[40088] = "45000/Cj",
	[40089] = "45000/Cj",
	[40090] = "45000/Cj",
	[40091] = "45000/Cj",
	[40092] = "45000/Cj",
	[40094] = "999999/Cj",
	[40095] = "999999/Cj",
	[40096] = "45000/Cj",
	[40098] = "45000/Cj",
	[40099] = "999999/Cj",
	[40100] = "45000/Cj",
	[40101] = "45000/Cj",
	[40102] = "45000/Cj",
	[40103] = "45000/Cj",
	[40104] = "45000/Cj",
	[40105] = "45000/Cj",
	[40106] = "45000/Cj",
	[41285] = "60000/Cj",
	[41307] = "999999/Cj",
	[41333] = "60000/Cj",
	[41334] = "30000/Ca",
	[41335] = "60000/Cj",
	[41339] = "999999/Cj",
	[41367] = "999999/Cj",
	[41375] = "999999/Cj",
	[41376] = "60000/Cj",
	[41377] = "60000/Cj",
	[41378] = "60000/Cj",
	[41379] = "60000/Cj",
	[41380] = "60000/Cj",
	[41381] = "999999/Cj",
	[41382] = "60000/Cj",
	[41385] = "60000/Cj",
	[41389] = "999999/Cj",
	[41395] = "60000/Cj",
	[41396] = "60000/Cj",
	[41397] = "999999/Cj",
	[41398] = "60000/Cj",
	[41400] = "999999/Cj",
	[41401] = "60000/Cj",
	[42142] = "11250/Cj",
	[42143] = "11250/Cj",
	[42144] = "11250/Cj",
	[42145] = "11250/Cj",
	[42146] = "11250/Cj",
	[42148] = "11250/Cj",
	[42149] = "11250/Cj",
	[42150] = "11250/Cj",
	[42151] = "11250/Cj",
	[42152] = "11250/Cj",
	[42153] = "11250/Cj",
	[42154] = "11250/Cj",
	[42155] = "11250/Cj",
	[42156] = "11250/Cj",
	[42157] = "11250/Cj",
	[42158] = "11250/Cj",
	[42225] = "0/V",
	[42336] = "999999/Cj",
	[42337] = "999999/Cj",
	[42338] = "999999/Cj",
	[42339] = "999999/Cj",
	[42340] = "999999/Cj",
	[42341] = "999999/Cj",
	[42395] = "999999/Cj",
	[42413] = "999999/Cj",
	[42418] = "999999/Cj",
	[42420] = "999999/Cj",
	[42421] = "999999/Cj",
	[42642] = "71245/Cj",
	[42643] = "66867/Cj",
	[42644] = "999999/Cj",
	[42645] = "71245/Cj",
	[42646] = "71245/Cj",
	[42647] = "71245/Cj",
	[42701] = "999999/Cj",
	[42702] = "999999/Cj",
	[43244] = "999999/Cj",
	[43245] = "999999/Cj",
	[43246] = "999999/Cj",
	[43247] = "999999/Cj",
	[43248] = "999999/Cj",
	[43249] = "999999/Cj",
	[43250] = "50150/Cj",
	[43251] = "50150/Cj",
	[43252] = "50150/Cj",
	[43253] = "50150/Cj",
	[43482] = "40000/Cj",
	[43498] = "50150/Cj",
	[43582] = "75623/Cj",
	[44063] = "999999/Cj",
	[44943] = "0/Cj",
	-- WotLK Leatherworking components
	[33567] = "2250/S",
	[38347] = "55000/Cl",
	[38371] = "999999/Cl",
	[38372] = "999999/Cl",
	[38373] = "999999/Cl",
	[38374] = "999999/Cl",
	[38375] = "999999/Cl",
	[38376] = "999999/Cl",
	[38399] = "40000/Cl",
	[38400] = "999999/Cl",
	[38401] = "999999/Cl",
	[38402] = "999999/Cl",
	[38403] = "999999/Cl",
	[38404] = "999999/Cl",
	[38405] = "999999/Cl",
	[38406] = "999999/Cl",
	[38407] = "999999/Cl",
	[38408] = "999999/Cl",
	[38409] = "999999/Cl",
	[38410] = "999999/Cl",
	[38411] = "999999/Cl",
	[38412] = "999999/Cl",
	[38413] = "999999/Cl",
	[38414] = "999999/Cl",
	[38415] = "999999/Cl",
	[38416] = "999999/Cl",
	[38417] = "999999/Cl",
	[38418] = "999999/Cl",
	[38419] = "999999/Cl",
	[38420] = "999999/Cl",
	[38421] = "999999/Cl",
	[38422] = "999999/Cl",
	[38424] = "999999/Cl",
	[38433] = "999999/Cl",
	[38434] = "999999/Cl",
	[38435] = "999999/Cl",
	[38436] = "999999/Cl",
	[38437] = "999999/Cl",
	[38438] = "999999/Cl",
	[38439] = "999999/Cl",
	[38440] = "999999/Cl",
	[38441] = "999999/Cl",
	[38557] = "10000/DS",
	[38558] = "1100/DS",
	[38561] = "10000/S",
	[38590] = "999999/Cl",
	[38591] = "999999/Cl",
	[38592] = "999999/Cl",
	[41238] = "999999/Cl",
	[42731] = "999999/Cl",
	[43129] = "999999/Cl",
	[43130] = "999999/Cl",
	[43131] = "999999/Cl",
	[43132] = "999999/Cl",
	[43133] = "999999/Cl",
	[43255] = "999999/Cl",
	[43256] = "999999/Cl",
	[43257] = "999999/Cl",
	[43258] = "999999/Cl",
	[43260] = "54270/Cl",
	[43261] = "49281/Cl",
	[43262] = "49472/Cl",
	[43263] = "66212/Cl",
	[43264] = "33233/Cl",
	[43265] = "33361/Cl",
	[43266] = "33489/Cl",
	[43271] = "70069/Cl",
	[43273] = "52935/Cl",
	[43433] = "50440/Cl",
	[43434] = "67509/Cl",
	[43435] = "33882/Cl",
	[43436] = "34006/Cl",
	[43437] = "34134/Cl",
	[43438] = "68524/Cl",
	[43439] = "51584/Cl",
	[43442] = "41723/Cl",
	[43443] = "63093/Cl",
	[43444] = "42025/Cl",
	[43445] = "86551/Cl",
	[43446] = "43429/Cl",
	[43447] = "59149/Cl",
	[43448] = "79172/Cl",
	[43449] = "59874/Cl",
	[43450] = "39892/Cl",
	[43451] = "60329/Cl",
	[43452] = "40195/Cl",
	[43453] = "80696/Cl",
	[43454] = "40501/Cl",
	[43455] = "60975/Cl",
	[43456] = "81607/Cl",
	[43457] = "61708/Cl",
	[43458] = "116805/Cl",
	[43459] = "58614/Cl",
	[43461] = "121217/Cl",
	[43469] = "85050/Cl",
	[43481] = "75745/Cl",
	[43484] = "51041/Cl",
	[43495] = "98827/Cl",
	[43502] = "76010/Cl",
	[43565] = "999999/Cl",
	[43566] = "999999/Cl",
	[43590] = "99260/Cl",
	[43591] = "53027/Cl",
	[43592] = "79830/Cl",
	[43593] = "119112/Cl",
	[43594] = "59556/Cl",
	[43595] = "97257/Cl",
	[44436] = "999999/Cl",
	[44437] = "999999/Cl",
	[44438] = "999999/Cl",
	[44440] = "999999/Cl",
	[44441] = "999999/Cl",
	[44442] = "999999/Cl",
	[44443] = "999999/Cl",
	[44444] = "999999/Cl",
	[44445] = "999999/Cl",
	[44446] = "999999/Cl",
	[44447] = "37500/Cl",
	[44448] = "37500/Cl",
	[44930] = "75760/Cl",
	[44931] = "101367/Cl",
	[44963] = "20000/Cl",
	-- WotLK Tailoring components
	[6836] = "999999/Ct",
	[38225] = "23750/Ct",
	[38277] = "999999/Ct",
	[38278] = "999999/Ct",
	[38426] = "7500/V",
	[41248] = "999999/Ct",
	[41249] = "999999/Ct",
	[41250] = "999999/Ct",
	[41251] = "999999/Ct",
	[41252] = "999999/Ct",
	[41253] = "999999/Ct",
	[41254] = "999999/Ct",
	[41255] = "999999/Ct",
	[41509] = "999999/Ct",
	[41510] = "999999/Ct",
	[41511] = "999999/Ct",
	[41512] = "999999/Ct",
	[41513] = "999999/Ct",
	[41515] = "999999/Ct",
	[41516] = "999999/Ct",
	[41519] = "999999/Ct",
	[41520] = "999999/Ct",
	[41521] = "999999/Ct",
	[41522] = "999999/Ct",
	[41523] = "999999/Ct",
	[41525] = "999999/Ct",
	[41528] = "999999/Ct",
	[41543] = "999999/Ct",
	[41544] = "999999/Ct",
	[41545] = "999999/Ct",
	[41546] = "999999/Ct",
	[41548] = "999999/Ct",
	[41549] = "999999/Ct",
	[41550] = "999999/Ct",
	[41551] = "999999/Ct",
	[41553] = "999999/Ct",
	[41554] = "999999/Ct",
	[41555] = "999999/Ct",
	[41593] = "999999/Ct",
	[41594] = "999999/Ct",
	[41595] = "999999/Ct",
	[41597] = "62500/Ct",
	[41598] = "45000/Ct",
	[41599] = "999999/Ct",
	[41600] = "20000/Ct",
	[41601] = "999999/Ct",
	[41602] = "20000/Ct",
	[41603] = "999999/Ct",
	[41604] = "20000/Ct",
	[41607] = "999999/Ct",
	[41608] = "999999/Ct",
	[41609] = "999999/Ct",
	[41610] = "999999/Ct",
	[41984] = "999999/Ct",
	[41985] = "999999/Ct",
	[41986] = "999999/Ct",
	[42093] = "999999/Ct",
	[42095] = "999999/Ct",
	[42096] = "999999/Ct",
	[42100] = "999999/Ct",
	[42101] = "999999/Ct",
	[42102] = "999999/Ct",
	[42103] = "999999/Ct",
	[42111] = "999999/Ct",
	[42113] = "999999/Ct",
	[42253] = "10000/D",
	[43583] = "999999/Ct",
	[43584] = "999999/Ct",
	[43585] = "999999/Ct",
	[43969] = "999999/Ct",
	[43970] = "999999/Ct",
	[43971] = "999999/Ct",
	[43972] = "999999/Ct",
	[43973] = "999999/Ct",
	[43974] = "999999/Ct",
	[43975] = "999999/Ct",
	[44211] = "999999/Ct",
	[44554] = "999999/Ct",
	[44558] = "999999/Ct",
	-- WotLK Enchanting components
	[22572] = "999999/E",
	[34055] = "999999/EC",
	[34056] = "999999/E",
	[34057] = "999999/E",
	[44452] = "999999/Cn",
	-- WotLK Cooking components
	[2594] = "375/DV",
	[22577] = "400/DV",
	[34736] = "200/D",
	[34747] = "225/Cc",
	[34748] = "300/Cc",
	[34749] = "300/Cc",
	[34750] = "225/Cc",
	[34751] = "225/Cc",
	[34752] = "225/Cc",
	[34753] = "10000/Cc",
	[34754] = "400/Cc",
	[34755] = "400/Cc",
	[34756] = "400/Cc",
	[34757] = "400/Cc",
	[34758] = "225/Cc",
	[34759] = "300/Cc",
	[34760] = "300/Cc",
	[34761] = "300/Cc",
	[34762] = "300/Cc",
	[34763] = "300/Cc",
	[34764] = "300/Cc",
	[34765] = "300/Cc",
	[34766] = "500/Cc",
	[34767] = "500/Cc",
	[34768] = "500/Cc",
	[34769] = "500/Cc",
	[35948] = "800/DV",
	[35949] = "425/V",
	[36782] = "150/DF",
	[39520] = "200/Cc",
	[41800] = "8/F",
	[41801] = "8/F",
	[41802] = "8/F",
	[41803] = "8/F",
	[41806] = "8/F",
	[41807] = "8/F",
	[41808] = "8/F",
	[41809] = "8/F",
	[41810] = "8/F",
	[41812] = "8/F",
	[41813] = "8/F",
	[42942] = "300/Cc",
	[42993] = "500/Cc",
	[42994] = "400/Cc",
	[42995] = "400/Cc",
	[42996] = "500/Cc",
	[42997] = "400/Cc",
	[42998] = "500/Cc",
	[42999] = "500/Cc",
	[43000] = "500/Cc",
	[43001] = "400/Cc",
	[43004] = "400/Cc",
	[43005] = "500/Cc",
	[43007] = "0/VQ",
	[43009] = "200/D",
	[43010] = "200/D",
	[43011] = "200/D",
	[43012] = "200/D",
	[43013] = "200/D",
	[43015] = "15000/Cc",
	[43268] = "300/Cc",
	[43478] = "10000/Cc",
	[43480] = "10000/Cc",
	[43488] = "100/Cc",
	[43490] = "100/Cc",
	[43491] = "100/Cc",
	[43492] = "100/Cc",
	[43501] = "1500/D",
	[44953] = "400/Cc",
	-- WotLK Smelting components
	[36909] = "1000/M",
	[36910] = "1250/M",
	[36912] = "2500/M",
	[36913] = "12500/Cs",
	[36916] = "3750/Cs",
	[37663] = "12500/Cs",
	-- WotLK First Aid components
	[34721] = "1250/Cf",
	[34722] = "2500/Cf",
}

TradeskillInfo.vars.recipes = {
-- factionrank: 4 Neutral, 5 Friendly, 6 Honored, 7 Revered, 8 Exalted
-- [recipe] = "result|source|price|factionrank"
	[728] = "733|V92Qa|200",
	[2406] = "2307|D",
	[2407] = "2311|D",
	[2408] = "2312|D",
	[2409] = "2317|D",
	[2553] = "2457|D",
	[2555] = "2459|D",
	[2598] = "2572|D",
	[2601] = "2585|D",
	[2697] = "724|V92Qa|400",
	[2698] = "2682|V92|400",
	[2699] = "1082|V92Qa|800",
	[2700] = "2685|V92D|400",
	[2701] = "1017|V92Qa|1600",
	[2881] = "2864|D",
	[2882] = "3481|D",
	[2883] = "3490|D",
	[2889] = "2888|V92Qa|240",
	[3393] = "3384|D",
	[3394] = "3386|D",
	[3395] = "3387|D",
	[3396] = "3390|D",
	[3608] = "3492|D",
	[3609] = "3471|QaD",
	[3610] = "3474|D",
	[3611] = "3484|D",
	[3612] = "3485|D",
	[3678] = "3662|V92Qa|400",
	[3679] = "3220|V92Qa|400",
	[3680] = "3663|V92Qa|1600",
	[3681] = "3664|V92Qa|1600",
	[3682] = "3665|V92V90V142Qa|1600",
	[3683] = "3666|V92Qa|1600",
	[3734] = "3726|V187V177Qh|1600",
	[3735] = "3727|V216V194Qh|1800",
	[3736] = "3728|Qa",
	[3737] = "3729|Q",
	[3830] = "3825|D",
	[3831] = "3826|D",
	[3832] = "3828|D",
	[3866] = "3850|D",
	[3867] = "3852|D",
	[3868] = "3854|D",
	[3869] = "3856|D",
	[3870] = "3840|D",
	[3871] = "3841|D",
	[3872] = "3843|D",
	[3873] = "3845|D",
	[3874] = "3846|D",
	[3875] = "3847|D",
	[4292] = "4241|D",
	[4293] = "4244|D",
	[4294] = "4250|D",
	[4296] = "4252|D",
	[4297] = "4254|D",
	[4298] = "4258|D",
	[4299] = "4256|D",
	[4300] = "4260|D",
	[4301] = "4264|D",
	[4345] = "4313|D",
	[4346] = "4311|D",
	[4347] = "4315|D",
	[4348] = "4331|D",
	[4349] = "4317|D",
	[4350] = "4321|D",
	[4351] = "4323|D",
	[4352] = "4325|D",
	[4353] = "4328|D",
	[4354] = "4335|D",
	[4355] = "4327|V128V52|1500",
	[4356] = "4329|D",
	[4408] = "4401|D",
	[4409] = "4367|D",
	[4410] = "4373|D",
	[4411] = "4376|D",
	[4412] = "4383|D",
	[4413] = "4388|D",
	[4414] = "4403|D",
	[4415] = "4393|D",
	[4416] = "4395|D",
	[4417] = "4398|D",
	[4597] = "4596|Qh",
	[4609] = "4457|V138V177Q|1000",
	[4624] = "4623|Q",
	[5083] = "5081|Qh",
	[5482] = "5472|Qa",
	[5483] = "5473|V60|140",
	[5484] = "5474|V205|240",
	[5485] = "5476|V106|400",
	[5486] = "5477|V181QQa|440",
	[5487] = "5478|Qh",
	[5488] = "5479|V181|400",
	[5489] = "5480|V187V194|1200",
	[5528] = "5526|V67V102|800",
	[5543] = "5541|D",
	[5578] = "2869|D",
	[5640] = "5631|V35V206V61V156|100",
	[5642] = "5634|V173V188V101V194|1800",
	[5643] = "5633|V188V61V194|2000",
	[5771] = "5762|V55V191V7V118|200",
	[5772] = "5763|V6V80V157V191V19V118V129V202V210V95V217|500",
	[5773] = "5770|D",
	[5774] = "5764|D",
	[5775] = "5765|D",
	[5786] = "5780|V55V125V7D|550",
	[5787] = "5781|V55V125V7D|600",
	[5788] = "5782|V128V24V15D|650",
	[5789] = "5783|V68V15D|2800",
	[5972] = "5958|D",
	[5973] = "5963|V62V107V72V90V194D|650",
	[5974] = "5965|D",
	[6039] = "6038|V91|5000",
	[6044] = "6042|D",
	[6045] = "6043|D",
	[6046] = "6041|D",
	[6047] = "3837|V103|4400",
	[6053] = "6051|V206V70V105|800",
	[6054] = "6048|V64V24|900",
	[6055] = "6049|V136V79|1500",
	[6056] = "6050|V41V57|2000",
	[6057] = "6052|V114V22V57V3|2000",
	[6068] = "3824|V131V17|1500",
	[6211] = "3391|D",
	[6270] = "6240|V183V191V19V26V202|200",
	[6271] = "6239|D",
	[6272] = "6242|V40V42V7V202V156|300",
	[6274] = "6263|V55V4V19V119V210|400",
	[6275] = "6264|V42V80V157V171V129V156|800",
	[6325] = "6290|V23V59V93V146V183V66V122V166V113|40",
	[6326] = "787|V102V143V179V122V214|40",
	[6328] = "4592|V93V146V179V183V66V96V134V113|400",
	[6329] = "6316|V93|400",
	[6330] = "4593|V23V112V37V134V166V162V97|1200",
	[6342] = "-7443|V81V184V190V99V108V111V140V182V89|300",
	[6344] = "-7766|D",
	[6346] = "-7776|V99V111|400",
	[6347] = "-7782|D",
	[6348] = "-7786|D",
	[6349] = "-7793|V184V99V108V140|500",
	[6368] = "5095|V23V67V102V143V175V96V168V214V162V97|400",
	[6369] = "4594|V67V112V175V179V168V200V203V91V113|2200",
	[6375] = "-7859|D",
	[6377] = "-7867|V140V217|1000",
	[6390] = "6384|D",
	[6391] = "6385|D",
	[6401] = "4333|V171V119V177|1100",
	[6454] = "6453|D",
	[6474] = "6466|V88|550",
	[6475] = "6467|V88|1500",
	[6476] = "6468|Q",
	[6661] = "6657|D",
	[6663] = "6662|D",
	[6672] = "4852|D",
	[6710] = "6709|Qa",
	[6716] = "6714|D",
	[6735] = "6731|Qa",
	[6892] = "6890|V39V7|250",
	[7084] = "7059|D",
	[7085] = "7060|D",
	[7086] = "7061|D",
	[7087] = "7056|V177V208|1200",
	[7088] = "7063|V197|5000",
	[7089] = "7053|V20V85|1500",
	[7090] = "7065|D",
	[7091] = "7049|D",
	[7092] = "7047|D",
	[7114] = "4319|V198V98|1000",
	[7192] = "7189|D",
	[7288] = "7280|D",
	[7289] = "7283|V25D|650",
	[7290] = "7284|V198D|1600",
	[7360] = "4248|D",
	[7361] = "7349|V65D|1800",
	[7362] = "7352|V217|2000",
	[7363] = "7358|D",
	[7364] = "7359|D",
	[7449] = "7373|D",
	[7450] = "7375|D",
	[7451] = "7386|V153V164V74V83V194D|2800",
	[7452] = "7390|D",
	[7453] = "7391|D",
	[7560] = "7506|V49V82|1200",
	[7561] = "7148|V105V177V193V217|2000",
	[7613] = "4255|V198V50V194D|2000",
	[7742] = "4397|V212|2400",
	[7975] = "7921|D",
	[7976] = "7967|D",
	[7978] = "7913|Qh",
	[7979] = "7914|Qh",
	[7980] = "7915|Qh",
	[7981] = "7916|Qh",
	[7982] = "7917|Qh",
	[7983] = "7926|Q",
	[7984] = "7927|Q",
	[7985] = "7928|Q",
	[7989] = "7969|D",
	[7990] = "7934|D",
	[7991] = "7932|D",
	[7992] = "7942|D",
	[7993] = "7944|D",
	[7995] = "7924|V63V51|6000",
	[8028] = "7946|D",
	[8029] = "7943|D",
	[8030] = "7947|V117D|10000",
	[8384] = "8174|D",
	[8385] = "8187|V153V74|3500",
	[8386] = "8200|D",
	[8387] = "8201|D",
	[8389] = "8202|D",
	[8390] = "8216|D",
	[8395] = "8203|D",
	[8397] = "8205|D",
	[8398] = "8204|D",
	[8399] = "8209|D",
	[8400] = "8207|D",
	[8401] = "8206|D",
	[8402] = "8208|D",
	[8403] = "8210|Q",
	[8404] = "8211|Q",
	[8405] = "8214|Q",
	[8406] = "8213|Q",
	[8407] = "8212|Q",
	[8408] = "8215|Q",
	[8409] = "8192|V145V74V201D|4000",
	[9293] = "9036|D",
	[9294] = "9144|D",
	[9295] = "9172|D",
	[9296] = "9088|D",
	[9297] = "9197|D",
	[9298] = "9206|D",
	[9300] = "9224|V144V158|10000",
	[9301] = "9264|V121V5|10000",
	[9302] = "9210|V114V22|9000",
	[9303] = "9149|V3|8000",
	[9304] = "1|V3|8000",
	[9305] = "2|V3|8000",
	[9367] = "9366|Qa",
	[10300] = "10007|D",
	[10301] = "10008|D",
	[10302] = "10009|D",
	[10311] = "10052|V42V118|3000",
	[10312] = "10018|D",
	[10314] = "10054|V150V19|4000",
	[10315] = "10029|D",
	[10316] = "10048|D",
	[10317] = "10055|V150V19|4000",
	[10318] = "10030|V28|7000",
	[10320] = "10033|D",
	[10321] = "10034|V150V129|4500",
	[10323] = "10035|V150V129|4500",
	[10325] = "10040|V4V118|10000",
	[10326] = "10036|V150V129|5000",
	[10424] = "10423|D",
	[10463] = "10025|Q",
	[10601] = "10499|D",
	[10602] = "10546|V100V211|3000",
	[10603] = "10501|D",
	[10604] = "10510|D",
	[10605] = "10502|D",
	[10606] = "10518|D",
	[10607] = "10506|V84|3600",
	[10608] = "10548|D",
	[10609] = "10576|V163|4000",
	[10644] = "9061|",
	[10713] = "9060|C",
	[10728] = "4336|V139|1500",
	[10858] = "3851|V75V132V78|3000",
	[11038] = "-13380|D",
	[11039] = "-13419|V30V104|800",
	[11081] = "-13464|D",
	[11098] = "-13522|D",
	[11101] = "-13536|V30V104|2500",
	[11150] = "-13612|D",
	[11151] = "-13617|D",
	[11152] = "-13620|D",
	[11163] = "-13646|V128V90|3000",
	[11164] = "-13653|D",
	[11165] = "-13655|D",
	[11166] = "-13698|D",
	[11167] = "-13687|D",
	[11168] = "-13689|D",
	[11202] = "-13817|D",
	[11203] = "-13841|D",
	[11204] = "-13846|D",
	[11205] = "-13868|D",
	[11206] = "-13882|D",
	[11207] = "-13898|D",
	[11208] = "-13915|D",
	[11223] = "-13931|V133V13|5800",
	[11224] = "-13933|D",
	[11225] = "-13945|D",
	[11226] = "-13947|D",
	[11610] = "11608|D",
	[11611] = "11607|D",
	[11612] = "11604|D",
	[11614] = "11606|D",
	[11615] = "11605|D",
	[11813] = "-15596|D",
	[11827] = "11826|D",
	[11828] = "11825|D",
	[12162] = "3849|V87V176V86|3000",
	[12163] = "3853|V215|4400",
	[12164] = "3855|V195V76|4400",
	[12226] = "12224|V1|25",
	[12227] = "12209|V177|1600",
	[12228] = "12210|V27V62V68V90V142V147V194|5000",
	[12229] = "13851|V196V169V177|5000",
	[12231] = "12212|V27V142V194|3000",
	[12232] = "12213|V13V98V147V194|5000",
	[12233] = "12214|V68V73V177|3000",
	[12239] = "12217|V68V147V177|7000",
	[12240] = "12215|V73V98V194|7000",
	[12261] = "12260|D",
	[12682] = "12405|D",
	[12683] = "12406|D",
	[12684] = "12408|D",
	[12685] = "12416|D",
	[12687] = "12428|Q",
	[12688] = "12424|Q",
	[12689] = "12415|D",
	[12690] = "12425|Q",
	[12691] = "12624|D",
	[12692] = "12645|D",
	[12693] = "12409|D",
	[12694] = "12410|D",
	[12695] = "12418|D",
	[12696] = "12628|Q",
	[12697] = "12419|D",
	[12699] = "12631|Q",
	[12700] = "12426|Q",
	[12701] = "12427|Q",
	[12702] = "12417|D",
	[12703] = "12632|V117D|40000",
	[12704] = "12414|D",
	[12705] = "12422|Q",
	[12706] = "12610|D",
	[12707] = "12611|D",
	[12711] = "12633|D",
	[12713] = "12420|D",
	[12714] = "12612|D",
	[12715] = "12429|Q",
	[12716] = "12636|D",
	[12717] = "12640|D",
	[12718] = "12613|D",
	[12719] = "12614|D",
	[12720] = "12639|D",
	[12725] = "12620|Q",
	[12726] = "12619|Q",
	[12727] = "12618|Q",
	[12728] = "12641|D",
	[12819] = "12773|V117D|16000",
	[12821] = "12774|Q",
	[12823] = "12775|V117D|20000",
	[12824] = "12776|Q",
	[12825] = "12777|Q",
	[12827] = "12781|D",
	[12828] = "12792|D",
	[12830] = "12782|D",
	[12833] = "12796|D",
	[12834] = "12790|D",
	[12835] = "12798|D",
	[12836] = "12797|D",
	[12837] = "12794|D",
	[12838] = "12784|D",
	[12839] = "12783|D",
	[12958] = "3|V3|50000",
	[13287] = "4455|V186|2500",
	[13288] = "4456|V8D|2500",
	[13308] = "4386|V161V177|1800",
	[13309] = "4372|V46V82|1000",
	[13310] = "4407|V126V177|2000",
	[13311] = "4396|V58|10000",
	[13476] = "13442|D",
	[13477] = "13443|V188V5|12000",
	[13478] = "13445|V173V101|13000",
	[13479] = "13447|D",
	[13480] = "13446|V45|15000",
	[13481] = "13453|D",
	[13482] = "6|V9V10V155|15000|6",
	[13483] = "4|V152|15000",
	[13484] = "7|V127|15000|5",
	[13485] = "9|V117|15000",
	[13486] = "8|D",
	[13487] = "11|D",
	[13488] = "5|D",
	[13489] = "10|D",
	[13490] = "13455|D",
	[13491] = "13452|D",
	[13492] = "13462|D",
	[13493] = "13454|D",
	[13494] = "13457|D",
	[13495] = "13456|D",
	[13496] = "13458|D",
	[13497] = "13461|D",
	[13499] = "13459|D",
	[13501] = "13444|V117|30000",
	[13518] = "13506|D",
	[13519] = "13510|D",
	[13520] = "13511|D",
	[13521] = "13512|D",
	[13522] = "13513|D",
	[13939] = "6887|V54|16000",
	[13940] = "13927|V91|16000",
	[13941] = "13930|V91|16000",
	[13942] = "13928|V54|16000",
	[13943] = "13929|V91|16000",
	[13945] = "13931|V54|20000",
	[13946] = "13932|V54|20000",
	[13947] = "13933|V196V169|20000",
	[13948] = "13934|V196V169|20000",
	[13949] = "13935|V196V169|20000",
	[14466] = "13869|D",
	[14467] = "13868|D",
	[14468] = "14046|V154|12000",
	[14469] = "13858|V34|12000",
	[14470] = "13857|D",
	[14471] = "14042|D",
	[14472] = "13860|V34|12000",
	[14473] = "14143|D",
	[14474] = "13870|D",
	[14476] = "14043|D",
	[14477] = "14142|D",
	[14478] = "14100|D",
	[14479] = "14101|D",
	[14480] = "14141|D",
	[14481] = "13863|V154|16000",
	[14482] = "14044|D",
	[14483] = "14107|V116|16000",
	[14484] = "14103|D",
	[14485] = "14132|D",
	[14486] = "14134|D",
	[14488] = "13864|V34|12000",
	[14489] = "13871|D",
	[14490] = "14045|D",
	[14491] = "13865|D",
	[14492] = "14108|D",
	[14493] = "14136|D",
	[14494] = "14104|D",
	[14495] = "14144|D",
	[14496] = "14111|D",
	[14497] = "14137|D",
	[14498] = "13866|D",
	[14499] = "14155|D",
	[14500] = "14128|D",
	[14501] = "14138|D",
	[14504] = "13867|D",
	[14505] = "14130|D",
	[14506] = "14106|D",
	[14507] = "14139|D",
	[14508] = "14112|D",
	[14509] = "14140|D",
	[14510] = "14156|D",
	[14511] = "14146|D",
	[14512] = "14154|D",
	[14513] = "14152|D",
	[14514] = "14153|D",
	[14526] = "14342|V154V45|20000",
	[14627] = "4332|V32|800",
	[14630] = "4322|V177V208|1000",
	[14634] = "3829|V21|2500",
	[14635] = "4262|V159V194|3000",
	[14639] = "4381|V46V135|1500",
	[15724] = "15077|V213|12000",
	[15725] = "15083|V109V199|12000",
	[15726] = "15045|V123|12000",
	[15727] = "15076|D",
	[15728] = "15084|D",
	[15729] = "15074|V14D|12000",
	[15730] = "15047|D",
	[15731] = "15091|D",
	[15732] = "15054|D",
	[15733] = "15046|D",
	[15734] = "15061|V153V74D|14000",
	[15735] = "15067|V53D|14000",
	[15737] = "15073|D",
	[15738] = "15078|D",
	[15739] = "15092|D",
	[15740] = "15071|V154|16000",
	[15741] = "15057|V109V199D|16000",
	[15743] = "15082|D",
	[15744] = "15086|D",
	[15745] = "15093|D",
	[15746] = "15072|D",
	[15747] = "15069|D",
	[15748] = "15079|D",
	[15749] = "15053|D",
	[15751] = "15048|V14D|20000",
	[15752] = "15060|D",
	[15753] = "15056|D",
	[15755] = "15075|D",
	[15756] = "15094|V77|22000",
	[15757] = "15087|D",
	[15758] = "15063|V141|22000",
	[15759] = "15050|V152|22000",
	[15760] = "15066|D",
	[15761] = "15070|D",
	[15762] = "15080|V213|25000",
	[15763] = "15049|D",
	[15764] = "15058|D",
	[15765] = "15095|D",
	[15768] = "15088|D223",
	[15770] = "15051|D",
	[15771] = "15059|D",
	[15772] = "15062|D",
	[15773] = "15085|D220",
	[15774] = "15081|D222",
	[15775] = "15055|D",
	[15776] = "15090|D221",
	[15777] = "15096|D219",
	[15779] = "15068|D",
	[15781] = "15052|D",
	[16041] = "15993|V49V174|12000",
	[16042] = "15994|V49V174|12000",
	[16043] = "15995|D",
	[16044] = "15996|D",
	[16045] = "15999|D",
	[16046] = "16023|V209|16000",
	[16047] = "16000|V209|16000",
	[16048] = "16004|D",
	[16049] = "16005|D",
	[16050] = "16006|V209|20000",
	[16051] = "15997|D",
	[16052] = "16009|D",
	[16053] = "16008|D",
	[16054] = "16022|D",
	[16055] = "16040|D",
	[16056] = "16007|D",
	[16072] = "0|V167V203|10000",
	[16083] = "0|V148|10000",
	[16084] = "0|V36V11V52|10000",
	[16110] = "12218|V120V12V69V154|12000",
	[16111] = "12216|V102V13V189|12000",
	[16112] = "6451|V36V11V52|2200",
	[16113] = "8544|V36V11V52|5000",
	[16214] = "-20008|D",
	[16215] = "-20020|D",
	[16216] = "-20014|D",
	[16217] = "-20017|V133V31|12000",
	[16218] = "-20009|D",
	[16219] = "-20012|D",
	[16220] = "-20024|D",
	[16221] = "-20026|V154|16000",
	[16222] = "-20016|D",
	[16223] = "-20029|D",
	[16224] = "-20015|V116|20000",
	[16242] = "-20028|D",
	[16243] = "-20051|V116|22000",
	[16244] = "-20013|D",
	[16245] = "-20023|D",
	[16246] = "-20010|D",
	[16247] = "-20030|D",
	[16248] = "-20033|D",
	[16249] = "-20036|D",
	[16250] = "-20031|D",
	[16251] = "-20011|D",
	[16252] = "-20034|D",
	[16253] = "-20025|D",
	[16254] = "-20032|D",
	[16255] = "-20035|D",
	[16767] = "16766|V71|3000",
	[17017] = "16980|V115|180000|6",
	[17018] = "16979|V115|80000|5",
	[17022] = "16982|V115|150000|5",
	[17023] = "16983|V115|160000|5",
	[17025] = "16984|V115|160000|6",
	[17049] = "16989|V115|90000|6",
	[17051] = "17014|V115|70000|5",
	[17052] = "17013|V115|180000|8",
	[17053] = "16988|V115|200000|7",
	[17059] = "17015|V115|220000|6",
	[17060] = "17016|V115|220000|8",
	[17062] = "8364|V67V112V175V179V168V200V203V91V113|2200",
	[17200] = "17197|V94V204V151V165V137|25",
	[17201] = "17198|V94V204V151V165V137|240",
	[17706] = "17704|D",
	[17709] = "17708|D",
	[17720] = "17716|D",
	[17722] = "17721|D",
	[17724] = "17723|Q",
	[17725] = "-21931|D",
	[18046] = "18045|V185V38|12000",
	[18160] = "7676|V172Q|200",
	[18239] = "18238|V159|3500",
	[18252] = "18251|D",
	[18257] = "18253|D",
	[18259] = "-22749|D",
	[18260] = "-22750|D",
	[18264] = "18262|D",
	[18265] = "18263|D",
	[18267] = "18254|D",
	[18290] = "18283|D",
	[18291] = "18168|D",
	[18292] = "18282|D",
	[18414] = "18405|D",
	[18415] = "18407|D",
	[18416] = "18408|D",
	[18417] = "18409|D",
	[18418] = "18413|D",
	[18487] = "18486|V170|40000",
	[18514] = "18504|D",
	[18515] = "18506|D",
	[18516] = "18508|D",
	[18517] = "18509|D",
	[18518] = "18510|D",
	[18519] = "18511|D",
	[18592] = "17193|Q",
	[18647] = "9318|V174|1800",
	[18648] = "9313|V29V48|1800",
	[18649] = "9312|V33V49|1800",
	[18650] = "18588|V16|5000",
	[18651] = "18631|V126|12000",
	[18652] = "18634|V209|12000",
	[18653] = "18587|D",
	[18654] = "18645|D",
	[18655] = "18637|D",
	[18656] = "18594|V209|16000",
	[18657] = "18638|D",
	[18658] = "18639|D",
	[18661] = "18660|D",
	[18731] = "18662|V18V178D|2000",
	[18949] = "18948|V164V83D|2000",
	[19027] = "19026|V218|5000",
	[19202] = "19043|V127|22000|6",
	[19203] = "19051|V9V10V155|22000|6",
	[19204] = "19048|V127|40000|7",
	[19205] = "19057|V9V10V155|40000|7",
	[19206] = "19148|V115|60000|7",
	[19207] = "19164|V115|80000|7",
	[19208] = "19166|V115|70000|7",
	[19209] = "19167|V115|70000|8",
	[19210] = "19170|V115|120000|8",
	[19211] = "19168|V115|120000|8",
	[19212] = "19169|V115|120000|8",
	[19215] = "19047|V127|22000|6",
	[19216] = "19056|V9V10V155|22000|6",
	[19217] = "19059|V9V10V155|40000|7",
	[19218] = "19050|V127|40000|7",
	[19219] = "19156|V115|60000|6",
	[19220] = "19165|V115|90000|7",
	[19326] = "19044|V127|22000|6",
	[19327] = "19049|V127|40000|7",
	[19328] = "19052|V9V10V155|22000|6",
	[19329] = "19058|V9V10V155|40000|7",
	[19330] = "19149|V115|60000|7",
	[19331] = "19157|V115|90000|7",
	[19332] = "19162|V115|90000|7",
	[19333] = "19163|V115|90000|7",
	[19442] = "19440|V9V10V155|100000|6D",
	[19444] = "-23799|V115|30000|7",
	[19445] = "-23800|V127|30000|6",
	[19446] = "-23801|V9V10V155|30000|6",
	[19447] = "-23802|V9V10V155|60000|7",
	[19448] = "-23803|V115|80000|6",
	[19449] = "-23804|V115|100000|7",
	[19764] = "19682|V160|50000|7",
	[19765] = "19683|V160|50000|6",
	[19766] = "19684|V160|50000|5",
	[19769] = "19685|V160|50000|7",
	[19770] = "19686|V160|50000|6",
	[19771] = "19687|V160|50000|5",
	[19772] = "19688|V160|50000|7",
	[19773] = "19689|V160|50000|6",
	[19776] = "19690|V160|50000|7",
	[19777] = "19691|V160|50000|6",
	[19778] = "19692|V160|50000|5",
	[19779] = "19693|V160|50000|7",
	[19780] = "19694|V160|50000|6",
	[19781] = "19695|V160|50000|5",
	[20000] = "19999|V160|50000|6",
	[20001] = "19998|V160|50000|5",
	[20011] = "20007|V160|50000|7",
	[20012] = "20002|V160|50000|5",
	[20013] = "20008|V160|50000|8",
	[20014] = "20004|V160|50000|6",
	[20040] = "20039|V115|80000|8",
	[20075] = "20074|V147|2000",
	[20253] = "15064|V127|16000|5",
	[20254] = "15065|V127|20000|5",
	[20382] = "20380|V2|60000|8",
	[20506] = "20481|V2|40000|5",
	[20507] = "20480|V2|40000|6",
	[20508] = "20479|V2|40000|7",
	[20509] = "20476|V2|40000|5",
	[20510] = "20477|V2|40000|6",
	[20511] = "20478|V2|40000|7",
	[20546] = "20538|Q",
	[20547] = "20537|Q",
	[20548] = "20539|Q",
	[20553] = "20549|Q",
	[20554] = "20550|Q",
	[20555] = "20551|Q",
	[20576] = "20575|V6D|350",
	[20727] = "-25073|D",
	[20728] = "-25074|D",
	[20729] = "-25078|D",
	[20730] = "-25079|D",
	[20732] = "-25081|V89|90000|5",
	[20733] = "-25082|V89|90000|6",
	[20752] = "-25125|V190V89V81V108V140V182V184V99V111|3000",
	[20753] = "-25126|V140V111V184V99V182V89V190V81V108|4000",
	[20754] = "-25127|V89|10000",
	[20755] = "-25128|V89|20000",
	[20756] = "-25129|V160|40000|6",
	[20757] = "-25130|V160|40000|5",
	[20758] = "-25124|V89V190V81V108V140V182V99V184V111|500",
	[20761] = "12|V115|120000|5",
	[21025] = "21023|Q",
	[21099] = "21072|V47V203V37V128V43V207V56V44V91V146V180V149V134V162|500",
	[21219] = "21217|V47V203V37V128V43V207V56V44V91V146V180V149V134V162|5000",
	[21302] = "20844|D",
	[21358] = "21340|V197|12000",
	[21371] = "21342|D",
	[21547] = "21546|D",
	[21548] = "21278|D",
	[44916] = "21154|Q",
	[44917] = "21542|Q",
	[21724] = "21558|D",
	[21725] = "21559|D",
	[21726] = "21557|D",
	[21727] = "21589|D",
	[21728] = "21590|D",
	[21729] = "21592|D",
	[21730] = "21571|D",
	[21731] = "21574|D",
	[21732] = "21576|D",
	[21733] = "21714|D",
	[21734] = "21716|D",
	[21735] = "21718|D",
	[44918] = "21570|Q",
	[44919] = "21569|Q",
	[22209] = "22197|V192|50000|5",
	[22214] = "22195|V192|50000|6",
	[22219] = "22198|V110|50000|7",
	[22220] = "22194|D",
	[22221] = "22191|V110|80000|7",
	[22222] = "22196|D",
	[22307] = "22246|V190V81V108V140V182V99V184V111V89|6000",
	[22308] = "22248|V89|20000",
	[22309] = "22249|D",
	[22310] = "22251|V130|20000|5",
	[22312] = "22252|V130|50000|7",
	[22388] = "22385|D",
	[22389] = "22383|D",
	[22390] = "22384|D",
	[22392] = "-27837|V127|25000|5",
	[22683] = "22660|V130|90000|7",
	[22766] = "22762|V192|50000|7",
	[22767] = "22763|V192|50000|6",
	[22768] = "22764|V192|50000|5",
	[22769] = "22761|V2|50000|5",
	[22770] = "22760|V2|50000|6",
	[22771] = "22759|V2|50000|7",
	[22772] = "22758|V130|50000|5",
	[22773] = "22757|V130|50000|6",
	[22774] = "22756|V130|50000|7",
-- Burning Crusade
	[12698] = "12625|D",
	[13517] = "13503|V255|80000|7",
	[15769] = "15138|D",
	[20854] = "20830|V133V31V282V283|1800",
	[20855] = "20833|V30V156|1500",
	[20856] = "20831|V285V286V282V283|1500",
	[20970] = "20950|V72V284|1500",
	[20971] = "20954|V24V128|1500",
	[20973] = "20958|V128V98|2000",
	[20974] = "20966|D",
	[20975] = "20959|V287V288V282V283|2500",
	[20976] = "20967|D",
	[21892] = "21842|V224V225V226|40000",
	[21893] = "21843|V225V228|40000",
	[21894] = "21844|V224V226V227V228|40000",
	[21895] = "21845|V231|40000",
	[21896] = "21854|V224V225V226|40000",
	[21897] = "21855|V224V225V226|40000",
	[21898] = "21859|V238V239|60000",
	[21899] = "21860|V238V239|60000",
	[21900] = "21861|V230|60000",
	[21901] = "21862|V230|60000",
	[21902] = "21863|V227V228|80000",
	[21903] = "21864|D",
	[21904] = "21865|D",
	[21905] = "21866|D",
	[21906] = "21867|D",
	[21907] = "21868|D",
	[21908] = "21846|V232|60000",
	[21909] = "21847|V232|60000",
	[21910] = "21848|V232|60000",
	[21911] = "21858|V232|60000",
	[21912] = "21869|V229|60000",
	[21913] = "21871|V229|60000",
	[21914] = "21870|V229|60000",
	[21915] = "21872|V229|60000",
	[21916] = "21873|V231|60000",
	[21917] = "21875|V231|60000",
	[21918] = "21874|V231|60000",
	[21919] = "21876|V231|60000",
	[21940] = "21756|D",
	[21941] = "21758|V68V13|5000",
	[21942] = "20969|V62V90|6000",
	[21943] = "21760|V142V68|6000",
	[21944] = "21763|D",
	[21945] = "21754|D",
	[21947] = "21753|D",
	[21948] = "21766|V287V289V282V283|7500",
	[21949] = "21769|D",
	[21952] = "21774|V130|10000",
	[21953] = "21777|D",
	[21954] = "21778|V77|10000",
	[21955] = "21784|D",
	[21956] = "21789|D",
	[21957] = "21792|V154|10000",
	[21992] = "21990|V265V264|20000",
	[21993] = "21991|V265V264|40000",
	[22530] = "-27906|D",
	[22532] = "-27913|D",
	[22533] = "-27914|D",
	[22534] = "-27917|D",
	[22535] = "-27920|D",
	[22536] = "-27924|V234|100000|6",
	[22537] = "-27926|V255|100000|7",
	[22538] = "-27927|V234|200000|6",
	[22539] = "-27945|V309|60000",
	[22540] = "-27946|D",
	[22541] = "-27947|D",
	[22542] = "-27948|D",
	[22543] = "-27950|D",
	[22544] = "-27951|D",
	[22545] = "-27954|D",
	[22548] = "-27962|D",
	[22551] = "-27968|D",
	[22553] = "-27972|D",
	[22554] = "-27971|D",
	[22555] = "-27975|D",
	[22556] = "-27977|D",
	[22557] = "-28004|D",
	[22558] = "-28003|D",
	[22559] = "-27984|D",
	[22560] = "-27981|D",
	[22561] = "-27982|D",
	[22562] = "22521|V311V312V310|50000",
	[22563] = "22522|V311V312V310|70000",
	[22565] = "22449|V311V312V310|60000",
	[22647] = "22645|V275V270|400",
	[22729] = "22728|D",
	[22900] = "22823|V261V258V262V253V263V259|30000",
	[22901] = "22826|V263V252|30000",
	[22902] = "22827|V251V252|40000",
	[22903] = "22828|D",
	[22904] = "22830|D",
	[22906] = "22871|V256|0|8",
	[22907] = "22832|V253V251|50000",
	[22908] = "22833|V236|60000|7",
	[22909] = "22834|V253V251|50000",
	[22910] = "22835|V234|80000|7",
	[22911] = "22836|D",
	[22912] = "22837|D",
	[22913] = "22838|D",
	[22914] = "22839|D",
	[22915] = "21884|V255|80000|7",
	[22916] = "21885|V256|0|7",
	[22918] = "22451|V237|80000|7",
	[22919] = "22840|D",
	[22920] = "22841|D",
	[22921] = "22842|D",
	[22922] = "22844|V237|100000|8",
	[22923] = "22845|D",
	[22924] = "22846|D",
	[22925] = "22847|D",
	[22926] = "22848|D",
	[22927] = "22849|D",
	[23130] = "23094|V291V292|40000",
	[23131] = "23095|V291V292|50000",
	[23133] = "23096|V236|60000|5",
	[23134] = "23097|V233|60000|6",
	[23135] = "23098|V291V292|40000",
	[23136] = "23099|V233|50000|5",
	[23137] = "23100|V291V292|60000",
	[23138] = "23101|V234|60000|5",
	[23140] = "23103|V291V292|40000",
	[23141] = "23104|V291V292|50000",
	[23143] = "23106|V236|60000|6",
	[23144] = "23108|V291V292|40000",
	[23145] = "23109|V235|50000|6",
	[23146] = "23110|V233|60000|5",
	[23147] = "23111|V291V292|60000",
	[23148] = "23113|V291V292|40000",
	[23149] = "23114|V235|50000|5",
	[23150] = "23115|V233|60000|6",
	[23151] = "23116|V291V292|60000",
	[23152] = "23118|V291V292|40000",
	[23153] = "23119|V291V292|50000",
	[23154] = "23120|D",
	[23155] = "23121|V233|60000|6",
	[23574] = "23571|V258V259V260|80000",
	[23590] = "23502|V243V244V245|40000",
	[23591] = "23503|V243V244V245|40000",
	[23592] = "23504|V243V244V245|40000",
	[23593] = "23505|V243V244V245|40000",
	[23594] = "23506|V241V242|60000",
	[23595] = "23508|V241V242|60000",
	[23596] = "23507|V241V242|60000",
	[23597] = "23510|V236|60000|5",
	[23598] = "23511|V236|60000|6",
	[23599] = "23509|V236|60000|7",
	[23600] = "23512|V236|80000|8",
	[23601] = "23515|V235|60000|5",
	[23602] = "23516|V235|60000|8",
	[23603] = "23514|V235|60000|6",
	[23604] = "23513|V235|80000|7",
	[23605] = "23517|D",
	[23606] = "23518|D",
	[23607] = "23519|D",
	[23608] = "23524|D",
	[23609] = "23523|D",
	[23610] = "23525|D",
	[23611] = "23520|D",
	[23612] = "23521|D",
	[23613] = "23522|D",
	[23615] = "23526|D",
	[23617] = "23527|D",
	[23618] = "23529|V237|60000|6",
	[23620] = "23531|D",
	[23621] = "23532|D",
	[23622] = "23533|D",
	[23623] = "23534|D",
	[23624] = "23535|D",
	[23625] = "23536|D",
	[23626] = "23537|D",
	[23627] = "23538|D",
	[23628] = "23539|D",
	[23629] = "23540|D",
	[23630] = "23541|D",
	[23631] = "23542|D",
	[23632] = "23543|D",
	[23633] = "23544|D",
	[23634] = "23546|D",
	[23635] = "23554|D",
	[23636] = "23555|D",
	[23637] = "23556|D",
	[23638] = "23575|V246V247|60000",
	[23639] = "23576|D",
	[23799] = "23746|V293V294V295|80000",
	[23800] = "23747|D",
	[23802] = "23748|D",
	[23803] = "23758|V299V297|60000",
	[23804] = "23761|D",
	[23805] = "23762|V300V299|80000",
	[23806] = "23763|D",
	[23807] = "23764|V296V297|60000",
	[23808] = "23765|D",
	[23809] = "23766|D",
	[23810] = "23767|D",
	[23883] = "33092|D",
	[23884] = "33093|D",
	[23811] = "23768|V300V293V298V295|60000",
	[23814] = "23771|V237|60000|5",
	[23815] = "23773|V293V298V295|60000",
	[23816] = "23774|V293V298V295|40000",
	[23887] = "23824|D",
	[23888] = "23821|D",
	[24158] = "24079|D",
	[24159] = "24080|D",
	[24160] = "24082|D",
	[24161] = "24085|D",
	[24162] = "24086|D",
	[24163] = "24087|D",
	[24164] = "24088|D",
	[24165] = "24089|D",
	[24166] = "24106|D",
	[24167] = "24110|D",
	[24168] = "24114|D",
	[24169] = "24116|D",
	[24170] = "24117|D",
	[24171] = "24121|D",
	[24172] = "24122|D",
	[24173] = "24123|D",
	[24174] = "24092|V254|120000|7",
	[24175] = "24093|V234|120000|7",
	[24176] = "24095|V236|120000|7",
	[24177] = "24097|V235|120000|7",
	[24178] = "24098|V233|120000|7",
	[24179] = "24124|V234|120000|7",
	[24181] = "24126|V254|120000|7",
	[24182] = "24127|V255|120000|7",
	[24183] = "24128|V237|120000|7",
	[24192] = "24031|D",
	[24193] = "24027|D",
	[24194] = "24028|D",
	[24195] = "24029|D",
	[24196] = "24030|D",
	[24197] = "24032|D",
	[24198] = "24036|D",
	[24199] = "24033|D",
	[24200] = "24035|D",
	[24201] = "24037|D",
	[24202] = "24039|D",
	[24203] = "24047|D",
	[24204] = "24048|D",
	[24205] = "24051|D",
	[24206] = "24050|D",
	[24207] = "24052|D",
	[24209] = "24054|D",
	[24210] = "24055|D",
	[24211] = "24056|D",
	[24212] = "24057|D",
	[24213] = "24058|D",
	[24214] = "24059|D",
	[24215] = "24060|D",
	[24216] = "24061|D",
	[24217] = "24062|D",
	[24218] = "24066|D",
	[24219] = "24065|D",
	[24220] = "24067|D",
	[24292] = "24273|V236|60000|6",
	[24293] = "24275|V235|60000|6",
	[24294] = "24274|V236|360000|8",
	[24295] = "24276|V235|360000|8",
	[24296] = "24249|D",
	[24297] = "24250|D",
	[24298] = "24251|D",
	[24299] = "24252|D",
	[24300] = "24253|D",
	[24301] = "24254|D",
	[24302] = "24255|D",
	[24303] = "24256|D",
	[24304] = "24257|D",
	[24305] = "24258|D",
	[24306] = "24259|D",
	[24307] = "24260|D",
	[24308] = "24261|D",
	[24309] = "24262|D",
	[24310] = "24263|D",
	[24311] = "24264|D",
	[24312] = "24266|D",
	[24313] = "24267|D",
	[24314] = "24270|V233|40000|6",
	[24315] = "24269|V237|30000|5",
	[24316] = "24271|V232|40000",
	[25526] = "25521|V237|60000|6",
	[25720] = "23793|V304V302V303|50000",
	[25721] = "25651|V235|50000|7",
	[25722] = "25652|V236|50000|7",
	[25725] = "25653|V305|50000",
	[25726] = "25679|V302V303|10000",
	[25728] = "25680|D",
	[25729] = "25681|D",
	[25730] = "25682|D",
	[25731] = "25683|D",
	[25732] = "25685|V233|120000|5",
	[25733] = "25686|V233|140000|6",
	[25734] = "25687|V233|140000|7",
	[25735] = "25689|V237|160000|6",
	[25736] = "25690|V237|140000|6",
	[25737] = "25691|V237|140000|5",
	[25846] = "25844|V243|40000",
	[25847] = "25845|V246V247|120000",
	[25848] = "22462|V307V277|100000",
	[25849] = "22463|V310|120000",
	[25869] = "25867|V237|80000|6",
	[25887] = "25886|D",
	[25902] = "25896|D",
	[25903] = "25897|D",
	[25904] = "25901|V255|120000|5",
	[25905] = "25898|D",
	[25906] = "25899|D",
	[25907] = "25890|D",
	[25908] = "25894|V233|120000|6",
	[25909] = "25893|D",
	[25910] = "25895|V254|120000|6",
	[27684] = "27651|D",
	[27685] = "27635|V269|40",
	[27686] = "24105|D",
	[27687] = "27636|V270|400",
	[27688] = "27655|V280V281|20000",
	[27689] = "27656|V256|20000",
	[27690] = "27657|V271V272|30000",
	[27691] = "27658|V278V279|30000",
	[27692] = "27659|V271V278V272V279|30000",
	[27693] = "27660|D",
	[27694] = "27661|V273V274|20000",
	[27695] = "27662|V273V239|20000",
	[27696] = "27663|D",
	[27697] = "27664|V278V279|30000",
	[27698] = "27665|V278V279|30000",
	[27699] = "27666|V276V277|30000",
	[27700] = "27667|V276V277|30000",
	[28270] = "-33992|D",
	[28271] = "-33994|V237|80000|7",
	[28272] = "-33997|V254|80000|6",
	[28273] = "-33999|V255|60000|6",
	[28274] = "-34003|V233|40000|5",
	[28276] = "-34005|D",
	[28277] = "-34006|D",
	[28279] = "-34007|D",
	[28280] = "-34008|D",
	[28281] = "-34010|V255|60000|7",
	[28282] = "-34009|V310|40000",
	[28291] = "28290|V291V292|60000",
	[28596] = "28595|V291V292|50000",
	[28632] = "28421|V237|60000|6",
	[29669] = "29483|D",
	[29672] = "29485|D",
	[29673] = "29486|D",
	[29674] = "29487|D",
	[29675] = "29488|D",
	[29677] = "29489|V236|80000|8",
	[29682] = "29490|V236|80000|6",
	[29684] = "29491|V236|80000|7",
	[29689] = "29492|V235|80000|8",
	[29691] = "29493|V235|80000|7",
	[29693] = "29494|V235|80000|6",
	[29698] = "29495|V236|80000|8",
	[29700] = "29496|V236|80000|7",
	[29701] = "29497|V236|80000|6",
	[29702] = "29498|V235|80000|8",
	[29703] = "29499|V235|80000|7",
	[29704] = "29500|V235|80000|6",
	[29713] = "29532|V254|120000|6",
	[29714] = "29531|DV257V301|120000|6",
	[34174] = "29531|DV257V301|120000|6",
	[34175] = "29531|DV257V301|120000|6",
	[29717] = "29529|V255|120000|6",
	[29718] = "29530|V257V301D|120000|6",
	[34172] = "29530|V257V301D|120000|6",
	[34173] = "29530|V257V301D|120000|6",
	[29720] = "29534|V237|60000|6",
	[29721] = "29536|V237|120000|8",
	[29723] = "29502|D",
	[29724] = "29503|D",
	[29725] = "29504|D",
	[29726] = "29505|D",
	[29727] = "29506|D",
	[29728] = "29507|D",
	[29729] = "29508|D",
	[29730] = "29512|D",
	[29731] = "29509|D",
	[29732] = "29510|D",
	[29733] = "29511|D",
	[29734] = "29514|D",
	[30156] = "30155|V256V268|0",
	[30483] = "24272|V229|40000",
	[30826] = "30825|V255|120000|6",
	[30833] = "30831|V234|60000|6",
	[30842] = "30837|V235|60000|5",
	[30843] = "30838|V235|80000|6",
	[30844] = "30839|V235|100000|8",
	[31390] = "31364|V237|240000|8",
	[31391] = "31367|V237|240000|7",
	[31392] = "31368|V237|240000|7",
	[31393] = "31369|V240|240000|6",
	[31394] = "31370|V240|240000|7",
	[31395] = "31371|V240|240000|6",
	[31401] = "31398|V290|120000|6",
	[31402] = "31399|V237|120000|8",
	[31674] = "31673|D",
	[31675] = "31672|D",
	[31680] = "31679|D",
	[31681] = "31676|D",
	[31682] = "31677|D",
-- Honor Hold / Thrallmar
	[22531] = "-27911|V248V249|60000|5",
	[24000] = "-27911|V248V249|60000|5",
	[23142] = "23105|V248V249|60000|5",
	[31359] = "23105|V248V249|60000|5",
	[25738] = "25695|V248V249|120000|5",
	[29213] = "25695|V248V249|120000|5",
	[22905] = "22831|V248V249|50000|6",
	[24001] = "22831|V248V249|50000|6",
	[25739] = "25697|V248V249|160000|6",
	[29214] = "25697|V248V249|160000|6",
	[25740] = "25696|V248V249|160000|6",
	[29215] = "25696|V248V249|160000|6",
	[25870] = "25868|V248V249|80000|6",
	[29232] = "25868|V248V249|80000|6",
	[29719] = "29533|V248V249|60000|6",
	[31361] = "29533|V248V249|60000|6",
	[22547] = "-27960|V248V249|60000|7",
	[24003] = "-27960|V248V249|60000|7",
	[24180] = "24125|V248V249|120000|7",
	[31358] = "24125|V248V249|120000|7",
	[23619] = "23530|V248V249|60000|8",
	[24002] = "23530|V248V249|60000|8",
	[29722] = "29535|V248V249|120000|8",
	[31362] = "29535|V248V249|120000|8",
-- Kurenai / The Mag'har
	[25741] = "25694|V257V301|120000|5",
	[29217] = "25694|V257V301|120000|5",
	[25742] = "25692|V257V301|120000|6",
	[29219] = "25692|V257V301|120000|6",
	[29664] = "29540|V257V301|50000|6",
	[30444] = "29540|V257V301|50000|6",
	[25743] = "25693|V257V301|120000|7",
	[29218] = "25693|V257V301|120000|7",
	[22917] = "22452|V257V301|80000|7",
	[30443] = "22452|V257V301|80000|7",
-- New source of recipes for flasks
	[13519] = "13510|DV255|40000|8",
	[13520] = "13511|DV237|40000|8",
	[13521] = "13512|DV254|40000|8",
	[13522] = "13513|DV234|40000|8",
	[31354] = "13510|V255|40000|8",
	[31356] = "13511|V237|40000|8",
	[31355] = "13512|V254|40000|8",
	[31357] = "13513|V234|40000|8",
--New
	[7929] = "9957|Qh",
	[32429] = "32393|V313|80000|6",
	[32430] = "32399|V313|80000|6",
	[32431] = "32400|V313|80000|7",
	[32432] = "32397|V313|80000|7",
	[32436] = "32393|V313|80000|6",
	[32435] = "32396|V313|80000|6",
	[32433] = "32394|V313|80000|7",
	[32434] = "32395|V313|80000|7",
	[32447] = "32420|V313|80000|7",
	[32438] = "32392|V313|80000|6",
	[32440] = "32390|V313|80000|6",
	[32439] = "32389|V313|80000|7",
	[32437] = "32391|V313|80000|7",
	[32442] = "32403|V313|80000|6",
	[32444] = "32401|V313|80000|6",
	[32443] = "32404|V313|80000|7",
	[32441] = "32402|V313|80000|7",
	[33205] = "33204|V290|240000|8",
	[33124] = "33122|V290|50000|7",
	[33165] = "-42620|V290|30000|8",
	[33209] = "33208|V290|40000|6",
	[32299] = "32213|V314|60000|6",
	[32274] = "32193|V314|60000|5",
	[32283] = "32197|V314|60000|5",
	[32290] = "32204|V314|60000|5",
	[32311] = "32225|V314|60000|6",
	[32277] = "32194|V314|60000|5",
	[32309] = "32249|V314|60000|7",
	[32293] = "32207|V314|60000|5",
	[32306] = "32220|V314|60000|6",
	[32301] = "32215|V314|60000|6",
	[32300] = "32214|V314|60000|6",
	[32312] = "32226|V314|60000|6",
	[32305] = "32219|V314|60000|6",
	[32288] = "32202|V314|60000|5",
	[32304] = "32218|V314|60000|6",
	[32310] = "32224|V314|60000|6",
	[32292] = "32206|V314|60000|7",
	[32302] = "32216|V314|60000|7",
	[32282] = "32196|V314|60000|5",
	[32291] = "32205|V314|60000|5",
	[32286] = "32200|V314|60000|5",
	[32287] = "32201|V314|60000|5",
	[32284] = "32198|V314|60000|5",
	[32281] = "32195|V314|60000|5",
	[32294] = "32208|V314|60000|5",
	[32308] = "32222|V314|60000|7",
	[33159] = "33140|V255|120000|7",
	[33156] = "33131|V233|120000|7",
	[33305] = "33133|V233|120000|7",
	[33160] = "33144|V254|120000|6",
	[33157] = "33135|V234|120000|7",
	[33155] = "33134|V255|120000|6",
	[33158] = "33143|V254|120000|7",
	[32381] = "7191|V209V294|16000", --Fused Wiring
	[30280] = "30038|D",
	[30281] = "30036|D",
	[30282] = "30037|D",
	[32755] = "32587|D",
	[32754] = "32586|D",
	[30302] = "30040|D",
	[30301] = "30042|D",
	[30303] = "30046|D",
	[30305] = "30041|D",
	[30307] = "30045|D",
	[30308] = "30043|D",
	[30304] = "30044|D",
	[32748] = "32574|D",
	[32751] = "32579|D",
	[32745] = "32583|D",
	[32746] = "32580|D",
	[32744] = "32582|D",
	[32750] = "32577|D",
	[32745] = "32583|D",
	[32749] = "32575|D",
	[32747] = "32581|D",
	[30306] = "30039|D",
	[30321] = "30034|D",
	[30323] = "30033|D",
	[30322] = "30032|D",
	[30324] = "30031|D",
	[32739] = "32573|D",
	[32736] = "32568|D",
	[32738] = "32571|D",
	[32737] = "32570|D",
	[33174] = "33173|D",
	[33783] = '33782|D', --Steady Talasite
	[33869] = "33867|Q",
	[33925] = "33924|Q",
	[34413] = "34411|QV151V204",
	[33875] = "33874|Q",
	[33870] = "33825|Q",
	[33873] = "33872|Q",
	[33871] = "33866|Q",
	[34114] = "34113|D",
	[33804] = "20475|D",
	[33307] = "-42974|D",
	[33954] = "32854|D",
	[33186] = "33185|D",
	[33792] = "33185|D",
	[34200] = "34105|V234|400000|7",
	[34201] = "34106|V248V249|400000|7",
	[34218] = "34106|V248V249|400000|7",
	[34491] = "34490|D",
	[34262] = "34086|QV151V204",
	[34261] = "34807|QhV151",
	[34319] = "34805|QaV204",
	[30283] = "30035|D",
	[32753] = "32585|D",
	[32752] = "32584|D",
	[32411] = "32410|D",
	[32412] = "32409|V233|12000|8",
	[33622] = "32409|V233|12000|8",
	[31876] = "31863|D",
	[24192] = "24031|D",
	[24193] = "24027|D",
	[31875] = "31861|D",
	[31874] = "31869|D",
	[31877] = "31865|D",
	[24208] = "24053|D",
	[31878] = "31867|D",
	[31879] = "31868|D",
	[31871] = "31862|D",
	[31870] = "31860|D",
	[31872] = "31864|D",
	[31873] = "31866|D",
	[32307] = "32211|D",
	[32303] = "32217|D",
	[32298] = "32212|D",
	[32297] = "32221|D",
	[32296] = "32210|D",
	[32289] = "32203|D",
	[32285] = "32197|D",
	[99999] = "7929|Qh",
	[35202] = "34360|D",
	[35533] = "34360|D",
	[35200] = "34361|D",
	[35203] = "34358|D",
	[35535] = "34358|D",
	[35238] = "32213|V316|500000|6",
	[35244] = "32193|V316|500000|5",
	[35245] = "32197|V316|500000|5",
	[35255] = "32204|V316|500000|5",
	[35251] = "32225|V316|500000|6",
	[35246] = "32194|V316|500000|5",
	[35252] = "32223|V316|500000|7",
	[35247] = "32199|V316|500000|8",
	[35765] = "35759|V314|15000|6",
	[35769] = "35759|V315|500000|7",
	[35256] = "32207|V316|500000|5",
	[35266] = "32220|V316|500000|6",
	[35239] = "32215|V316|500000|6",
	[35257] = "32210|V316|500000|8",
	[35240] = "32214|V316|500000|6",
	[35267] = "32217|V316|500000|8",
	[35253] = "32226|V316|500000|6",
	[35268] = "32219|V316|500000|6",
	[35262] = "32202|V316|500000|5",
	[35258] = "32209|V316|500000|8",
	[35269] = "32218|V316|500000|6",
	[35763] = "35761|V314|15000|6",
	[35768] = "35761|V315|500000|7",
	[35254] = "32224|V316|500000|6",
	[35762] = "35760|V314|15000|6",
	[35767] = "35760|V315|500000|7",
	[35259] = "32206|V316|500000|7",
	[35241] = "32216|V316|500000|7",
	[35248] = "32196|V316|500000|5",
	[35242] = "32212|V316|500000|8",
	[35260] = "32205|V316|500000|5",
	[35263] = "32200|V316|500000|5",
	[35243] = "32211|V316|500000|8",
	[35264] = "32201|V316|500000|5",
	[35764] = "35758|V314|15000|6",
	[35766] = "35758|V315|500000|7",
	[35265] = "32203|V316|500000|8",
	[35249] = "32198|V316|500000|5",
	[35250] = "32195|V316|500000|5",
	[35261] = "32208|V316|500000|5",
	[35270] = "32221|V316|500000|8",
	[35271] = "32222|V316|500000|7",
	[35201] = "34359|D",
	[35198] = "34362|D",
	[35199] = "34363|D",
	[35538] = "34363|D",
	[35218] = "34369|D",
	[35539] = "34369|D",
	[35217] = "34373|D",
	[35213] = "34374|D",
	[35541] = "34374|D",
	[35214] = "34370|D",
	[35205] = "34367|D",
	[35544] = "34367|D",
	[35216] = "34371|D",
	[35545] = "34371|D",
	[35212] = "34372|D",
	[35546] = "34372|D",
	[35207] = "34365|D",
	[35548] = "34365|D",
	[35219] = "34375|D",
	[35215] = "34376|D",
	[35550] = "34376|D",
	[35204] = "34366|D",
	[35551] = "34366|D",
	[35206] = "34364|D",
	[35209] = "34378|D",
	[35553] = "34378|D",
	[35211] = "34377|D",
	[35210] = "34379|D",
	[35208] = "34380|D",
	[35186] = "34847|D",
	[35187] = "35185|D",
	[35189] = "35181|D",
	[35190] = "35182|D",
	[35191] = "35183|D",
	[35192] = "35184|D",
	[35193] = "34355|D",
	[35194] = "34356|D",
	[35195] = "34354|D",
	[35196] = "34357|D",
	[35197] = "34353|D",
	[34834] = "34832|Q",
	[35505] = "35503|V316|150000|7",
	[35502] = "35501|V316|150000|7",
	[34872] = "-45765|V316|150000|7",
	[35564] = "35563|V12V120|12000",
	[35566] = "35565|V12V120|12000",
	[35273] = "35128|D",
	[35708] = "35707|V316|150000|7",
	[35582] = "35581|D",
	[35550] = "-46594|V316|150000|7",
	[35755] = "35751|V316|250000|8",
	[35752] = "35748|V316|250000|8",
	[35754] = "35750|V316|250000|8",
	[35753] = "35749|V316|250000|8",
	[35697] = "35700|V316|250000|7",
	[35695] = "35693|V316|250000|7",
	[35696] = "35694|V316|250000|7",
	[35699] = "35703|V316|250000|7",
	[35698] = "35702|V316|250000|7",
	[35517] = "32574|D",
	[35518] = "32586|D",
	[35519] = "32582|D",
	[35302] = "29503|D",
	[35303] = "29506|D",
	[35520] = "32577|D",
	[35521] = "32579|D",
	[35522] = "32587|D",
	[35301] = "29511|D",
	[35523] = "32583|D",
	[35524] = "32575|D",
	[35525] = "32585|D",
	[35526] = "32584|D",
	[35527] = "32580|D",
	[35528] = "32581|D",
	[35309] = "24255|D",
	[35300] = "29509|D",
	[35531] = "32568|D",
	[35532] = "32570|D",
	[35306] = "24031|D",
	[35307] = "24051|D",
	[35305] = "24030|D",
	[35304] = "24033|D",
	[35297] = "-34008|D",
	[35299] = "-34007|D",
	[35756] = "-47051|D",
	[35308] = "24249|D",
	[35310] = "33092|D",
	[35311] = "33093|D",
	[35298] = "-27948|D",
	[35296] = "33185|D",
	[35294] = "22848|D",
	[35295] = "22838|D",
	[35325] = "35319|V315|250000|8",
	[35322] = "35315|V315|250000|8",
	[35323] = "35316|V315|250000|8",
-- WotLK recipes
	[39644] = "39520|Q",
	[43017] = "43015|V318V319",
	[43018] = "34754|V318V319",
	[43019] = "34755|V318V319",
	[43020] = "34756|V318V319",
	[43021] = "34757|V318V319",
	[43022] = "34758|V318V319",
	[43023] = "34766|V318V319",
	[43024] = "34767|V318V319",
	[43025] = "34768|V318V319",
	[43026] = "34769|V318V319",
	[43027] = "42993|V318V319",
	[43028] = "42994|V318V319",
	[43029] = "43004|V318V319",
	[43030] = "42995|V318V319",
	[43031] = "42996|V318V319",
	[43032] = "42997|V318V319",
	[43033] = "42998|V318V319",
	[43034] = "43005|V318V319",
	[43035] = "42999|V318V319",
	[43036] = "43000|V318V319",
	[43037] = "43001|V318V319",
	[43505] = "43478|V318V319",
	[43506] = "43480|V318V319",
	[44954] = "44953|V318V319",
	[43507] = "43490|D",
	[43508] = "43488|D",
	[43509] = "43491|D",
	[43510] = "43492|D",
	[37331] = "-44556|D",
	[37332] = "-44483|D",
	[37333] = "-44494|D",
	[42178] = "41254|D",
	[42172] = "41248|D",
	[42173] = "41249|D",
	[42175] = "41250|D",
	[42176] = "41253|D",
	[42177] = "41252|D",
	[37915] = "6836|V320",
	[38327] = "38277|V320",
	[38328] = "38278|V320",
	-- WotLK Alchemy Recipes
	[32070] = "32063|V237", -- Recipe: Earthen Elixir
	[32071] = "32068|V321V322", -- Recipe: Elixir of Ironskin
	[44565] = "40214|D", -- Recipe: Mighty Fire Protection Potion
	[44566] = "40215|D", -- Recipe: Mighty Frost Protection Potion
	[44567] = "40216|D", -- Recipe: Mighty Nature Protection Potion
	[44564] = "40213|D", -- Recipe: Mighty Arcane Protection Potion
	[44568] = "40217|D", -- Recipe: Mighty Shadow Protection Potion
	-- WotLK Blacksmithing Recipes
	[41120] = "40958|D", -- Plans: Reinforced Cobalt Legplates
	[41122] = "40959|D", -- Plans: Reinforced Cobalt Chestpiece
	[41123] = "40957|D", -- Plans: Reinforced Cobalt Helm
	[41124] = "40956|D", -- Plans: Reinforced Cobalt Shoulders
	[44937] = "44936|Vh325Vh326Va327Va328", -- Plans: Titanium Plating
	-- WotLK Enchanting Recipes
	[22552] = "-27967|V322V323|60000|6", -- Formula: Enchant Weapon - Major Striking
	[33148] = "-25086|V234|100000|8", -- Formula: Enchant Cloak - Dodge
	[33149] = "-25083|V237|100000|8", -- Formula: Enchant Cloak - Stealth
	[33150] = "-25084|Vh248Va249|100000|8", -- Formula: Enchant Cloak - Subtlety
	[33152] = "-25080|V254|100000|8", -- Formula: Enchant Gloves - Superior Agility
	[33153] = "-25072|V255|100000|8", -- Formula: Enchant Gloves - Threat
	[35498] = "-46578|D", -- Formula: Enchant Weapon - Deathfrost
	[35500] = "-46594|V315|150000|6", -- Formula: Enchant Chest - Defense
	[37330] = "-44596|D", -- Formula: Enchant Cloak - Superior Arcane Resistance
	[37334] = "-44590|D", -- Formula: Enchant Cloak - Superior Shadow Resistance
	[37339] = "-44621|V324", -- Formula: Enchant Weapon - Giant Slayer
	[37340] = "-44588|V324", -- Formula: Enchant Chest - Exceptional Resilience
	[37344] = "-44524|V324", -- Formula: Enchant Weapon - Icebreaker
	[37347] = "-44591|V324", -- Formula: Enchant Cloak - Titanweave
	[37349] = "-44631|V324", -- Formula: Enchant Cloak - Shadow Armor
	[44471] = "-47672|V324", -- Formula: Enchant Cloak - Mighty Armor
	[44472] = "-47898|V324", -- Formula: Enchant Cloak - Greater Speed
	[44473] = "-44595|V324", -- Formula: Enchant Weapon - Scourgebane
	[44483] = "-60691|V324", -- Formula: Enchant 2H Weapon - Massacre
	[44484] = "-44575|V324", -- Formula: Enchant Bracers - Greater Assault
	[44485] = "-44625|V324", -- Formula: Enchant Gloves - Armsman
	[44486] = "-60707|V324", -- Formula: Enchant Weapon - Superior Potency
	[44487] = "-60714|V324", -- Formula: Enchant Weapon - Mighty Spellpower
	[44488] = "-47899|V324", -- Formula: Enchant Cloak - Wisdom
	[44489] = "-60692|V324", -- Formula: Enchant Chest - Powerful Stats
	[44490] = "-60763|V324", -- Formula: Enchant Boots - Greater Assault
	[44491] = "-47901|V324", -- Formula: Enchant Boots - Tuskarr's Vitality
	[44492] = "-59621|V324", -- Formula: Enchant Weapon - Berserking
	[44494] = "-44576|V324", -- Formula: Enchant Weapon - Lifeward
	[44495] = "-59625|V324", -- Formula: Enchant Weapon - Black Magic
	[44496] = "-59619|V324", -- Formula: Enchant Weapon - Accuracy
	[44498] = "-60767|V324", -- Formula: Enchant Bracer - Superior Spellpower
	[44944] = "-62256|V324", -- Fromula: Enchant Bracers - Major Stamina
	-- WotLK Engineering Recipes
	[23874] = "23819|V322V323|80000|7", -- Schematic: Elemental Seaforium Charge
	[44502] = "41508|Vh325Vh326|4000000|8", -- Schematic: Mechano-hog
	[44503] = "44413|Va327Va328|4000000|8", -- Schematic: Mekgineer's Chopper
	[23817] = "23775|V344", -- Schematic: Titanium Toolbox
	-- WotLK First Aid Recipes
	[39152] = "34722|D", -- Manual: Heavy Frostweave Bandage
	-- WotLK Jewelcrafting Recipes
	[32295] = "32209|D", -- Design: Mystic Lionseye
	[34689] = "34220|D", -- Design: Chaotic Skyfire Diamond
	[37504] = "37503|V316V329|500000|8", -- Design: Purified Shadowsong Amethyst
	[41559] = "39917|Va345Vh346", -- Design: Mystic Sun Crystal
	[41560] = "39932|Va345Vh346", -- Design: Stormy Chalcedony
	[41561] = "39959|V330|20000|5", -- Design: Reckless Huge Citrine
	[41562] = "39952|V331|20000|5", -- Design: Deadly Huge Citrine
	[41563] = "39958|Va345Vh346", -- Design: Durable Huge Citrine
	[41564] = "39962|Va345Vh346", -- Design: Empowered Huge Citrine
	[41565] = "39954|Va345Vh346", -- Design: Lucent Huge Citrine
	[41566] = "39950|Va345Vh346", -- Design: Resplendent Huge Citrine
	[41567] = "39975|V332|20000|5", -- Design: Vivid Dark Jade
	[41568] = "39979|V333V334|20000|5", -- Design: Seer's Dark Jade
	[41569] = "39992|Va345Vh346", -- Design: Shattered Dark Jade
	[41570] = "39991|Va345Vh346", -- Design: Tense Dark Jade
	[41571] = "39982|Va345Vh346", -- Design: Turbid Dark Jade
	[41572] = "39977|Va345Vh346", -- Design: Steady Dark Jade
	[41573] = "39988|Va345Vh346", -- Design: Opaque Dark Jade
	[41574] = "39939|V333V334|20000|6", -- Design: Defender's Shadow Crystal
	[41575] = "39945|Va345Vh346", -- Design: Mysterious Shadow Crystal
	[41576] = "39996|V335", -- Design: Bold Scarlet Ruby
	[41577] = "39997|V335", -- Design: Delicate Scarlet Ruby
	[41578] = "40001|V335", -- Design: Flashing Scarlet Ruby
	[41579] = "40017|V335", -- Design: Quick Autumn's Glow
	[41580] = "40014|V335", -- Design: Rigid Autumn's Glow
	[41581] = "40010|V335", -- Design: Lustrous Sky Sapphire
	[41582] = "40044|V335", -- Design: Glinting Monarch Topaz
	[41686] = "40048|V335", -- Design: Potent Monarch Topaz
	[41687] = "40055|V335", -- Design: Stark Monarch Topaz
	[41688] = "40049|V335", -- Design: Veiled Monarch Topaz
	[41689] = "40047|V335", -- Design: Luminous Monarch Topaz
	[41690] = "40051|V335", -- Design: Reckless Monarch Topaz
	[41692] = "40105|V335", -- Design: Energized Forest Emerald
	[41693] = "40091|V335", -- Design: Forceful Forest Emerald
	[41694] = "40104|V335", -- Design: Intricate Forest Emerald
	[41696] = "40100|V335", -- Design: Lambent Forest Emerald
	[41697] = "40089|V335", -- Design: Enduring Forest Emerald
	[41698] = "40088|V335", -- Design: Vivid Forest Emerald
	[41699] = "40092|V335", -- Design: Seer's Forest Emerald
	[41701] = "40027|V335", -- Design: Royal Twilight Opal
	[41702] = "40033|V335", -- Design: Puissant Twilight Opal
	[41703] = "40031|V335", -- Design: Regal Twilight Opal
	[41704] = "41285|V335", -- Design: Chaotic Skyflare Diamond
	[41705] = "41377|V335", -- Design: Effulgent Skyflare Diamond
	[41706] = "41333|V335", -- Design: Ember Skyflare Diamond
	[41707] = "41376|V335", -- Design: Revitalizing Skyflare Diamond
	[41708] = "41401|V335", -- Design: Insightful Earthsiege Diamond
	[41709] = "41385|V335", -- Design: Invigorating Earthsiege Diamond
	[41710] = "41398|V335", -- Design: Relentless Earthsiege Diamond
	[41711] = "41382|V335", -- Design: Trenchant Earthsiege Diamond
	[41718] = "39998|V336|40000|8", -- Design: Runed Scarlet Ruby
	[41720] = "40013|V337|40000|8", -- Design: Smooth Autumn's Glow
	[41721] = "40052|V331|40000|7", -- Design: Wicked Monarch Topaz
	[41722] = "40057|V338|40000|8", -- Design: Glimmering Monarch Topaz
	[41723] = "40086|V330|40000|7", -- Design: Jagged Forest Emerald
	[41724] = "40096|V332|40000|7", -- Design: Sundered Forest Emerald
	[41725] = "40025|V331|40000|8", -- Design: Glowing Twilight Opal
	[41726] = "40034|V339|40000|7", -- Design: Guardian's Twilight Opal
	[41727] = "40016|Va340Vh342", -- Design: Mystic Autumn's Glow
	[41728] = "40011|Va340Vh342", -- Design: Stormy Sky Sapphire
	[41730] = "40050|Va340Vh342", -- Design: Durable Monarch Topaz
	[41732] = "40054|Va340Vh342", -- Design: Empowered Monarch Topaz
	[41733] = "40045|Va340Vh342", -- Design: Lucent Monarch Topaz
	[41734] = "40040|Va340Vh342", -- Design: Resplendent Monarch Topaz
	[41735] = "40106|Va340Vh342", -- Design: Shattered Forest Emerald
	[41736] = "40101|Va340Vh342", -- Design: Tense Forest Emerald
	[41737] = "40102|Va340Vh342", -- Design: Turbid Forest Emerald
	[41738] = "40090|Va340Vh342", -- Design: Steady Forest Emerald
	[41739] = "40103|Va340Vh342", -- Design: Opaque Forest Emerald
	[41740] = "40028|Va340Vh342", -- Design: Mysterious Twilight Opal
	[41742] = "41335|Va340Vh342", -- Design: Enigmatic Skyflare Diamond
	[41743] = "41378|Va340Vh342", -- Design: Forlorn Skyflare Diamond
	[41744] = "41379|Va340Vh342", -- Design: Impassive Skyflare Diamond
	[41777] = "40038|D", -- Design: Etched Monarch Topaz
	[41778] = "40059|D", -- Design: Resolute Monarch Topaz
	[41779] = "40056|D", -- Design: Stalwart Monarch Topaz
	[41780] = "40039|D", -- Design: Champion's Monarch Topaz
	[41781] = "40095|D", -- Design: Misty Forest Emerald
	[41782] = "40099|D", -- Design: Shining Forest Emerald
	[41783] = "40026|D", -- Design: Purified Twilight Opal
	[41784] = "40022|D", -- Design: Sovereign Twilight Opal
	[41785] = "40024|D", -- Design: Tenuous Twilight Opal
	[41786] = "41307|D", -- Design: Destructive Skyflare Diamond
	[41787] = "41400|D", -- Design: Thundering Skyflare Diamond
	[41788] = "41389|D", -- Design: Beaming Earthsiege Diamond
	[41789] = "40037|D", -- Design: Inscribed Monarch Topaz
	[41790] = "40003|D", -- Design: Precise Scarlet Ruby
	[41791] = "40015|D", -- Design: Thick Autumn's Glow
	[41792] = "40046|D", -- Design: Deft Monarch Topaz
	[41793] = "40041|D", -- Design: Fierce Monarch Topaz
	[41794] = "40043|D", -- Design: Deadly Monarch Topaz
	[41795] = "40085|D", -- Design: Timeless Forest Emerald
	[41796] = "40030|D", -- Design: Infused Twilight Opal
	[41797] = "41380|D", -- Design: Austere Earthsiege Diamond
	[41798] = "41395|D", -- Design: Bracing Earthsiege Diamond
	[41799] = "41396|D", -- Design: Eternal Earthsiege Diamond
	[41817] = "40002|D", -- Design: Fractured Scarlet Ruby
	[41818] = "40058|D", -- Design: Accurate Monarch Topaz
	[41819] = "40098|D", -- Design: Radiant Forest Emerald
	[41820] = "40032|D", -- Design: Defender's Twilight Opal
	[42138] = "40008|V335", -- Design: Solid Sky Sapphire
	[42298] = "42142|V335", -- Design: Bold Dragon's Eye
	[42299] = "36766|V335", -- Design: Bright Dragon's Eye
	[42300] = "42148|V335", -- Design: Brilliant Dragon's Eye
	[42301] = "42143|V335", -- Design: Delicate Dragon's Eye
	[42302] = "42152|V335", -- Design: Flashing Dragon's Eye
	[42303] = "42153|V335", -- Design: Fractured Dragon's Eye
	[42304] = "42146|V335", -- Design: Lustrous Dragon's Eye
	[42305] = "42158|V335", -- Design: Mystic Dragon's Eye
	[42306] = "42154|V335", -- Design: Precise Dragon's Eye
	[42307] = "42150|V335", -- Design: Quick Dragon's Eye
	[42308] = "42156|V335", -- Design: Rigid Dragon's Eye
	[42309] = "42144|V335", -- Design: Runed Dragon's Eye
	[42310] = "42149|V335", -- Design: Smooth Dragon's Eye
	[42311] = "36767|V335", -- Design: Solid Dragon's Eye
	[42312] = "42145|V335", -- Design: Sparkling Dragon's Eye
	[42313] = "42155|V335", -- Design: Stormy Dragon's Eye
	[42314] = "42151|V335", -- Design: Subtle Dragon's Eye
	[42315] = "42157|V335", -- Design: Thick Dragon's Eye
	[42648] = "42642|V335", -- Design: Titanium Impact Band
	[42649] = "42643|V335", -- Design: Titanium Earthguard Ring
	[42650] = "42644|V335", -- Design: Titanium Spellshock Ring
	[42651] = "42645|V335", -- Design: Titanium Impact Choker
	[42652] = "42646|V335", -- Design: Titanium Earthguard Chain
	[42653] = "42647|V335", -- Design: Titanium Spellshock Necklace
	[43317] = "43250|V335", -- Design: Ring of Earthen Might
	[43318] = "43251|V335", -- Design: Ring of Scarlet Shadows
	[43319] = "43252|V335", -- Design: Windfire Band
	[43320] = "43253|V335", -- Design: Ring of Northern Tears
	[43485] = "43482|V335", -- Design: Savage Titanium Ring
	[43497] = "43498|V335", -- Design: Savage Titanium Band
	[43597] = "43582|V335", -- Design: Titanium Frostguard Ring
	-- WotLK Leatherworking Recipes
	[15742] = "15064|D", -- Pattern: Warbear Harness
	[44509] = "38399|V333V334|50000|7", -- Pattern: Trapper's Traveling Pack
	[44510] = "38347|V337|50000|6", -- Pattern: Mammoth Mining Bag
	[44511] = "44447|V333V334|50000|6", -- Pattern: Dragonscale Ammo Pouch
	[44512] = "44448|V331|50000|6", -- Pattern: Nerubian Reinforced Quiver
	[44513] = "43260|V343", -- Pattern: Eviscerator's Facemask
	[44514] = "43433|V343", -- Pattern: Eviscerator's Shoulderpads
	[44515] = "43434|V343", -- Pattern: Eviscerator's Chestguard
	[44516] = "43435|V343", -- Pattern: Eviscerator's Bindings
	[44517] = "43436|V343", -- Pattern: Eviscerator's Gauntlets
	[44518] = "43437|V343", -- Pattern: Eviscerator's Waistguard
	[44519] = "43438|V343", -- Pattern: Eviscerator's Legguards
	[44520] = "43439|V343", -- Pattern: Eviscerator's Treads
	[44521] = "43261|V343", -- Pattern: Overcast Headguard
	[44522] = "43262|V343", -- Pattern: Overcast Spaulders
	[44523] = "43263|V343", -- Pattern: Overcast Chestguard
	[44524] = "43264|V343", -- Pattern: Overcast Bracers
	[44525] = "43265|V343", -- Pattern: Overcast Handwraps
	[44526] = "43266|V343", -- Pattern: Overcast Belt
	[44527] = "43271|V343", -- Pattern: Overcast Leggings
	[44528] = "43273|V343", -- Pattern: Overcast Boots
	[44530] = "43447|V343", -- Pattern: Swiftarrow Helm
	[44531] = "43449|V343", -- Pattern: Swiftarrow Shoulderguards
	[44532] = "43445|V343", -- Pattern: Swiftarrow Hauberk
	[44533] = "43444|V343", -- Pattern: Swiftarrow Bracers
	[44534] = "43446|V343", -- Pattern: Swiftarrow Gauntlets
	[44535] = "43442|V343", -- Pattern: Swiftarrow Belt
	[44536] = "43448|V343", -- Pattern: Swiftarrow Leggings
	[44537] = "43443|V343", -- Pattern: Swiftarrow Boots
	[44538] = "43455|V343", -- Pattern: Stormhide Crown
	[44539] = "43457|V343", -- Pattern: Stormhide Shoulders
	[44540] = "43453|V343", -- Pattern: Stormhide Hauberk
	[44541] = "43452|V343", -- Pattern: Stormhide Wristguards
	[44542] = "43454|V343", -- Pattern: Stormhide Grips
	[44543] = "43450|V343", -- Pattern: Stormhide Belt
	[44544] = "43456|V343", -- Pattern: Stormhide Legguards
	[44545] = "43451|V343", -- Pattern: Stormhide Stompers
	[44546] = "43458|V343", -- Pattern: Giantmaim Legguards
	[44547] = "43459|V343", -- Pattern: Giantmaim Bracers
	[44548] = "43461|V343", -- Pattern: Revenant's Breastplate
	[44549] = "43469|V343", -- Pattern: Revenant's Treads
	[44550] = "43481|V343", -- Pattern: Trollwoven Spaulders
	[44551] = "43484|V343", -- Pattern: Trollwoven Girdle
	[44552] = "43495|V343", -- Pattern: Earthgiving Legguards
	[44553] = "43502|V343", -- Pattern: Earthgiving Boots
	[44584] = "43590|V343", -- Pattern: Polar Vest
	[44585] = "43591|V343", -- Pattern: Polar Cord
	[44586] = "43592|V343", -- Pattern: Polar Boots
	[44587] = "43593|V343", -- Pattern: Icy Scale Chestguard
	[44588] = "43594|V343", -- Pattern: Icy Scale Belt
	[44589] = "43595|V343", -- Pattern: Icy Scale Boots
	[44932] = "44930|V343", -- Pattern: Windripper Boots
	[44933] = "44931|V343", -- Pattern: Windripper Leggings

	-- WotLK Tailoring Recipes
	[38229] = "38225|V256|0|7", -- Pattern: Mycah's Botanical Bag
	[42183] = "41597|V331|50000|7", -- Pattern: Abyssal Bag
	[42184] = "41600|V337|50000|8", -- Pattern: Glacial Bag
	[42185] = "41598|V338|50000|7", -- Pattern: Mysterious Bag
	[42187] = "41602|V339|50000|8", -- Pattern: Brilliant Spellthread
	[42188] = "41604|V336|50000|8", -- Pattern: Sapphire Spellthread
}
